// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This is a generated file. Please see the "service_manifest" template in
// src/services/service_manager/public/service_manifest.gni for more details.

#include "components/services/heap_profiling/manifest.h"

#include <set>

#include "base/files/file_path.h"
#include "base/no_destructor.h"
#include "build/build_config.h"
#include "services/service_manager/public/cpp/manifest_builder.h"




namespace heap_profiling {


const service_manager::Manifest& GetManifest() {
  static base::NoDestructor<service_manager::Manifest> manifest{
      service_manager::ManifestBuilder()
          .WithServiceName("heap_profiling")
          .WithDisplayName("Heap Profiling Service")
          .WithOptions(service_manager::ManifestOptionsBuilder()
                           .WithSandboxType("profiling")
                           .WithInstanceSharingPolicy(
                                service_manager::Manifest::InstanceSharingPolicy::
                                    kSharedAcrossGroups)
                           .Build())
          .ExposeCapability(
              "profiling", std::set<const char*>{
                  "heap_profiling.mojom.ProfilingService",})
          .ExposeCapability(
              "heap_profiler", std::set<const char*>{
                  "memory_instrumentation.mojom.HeapProfiler",})
          .RequireCapability("*", "app")
          .RequireCapability("resource_coordinator", "heap_profiler_helper")
          .Build() };
  return *manifest;
}

}  // namespace heap_profiling
