// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "components/services/pdf_compositor/public/interfaces/pdf_compositor.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_JUMBO_H_
#define COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/shared_memory_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace printing {
namespace mojom {


void PdfCompositorInterceptorForTesting::NotifyUnavailableSubframe(uint64_t frame_guid) {
  GetForwardingInterface()->NotifyUnavailableSubframe(std::move(frame_guid));
}
void PdfCompositorInterceptorForTesting::AddSubframeContent(uint64_t frame_guid, base::ReadOnlySharedMemoryRegion serialized_content, const base::flat_map<uint32_t, uint64_t>& subframe_content_info) {
  GetForwardingInterface()->AddSubframeContent(std::move(frame_guid), std::move(serialized_content), std::move(subframe_content_info));
}
void PdfCompositorInterceptorForTesting::CompositePageToPdf(uint64_t frame_guid, base::ReadOnlySharedMemoryRegion sk_region, const base::flat_map<uint32_t, uint64_t>& subframe_content_info, CompositePageToPdfCallback callback) {
  GetForwardingInterface()->CompositePageToPdf(std::move(frame_guid), std::move(sk_region), std::move(subframe_content_info), std::move(callback));
}
void PdfCompositorInterceptorForTesting::CompositeDocumentToPdf(uint64_t frame_guid, base::ReadOnlySharedMemoryRegion sk_region, const base::flat_map<uint32_t, uint64_t>& subframe_content_info, CompositeDocumentToPdfCallback callback) {
  GetForwardingInterface()->CompositeDocumentToPdf(std::move(frame_guid), std::move(sk_region), std::move(subframe_content_info), std::move(callback));
}
void PdfCompositorInterceptorForTesting::SetWebContentsURL(const GURL& url) {
  GetForwardingInterface()->SetWebContentsURL(std::move(url));
}
void PdfCompositorInterceptorForTesting::SetUserAgent(const std::string& user_agent) {
  GetForwardingInterface()->SetUserAgent(std::move(user_agent));
}
PdfCompositorAsyncWaiter::PdfCompositorAsyncWaiter(
    PdfCompositor* proxy) : proxy_(proxy) {}

PdfCompositorAsyncWaiter::~PdfCompositorAsyncWaiter() = default;

void PdfCompositorAsyncWaiter::CompositePageToPdf(
    uint64_t frame_guid, base::ReadOnlySharedMemoryRegion sk_region, const base::flat_map<uint32_t, uint64_t>& subframe_content_info, PdfCompositor::Status* out_status, base::ReadOnlySharedMemoryRegion* out_pdf_region) {
  base::RunLoop loop;
  proxy_->CompositePageToPdf(std::move(frame_guid),std::move(sk_region),std::move(subframe_content_info),
      base::BindOnce(
          [](base::RunLoop* loop,
             PdfCompositor::Status* out_status
,
             base::ReadOnlySharedMemoryRegion* out_pdf_region
,
             PdfCompositor::Status status,
             base::ReadOnlySharedMemoryRegion pdf_region) {*out_status = std::move(status);*out_pdf_region = std::move(pdf_region);
            loop->Quit();
          },
          &loop,
          out_status,
          out_pdf_region));
  loop.Run();
}
void PdfCompositorAsyncWaiter::CompositeDocumentToPdf(
    uint64_t frame_guid, base::ReadOnlySharedMemoryRegion sk_region, const base::flat_map<uint32_t, uint64_t>& subframe_content_info, PdfCompositor::Status* out_status, base::ReadOnlySharedMemoryRegion* out_pdf_region) {
  base::RunLoop loop;
  proxy_->CompositeDocumentToPdf(std::move(frame_guid),std::move(sk_region),std::move(subframe_content_info),
      base::BindOnce(
          [](base::RunLoop* loop,
             PdfCompositor::Status* out_status
,
             base::ReadOnlySharedMemoryRegion* out_pdf_region
,
             PdfCompositor::Status status,
             base::ReadOnlySharedMemoryRegion pdf_region) {*out_status = std::move(status);*out_pdf_region = std::move(pdf_region);
            loop->Quit();
          },
          &loop,
          out_status,
          out_pdf_region));
  loop.Run();
}





}  // namespace mojom
}  // namespace printing

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif