// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_VISITEDLINK_COMMON_VISITEDLINK_MOJOM_TEST_UTILS_H_
#define COMPONENTS_VISITEDLINK_COMMON_VISITEDLINK_MOJOM_TEST_UTILS_H_

#include "components/visitedlink/common/visitedlink.mojom.h"


namespace visitedlink {
namespace mojom {


class  VisitedLinkNotificationSinkInterceptorForTesting : public VisitedLinkNotificationSink {
  virtual VisitedLinkNotificationSink* GetForwardingInterface() = 0;
  void UpdateVisitedLinks(base::ReadOnlySharedMemoryRegion table_region) override;
  void AddVisitedLinks(const std::vector<uint64_t>& link_hashes) override;
  void ResetVisitedLinks(bool invalidate_cached_hashes) override;
};
class  VisitedLinkNotificationSinkAsyncWaiter {
 public:
  explicit VisitedLinkNotificationSinkAsyncWaiter(VisitedLinkNotificationSink* proxy);
  ~VisitedLinkNotificationSinkAsyncWaiter();

 private:
  VisitedLinkNotificationSink* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VisitedLinkNotificationSinkAsyncWaiter);
};




}  // namespace mojom
}  // namespace visitedlink

#endif  // COMPONENTS_VISITEDLINK_COMMON_VISITEDLINK_MOJOM_TEST_UTILS_H_