// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "content/common/frame.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef CONTENT_COMMON_FRAME_MOJOM_JUMBO_H_
#define CONTENT_COMMON_FRAME_MOJOM_JUMBO_H_
#include "content/common/frame_messages.h"
#include "content/common/resource_messages.h"
#include "content/public/common/load_timing_info_struct_traits.h"
#include "content/public/common/resource_type_struct_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "mojo/public/cpp/base/values_mojom_traits.h"
#include "services/network/public/cpp/net_ipc_param_traits.h"
#include "services/network/public/cpp/network_ipc_param_traits.h"
#include "services/network/public/cpp/network_param_mojom_traits.h"
#include "third_party/blink/common/feature_policy/feature_policy_mojom_traits.h"
#include "third_party/blink/public/common/loader/url_loader_factory_bundle_mojom_traits.h"
#include "ui/base/mojo/window_open_disposition_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "url/mojom/origin_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace content {
namespace mojom {


void FrameInterceptorForTesting::GetInterfaceProvider(::service_manager::mojom::InterfaceProviderRequest interfaces) {
  GetForwardingInterface()->GetInterfaceProvider(std::move(interfaces));
}
void FrameInterceptorForTesting::GetCanonicalUrlForSharing(GetCanonicalUrlForSharingCallback callback) {
  GetForwardingInterface()->GetCanonicalUrlForSharing(std::move(callback));
}
void FrameInterceptorForTesting::BlockRequests() {
  GetForwardingInterface()->BlockRequests();
}
void FrameInterceptorForTesting::ResumeBlockedRequests() {
  GetForwardingInterface()->ResumeBlockedRequests();
}
void FrameInterceptorForTesting::CancelBlockedRequests() {
  GetForwardingInterface()->CancelBlockedRequests();
}
void FrameInterceptorForTesting::OnPortalActivated() {
  GetForwardingInterface()->OnPortalActivated();
}
FrameAsyncWaiter::FrameAsyncWaiter(
    Frame* proxy) : proxy_(proxy) {}

FrameAsyncWaiter::~FrameAsyncWaiter() = default;

void FrameAsyncWaiter::GetCanonicalUrlForSharing(
    base::Optional<GURL>* out_canonical_url) {
  base::RunLoop loop;
  proxy_->GetCanonicalUrlForSharing(
      base::BindOnce(
          [](base::RunLoop* loop,
             base::Optional<GURL>* out_canonical_url
,
             const base::Optional<GURL>& canonical_url) {*out_canonical_url = std::move(canonical_url);
            loop->Quit();
          },
          &loop,
          out_canonical_url));
  loop.Run();
}



void FrameNavigationControlInterceptorForTesting::CommitNavigation(const network::ResourceResponseHead& head, const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, ::network::mojom::URLLoaderClientEndpointsPtr url_loader_client_endpoints, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, base::Optional<std::vector<::content::mojom::TransferrableURLLoaderPtr>> subresource_overrides, ::blink::mojom::ControllerServiceWorkerInfoPtr controller_service_worker_info, ::network::mojom::URLLoaderFactoryPtr prefetch_loader_factory, const base::UnguessableToken& devtools_navigation_token, CommitNavigationCallback callback) {
  GetForwardingInterface()->CommitNavigation(std::move(head), std::move(common_params), std::move(request_params), std::move(url_loader_client_endpoints), std::move(subresource_loader_factories), std::move(subresource_overrides), std::move(controller_service_worker_info), std::move(prefetch_loader_factory), std::move(devtools_navigation_token), std::move(callback));
}
void FrameNavigationControlInterceptorForTesting::CommitFailedNavigation(const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, bool has_stale_copy_in_cache, int32_t error_code, const base::Optional<std::string>& error_page_content, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, CommitFailedNavigationCallback callback) {
  GetForwardingInterface()->CommitFailedNavigation(std::move(common_params), std::move(request_params), std::move(has_stale_copy_in_cache), std::move(error_code), std::move(error_page_content), std::move(subresource_loader_factories), std::move(callback));
}
void FrameNavigationControlInterceptorForTesting::CommitSameDocumentNavigation(const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, CommitSameDocumentNavigationCallback callback) {
  GetForwardingInterface()->CommitSameDocumentNavigation(std::move(common_params), std::move(request_params), std::move(callback));
}
void FrameNavigationControlInterceptorForTesting::HandleRendererDebugURL(const GURL& url) {
  GetForwardingInterface()->HandleRendererDebugURL(std::move(url));
}
void FrameNavigationControlInterceptorForTesting::UpdateSubresourceLoaderFactories(std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories) {
  GetForwardingInterface()->UpdateSubresourceLoaderFactories(std::move(subresource_loader_factories));
}
void FrameNavigationControlInterceptorForTesting::BindDevToolsAgent(::blink::mojom::DevToolsAgentHostAssociatedPtrInfo agent_host, ::blink::mojom::DevToolsAgentAssociatedRequest agent) {
  GetForwardingInterface()->BindDevToolsAgent(std::move(agent_host), std::move(agent));
}
FrameNavigationControlAsyncWaiter::FrameNavigationControlAsyncWaiter(
    FrameNavigationControl* proxy) : proxy_(proxy) {}

FrameNavigationControlAsyncWaiter::~FrameNavigationControlAsyncWaiter() = default;

void FrameNavigationControlAsyncWaiter::CommitNavigation(
    const network::ResourceResponseHead& head, const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, ::network::mojom::URLLoaderClientEndpointsPtr url_loader_client_endpoints, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, base::Optional<std::vector<::content::mojom::TransferrableURLLoaderPtr>> subresource_overrides, ::blink::mojom::ControllerServiceWorkerInfoPtr controller_service_worker_info, ::network::mojom::URLLoaderFactoryPtr prefetch_loader_factory, const base::UnguessableToken& devtools_navigation_token, ::blink::mojom::CommitResult* out_commit_result) {
  base::RunLoop loop;
  proxy_->CommitNavigation(std::move(head),std::move(common_params),std::move(request_params),std::move(url_loader_client_endpoints),std::move(subresource_loader_factories),std::move(subresource_overrides),std::move(controller_service_worker_info),std::move(prefetch_loader_factory),std::move(devtools_navigation_token),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::blink::mojom::CommitResult* out_commit_result
,
             ::blink::mojom::CommitResult commit_result) {*out_commit_result = std::move(commit_result);
            loop->Quit();
          },
          &loop,
          out_commit_result));
  loop.Run();
}
void FrameNavigationControlAsyncWaiter::CommitFailedNavigation(
    const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, bool has_stale_copy_in_cache, int32_t error_code, const base::Optional<std::string>& error_page_content, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, ::blink::mojom::CommitResult* out_commit_result) {
  base::RunLoop loop;
  proxy_->CommitFailedNavigation(std::move(common_params),std::move(request_params),std::move(has_stale_copy_in_cache),std::move(error_code),std::move(error_page_content),std::move(subresource_loader_factories),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::blink::mojom::CommitResult* out_commit_result
,
             ::blink::mojom::CommitResult commit_result) {*out_commit_result = std::move(commit_result);
            loop->Quit();
          },
          &loop,
          out_commit_result));
  loop.Run();
}
void FrameNavigationControlAsyncWaiter::CommitSameDocumentNavigation(
    const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, ::blink::mojom::CommitResult* out_commit_result) {
  base::RunLoop loop;
  proxy_->CommitSameDocumentNavigation(std::move(common_params),std::move(request_params),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::blink::mojom::CommitResult* out_commit_result
,
             ::blink::mojom::CommitResult commit_result) {*out_commit_result = std::move(commit_result);
            loop->Quit();
          },
          &loop,
          out_commit_result));
  loop.Run();
}



void FrameBindingsControlInterceptorForTesting::AllowBindings(int32_t enabled_bindings_flags) {
  GetForwardingInterface()->AllowBindings(std::move(enabled_bindings_flags));
}
FrameBindingsControlAsyncWaiter::FrameBindingsControlAsyncWaiter(
    FrameBindingsControl* proxy) : proxy_(proxy) {}

FrameBindingsControlAsyncWaiter::~FrameBindingsControlAsyncWaiter() = default;




void FrameFactoryInterceptorForTesting::CreateFrame(int32_t frame_routing_id, FrameRequest frame) {
  GetForwardingInterface()->CreateFrame(std::move(frame_routing_id), std::move(frame));
}
FrameFactoryAsyncWaiter::FrameFactoryAsyncWaiter(
    FrameFactory* proxy) : proxy_(proxy) {}

FrameFactoryAsyncWaiter::~FrameFactoryAsyncWaiter() = default;




KeepAliveHandleAsyncWaiter::KeepAliveHandleAsyncWaiter(
    KeepAliveHandle* proxy) : proxy_(proxy) {}

KeepAliveHandleAsyncWaiter::~KeepAliveHandleAsyncWaiter() = default;




void FrameHostInterceptorForTesting::CreateNewWindow(CreateNewWindowParamsPtr params, CreateNewWindowCallback callback) {
  GetForwardingInterface()->CreateNewWindow(std::move(params), std::move(callback));
}
void FrameHostInterceptorForTesting::CreatePortal(::blink::mojom::PortalRequest portal, CreatePortalCallback callback) {
  GetForwardingInterface()->CreatePortal(std::move(portal), std::move(callback));
}
void FrameHostInterceptorForTesting::IssueKeepAliveHandle(KeepAliveHandleRequest keep_alive_handle) {
  GetForwardingInterface()->IssueKeepAliveHandle(std::move(keep_alive_handle));
}
void FrameHostInterceptorForTesting::DidCommitProvisionalLoad(std::unique_ptr<::FrameHostMsg_DidCommitProvisionalLoad_Params> params, DidCommitProvisionalLoadInterfaceParamsPtr interface_params) {
  GetForwardingInterface()->DidCommitProvisionalLoad(std::move(params), std::move(interface_params));
}
void FrameHostInterceptorForTesting::DidCommitSameDocumentNavigation(std::unique_ptr<::FrameHostMsg_DidCommitProvisionalLoad_Params> params) {
  GetForwardingInterface()->DidCommitSameDocumentNavigation(std::move(params));
}
void FrameHostInterceptorForTesting::BeginNavigation(const content::CommonNavigationParams& common_params, ::content::mojom::BeginNavigationParamsPtr begin_params, ::blink::mojom::BlobURLTokenPtr blob_url_token, ::content::mojom::NavigationClientAssociatedPtrInfo navigation_client, ::blink::mojom::NavigationInitiatorPtr navigation_initiator) {
  GetForwardingInterface()->BeginNavigation(std::move(common_params), std::move(begin_params), std::move(blob_url_token), std::move(navigation_client), std::move(navigation_initiator));
}
void FrameHostInterceptorForTesting::SubresourceResponseStarted(const GURL& url, uint32_t cert_status) {
  GetForwardingInterface()->SubresourceResponseStarted(std::move(url), std::move(cert_status));
}
void FrameHostInterceptorForTesting::ResourceLoadComplete(::content::mojom::ResourceLoadInfoPtr url_load_info) {
  GetForwardingInterface()->ResourceLoadComplete(std::move(url_load_info));
}
void FrameHostInterceptorForTesting::DidChangeName(const std::string& name, const std::string& unique_name) {
  GetForwardingInterface()->DidChangeName(std::move(name), std::move(unique_name));
}
void FrameHostInterceptorForTesting::EnforceInsecureRequestPolicy(uint8_t policy_bitmap) {
  GetForwardingInterface()->EnforceInsecureRequestPolicy(std::move(policy_bitmap));
}
void FrameHostInterceptorForTesting::EnforceInsecureNavigationsSet(const std::vector<uint32_t>& set) {
  GetForwardingInterface()->EnforceInsecureNavigationsSet(std::move(set));
}
void FrameHostInterceptorForTesting::DidSetFramePolicyHeaders(blink::WebSandboxFlags sandbox_flags, const std::vector<blink::ParsedFeaturePolicyDeclaration>& parsed_header) {
  GetForwardingInterface()->DidSetFramePolicyHeaders(std::move(sandbox_flags), std::move(parsed_header));
}
void FrameHostInterceptorForTesting::CancelInitialHistoryLoad() {
  GetForwardingInterface()->CancelInitialHistoryLoad();
}
void FrameHostInterceptorForTesting::UpdateEncoding(const std::string& encoding_name) {
  GetForwardingInterface()->UpdateEncoding(std::move(encoding_name));
}
void FrameHostInterceptorForTesting::FrameSizeChanged(const gfx::Size& size) {
  GetForwardingInterface()->FrameSizeChanged(std::move(size));
}
void FrameHostInterceptorForTesting::FullscreenStateChanged(bool is_fullscreen) {
  GetForwardingInterface()->FullscreenStateChanged(std::move(is_fullscreen));
}
FrameHostAsyncWaiter::FrameHostAsyncWaiter(
    FrameHost* proxy) : proxy_(proxy) {}

FrameHostAsyncWaiter::~FrameHostAsyncWaiter() = default;

void FrameHostAsyncWaiter::CreateNewWindow(
    CreateNewWindowParamsPtr params, CreateNewWindowStatus* out_status, CreateNewWindowReplyPtr* out_reply) {
  base::RunLoop loop;
  proxy_->CreateNewWindow(std::move(params),
      base::BindOnce(
          [](base::RunLoop* loop,
             CreateNewWindowStatus* out_status
,
             CreateNewWindowReplyPtr* out_reply
,
             CreateNewWindowStatus status,
             CreateNewWindowReplyPtr reply) {*out_status = std::move(status);*out_reply = std::move(reply);
            loop->Quit();
          },
          &loop,
          out_status,
          out_reply));
  loop.Run();
}
void FrameHostAsyncWaiter::CreatePortal(
    ::blink::mojom::PortalRequest portal, int32_t* out_proxy_routing_id, base::UnguessableToken* out_portal_token) {
  base::RunLoop loop;
  proxy_->CreatePortal(std::move(portal),
      base::BindOnce(
          [](base::RunLoop* loop,
             int32_t* out_proxy_routing_id
,
             base::UnguessableToken* out_portal_token
,
             int32_t proxy_routing_id,
             const base::UnguessableToken& portal_token) {*out_proxy_routing_id = std::move(proxy_routing_id);*out_portal_token = std::move(portal_token);
            loop->Quit();
          },
          &loop,
          out_proxy_routing_id,
          out_portal_token));
  loop.Run();
}





}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif