// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_IMAGE_DOWNLOADER_IMAGE_DOWNLOADER_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_IMAGE_DOWNLOADER_IMAGE_DOWNLOADER_MOJOM_TEST_UTILS_H_

#include "content/common/image_downloader/image_downloader.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT ImageDownloaderInterceptorForTesting : public ImageDownloader {
  virtual ImageDownloader* GetForwardingInterface() = 0;
  void DownloadImage(const GURL& url, bool is_favicon, uint32_t max_bitmap_size, bool bypass_cache, DownloadImageCallback callback) override;
};
class CONTENT_EXPORT ImageDownloaderAsyncWaiter {
 public:
  explicit ImageDownloaderAsyncWaiter(ImageDownloader* proxy);
  ~ImageDownloaderAsyncWaiter();
  void DownloadImage(
      const GURL& url, bool is_favicon, uint32_t max_bitmap_size, bool bypass_cache, int32_t* out_http_status_code, std::vector<SkBitmap>* out_images, std::vector<gfx::Size>* out_original_image_sizes);

 private:
  ImageDownloader* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ImageDownloaderAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_IMAGE_DOWNLOADER_IMAGE_DOWNLOADER_MOJOM_TEST_UTILS_H_