// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "content/common/media/peer_connection_tracker.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef CONTENT_COMMON_MEDIA_PEER_CONNECTION_TRACKER_MOJOM_JUMBO_H_
#define CONTENT_COMMON_MEDIA_PEER_CONNECTION_TRACKER_MOJOM_JUMBO_H_
#endif


namespace content {
namespace mojom {


void PeerConnectionTrackerHostInterceptorForTesting::RemovePeerConnection(int32_t lid) {
  GetForwardingInterface()->RemovePeerConnection(std::move(lid));
}
void PeerConnectionTrackerHostInterceptorForTesting::UpdatePeerConnection(int32_t lid, const std::string& type, const std::string& value) {
  GetForwardingInterface()->UpdatePeerConnection(std::move(lid), std::move(type), std::move(value));
}
void PeerConnectionTrackerHostInterceptorForTesting::GetUserMedia(const std::string& origin, bool audio, bool video, const std::string& audio_constraints, const std::string& video_constraints) {
  GetForwardingInterface()->GetUserMedia(std::move(origin), std::move(audio), std::move(video), std::move(audio_constraints), std::move(video_constraints));
}
void PeerConnectionTrackerHostInterceptorForTesting::WebRtcEventLogWrite(int32_t lid, const std::string& output) {
  GetForwardingInterface()->WebRtcEventLogWrite(std::move(lid), std::move(output));
}
PeerConnectionTrackerHostAsyncWaiter::PeerConnectionTrackerHostAsyncWaiter(
    PeerConnectionTrackerHost* proxy) : proxy_(proxy) {}

PeerConnectionTrackerHostAsyncWaiter::~PeerConnectionTrackerHostAsyncWaiter() = default;






}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif