// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "content/common/render_frame_message_filter.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_JUMBO_H_
#define CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_JUMBO_H_
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace content {
namespace mojom {


void RenderFrameMessageFilterInterceptorForTesting::SetCookie(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, const std::string& cookie, SetCookieCallback callback) {
  GetForwardingInterface()->SetCookie(std::move(render_frame_id), std::move(url), std::move(first_party_for_cookies), std::move(cookie), std::move(callback));
}
void RenderFrameMessageFilterInterceptorForTesting::GetCookies(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, GetCookiesCallback callback) {
  GetForwardingInterface()->GetCookies(std::move(render_frame_id), std::move(url), std::move(first_party_for_cookies), std::move(callback));
}
RenderFrameMessageFilterAsyncWaiter::RenderFrameMessageFilterAsyncWaiter(
    RenderFrameMessageFilter* proxy) : proxy_(proxy) {}

RenderFrameMessageFilterAsyncWaiter::~RenderFrameMessageFilterAsyncWaiter() = default;

void RenderFrameMessageFilterAsyncWaiter::SetCookie(
    int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, const std::string& cookie) {
  base::RunLoop loop;
  proxy_->SetCookie(std::move(render_frame_id),std::move(url),std::move(first_party_for_cookies),std::move(cookie),
      base::BindOnce(
          [](base::RunLoop* loop) {
            loop->Quit();
          },
          &loop));
  loop.Run();
}
void RenderFrameMessageFilterAsyncWaiter::GetCookies(
    int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, std::string* out_cookies) {
  base::RunLoop loop;
  proxy_->GetCookies(std::move(render_frame_id),std::move(url),std::move(first_party_for_cookies),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::string* out_cookies
,
             const std::string& cookies) {*out_cookies = std::move(cookies);
            loop->Quit();
          },
          &loop,
          out_cookies));
  loop.Run();
}





}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif