// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDER_WIDGET_WINDOW_TREE_CLIENT_FACTORY_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_RENDER_WIDGET_WINDOW_TREE_CLIENT_FACTORY_MOJOM_TEST_UTILS_H_

#include "content/common/render_widget_window_tree_client_factory.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT RenderWidgetWindowTreeClientInterceptorForTesting : public RenderWidgetWindowTreeClient {
  virtual RenderWidgetWindowTreeClient* GetForwardingInterface() = 0;
  void Embed(uint32_t frame_routing_id, const base::UnguessableToken& token) override;
  void DestroyFrame(uint32_t frame_routing_id) override;
};
class CONTENT_EXPORT RenderWidgetWindowTreeClientAsyncWaiter {
 public:
  explicit RenderWidgetWindowTreeClientAsyncWaiter(RenderWidgetWindowTreeClient* proxy);
  ~RenderWidgetWindowTreeClientAsyncWaiter();

 private:
  RenderWidgetWindowTreeClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RenderWidgetWindowTreeClientAsyncWaiter);
};


class CONTENT_EXPORT RenderWidgetWindowTreeClientFactoryInterceptorForTesting : public RenderWidgetWindowTreeClientFactory {
  virtual RenderWidgetWindowTreeClientFactory* GetForwardingInterface() = 0;
  void CreateWindowTreeClientForRenderWidget(uint32_t render_widget_host_routing_id, ::ws::mojom::WindowTreeClientRequest window_tree_client, RenderWidgetWindowTreeClientRequest render_widget_window_tree_client_request) override;
};
class CONTENT_EXPORT RenderWidgetWindowTreeClientFactoryAsyncWaiter {
 public:
  explicit RenderWidgetWindowTreeClientFactoryAsyncWaiter(RenderWidgetWindowTreeClientFactory* proxy);
  ~RenderWidgetWindowTreeClientFactoryAsyncWaiter();

 private:
  RenderWidgetWindowTreeClientFactory* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RenderWidgetWindowTreeClientFactoryAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_RENDER_WIDGET_WINDOW_TREE_CLIENT_FACTORY_MOJOM_TEST_UTILS_H_