// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDERER_HOST_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_RENDERER_HOST_MOJOM_TEST_UTILS_H_

#include "content/common/renderer_host.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT RendererHostInterceptorForTesting : public RendererHost {
  virtual RendererHost* GetForwardingInterface() = 0;
  void GetBrowserHistogram(const std::string& name, GetBrowserHistogramCallback callback) override;
  void SuddenTerminationChanged(bool enabled) override;
};
class CONTENT_EXPORT RendererHostAsyncWaiter {
 public:
  explicit RendererHostAsyncWaiter(RendererHost* proxy);
  ~RendererHostAsyncWaiter();
  void GetBrowserHistogram(
      const std::string& name, std::string* out_histogram_json);

 private:
  RendererHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RendererHostAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_RENDERER_HOST_MOJOM_TEST_UTILS_H_