// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "content/common/shared_worker/shared_worker_factory.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef CONTENT_COMMON_SHARED_WORKER_SHARED_WORKER_FACTORY_MOJOM_JUMBO_H_
#define CONTENT_COMMON_SHARED_WORKER_SHARED_WORKER_FACTORY_MOJOM_JUMBO_H_
#include "content/public/common/common_param_traits_macros.h"
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "services/network/public/cpp/network_ipc_param_traits.h"
#include "third_party/blink/public/common/loader/url_loader_factory_bundle_mojom_traits.h"
#include "url/mojom/origin_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace content {
namespace mojom {


void SharedWorkerFactoryInterceptorForTesting::CreateSharedWorker(::blink::mojom::SharedWorkerInfoPtr info, bool pause_on_start, const base::UnguessableToken& devtools_worker_token, const content::RendererPreferences& renderer_preferences, ::content::mojom::RendererPreferenceWatcherRequest preference_watcher_request, ::blink::mojom::WorkerContentSettingsProxyPtr content_settings, ::blink::mojom::ServiceWorkerProviderInfoForSharedWorkerPtr service_worker_provider_info, int32_t appcache_host_id, ::network::mojom::URLLoaderFactoryAssociatedPtrInfo main_script_loader_factory, ::blink::mojom::WorkerMainScriptLoadParamsPtr main_script_load_params, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, ::blink::mojom::ControllerServiceWorkerInfoPtr controller_info, ::blink::mojom::SharedWorkerHostPtr host, ::blink::mojom::SharedWorkerRequest shared_worker, ::service_manager::mojom::InterfaceProviderPtr interface_provider) {
  GetForwardingInterface()->CreateSharedWorker(std::move(info), std::move(pause_on_start), std::move(devtools_worker_token), std::move(renderer_preferences), std::move(preference_watcher_request), std::move(content_settings), std::move(service_worker_provider_info), std::move(appcache_host_id), std::move(main_script_loader_factory), std::move(main_script_load_params), std::move(subresource_loader_factories), std::move(controller_info), std::move(host), std::move(shared_worker), std::move(interface_provider));
}
SharedWorkerFactoryAsyncWaiter::SharedWorkerFactoryAsyncWaiter(
    SharedWorkerFactory* proxy) : proxy_(proxy) {}

SharedWorkerFactoryAsyncWaiter::~SharedWorkerFactoryAsyncWaiter() = default;






}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif