// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_PUBLIC_COMMON_RENDERER_PREFERENCE_WATCHER_MOJOM_SHARED_H_
#define CONTENT_PUBLIC_COMMON_RENDERER_PREFERENCE_WATCHER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "content/public/common/renderer_preference_watcher.mojom-shared-internal.h"
#include "content/public/common/renderer_preferences.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace content {
namespace mojom {


}  // namespace mojom
}  // namespace content

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace content {
namespace mojom {
// Interface base classes. They are used for type safety check.
class RendererPreferenceWatcherInterfaceBase {};

using RendererPreferenceWatcherPtrDataView =
    mojo::InterfacePtrDataView<RendererPreferenceWatcherInterfaceBase>;
using RendererPreferenceWatcherRequestDataView =
    mojo::InterfaceRequestDataView<RendererPreferenceWatcherInterfaceBase>;
using RendererPreferenceWatcherAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<RendererPreferenceWatcherInterfaceBase>;
using RendererPreferenceWatcherAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<RendererPreferenceWatcherInterfaceBase>;
class RendererPreferenceWatcher_NotifyUpdate_ParamsDataView {
 public:
  RendererPreferenceWatcher_NotifyUpdate_ParamsDataView() {}

  RendererPreferenceWatcher_NotifyUpdate_ParamsDataView(
      internal::RendererPreferenceWatcher_NotifyUpdate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNewPrefsDataView(
      ::content::mojom::RendererPreferencesDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNewPrefs(UserType* output) {
    auto* pointer = data_->new_prefs.Get();
    return mojo::internal::Deserialize<::content::mojom::RendererPreferencesDataView>(
        pointer, output, context_);
  }
 private:
  internal::RendererPreferenceWatcher_NotifyUpdate_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace content

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace content {
namespace mojom {

inline void RendererPreferenceWatcher_NotifyUpdate_ParamsDataView::GetNewPrefsDataView(
    ::content::mojom::RendererPreferencesDataView* output) {
  auto pointer = data_->new_prefs.Get();
  *output = ::content::mojom::RendererPreferencesDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace content

#endif  // CONTENT_PUBLIC_COMMON_RENDERER_PREFERENCE_WATCHER_MOJOM_SHARED_H_