// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_PUBLIC_COMMON_RENDERER_PREFERENCE_WATCHER_MOJOM_TEST_UTILS_H_
#define CONTENT_PUBLIC_COMMON_RENDERER_PREFERENCE_WATCHER_MOJOM_TEST_UTILS_H_

#include "content/public/common/renderer_preference_watcher.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT RendererPreferenceWatcherInterceptorForTesting : public RendererPreferenceWatcher {
  virtual RendererPreferenceWatcher* GetForwardingInterface() = 0;
  void NotifyUpdate(const content::RendererPreferences& new_prefs) override;
};
class CONTENT_EXPORT RendererPreferenceWatcherAsyncWaiter {
 public:
  explicit RendererPreferenceWatcherAsyncWaiter(RendererPreferenceWatcher* proxy);
  ~RendererPreferenceWatcherAsyncWaiter();

 private:
  RendererPreferenceWatcher* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RendererPreferenceWatcherAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_PUBLIC_COMMON_RENDERER_PREFERENCE_WATCHER_MOJOM_TEST_UTILS_H_