// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "content/public/common/resource_type.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
namespace content {
namespace mojom {

std::ostream& operator<<(std::ostream& os, ResourceType value) {
  switch(value) {
    case ResourceType::RESOURCE_TYPE_MAIN_FRAME:
      return os << "ResourceType::RESOURCE_TYPE_MAIN_FRAME";
    case ResourceType::RESOURCE_TYPE_SUB_FRAME:
      return os << "ResourceType::RESOURCE_TYPE_SUB_FRAME";
    case ResourceType::RESOURCE_TYPE_STYLESHEET:
      return os << "ResourceType::RESOURCE_TYPE_STYLESHEET";
    case ResourceType::RESOURCE_TYPE_SCRIPT:
      return os << "ResourceType::RESOURCE_TYPE_SCRIPT";
    case ResourceType::RESOURCE_TYPE_IMAGE:
      return os << "ResourceType::RESOURCE_TYPE_IMAGE";
    case ResourceType::RESOURCE_TYPE_FONT_RESOURCE:
      return os << "ResourceType::RESOURCE_TYPE_FONT_RESOURCE";
    case ResourceType::RESOURCE_TYPE_SUB_RESOURCE:
      return os << "ResourceType::RESOURCE_TYPE_SUB_RESOURCE";
    case ResourceType::RESOURCE_TYPE_OBJECT:
      return os << "ResourceType::RESOURCE_TYPE_OBJECT";
    case ResourceType::RESOURCE_TYPE_MEDIA:
      return os << "ResourceType::RESOURCE_TYPE_MEDIA";
    case ResourceType::RESOURCE_TYPE_WORKER:
      return os << "ResourceType::RESOURCE_TYPE_WORKER";
    case ResourceType::RESOURCE_TYPE_SHARED_WORKER:
      return os << "ResourceType::RESOURCE_TYPE_SHARED_WORKER";
    case ResourceType::RESOURCE_TYPE_PREFETCH:
      return os << "ResourceType::RESOURCE_TYPE_PREFETCH";
    case ResourceType::RESOURCE_TYPE_FAVICON:
      return os << "ResourceType::RESOURCE_TYPE_FAVICON";
    case ResourceType::RESOURCE_TYPE_XHR:
      return os << "ResourceType::RESOURCE_TYPE_XHR";
    case ResourceType::RESOURCE_TYPE_PING:
      return os << "ResourceType::RESOURCE_TYPE_PING";
    case ResourceType::RESOURCE_TYPE_SERVICE_WORKER:
      return os << "ResourceType::RESOURCE_TYPE_SERVICE_WORKER";
    case ResourceType::RESOURCE_TYPE_CSP_REPORT:
      return os << "ResourceType::RESOURCE_TYPE_CSP_REPORT";
    case ResourceType::RESOURCE_TYPE_PLUGIN_RESOURCE:
      return os << "ResourceType::RESOURCE_TYPE_PLUGIN_RESOURCE";
    case ResourceType::RESOURCE_TYPE_LAST_TYPE:
      return os << "ResourceType::RESOURCE_TYPE_LAST_TYPE";
    default:
      return os << "Unknown ResourceType value: " << static_cast<int32_t>(value);
  }
}

namespace internal {

}  // namespace internal
}  // namespace mojom
}  // namespace content

#if defined(_MSC_VER)
#pragma warning(pop)
#endif