// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_PUBLIC_COMMON_RESOURCE_USAGE_REPORTER_MOJOM_TEST_UTILS_H_
#define CONTENT_PUBLIC_COMMON_RESOURCE_USAGE_REPORTER_MOJOM_TEST_UTILS_H_

#include "content/public/common/resource_usage_reporter.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT ResourceUsageReporterInterceptorForTesting : public ResourceUsageReporter {
  virtual ResourceUsageReporter* GetForwardingInterface() = 0;
  void GetUsageData(GetUsageDataCallback callback) override;
};
class CONTENT_EXPORT ResourceUsageReporterAsyncWaiter {
 public:
  explicit ResourceUsageReporterAsyncWaiter(ResourceUsageReporter* proxy);
  ~ResourceUsageReporterAsyncWaiter();
  void GetUsageData(
      ResourceUsageDataPtr* out_data);

 private:
  ResourceUsageReporter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ResourceUsageReporterAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_PUBLIC_COMMON_RESOURCE_USAGE_REPORTER_MOJOM_TEST_UTILS_H_