// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_MOJOM_SHARED_INTERNAL_H_
#define DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "device/usb/public/mojom/device.mojom-shared-internal.h"
#include "device/usb/public/mojom/device_enumeration_options.mojom-shared-internal.h"
#include "device/usb/public/mojom/device_manager_client.mojom-shared-internal.h"
#include "mojo/public/mojom/base/file.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data));
      new (data()) UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data>(index_);
    }
    UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data client;

 private:
  UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data();
  ~UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data) == 16,
              "Bad sizeof(UsbDeviceManager_EnumerateDevicesAndSetClient_Params_Data)");
class  UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data));
      new (data()) UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data>(index_);
    }
    UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::device::mojom::internal::UsbDeviceInfo_Data>>> results;

 private:
  UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data();
  ~UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data() = delete;
};
static_assert(sizeof(UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data) == 16,
              "Bad sizeof(UsbDeviceManager_EnumerateDevicesAndSetClient_ResponseParams_Data)");
class  UsbDeviceManager_GetDevices_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManager_GetDevices_Params_Data));
      new (data()) UsbDeviceManager_GetDevices_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManager_GetDevices_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManager_GetDevices_Params_Data>(index_);
    }
    UsbDeviceManager_GetDevices_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::UsbEnumerationOptions_Data> options;

 private:
  UsbDeviceManager_GetDevices_Params_Data();
  ~UsbDeviceManager_GetDevices_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManager_GetDevices_Params_Data) == 16,
              "Bad sizeof(UsbDeviceManager_GetDevices_Params_Data)");
class  UsbDeviceManager_GetDevices_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManager_GetDevices_ResponseParams_Data));
      new (data()) UsbDeviceManager_GetDevices_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManager_GetDevices_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManager_GetDevices_ResponseParams_Data>(index_);
    }
    UsbDeviceManager_GetDevices_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::device::mojom::internal::UsbDeviceInfo_Data>>> results;

 private:
  UsbDeviceManager_GetDevices_ResponseParams_Data();
  ~UsbDeviceManager_GetDevices_ResponseParams_Data() = delete;
};
static_assert(sizeof(UsbDeviceManager_GetDevices_ResponseParams_Data) == 16,
              "Bad sizeof(UsbDeviceManager_GetDevices_ResponseParams_Data)");
class  UsbDeviceManager_GetDevice_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManager_GetDevice_Params_Data));
      new (data()) UsbDeviceManager_GetDevice_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManager_GetDevice_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManager_GetDevice_Params_Data>(index_);
    }
    UsbDeviceManager_GetDevice_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> guid;
  mojo::internal::Handle_Data device_request;
  mojo::internal::Interface_Data device_client;
  uint8_t padfinal_[4];

 private:
  UsbDeviceManager_GetDevice_Params_Data();
  ~UsbDeviceManager_GetDevice_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManager_GetDevice_Params_Data) == 32,
              "Bad sizeof(UsbDeviceManager_GetDevice_Params_Data)");
class  UsbDeviceManager_SetClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManager_SetClient_Params_Data));
      new (data()) UsbDeviceManager_SetClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManager_SetClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManager_SetClient_Params_Data>(index_);
    }
    UsbDeviceManager_SetClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data client;

 private:
  UsbDeviceManager_SetClient_Params_Data();
  ~UsbDeviceManager_SetClient_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManager_SetClient_Params_Data) == 16,
              "Bad sizeof(UsbDeviceManager_SetClient_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_MOJOM_SHARED_INTERNAL_H_