// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_CLIENT_MOJOM_SHARED_INTERNAL_H_
#define DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_CLIENT_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "device/usb/public/mojom/device.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  UsbDeviceManagerClient_OnDeviceAdded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManagerClient_OnDeviceAdded_Params_Data));
      new (data()) UsbDeviceManagerClient_OnDeviceAdded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManagerClient_OnDeviceAdded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManagerClient_OnDeviceAdded_Params_Data>(index_);
    }
    UsbDeviceManagerClient_OnDeviceAdded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::UsbDeviceInfo_Data> device_info;

 private:
  UsbDeviceManagerClient_OnDeviceAdded_Params_Data();
  ~UsbDeviceManagerClient_OnDeviceAdded_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManagerClient_OnDeviceAdded_Params_Data) == 16,
              "Bad sizeof(UsbDeviceManagerClient_OnDeviceAdded_Params_Data)");
class  UsbDeviceManagerClient_OnDeviceRemoved_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManagerClient_OnDeviceRemoved_Params_Data));
      new (data()) UsbDeviceManagerClient_OnDeviceRemoved_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManagerClient_OnDeviceRemoved_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManagerClient_OnDeviceRemoved_Params_Data>(index_);
    }
    UsbDeviceManagerClient_OnDeviceRemoved_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::UsbDeviceInfo_Data> device_info;

 private:
  UsbDeviceManagerClient_OnDeviceRemoved_Params_Data();
  ~UsbDeviceManagerClient_OnDeviceRemoved_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManagerClient_OnDeviceRemoved_Params_Data) == 16,
              "Bad sizeof(UsbDeviceManagerClient_OnDeviceRemoved_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_CLIENT_MOJOM_SHARED_INTERNAL_H_