// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_TEST_MOJOM_SHARED_INTERNAL_H_
#define DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_TEST_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {
class TestDeviceInfo_Data;

#pragma pack(push, 1)
class  TestDeviceInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TestDeviceInfo_Data));
      new (data()) TestDeviceInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TestDeviceInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TestDeviceInfo_Data>(index_);
    }
    TestDeviceInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> guid;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::String_Data> serial_number;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> landing_page;

 private:
  TestDeviceInfo_Data();
  ~TestDeviceInfo_Data() = delete;
};
static_assert(sizeof(TestDeviceInfo_Data) == 40,
              "Bad sizeof(TestDeviceInfo_Data)");
// Used by TestDeviceInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct TestDeviceInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  TestDeviceInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~TestDeviceInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    TestDeviceInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    TestDeviceInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  UsbDeviceManagerTest_AddDeviceForTesting_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManagerTest_AddDeviceForTesting_Params_Data));
      new (data()) UsbDeviceManagerTest_AddDeviceForTesting_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManagerTest_AddDeviceForTesting_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManagerTest_AddDeviceForTesting_Params_Data>(index_);
    }
    UsbDeviceManagerTest_AddDeviceForTesting_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::String_Data> serial_number;
  mojo::internal::Pointer<mojo::internal::String_Data> landing_page;

 private:
  UsbDeviceManagerTest_AddDeviceForTesting_Params_Data();
  ~UsbDeviceManagerTest_AddDeviceForTesting_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManagerTest_AddDeviceForTesting_Params_Data) == 32,
              "Bad sizeof(UsbDeviceManagerTest_AddDeviceForTesting_Params_Data)");
class  UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data));
      new (data()) UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data>(index_);
    }
    UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<mojo::internal::String_Data> message;

 private:
  UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data();
  ~UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data() = delete;
};
static_assert(sizeof(UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data) == 24,
              "Bad sizeof(UsbDeviceManagerTest_AddDeviceForTesting_ResponseParams_Data)");
class  UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data));
      new (data()) UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data>(index_);
    }
    UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> guid;

 private:
  UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data();
  ~UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data) == 16,
              "Bad sizeof(UsbDeviceManagerTest_RemoveDeviceForTesting_Params_Data)");
class  UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data));
      new (data()) UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data>(index_);
    }
    UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data();
  ~UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data() = delete;
};
static_assert(sizeof(UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data) == 8,
              "Bad sizeof(UsbDeviceManagerTest_RemoveDeviceForTesting_ResponseParams_Data)");
class  UsbDeviceManagerTest_GetTestDevices_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManagerTest_GetTestDevices_Params_Data));
      new (data()) UsbDeviceManagerTest_GetTestDevices_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManagerTest_GetTestDevices_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManagerTest_GetTestDevices_Params_Data>(index_);
    }
    UsbDeviceManagerTest_GetTestDevices_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  UsbDeviceManagerTest_GetTestDevices_Params_Data();
  ~UsbDeviceManagerTest_GetTestDevices_Params_Data() = delete;
};
static_assert(sizeof(UsbDeviceManagerTest_GetTestDevices_Params_Data) == 8,
              "Bad sizeof(UsbDeviceManagerTest_GetTestDevices_Params_Data)");
class  UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data));
      new (data()) UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data>(index_);
    }
    UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::TestDeviceInfo_Data>>> devices;

 private:
  UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data();
  ~UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data() = delete;
};
static_assert(sizeof(UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data) == 16,
              "Bad sizeof(UsbDeviceManagerTest_GetTestDevices_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // DEVICE_USB_PUBLIC_MOJOM_DEVICE_MANAGER_TEST_MOJOM_SHARED_INTERNAL_H_