// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "device/vr/public/mojom/vr_service.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {
class XRRuntimeSessionOptions_Data;
class XRGamepadButton_Data;
class XRGamepad_Data;
class XRGamepadData_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeSessionOptions_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeSessionOptions_Data));
      new (data()) XRRuntimeSessionOptions_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeSessionOptions_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeSessionOptions_Data>(index_);
    }
    XRRuntimeSessionOptions_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t immersive : 1;
  uint8_t environment_integration : 1;
  uint8_t has_user_activation : 1;
  uint8_t use_legacy_webvr_render_path : 1;
  uint8_t pad3_[3];
  int32_t render_process_id;
  int32_t render_frame_id;
  uint8_t padfinal_[4];

 private:
  XRRuntimeSessionOptions_Data();
  ~XRRuntimeSessionOptions_Data() = delete;
};
static_assert(sizeof(XRRuntimeSessionOptions_Data) == 24,
              "Bad sizeof(XRRuntimeSessionOptions_Data)");
// Used by XRRuntimeSessionOptions::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct XRRuntimeSessionOptions_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  XRRuntimeSessionOptions_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~XRRuntimeSessionOptions_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    XRRuntimeSessionOptions_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    XRRuntimeSessionOptions_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRGamepadButton_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRGamepadButton_Data));
      new (data()) XRGamepadButton_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRGamepadButton_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRGamepadButton_Data>(index_);
    }
    XRGamepadButton_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t pressed : 1;
  uint8_t touched : 1;
  uint8_t pad1_[7];
  double value;

 private:
  XRGamepadButton_Data();
  ~XRGamepadButton_Data() = delete;
};
static_assert(sizeof(XRGamepadButton_Data) == 24,
              "Bad sizeof(XRGamepadButton_Data)");
// Used by XRGamepadButton::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct XRGamepadButton_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  XRGamepadButton_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~XRGamepadButton_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    XRGamepadButton_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    XRGamepadButton_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRGamepad_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRGamepad_Data));
      new (data()) XRGamepad_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRGamepad_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRGamepad_Data>(index_);
    }
    XRGamepad_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t can_provide_orientation : 1;
  uint8_t can_provide_position : 1;
  uint8_t pad1_[3];
  int32_t hand;
  mojo::internal::Pointer<mojo::internal::Array_Data<double>> axes;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::XRGamepadButton_Data>>> buttons;
  mojo::internal::Pointer<::device::mojom::internal::VRPose_Data> pose;
  uint32_t controller_id;
  uint8_t pad6_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeTicks_Data> timestamp;

 private:
  XRGamepad_Data();
  ~XRGamepad_Data() = delete;
};
static_assert(sizeof(XRGamepad_Data) == 56,
              "Bad sizeof(XRGamepad_Data)");
// Used by XRGamepad::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct XRGamepad_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  XRGamepad_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~XRGamepad_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    XRGamepad_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    XRGamepad_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRGamepadData_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRGamepadData_Data));
      new (data()) XRGamepadData_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRGamepadData_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRGamepadData_Data>(index_);
    }
    XRGamepadData_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::XRGamepad_Data>>> gamepads;

 private:
  XRGamepadData_Data();
  ~XRGamepadData_Data() = delete;
};
static_assert(sizeof(XRGamepadData_Data) == 16,
              "Bad sizeof(XRGamepadData_Data)");
// Used by XRGamepadData::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct XRGamepadData_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  XRGamepadData_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~XRGamepadData_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    XRGamepadData_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    XRGamepadData_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRSessionController_SetFrameDataRestricted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRSessionController_SetFrameDataRestricted_Params_Data));
      new (data()) XRSessionController_SetFrameDataRestricted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRSessionController_SetFrameDataRestricted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRSessionController_SetFrameDataRestricted_Params_Data>(index_);
    }
    XRSessionController_SetFrameDataRestricted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t restricted : 1;
  uint8_t padfinal_[7];

 private:
  XRSessionController_SetFrameDataRestricted_Params_Data();
  ~XRSessionController_SetFrameDataRestricted_Params_Data() = delete;
};
static_assert(sizeof(XRSessionController_SetFrameDataRestricted_Params_Data) == 16,
              "Bad sizeof(XRSessionController_SetFrameDataRestricted_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data));
      new (data()) XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data>(index_);
    }
    XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::VRDisplayInfo_Data> display_info;

 private:
  XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data();
  ~XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data) == 16,
              "Bad sizeof(XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnDeviceActivated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnDeviceActivated_Params_Data));
      new (data()) XRRuntimeEventListener_OnDeviceActivated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnDeviceActivated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnDeviceActivated_Params_Data>(index_);
    }
    XRRuntimeEventListener_OnDeviceActivated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t reason;
  uint8_t padfinal_[4];

 private:
  XRRuntimeEventListener_OnDeviceActivated_Params_Data();
  ~XRRuntimeEventListener_OnDeviceActivated_Params_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnDeviceActivated_Params_Data) == 16,
              "Bad sizeof(XRRuntimeEventListener_OnDeviceActivated_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data));
      new (data()) XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data>(index_);
    }
    XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t will_not_present : 1;
  uint8_t padfinal_[7];

 private:
  XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data();
  ~XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data) == 16,
              "Bad sizeof(XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnDeviceIdle_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnDeviceIdle_Params_Data));
      new (data()) XRRuntimeEventListener_OnDeviceIdle_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnDeviceIdle_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnDeviceIdle_Params_Data>(index_);
    }
    XRRuntimeEventListener_OnDeviceIdle_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t reason;
  uint8_t padfinal_[4];

 private:
  XRRuntimeEventListener_OnDeviceIdle_Params_Data();
  ~XRRuntimeEventListener_OnDeviceIdle_Params_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnDeviceIdle_Params_Data) == 16,
              "Bad sizeof(XRRuntimeEventListener_OnDeviceIdle_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnExitPresent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnExitPresent_Params_Data));
      new (data()) XRRuntimeEventListener_OnExitPresent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnExitPresent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnExitPresent_Params_Data>(index_);
    }
    XRRuntimeEventListener_OnExitPresent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  XRRuntimeEventListener_OnExitPresent_Params_Data();
  ~XRRuntimeEventListener_OnExitPresent_Params_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnExitPresent_Params_Data) == 8,
              "Bad sizeof(XRRuntimeEventListener_OnExitPresent_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_RequestSession_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_RequestSession_Params_Data));
      new (data()) XRRuntime_RequestSession_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_RequestSession_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_RequestSession_Params_Data>(index_);
    }
    XRRuntime_RequestSession_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::XRRuntimeSessionOptions_Data> options;

 private:
  XRRuntime_RequestSession_Params_Data();
  ~XRRuntime_RequestSession_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_RequestSession_Params_Data) == 16,
              "Bad sizeof(XRRuntime_RequestSession_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_RequestSession_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_RequestSession_ResponseParams_Data));
      new (data()) XRRuntime_RequestSession_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_RequestSession_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_RequestSession_ResponseParams_Data>(index_);
    }
    XRRuntime_RequestSession_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::XRSession_Data> session;
  mojo::internal::Interface_Data controller;

 private:
  XRRuntime_RequestSession_ResponseParams_Data();
  ~XRRuntime_RequestSession_ResponseParams_Data() = delete;
};
static_assert(sizeof(XRRuntime_RequestSession_ResponseParams_Data) == 24,
              "Bad sizeof(XRRuntime_RequestSession_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_ListenToDeviceChanges_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_ListenToDeviceChanges_Params_Data));
      new (data()) XRRuntime_ListenToDeviceChanges_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_ListenToDeviceChanges_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_ListenToDeviceChanges_Params_Data>(index_);
    }
    XRRuntime_ListenToDeviceChanges_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data listener;

 private:
  XRRuntime_ListenToDeviceChanges_Params_Data();
  ~XRRuntime_ListenToDeviceChanges_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_ListenToDeviceChanges_Params_Data) == 16,
              "Bad sizeof(XRRuntime_ListenToDeviceChanges_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_ListenToDeviceChanges_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_ListenToDeviceChanges_ResponseParams_Data));
      new (data()) XRRuntime_ListenToDeviceChanges_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_ListenToDeviceChanges_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_ListenToDeviceChanges_ResponseParams_Data>(index_);
    }
    XRRuntime_ListenToDeviceChanges_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::VRDisplayInfo_Data> display_info;

 private:
  XRRuntime_ListenToDeviceChanges_ResponseParams_Data();
  ~XRRuntime_ListenToDeviceChanges_ResponseParams_Data() = delete;
};
static_assert(sizeof(XRRuntime_ListenToDeviceChanges_ResponseParams_Data) == 16,
              "Bad sizeof(XRRuntime_ListenToDeviceChanges_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_EnsureInitialized_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_EnsureInitialized_Params_Data));
      new (data()) XRRuntime_EnsureInitialized_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_EnsureInitialized_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_EnsureInitialized_Params_Data>(index_);
    }
    XRRuntime_EnsureInitialized_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t render_process_id;
  int32_t render_frame_id;

 private:
  XRRuntime_EnsureInitialized_Params_Data();
  ~XRRuntime_EnsureInitialized_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_EnsureInitialized_Params_Data) == 16,
              "Bad sizeof(XRRuntime_EnsureInitialized_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_EnsureInitialized_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_EnsureInitialized_ResponseParams_Data));
      new (data()) XRRuntime_EnsureInitialized_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_EnsureInitialized_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_EnsureInitialized_ResponseParams_Data>(index_);
    }
    XRRuntime_EnsureInitialized_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  XRRuntime_EnsureInitialized_ResponseParams_Data();
  ~XRRuntime_EnsureInitialized_ResponseParams_Data() = delete;
};
static_assert(sizeof(XRRuntime_EnsureInitialized_ResponseParams_Data) == 8,
              "Bad sizeof(XRRuntime_EnsureInitialized_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_SetListeningForActivate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_SetListeningForActivate_Params_Data));
      new (data()) XRRuntime_SetListeningForActivate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_SetListeningForActivate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_SetListeningForActivate_Params_Data>(index_);
    }
    XRRuntime_SetListeningForActivate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t listen_for_activation : 1;
  uint8_t padfinal_[7];

 private:
  XRRuntime_SetListeningForActivate_Params_Data();
  ~XRRuntime_SetListeningForActivate_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_SetListeningForActivate_Params_Data) == 16,
              "Bad sizeof(XRRuntime_SetListeningForActivate_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_SetInlinePosesEnabled_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_SetInlinePosesEnabled_Params_Data));
      new (data()) XRRuntime_SetInlinePosesEnabled_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_SetInlinePosesEnabled_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_SetInlinePosesEnabled_Params_Data>(index_);
    }
    XRRuntime_SetInlinePosesEnabled_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t enable : 1;
  uint8_t padfinal_[7];

 private:
  XRRuntime_SetInlinePosesEnabled_Params_Data();
  ~XRRuntime_SetInlinePosesEnabled_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_SetInlinePosesEnabled_Params_Data) == 16,
              "Bad sizeof(XRRuntime_SetInlinePosesEnabled_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) IsolatedXRGamepadProvider_RequestUpdate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IsolatedXRGamepadProvider_RequestUpdate_Params_Data));
      new (data()) IsolatedXRGamepadProvider_RequestUpdate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IsolatedXRGamepadProvider_RequestUpdate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IsolatedXRGamepadProvider_RequestUpdate_Params_Data>(index_);
    }
    IsolatedXRGamepadProvider_RequestUpdate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  IsolatedXRGamepadProvider_RequestUpdate_Params_Data();
  ~IsolatedXRGamepadProvider_RequestUpdate_Params_Data() = delete;
};
static_assert(sizeof(IsolatedXRGamepadProvider_RequestUpdate_Params_Data) == 8,
              "Bad sizeof(IsolatedXRGamepadProvider_RequestUpdate_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data));
      new (data()) IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data>(index_);
    }
    IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::XRGamepadData_Data> data;

 private:
  IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data();
  ~IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data() = delete;
};
static_assert(sizeof(IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data) == 16,
              "Bad sizeof(IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data));
      new (data()) IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data>(index_);
    }
    IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data provider;
  uint8_t padfinal_[4];

 private:
  IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data();
  ~IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data() = delete;
};
static_assert(sizeof(IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data) == 16,
              "Bad sizeof(IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) ImmersiveOverlay_RequestNextOverlayPose_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ImmersiveOverlay_RequestNextOverlayPose_Params_Data));
      new (data()) ImmersiveOverlay_RequestNextOverlayPose_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ImmersiveOverlay_RequestNextOverlayPose_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ImmersiveOverlay_RequestNextOverlayPose_Params_Data>(index_);
    }
    ImmersiveOverlay_RequestNextOverlayPose_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ImmersiveOverlay_RequestNextOverlayPose_Params_Data();
  ~ImmersiveOverlay_RequestNextOverlayPose_Params_Data() = delete;
};
static_assert(sizeof(ImmersiveOverlay_RequestNextOverlayPose_Params_Data) == 8,
              "Bad sizeof(ImmersiveOverlay_RequestNextOverlayPose_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data));
      new (data()) ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data>(index_);
    }
    ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::XRFrameData_Data> pose;

 private:
  ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data();
  ~ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data() = delete;
};
static_assert(sizeof(ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data) == 16,
              "Bad sizeof(ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) ImmersiveOverlay_SubmitOverlayTexture_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ImmersiveOverlay_SubmitOverlayTexture_Params_Data));
      new (data()) ImmersiveOverlay_SubmitOverlayTexture_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ImmersiveOverlay_SubmitOverlayTexture_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ImmersiveOverlay_SubmitOverlayTexture_Params_Data>(index_);
    }
    ImmersiveOverlay_SubmitOverlayTexture_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int16_t frame_id;
  uint8_t pad0_[2];
  mojo::internal::Handle_Data texture;
  mojo::internal::Pointer<::gfx::mojom::internal::RectF_Data> left_bounds;
  mojo::internal::Pointer<::gfx::mojom::internal::RectF_Data> right_bounds;

 private:
  ImmersiveOverlay_SubmitOverlayTexture_Params_Data();
  ~ImmersiveOverlay_SubmitOverlayTexture_Params_Data() = delete;
};
static_assert(sizeof(ImmersiveOverlay_SubmitOverlayTexture_Params_Data) == 32,
              "Bad sizeof(ImmersiveOverlay_SubmitOverlayTexture_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data));
      new (data()) ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data>(index_);
    }
    ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data();
  ~ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data() = delete;
};
static_assert(sizeof(ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data) == 16,
              "Bad sizeof(ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data));
      new (data()) ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data>(index_);
    }
    ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t overlay_visible : 1;
  uint8_t webxr_visible : 1;
  uint8_t padfinal_[7];

 private:
  ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data();
  ~ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data() = delete;
};
static_assert(sizeof(ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data) == 16,
              "Bad sizeof(ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRCompositorHost_CreateImmersiveOverlay_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRCompositorHost_CreateImmersiveOverlay_Params_Data));
      new (data()) XRCompositorHost_CreateImmersiveOverlay_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRCompositorHost_CreateImmersiveOverlay_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRCompositorHost_CreateImmersiveOverlay_Params_Data>(index_);
    }
    XRCompositorHost_CreateImmersiveOverlay_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data overlay;
  uint8_t padfinal_[4];

 private:
  XRCompositorHost_CreateImmersiveOverlay_Params_Data();
  ~XRCompositorHost_CreateImmersiveOverlay_Params_Data() = delete;
};
static_assert(sizeof(XRCompositorHost_CreateImmersiveOverlay_Params_Data) == 16,
              "Bad sizeof(XRCompositorHost_CreateImmersiveOverlay_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data));
      new (data()) IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data>(index_);
    }
    IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data runtime;
  mojo::internal::Interface_Data gamepad_factory;
  mojo::internal::Interface_Data compositor_host;
  int32_t device_id;
  uint8_t padfinal_[4];

 private:
  IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data();
  ~IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data() = delete;
};
static_assert(sizeof(IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data) == 40,
              "Bad sizeof(IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data));
      new (data()) IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data>(index_);
    }
    IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t device_index;
  uint8_t padfinal_[4];

 private:
  IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data();
  ~IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data() = delete;
};
static_assert(sizeof(IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data) == 16,
              "Bad sizeof(IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data));
      new (data()) IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data>(index_);
    }
    IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data();
  ~IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data() = delete;
};
static_assert(sizeof(IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data) == 8,
              "Bad sizeof(IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) IsolatedXRRuntimeProvider_RequestDevices_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IsolatedXRRuntimeProvider_RequestDevices_Params_Data));
      new (data()) IsolatedXRRuntimeProvider_RequestDevices_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IsolatedXRRuntimeProvider_RequestDevices_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IsolatedXRRuntimeProvider_RequestDevices_Params_Data>(index_);
    }
    IsolatedXRRuntimeProvider_RequestDevices_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client;

 private:
  IsolatedXRRuntimeProvider_RequestDevices_Params_Data();
  ~IsolatedXRRuntimeProvider_RequestDevices_Params_Data() = delete;
};
static_assert(sizeof(IsolatedXRRuntimeProvider_RequestDevices_Params_Data) == 16,
              "Bad sizeof(IsolatedXRRuntimeProvider_RequestDevices_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_INTERNAL_H_