// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_H_
#define DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "device/vr/public/mojom/isolated_xr_service.mojom-shared-internal.h"
#include "device/vr/public/mojom/vr_service.mojom-shared.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace device {
namespace mojom {
class XRRuntimeSessionOptionsDataView;

class XRGamepadButtonDataView;

class XRGamepadDataView;

class XRGamepadDataDataView;



}  // namespace mojom
}  // namespace device

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::device::mojom::XRRuntimeSessionOptionsDataView> {
  using Data = ::device::mojom::internal::XRRuntimeSessionOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::device::mojom::XRGamepadButtonDataView> {
  using Data = ::device::mojom::internal::XRGamepadButton_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::device::mojom::XRGamepadDataView> {
  using Data = ::device::mojom::internal::XRGamepad_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::device::mojom::XRGamepadDataDataView> {
  using Data = ::device::mojom::internal::XRGamepadData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace device {
namespace mojom {
// Interface base classes. They are used for type safety check.
class XRSessionControllerInterfaceBase {};

using XRSessionControllerPtrDataView =
    mojo::InterfacePtrDataView<XRSessionControllerInterfaceBase>;
using XRSessionControllerRequestDataView =
    mojo::InterfaceRequestDataView<XRSessionControllerInterfaceBase>;
using XRSessionControllerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<XRSessionControllerInterfaceBase>;
using XRSessionControllerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<XRSessionControllerInterfaceBase>;
class XRRuntimeEventListenerInterfaceBase {};

using XRRuntimeEventListenerPtrDataView =
    mojo::InterfacePtrDataView<XRRuntimeEventListenerInterfaceBase>;
using XRRuntimeEventListenerRequestDataView =
    mojo::InterfaceRequestDataView<XRRuntimeEventListenerInterfaceBase>;
using XRRuntimeEventListenerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<XRRuntimeEventListenerInterfaceBase>;
using XRRuntimeEventListenerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<XRRuntimeEventListenerInterfaceBase>;
class XRRuntimeInterfaceBase {};

using XRRuntimePtrDataView =
    mojo::InterfacePtrDataView<XRRuntimeInterfaceBase>;
using XRRuntimeRequestDataView =
    mojo::InterfaceRequestDataView<XRRuntimeInterfaceBase>;
using XRRuntimeAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<XRRuntimeInterfaceBase>;
using XRRuntimeAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<XRRuntimeInterfaceBase>;
class IsolatedXRGamepadProviderInterfaceBase {};

using IsolatedXRGamepadProviderPtrDataView =
    mojo::InterfacePtrDataView<IsolatedXRGamepadProviderInterfaceBase>;
using IsolatedXRGamepadProviderRequestDataView =
    mojo::InterfaceRequestDataView<IsolatedXRGamepadProviderInterfaceBase>;
using IsolatedXRGamepadProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IsolatedXRGamepadProviderInterfaceBase>;
using IsolatedXRGamepadProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IsolatedXRGamepadProviderInterfaceBase>;
class IsolatedXRGamepadProviderFactoryInterfaceBase {};

using IsolatedXRGamepadProviderFactoryPtrDataView =
    mojo::InterfacePtrDataView<IsolatedXRGamepadProviderFactoryInterfaceBase>;
using IsolatedXRGamepadProviderFactoryRequestDataView =
    mojo::InterfaceRequestDataView<IsolatedXRGamepadProviderFactoryInterfaceBase>;
using IsolatedXRGamepadProviderFactoryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IsolatedXRGamepadProviderFactoryInterfaceBase>;
using IsolatedXRGamepadProviderFactoryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IsolatedXRGamepadProviderFactoryInterfaceBase>;
class ImmersiveOverlayInterfaceBase {};

using ImmersiveOverlayPtrDataView =
    mojo::InterfacePtrDataView<ImmersiveOverlayInterfaceBase>;
using ImmersiveOverlayRequestDataView =
    mojo::InterfaceRequestDataView<ImmersiveOverlayInterfaceBase>;
using ImmersiveOverlayAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ImmersiveOverlayInterfaceBase>;
using ImmersiveOverlayAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ImmersiveOverlayInterfaceBase>;
class XRCompositorHostInterfaceBase {};

using XRCompositorHostPtrDataView =
    mojo::InterfacePtrDataView<XRCompositorHostInterfaceBase>;
using XRCompositorHostRequestDataView =
    mojo::InterfaceRequestDataView<XRCompositorHostInterfaceBase>;
using XRCompositorHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<XRCompositorHostInterfaceBase>;
using XRCompositorHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<XRCompositorHostInterfaceBase>;
class IsolatedXRRuntimeProviderClientInterfaceBase {};

using IsolatedXRRuntimeProviderClientPtrDataView =
    mojo::InterfacePtrDataView<IsolatedXRRuntimeProviderClientInterfaceBase>;
using IsolatedXRRuntimeProviderClientRequestDataView =
    mojo::InterfaceRequestDataView<IsolatedXRRuntimeProviderClientInterfaceBase>;
using IsolatedXRRuntimeProviderClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IsolatedXRRuntimeProviderClientInterfaceBase>;
using IsolatedXRRuntimeProviderClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IsolatedXRRuntimeProviderClientInterfaceBase>;
class IsolatedXRRuntimeProviderInterfaceBase {};

using IsolatedXRRuntimeProviderPtrDataView =
    mojo::InterfacePtrDataView<IsolatedXRRuntimeProviderInterfaceBase>;
using IsolatedXRRuntimeProviderRequestDataView =
    mojo::InterfaceRequestDataView<IsolatedXRRuntimeProviderInterfaceBase>;
using IsolatedXRRuntimeProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IsolatedXRRuntimeProviderInterfaceBase>;
using IsolatedXRRuntimeProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IsolatedXRRuntimeProviderInterfaceBase>;
class XRRuntimeSessionOptionsDataView {
 public:
  XRRuntimeSessionOptionsDataView() {}

  XRRuntimeSessionOptionsDataView(
      internal::XRRuntimeSessionOptions_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool immersive() const {
    return data_->immersive;
  }
  bool environment_integration() const {
    return data_->environment_integration;
  }
  int32_t render_process_id() const {
    return data_->render_process_id;
  }
  int32_t render_frame_id() const {
    return data_->render_frame_id;
  }
  bool has_user_activation() const {
    return data_->has_user_activation;
  }
  bool use_legacy_webvr_render_path() const {
    return data_->use_legacy_webvr_render_path;
  }
 private:
  internal::XRRuntimeSessionOptions_Data* data_ = nullptr;
};

class XRGamepadButtonDataView {
 public:
  XRGamepadButtonDataView() {}

  XRGamepadButtonDataView(
      internal::XRGamepadButton_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool pressed() const {
    return data_->pressed;
  }
  bool touched() const {
    return data_->touched;
  }
  double value() const {
    return data_->value;
  }
 private:
  internal::XRGamepadButton_Data* data_ = nullptr;
};

class XRGamepadDataView {
 public:
  XRGamepadDataView() {}

  XRGamepadDataView(
      internal::XRGamepad_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool can_provide_orientation() const {
    return data_->can_provide_orientation;
  }
  bool can_provide_position() const {
    return data_->can_provide_position;
  }
  inline void GetAxesDataView(
      mojo::ArrayDataView<double>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAxes(UserType* output) {
    auto* pointer = data_->axes.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<double>>(
        pointer, output, context_);
  }
  inline void GetButtonsDataView(
      mojo::ArrayDataView<XRGamepadButtonDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadButtons(UserType* output) {
    auto* pointer = data_->buttons.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::device::mojom::XRGamepadButtonDataView>>(
        pointer, output, context_);
  }
  inline void GetPoseDataView(
      ::device::mojom::VRPoseDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPose(UserType* output) {
    auto* pointer = data_->pose.Get();
    return mojo::internal::Deserialize<::device::mojom::VRPoseDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHand(UserType* output) const {
    auto data_value = data_->hand;
    return mojo::internal::Deserialize<::device::mojom::XRHandedness>(
        data_value, output);
  }

  ::device::mojom::XRHandedness hand() const {
    return static_cast<::device::mojom::XRHandedness>(data_->hand);
  }
  uint32_t controller_id() const {
    return data_->controller_id;
  }
  inline void GetTimestampDataView(
      ::mojo_base::mojom::TimeTicksDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTimestamp(UserType* output) {
    auto* pointer = data_->timestamp.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeTicksDataView>(
        pointer, output, context_);
  }
 private:
  internal::XRGamepad_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRGamepadDataDataView {
 public:
  XRGamepadDataDataView() {}

  XRGamepadDataDataView(
      internal::XRGamepadData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetGamepadsDataView(
      mojo::ArrayDataView<XRGamepadDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGamepads(UserType* output) {
    auto* pointer = data_->gamepads.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::device::mojom::XRGamepadDataView>>(
        pointer, output, context_);
  }
 private:
  internal::XRGamepadData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRSessionController_SetFrameDataRestricted_ParamsDataView {
 public:
  XRSessionController_SetFrameDataRestricted_ParamsDataView() {}

  XRSessionController_SetFrameDataRestricted_ParamsDataView(
      internal::XRSessionController_SetFrameDataRestricted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool restricted() const {
    return data_->restricted;
  }
 private:
  internal::XRSessionController_SetFrameDataRestricted_Params_Data* data_ = nullptr;
};

class XRRuntimeEventListener_OnDisplayInfoChanged_ParamsDataView {
 public:
  XRRuntimeEventListener_OnDisplayInfoChanged_ParamsDataView() {}

  XRRuntimeEventListener_OnDisplayInfoChanged_ParamsDataView(
      internal::XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDisplayInfoDataView(
      ::device::mojom::VRDisplayInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDisplayInfo(UserType* output) {
    auto* pointer = data_->display_info.Get();
    return mojo::internal::Deserialize<::device::mojom::VRDisplayInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntimeEventListener_OnDeviceActivated_ParamsDataView {
 public:
  XRRuntimeEventListener_OnDeviceActivated_ParamsDataView() {}

  XRRuntimeEventListener_OnDeviceActivated_ParamsDataView(
      internal::XRRuntimeEventListener_OnDeviceActivated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReason(UserType* output) const {
    auto data_value = data_->reason;
    return mojo::internal::Deserialize<::device::mojom::VRDisplayEventReason>(
        data_value, output);
  }

  ::device::mojom::VRDisplayEventReason reason() const {
    return static_cast<::device::mojom::VRDisplayEventReason>(data_->reason);
  }
 private:
  internal::XRRuntimeEventListener_OnDeviceActivated_Params_Data* data_ = nullptr;
};

class XRRuntimeEventListener_OnDeviceActivated_ResponseParamsDataView {
 public:
  XRRuntimeEventListener_OnDeviceActivated_ResponseParamsDataView() {}

  XRRuntimeEventListener_OnDeviceActivated_ResponseParamsDataView(
      internal::XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool will_not_present() const {
    return data_->will_not_present;
  }
 private:
  internal::XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data* data_ = nullptr;
};

class XRRuntimeEventListener_OnDeviceIdle_ParamsDataView {
 public:
  XRRuntimeEventListener_OnDeviceIdle_ParamsDataView() {}

  XRRuntimeEventListener_OnDeviceIdle_ParamsDataView(
      internal::XRRuntimeEventListener_OnDeviceIdle_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReason(UserType* output) const {
    auto data_value = data_->reason;
    return mojo::internal::Deserialize<::device::mojom::VRDisplayEventReason>(
        data_value, output);
  }

  ::device::mojom::VRDisplayEventReason reason() const {
    return static_cast<::device::mojom::VRDisplayEventReason>(data_->reason);
  }
 private:
  internal::XRRuntimeEventListener_OnDeviceIdle_Params_Data* data_ = nullptr;
};

class XRRuntimeEventListener_OnExitPresent_ParamsDataView {
 public:
  XRRuntimeEventListener_OnExitPresent_ParamsDataView() {}

  XRRuntimeEventListener_OnExitPresent_ParamsDataView(
      internal::XRRuntimeEventListener_OnExitPresent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::XRRuntimeEventListener_OnExitPresent_Params_Data* data_ = nullptr;
};

class XRRuntime_RequestSession_ParamsDataView {
 public:
  XRRuntime_RequestSession_ParamsDataView() {}

  XRRuntime_RequestSession_ParamsDataView(
      internal::XRRuntime_RequestSession_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetOptionsDataView(
      XRRuntimeSessionOptionsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOptions(UserType* output) {
    auto* pointer = data_->options.Get();
    return mojo::internal::Deserialize<::device::mojom::XRRuntimeSessionOptionsDataView>(
        pointer, output, context_);
  }
 private:
  internal::XRRuntime_RequestSession_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_RequestSession_ResponseParamsDataView {
 public:
  XRRuntime_RequestSession_ResponseParamsDataView() {}

  XRRuntime_RequestSession_ResponseParamsDataView(
      internal::XRRuntime_RequestSession_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSessionDataView(
      ::device::mojom::XRSessionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSession(UserType* output) {
    auto* pointer = data_->session.Get();
    return mojo::internal::Deserialize<::device::mojom::XRSessionDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeController() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::XRSessionControllerPtrDataView>(
            &data_->controller, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::XRRuntime_RequestSession_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_ListenToDeviceChanges_ParamsDataView {
 public:
  XRRuntime_ListenToDeviceChanges_ParamsDataView() {}

  XRRuntime_ListenToDeviceChanges_ParamsDataView(
      internal::XRRuntime_ListenToDeviceChanges_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeListener() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::XRRuntimeEventListenerAssociatedPtrInfoDataView>(
            &data_->listener, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::XRRuntime_ListenToDeviceChanges_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_ListenToDeviceChanges_ResponseParamsDataView {
 public:
  XRRuntime_ListenToDeviceChanges_ResponseParamsDataView() {}

  XRRuntime_ListenToDeviceChanges_ResponseParamsDataView(
      internal::XRRuntime_ListenToDeviceChanges_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDisplayInfoDataView(
      ::device::mojom::VRDisplayInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDisplayInfo(UserType* output) {
    auto* pointer = data_->display_info.Get();
    return mojo::internal::Deserialize<::device::mojom::VRDisplayInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::XRRuntime_ListenToDeviceChanges_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_EnsureInitialized_ParamsDataView {
 public:
  XRRuntime_EnsureInitialized_ParamsDataView() {}

  XRRuntime_EnsureInitialized_ParamsDataView(
      internal::XRRuntime_EnsureInitialized_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t render_process_id() const {
    return data_->render_process_id;
  }
  int32_t render_frame_id() const {
    return data_->render_frame_id;
  }
 private:
  internal::XRRuntime_EnsureInitialized_Params_Data* data_ = nullptr;
};

class XRRuntime_EnsureInitialized_ResponseParamsDataView {
 public:
  XRRuntime_EnsureInitialized_ResponseParamsDataView() {}

  XRRuntime_EnsureInitialized_ResponseParamsDataView(
      internal::XRRuntime_EnsureInitialized_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::XRRuntime_EnsureInitialized_ResponseParams_Data* data_ = nullptr;
};

class XRRuntime_SetListeningForActivate_ParamsDataView {
 public:
  XRRuntime_SetListeningForActivate_ParamsDataView() {}

  XRRuntime_SetListeningForActivate_ParamsDataView(
      internal::XRRuntime_SetListeningForActivate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool listen_for_activation() const {
    return data_->listen_for_activation;
  }
 private:
  internal::XRRuntime_SetListeningForActivate_Params_Data* data_ = nullptr;
};

class XRRuntime_SetInlinePosesEnabled_ParamsDataView {
 public:
  XRRuntime_SetInlinePosesEnabled_ParamsDataView() {}

  XRRuntime_SetInlinePosesEnabled_ParamsDataView(
      internal::XRRuntime_SetInlinePosesEnabled_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool enable() const {
    return data_->enable;
  }
 private:
  internal::XRRuntime_SetInlinePosesEnabled_Params_Data* data_ = nullptr;
};

class IsolatedXRGamepadProvider_RequestUpdate_ParamsDataView {
 public:
  IsolatedXRGamepadProvider_RequestUpdate_ParamsDataView() {}

  IsolatedXRGamepadProvider_RequestUpdate_ParamsDataView(
      internal::IsolatedXRGamepadProvider_RequestUpdate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IsolatedXRGamepadProvider_RequestUpdate_Params_Data* data_ = nullptr;
};

class IsolatedXRGamepadProvider_RequestUpdate_ResponseParamsDataView {
 public:
  IsolatedXRGamepadProvider_RequestUpdate_ResponseParamsDataView() {}

  IsolatedXRGamepadProvider_RequestUpdate_ResponseParamsDataView(
      internal::IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDataDataView(
      XRGamepadDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<::device::mojom::XRGamepadDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::IsolatedXRGamepadProvider_RequestUpdate_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_ParamsDataView {
 public:
  IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_ParamsDataView() {}

  IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_ParamsDataView(
      internal::IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeProvider() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::IsolatedXRGamepadProviderRequestDataView>(
            &data_->provider, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IsolatedXRGamepadProviderFactory_GetIsolatedXRGamepadProvider_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ImmersiveOverlay_RequestNextOverlayPose_ParamsDataView {
 public:
  ImmersiveOverlay_RequestNextOverlayPose_ParamsDataView() {}

  ImmersiveOverlay_RequestNextOverlayPose_ParamsDataView(
      internal::ImmersiveOverlay_RequestNextOverlayPose_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ImmersiveOverlay_RequestNextOverlayPose_Params_Data* data_ = nullptr;
};

class ImmersiveOverlay_RequestNextOverlayPose_ResponseParamsDataView {
 public:
  ImmersiveOverlay_RequestNextOverlayPose_ResponseParamsDataView() {}

  ImmersiveOverlay_RequestNextOverlayPose_ResponseParamsDataView(
      internal::ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPoseDataView(
      ::device::mojom::XRFrameDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPose(UserType* output) {
    auto* pointer = data_->pose.Get();
    return mojo::internal::Deserialize<::device::mojom::XRFrameDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::ImmersiveOverlay_RequestNextOverlayPose_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ImmersiveOverlay_SubmitOverlayTexture_ParamsDataView {
 public:
  ImmersiveOverlay_SubmitOverlayTexture_ParamsDataView() {}

  ImmersiveOverlay_SubmitOverlayTexture_ParamsDataView(
      internal::ImmersiveOverlay_SubmitOverlayTexture_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int16_t frame_id() const {
    return data_->frame_id;
  }
  mojo::ScopedHandle TakeTexture() {
    mojo::ScopedHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedHandle>(
            &data_->texture, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetLeftBoundsDataView(
      ::gfx::mojom::RectFDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLeftBounds(UserType* output) {
    auto* pointer = data_->left_bounds.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectFDataView>(
        pointer, output, context_);
  }
  inline void GetRightBoundsDataView(
      ::gfx::mojom::RectFDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRightBounds(UserType* output) {
    auto* pointer = data_->right_bounds.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectFDataView>(
        pointer, output, context_);
  }
 private:
  internal::ImmersiveOverlay_SubmitOverlayTexture_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ImmersiveOverlay_SubmitOverlayTexture_ResponseParamsDataView {
 public:
  ImmersiveOverlay_SubmitOverlayTexture_ResponseParamsDataView() {}

  ImmersiveOverlay_SubmitOverlayTexture_ResponseParamsDataView(
      internal::ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::ImmersiveOverlay_SubmitOverlayTexture_ResponseParams_Data* data_ = nullptr;
};

class ImmersiveOverlay_SetOverlayAndWebXRVisibility_ParamsDataView {
 public:
  ImmersiveOverlay_SetOverlayAndWebXRVisibility_ParamsDataView() {}

  ImmersiveOverlay_SetOverlayAndWebXRVisibility_ParamsDataView(
      internal::ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool overlay_visible() const {
    return data_->overlay_visible;
  }
  bool webxr_visible() const {
    return data_->webxr_visible;
  }
 private:
  internal::ImmersiveOverlay_SetOverlayAndWebXRVisibility_Params_Data* data_ = nullptr;
};

class XRCompositorHost_CreateImmersiveOverlay_ParamsDataView {
 public:
  XRCompositorHost_CreateImmersiveOverlay_ParamsDataView() {}

  XRCompositorHost_CreateImmersiveOverlay_ParamsDataView(
      internal::XRCompositorHost_CreateImmersiveOverlay_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeOverlay() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::ImmersiveOverlayRequestDataView>(
            &data_->overlay, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::XRCompositorHost_CreateImmersiveOverlay_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IsolatedXRRuntimeProviderClient_OnDeviceAdded_ParamsDataView {
 public:
  IsolatedXRRuntimeProviderClient_OnDeviceAdded_ParamsDataView() {}

  IsolatedXRRuntimeProviderClient_OnDeviceAdded_ParamsDataView(
      internal::IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRuntime() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::XRRuntimePtrDataView>(
            &data_->runtime, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeGamepadFactory() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::IsolatedXRGamepadProviderFactoryPtrDataView>(
            &data_->gamepad_factory, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeCompositorHost() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::XRCompositorHostPtrDataView>(
            &data_->compositor_host, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDeviceId(UserType* output) const {
    auto data_value = data_->device_id;
    return mojo::internal::Deserialize<::device::mojom::XRDeviceId>(
        data_value, output);
  }

  ::device::mojom::XRDeviceId device_id() const {
    return static_cast<::device::mojom::XRDeviceId>(data_->device_id);
  }
 private:
  internal::IsolatedXRRuntimeProviderClient_OnDeviceAdded_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IsolatedXRRuntimeProviderClient_OnDeviceRemoved_ParamsDataView {
 public:
  IsolatedXRRuntimeProviderClient_OnDeviceRemoved_ParamsDataView() {}

  IsolatedXRRuntimeProviderClient_OnDeviceRemoved_ParamsDataView(
      internal::IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDeviceIndex(UserType* output) const {
    auto data_value = data_->device_index;
    return mojo::internal::Deserialize<::device::mojom::XRDeviceId>(
        data_value, output);
  }

  ::device::mojom::XRDeviceId device_index() const {
    return static_cast<::device::mojom::XRDeviceId>(data_->device_index);
  }
 private:
  internal::IsolatedXRRuntimeProviderClient_OnDeviceRemoved_Params_Data* data_ = nullptr;
};

class IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_ParamsDataView {
 public:
  IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_ParamsDataView() {}

  IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_ParamsDataView(
      internal::IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IsolatedXRRuntimeProviderClient_OnDevicesEnumerated_Params_Data* data_ = nullptr;
};

class IsolatedXRRuntimeProvider_RequestDevices_ParamsDataView {
 public:
  IsolatedXRRuntimeProvider_RequestDevices_ParamsDataView() {}

  IsolatedXRRuntimeProvider_RequestDevices_ParamsDataView(
      internal::IsolatedXRRuntimeProvider_RequestDevices_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::IsolatedXRRuntimeProviderClientPtrDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IsolatedXRRuntimeProvider_RequestDevices_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace device

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::XRRuntimeSessionOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::device::mojom::XRRuntimeSessionOptionsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::device::mojom::internal::XRRuntimeSessionOptions_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->immersive = CallWithContext(Traits::immersive, input, custom_context);
    (*output)->environment_integration = CallWithContext(Traits::environment_integration, input, custom_context);
    (*output)->render_process_id = CallWithContext(Traits::render_process_id, input, custom_context);
    (*output)->render_frame_id = CallWithContext(Traits::render_frame_id, input, custom_context);
    (*output)->has_user_activation = CallWithContext(Traits::has_user_activation, input, custom_context);
    (*output)->use_legacy_webvr_render_path = CallWithContext(Traits::use_legacy_webvr_render_path, input, custom_context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::device::mojom::internal::XRRuntimeSessionOptions_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::device::mojom::XRRuntimeSessionOptionsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::XRGamepadButtonDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::device::mojom::XRGamepadButtonDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::device::mojom::internal::XRGamepadButton_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->pressed = CallWithContext(Traits::pressed, input, custom_context);
    (*output)->touched = CallWithContext(Traits::touched, input, custom_context);
    (*output)->value = CallWithContext(Traits::value, input, custom_context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::device::mojom::internal::XRGamepadButton_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::device::mojom::XRGamepadButtonDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::XRGamepadDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::device::mojom::XRGamepadDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::device::mojom::internal::XRGamepad_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->can_provide_orientation = CallWithContext(Traits::can_provide_orientation, input, custom_context);
    (*output)->can_provide_position = CallWithContext(Traits::can_provide_position, input, custom_context);
    decltype(CallWithContext(Traits::axes, input, custom_context)) in_axes = CallWithContext(Traits::axes, input, custom_context);
    typename decltype((*output)->axes)::BaseType::BufferWriter
        axes_writer;
    const mojo::internal::ContainerValidateParams axes_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<double>>(
        in_axes, buffer, &axes_writer, &axes_validate_params,
        context);
    (*output)->axes.Set(
        axes_writer.is_null() ? nullptr : axes_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->axes.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null axes in XRGamepad struct");
    decltype(CallWithContext(Traits::buttons, input, custom_context)) in_buttons = CallWithContext(Traits::buttons, input, custom_context);
    typename decltype((*output)->buttons)::BaseType::BufferWriter
        buttons_writer;
    const mojo::internal::ContainerValidateParams buttons_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::device::mojom::XRGamepadButtonDataView>>(
        in_buttons, buffer, &buttons_writer, &buttons_validate_params,
        context);
    (*output)->buttons.Set(
        buttons_writer.is_null() ? nullptr : buttons_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->buttons.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null buttons in XRGamepad struct");
    decltype(CallWithContext(Traits::pose, input, custom_context)) in_pose = CallWithContext(Traits::pose, input, custom_context);
    typename decltype((*output)->pose)::BaseType::BufferWriter
        pose_writer;
    mojo::internal::Serialize<::device::mojom::VRPoseDataView>(
        in_pose, buffer, &pose_writer, context);
    (*output)->pose.Set(
        pose_writer.is_null() ? nullptr : pose_writer.data());
    mojo::internal::Serialize<::device::mojom::XRHandedness>(
        CallWithContext(Traits::hand, input, custom_context), &(*output)->hand);
    (*output)->controller_id = CallWithContext(Traits::controller_id, input, custom_context);
    decltype(CallWithContext(Traits::timestamp, input, custom_context)) in_timestamp = CallWithContext(Traits::timestamp, input, custom_context);
    typename decltype((*output)->timestamp)::BaseType::BufferWriter
        timestamp_writer;
    mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
        in_timestamp, buffer, &timestamp_writer, context);
    (*output)->timestamp.Set(
        timestamp_writer.is_null() ? nullptr : timestamp_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->timestamp.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null timestamp in XRGamepad struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::device::mojom::internal::XRGamepad_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::device::mojom::XRGamepadDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::XRGamepadDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::device::mojom::XRGamepadDataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::device::mojom::internal::XRGamepadData_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::gamepads, input, custom_context)) in_gamepads = CallWithContext(Traits::gamepads, input, custom_context);
    typename decltype((*output)->gamepads)::BaseType::BufferWriter
        gamepads_writer;
    const mojo::internal::ContainerValidateParams gamepads_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::device::mojom::XRGamepadDataView>>(
        in_gamepads, buffer, &gamepads_writer, &gamepads_validate_params,
        context);
    (*output)->gamepads.Set(
        gamepads_writer.is_null() ? nullptr : gamepads_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->gamepads.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null gamepads in XRGamepadData struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::device::mojom::internal::XRGamepadData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::device::mojom::XRGamepadDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace device {
namespace mojom {





inline void XRGamepadDataView::GetAxesDataView(
    mojo::ArrayDataView<double>* output) {
  auto pointer = data_->axes.Get();
  *output = mojo::ArrayDataView<double>(pointer, context_);
}
inline void XRGamepadDataView::GetButtonsDataView(
    mojo::ArrayDataView<XRGamepadButtonDataView>* output) {
  auto pointer = data_->buttons.Get();
  *output = mojo::ArrayDataView<XRGamepadButtonDataView>(pointer, context_);
}
inline void XRGamepadDataView::GetPoseDataView(
    ::device::mojom::VRPoseDataView* output) {
  auto pointer = data_->pose.Get();
  *output = ::device::mojom::VRPoseDataView(pointer, context_);
}
inline void XRGamepadDataView::GetTimestampDataView(
    ::mojo_base::mojom::TimeTicksDataView* output) {
  auto pointer = data_->timestamp.Get();
  *output = ::mojo_base::mojom::TimeTicksDataView(pointer, context_);
}


inline void XRGamepadDataDataView::GetGamepadsDataView(
    mojo::ArrayDataView<XRGamepadDataView>* output) {
  auto pointer = data_->gamepads.Get();
  *output = mojo::ArrayDataView<XRGamepadDataView>(pointer, context_);
}




inline void XRRuntimeEventListener_OnDisplayInfoChanged_ParamsDataView::GetDisplayInfoDataView(
    ::device::mojom::VRDisplayInfoDataView* output) {
  auto pointer = data_->display_info.Get();
  *output = ::device::mojom::VRDisplayInfoDataView(pointer, context_);
}










inline void XRRuntime_RequestSession_ParamsDataView::GetOptionsDataView(
    XRRuntimeSessionOptionsDataView* output) {
  auto pointer = data_->options.Get();
  *output = XRRuntimeSessionOptionsDataView(pointer, context_);
}


inline void XRRuntime_RequestSession_ResponseParamsDataView::GetSessionDataView(
    ::device::mojom::XRSessionDataView* output) {
  auto pointer = data_->session.Get();
  *output = ::device::mojom::XRSessionDataView(pointer, context_);
}




inline void XRRuntime_ListenToDeviceChanges_ResponseParamsDataView::GetDisplayInfoDataView(
    ::device::mojom::VRDisplayInfoDataView* output) {
  auto pointer = data_->display_info.Get();
  *output = ::device::mojom::VRDisplayInfoDataView(pointer, context_);
}












inline void IsolatedXRGamepadProvider_RequestUpdate_ResponseParamsDataView::GetDataDataView(
    XRGamepadDataDataView* output) {
  auto pointer = data_->data.Get();
  *output = XRGamepadDataDataView(pointer, context_);
}






inline void ImmersiveOverlay_RequestNextOverlayPose_ResponseParamsDataView::GetPoseDataView(
    ::device::mojom::XRFrameDataDataView* output) {
  auto pointer = data_->pose.Get();
  *output = ::device::mojom::XRFrameDataDataView(pointer, context_);
}


inline void ImmersiveOverlay_SubmitOverlayTexture_ParamsDataView::GetLeftBoundsDataView(
    ::gfx::mojom::RectFDataView* output) {
  auto pointer = data_->left_bounds.Get();
  *output = ::gfx::mojom::RectFDataView(pointer, context_);
}
inline void ImmersiveOverlay_SubmitOverlayTexture_ParamsDataView::GetRightBoundsDataView(
    ::gfx::mojom::RectFDataView* output) {
  auto pointer = data_->right_bounds.Get();
  *output = ::gfx::mojom::RectFDataView(pointer, context_);
}

















}  // namespace mojom
}  // namespace device

#endif  // DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_H_