// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "extensions/common/mojo/guest_view.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_JUMBO_H_
#define EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_JUMBO_H_
#include "services/network/public/cpp/network_ipc_param_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace extensions {
namespace mojom {


void GuestViewInterceptorForTesting::CreateEmbeddedMimeHandlerViewGuest(int32_t render_frame_id, int32_t tab_id, const GURL& original_url, int32_t element_instance_id, const gfx::Size& element_size, ::content::mojom::TransferrableURLLoaderPtr transferrable_url_loader, int32_t plugin_frame_id) {
  GetForwardingInterface()->CreateEmbeddedMimeHandlerViewGuest(std::move(render_frame_id), std::move(tab_id), std::move(original_url), std::move(element_instance_id), std::move(element_size), std::move(transferrable_url_loader), std::move(plugin_frame_id));
}
void GuestViewInterceptorForTesting::CreateMimeHandlerViewGuest(int32_t render_frame_id, const std::string& view_id, int32_t element_instance_id, const gfx::Size& element_size, ::extensions::mime_handler::BeforeUnloadControlPtr before_unload_control, int32_t plugin_frame_id) {
  GetForwardingInterface()->CreateMimeHandlerViewGuest(std::move(render_frame_id), std::move(view_id), std::move(element_instance_id), std::move(element_size), std::move(before_unload_control), std::move(plugin_frame_id));
}
GuestViewAsyncWaiter::GuestViewAsyncWaiter(
    GuestView* proxy) : proxy_(proxy) {}

GuestViewAsyncWaiter::~GuestViewAsyncWaiter() = default;






}  // namespace mojom
}  // namespace extensions

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif