// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_TEST_UTILS_H_
#define EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_TEST_UTILS_H_

#include "extensions/common/mojo/guest_view.mojom.h"


namespace extensions {
namespace mojom {


class  GuestViewInterceptorForTesting : public GuestView {
  virtual GuestView* GetForwardingInterface() = 0;
  void CreateEmbeddedMimeHandlerViewGuest(int32_t render_frame_id, int32_t tab_id, const GURL& original_url, int32_t element_instance_id, const gfx::Size& element_size, ::content::mojom::TransferrableURLLoaderPtr transferrable_url_loader, int32_t plugin_frame_id) override;
  void CreateMimeHandlerViewGuest(int32_t render_frame_id, const std::string& view_id, int32_t element_instance_id, const gfx::Size& element_size, ::extensions::mime_handler::BeforeUnloadControlPtr before_unload_control, int32_t plugin_frame_id) override;
};
class  GuestViewAsyncWaiter {
 public:
  explicit GuestViewAsyncWaiter(GuestView* proxy);
  ~GuestViewAsyncWaiter();

 private:
  GuestView* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(GuestViewAsyncWaiter);
};




}  // namespace mojom
}  // namespace extensions

#endif  // EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_TEST_UTILS_H_