// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MIDI_MIDI_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define MEDIA_MIDI_MIDI_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace midi {
namespace mojom {
namespace internal {
class PortInfo_Data;

struct Result_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct PortState_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  PortInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PortInfo_Data));
      new (data()) PortInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PortInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PortInfo_Data>(index_);
    }
    PortInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> id;
  mojo::internal::Pointer<mojo::internal::String_Data> manufacturer;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::String_Data> version;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  PortInfo_Data();
  ~PortInfo_Data() = delete;
};
static_assert(sizeof(PortInfo_Data) == 48,
              "Bad sizeof(PortInfo_Data)");
// Used by PortInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct PortInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  PortInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~PortInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    PortInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    PortInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  MidiSessionClient_AddInputPort_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSessionClient_AddInputPort_Params_Data));
      new (data()) MidiSessionClient_AddInputPort_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSessionClient_AddInputPort_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSessionClient_AddInputPort_Params_Data>(index_);
    }
    MidiSessionClient_AddInputPort_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PortInfo_Data> info;

 private:
  MidiSessionClient_AddInputPort_Params_Data();
  ~MidiSessionClient_AddInputPort_Params_Data() = delete;
};
static_assert(sizeof(MidiSessionClient_AddInputPort_Params_Data) == 16,
              "Bad sizeof(MidiSessionClient_AddInputPort_Params_Data)");
class  MidiSessionClient_AddOutputPort_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSessionClient_AddOutputPort_Params_Data));
      new (data()) MidiSessionClient_AddOutputPort_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSessionClient_AddOutputPort_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSessionClient_AddOutputPort_Params_Data>(index_);
    }
    MidiSessionClient_AddOutputPort_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PortInfo_Data> info;

 private:
  MidiSessionClient_AddOutputPort_Params_Data();
  ~MidiSessionClient_AddOutputPort_Params_Data() = delete;
};
static_assert(sizeof(MidiSessionClient_AddOutputPort_Params_Data) == 16,
              "Bad sizeof(MidiSessionClient_AddOutputPort_Params_Data)");
class  MidiSessionClient_SetInputPortState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSessionClient_SetInputPortState_Params_Data));
      new (data()) MidiSessionClient_SetInputPortState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSessionClient_SetInputPortState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSessionClient_SetInputPortState_Params_Data>(index_);
    }
    MidiSessionClient_SetInputPortState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t port;
  int32_t state;

 private:
  MidiSessionClient_SetInputPortState_Params_Data();
  ~MidiSessionClient_SetInputPortState_Params_Data() = delete;
};
static_assert(sizeof(MidiSessionClient_SetInputPortState_Params_Data) == 16,
              "Bad sizeof(MidiSessionClient_SetInputPortState_Params_Data)");
class  MidiSessionClient_SetOutputPortState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSessionClient_SetOutputPortState_Params_Data));
      new (data()) MidiSessionClient_SetOutputPortState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSessionClient_SetOutputPortState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSessionClient_SetOutputPortState_Params_Data>(index_);
    }
    MidiSessionClient_SetOutputPortState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t port;
  int32_t state;

 private:
  MidiSessionClient_SetOutputPortState_Params_Data();
  ~MidiSessionClient_SetOutputPortState_Params_Data() = delete;
};
static_assert(sizeof(MidiSessionClient_SetOutputPortState_Params_Data) == 16,
              "Bad sizeof(MidiSessionClient_SetOutputPortState_Params_Data)");
class  MidiSessionClient_SessionStarted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSessionClient_SessionStarted_Params_Data));
      new (data()) MidiSessionClient_SessionStarted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSessionClient_SessionStarted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSessionClient_SessionStarted_Params_Data>(index_);
    }
    MidiSessionClient_SessionStarted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  MidiSessionClient_SessionStarted_Params_Data();
  ~MidiSessionClient_SessionStarted_Params_Data() = delete;
};
static_assert(sizeof(MidiSessionClient_SessionStarted_Params_Data) == 16,
              "Bad sizeof(MidiSessionClient_SessionStarted_Params_Data)");
class  MidiSessionClient_AcknowledgeSentData_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSessionClient_AcknowledgeSentData_Params_Data));
      new (data()) MidiSessionClient_AcknowledgeSentData_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSessionClient_AcknowledgeSentData_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSessionClient_AcknowledgeSentData_Params_Data>(index_);
    }
    MidiSessionClient_AcknowledgeSentData_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t bytes;
  uint8_t padfinal_[4];

 private:
  MidiSessionClient_AcknowledgeSentData_Params_Data();
  ~MidiSessionClient_AcknowledgeSentData_Params_Data() = delete;
};
static_assert(sizeof(MidiSessionClient_AcknowledgeSentData_Params_Data) == 16,
              "Bad sizeof(MidiSessionClient_AcknowledgeSentData_Params_Data)");
class  MidiSessionClient_DataReceived_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSessionClient_DataReceived_Params_Data));
      new (data()) MidiSessionClient_DataReceived_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSessionClient_DataReceived_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSessionClient_DataReceived_Params_Data>(index_);
    }
    MidiSessionClient_DataReceived_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t port;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> data;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeTicks_Data> timestamp;

 private:
  MidiSessionClient_DataReceived_Params_Data();
  ~MidiSessionClient_DataReceived_Params_Data() = delete;
};
static_assert(sizeof(MidiSessionClient_DataReceived_Params_Data) == 32,
              "Bad sizeof(MidiSessionClient_DataReceived_Params_Data)");
class  MidiSessionProvider_StartSession_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSessionProvider_StartSession_Params_Data));
      new (data()) MidiSessionProvider_StartSession_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSessionProvider_StartSession_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSessionProvider_StartSession_Params_Data>(index_);
    }
    MidiSessionProvider_StartSession_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  mojo::internal::Interface_Data client;
  uint8_t padfinal_[4];

 private:
  MidiSessionProvider_StartSession_Params_Data();
  ~MidiSessionProvider_StartSession_Params_Data() = delete;
};
static_assert(sizeof(MidiSessionProvider_StartSession_Params_Data) == 24,
              "Bad sizeof(MidiSessionProvider_StartSession_Params_Data)");
class  MidiSession_SendData_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MidiSession_SendData_Params_Data));
      new (data()) MidiSession_SendData_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MidiSession_SendData_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MidiSession_SendData_Params_Data>(index_);
    }
    MidiSession_SendData_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t port;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> data;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeTicks_Data> timestamp;

 private:
  MidiSession_SendData_Params_Data();
  ~MidiSession_SendData_Params_Data() = delete;
};
static_assert(sizeof(MidiSession_SendData_Params_Data) == 32,
              "Bad sizeof(MidiSession_SendData_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace midi

#endif  // MEDIA_MIDI_MIDI_SERVICE_MOJOM_SHARED_INTERNAL_H_