// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "media/mojo/interfaces/jpeg_encode_accelerator.mojom-blink-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef MEDIA_MOJO_INTERFACES_JPEG_ENCODE_ACCELERATOR_MOJOM_BLINK_JUMBO_H_
#define MEDIA_MOJO_INTERFACES_JPEG_ENCODE_ACCELERATOR_MOJOM_BLINK_JUMBO_H_
#endif


namespace media {
namespace mojom {
namespace blink {


void JpegEncodeAcceleratorInterceptorForTesting::Initialize(InitializeCallback callback) {
  GetForwardingInterface()->Initialize(std::move(callback));
}
void JpegEncodeAcceleratorInterceptorForTesting::EncodeWithFD(int32_t buffer_id, mojo::ScopedHandle input_fd, uint32_t input_buffer_size, int32_t coded_size_width, int32_t coded_size_height, mojo::ScopedHandle exif_fd, uint32_t exif_buffer_size, mojo::ScopedHandle output_fd, uint32_t output_buffer_size, EncodeWithFDCallback callback) {
  GetForwardingInterface()->EncodeWithFD(std::move(buffer_id), std::move(input_fd), std::move(input_buffer_size), std::move(coded_size_width), std::move(coded_size_height), std::move(exif_fd), std::move(exif_buffer_size), std::move(output_fd), std::move(output_buffer_size), std::move(callback));
}
JpegEncodeAcceleratorAsyncWaiter::JpegEncodeAcceleratorAsyncWaiter(
    JpegEncodeAccelerator* proxy) : proxy_(proxy) {}

JpegEncodeAcceleratorAsyncWaiter::~JpegEncodeAcceleratorAsyncWaiter() = default;

void JpegEncodeAcceleratorAsyncWaiter::Initialize(
    bool* out_success) {
  base::RunLoop loop;
  proxy_->Initialize(
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}
void JpegEncodeAcceleratorAsyncWaiter::EncodeWithFD(
    int32_t buffer_id, mojo::ScopedHandle input_fd, uint32_t input_buffer_size, int32_t coded_size_width, int32_t coded_size_height, mojo::ScopedHandle exif_fd, uint32_t exif_buffer_size, mojo::ScopedHandle output_fd, uint32_t output_buffer_size, int32_t* out_buffer_id, uint32_t* out_encoded_buffer_size, EncodeStatus* out_status) {
  base::RunLoop loop;
  proxy_->EncodeWithFD(std::move(buffer_id),std::move(input_fd),std::move(input_buffer_size),std::move(coded_size_width),std::move(coded_size_height),std::move(exif_fd),std::move(exif_buffer_size),std::move(output_fd),std::move(output_buffer_size),
      base::BindOnce(
          [](base::RunLoop* loop,
             int32_t* out_buffer_id
,
             uint32_t* out_encoded_buffer_size
,
             EncodeStatus* out_status
,
             int32_t buffer_id,
             uint32_t encoded_buffer_size,
             EncodeStatus status) {*out_buffer_id = std::move(buffer_id);*out_encoded_buffer_size = std::move(encoded_buffer_size);*out_status = std::move(status);
            loop->Quit();
          },
          &loop,
          out_buffer_id,
          out_encoded_buffer_size,
          out_status));
  loop.Run();
}





}  // namespace blink
}  // namespace mojom
}  // namespace media

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif