// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_INTERFACES_JPEG_ENCODE_ACCELERATOR_MOJOM_BLINK_TEST_UTILS_H_
#define MEDIA_MOJO_INTERFACES_JPEG_ENCODE_ACCELERATOR_MOJOM_BLINK_TEST_UTILS_H_

#include "media/mojo/interfaces/jpeg_encode_accelerator.mojom-blink.h"


namespace media {
namespace mojom {
namespace blink {


class  JpegEncodeAcceleratorInterceptorForTesting : public JpegEncodeAccelerator {
  virtual JpegEncodeAccelerator* GetForwardingInterface() = 0;
  void Initialize(InitializeCallback callback) override;
  void EncodeWithFD(int32_t buffer_id, mojo::ScopedHandle input_fd, uint32_t input_buffer_size, int32_t coded_size_width, int32_t coded_size_height, mojo::ScopedHandle exif_fd, uint32_t exif_buffer_size, mojo::ScopedHandle output_fd, uint32_t output_buffer_size, EncodeWithFDCallback callback) override;
};
class  JpegEncodeAcceleratorAsyncWaiter {
 public:
  explicit JpegEncodeAcceleratorAsyncWaiter(JpegEncodeAccelerator* proxy);
  ~JpegEncodeAcceleratorAsyncWaiter();
  void Initialize(
      bool* out_success);
  void EncodeWithFD(
      int32_t buffer_id, mojo::ScopedHandle input_fd, uint32_t input_buffer_size, int32_t coded_size_width, int32_t coded_size_height, mojo::ScopedHandle exif_fd, uint32_t exif_buffer_size, mojo::ScopedHandle output_fd, uint32_t output_buffer_size, int32_t* out_buffer_id, uint32_t* out_encoded_buffer_size, EncodeStatus* out_status);

 private:
  JpegEncodeAccelerator* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(JpegEncodeAcceleratorAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace media

#endif  // MEDIA_MOJO_INTERFACES_JPEG_ENCODE_ACCELERATOR_MOJOM_BLINK_TEST_UTILS_H_