// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This is a generated file. Please see the "service_manifest" template in
// src/services/service_manager/public/service_manifest.gni for more details.

#include "media/mojo/services/media_manifest.h"

#include <set>

#include "base/files/file_path.h"
#include "base/no_destructor.h"
#include "build/build_config.h"
#include "services/service_manager/public/cpp/manifest_builder.h"




namespace media {


const service_manager::Manifest& GetManifest() {
  static base::NoDestructor<service_manager::Manifest> manifest{
      service_manager::ManifestBuilder()
          .WithServiceName("media")
          .WithDisplayName("Media Service")
          .WithOptions(service_manager::ManifestOptionsBuilder()
                           .Build())
          .ExposeCapability(
              "media:media", std::set<const char*>{
                  "media.mojom.MediaService",})
          .RequireCapability("chromecast", "multizone")
          .RequireCapability("*", "app")
          .Build() };
  return *manifest;
}

}  // namespace media
