// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_SHARED_INTERNAL_H_
#define QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace qtwebchannel {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  WebChannelTransportRender_SetWorldId_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebChannelTransportRender_SetWorldId_Params_Data));
      new (data()) WebChannelTransportRender_SetWorldId_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebChannelTransportRender_SetWorldId_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebChannelTransportRender_SetWorldId_Params_Data>(index_);
    }
    WebChannelTransportRender_SetWorldId_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t worldId;
  uint8_t padfinal_[4];

 private:
  WebChannelTransportRender_SetWorldId_Params_Data();
  ~WebChannelTransportRender_SetWorldId_Params_Data() = delete;
};
static_assert(sizeof(WebChannelTransportRender_SetWorldId_Params_Data) == 16,
              "Bad sizeof(WebChannelTransportRender_SetWorldId_Params_Data)");
class  WebChannelTransportRender_ResetWorldId_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebChannelTransportRender_ResetWorldId_Params_Data));
      new (data()) WebChannelTransportRender_ResetWorldId_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebChannelTransportRender_ResetWorldId_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebChannelTransportRender_ResetWorldId_Params_Data>(index_);
    }
    WebChannelTransportRender_ResetWorldId_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WebChannelTransportRender_ResetWorldId_Params_Data();
  ~WebChannelTransportRender_ResetWorldId_Params_Data() = delete;
};
static_assert(sizeof(WebChannelTransportRender_ResetWorldId_Params_Data) == 8,
              "Bad sizeof(WebChannelTransportRender_ResetWorldId_Params_Data)");
class  WebChannelTransportRender_DispatchWebChannelMessage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebChannelTransportRender_DispatchWebChannelMessage_Params_Data));
      new (data()) WebChannelTransportRender_DispatchWebChannelMessage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebChannelTransportRender_DispatchWebChannelMessage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebChannelTransportRender_DispatchWebChannelMessage_Params_Data>(index_);
    }
    WebChannelTransportRender_DispatchWebChannelMessage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> binaryJson;
  uint32_t worldId;
  uint8_t padfinal_[4];

 private:
  WebChannelTransportRender_DispatchWebChannelMessage_Params_Data();
  ~WebChannelTransportRender_DispatchWebChannelMessage_Params_Data() = delete;
};
static_assert(sizeof(WebChannelTransportRender_DispatchWebChannelMessage_Params_Data) == 24,
              "Bad sizeof(WebChannelTransportRender_DispatchWebChannelMessage_Params_Data)");
class  WebChannelTransportHost_DispatchWebChannelMessage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebChannelTransportHost_DispatchWebChannelMessage_Params_Data));
      new (data()) WebChannelTransportHost_DispatchWebChannelMessage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebChannelTransportHost_DispatchWebChannelMessage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebChannelTransportHost_DispatchWebChannelMessage_Params_Data>(index_);
    }
    WebChannelTransportHost_DispatchWebChannelMessage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> binaryJson;

 private:
  WebChannelTransportHost_DispatchWebChannelMessage_Params_Data();
  ~WebChannelTransportHost_DispatchWebChannelMessage_Params_Data() = delete;
};
static_assert(sizeof(WebChannelTransportHost_DispatchWebChannelMessage_Params_Data) == 16,
              "Bad sizeof(WebChannelTransportHost_DispatchWebChannelMessage_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace qtwebchannel

#endif  // QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_SHARED_INTERNAL_H_