// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_SHARED_H_
#define QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "qtwebengine/browser/qtwebchannel.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace qtwebchannel {
namespace mojom {


}  // namespace mojom
}  // namespace qtwebchannel

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace qtwebchannel {
namespace mojom {
// Interface base classes. They are used for type safety check.
class WebChannelTransportRenderInterfaceBase {};

using WebChannelTransportRenderPtrDataView =
    mojo::InterfacePtrDataView<WebChannelTransportRenderInterfaceBase>;
using WebChannelTransportRenderRequestDataView =
    mojo::InterfaceRequestDataView<WebChannelTransportRenderInterfaceBase>;
using WebChannelTransportRenderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebChannelTransportRenderInterfaceBase>;
using WebChannelTransportRenderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebChannelTransportRenderInterfaceBase>;
class WebChannelTransportHostInterfaceBase {};

using WebChannelTransportHostPtrDataView =
    mojo::InterfacePtrDataView<WebChannelTransportHostInterfaceBase>;
using WebChannelTransportHostRequestDataView =
    mojo::InterfaceRequestDataView<WebChannelTransportHostInterfaceBase>;
using WebChannelTransportHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebChannelTransportHostInterfaceBase>;
using WebChannelTransportHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebChannelTransportHostInterfaceBase>;
class WebChannelTransportRender_SetWorldId_ParamsDataView {
 public:
  WebChannelTransportRender_SetWorldId_ParamsDataView() {}

  WebChannelTransportRender_SetWorldId_ParamsDataView(
      internal::WebChannelTransportRender_SetWorldId_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t worldId() const {
    return data_->worldId;
  }
 private:
  internal::WebChannelTransportRender_SetWorldId_Params_Data* data_ = nullptr;
};

class WebChannelTransportRender_ResetWorldId_ParamsDataView {
 public:
  WebChannelTransportRender_ResetWorldId_ParamsDataView() {}

  WebChannelTransportRender_ResetWorldId_ParamsDataView(
      internal::WebChannelTransportRender_ResetWorldId_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::WebChannelTransportRender_ResetWorldId_Params_Data* data_ = nullptr;
};

class WebChannelTransportRender_DispatchWebChannelMessage_ParamsDataView {
 public:
  WebChannelTransportRender_DispatchWebChannelMessage_ParamsDataView() {}

  WebChannelTransportRender_DispatchWebChannelMessage_ParamsDataView(
      internal::WebChannelTransportRender_DispatchWebChannelMessage_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetBinaryJsonDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBinaryJson(UserType* output) {
    auto* pointer = data_->binaryJson.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
  uint32_t worldId() const {
    return data_->worldId;
  }
 private:
  internal::WebChannelTransportRender_DispatchWebChannelMessage_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebChannelTransportHost_DispatchWebChannelMessage_ParamsDataView {
 public:
  WebChannelTransportHost_DispatchWebChannelMessage_ParamsDataView() {}

  WebChannelTransportHost_DispatchWebChannelMessage_ParamsDataView(
      internal::WebChannelTransportHost_DispatchWebChannelMessage_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetBinaryJsonDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBinaryJson(UserType* output) {
    auto* pointer = data_->binaryJson.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::WebChannelTransportHost_DispatchWebChannelMessage_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace qtwebchannel

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace qtwebchannel {
namespace mojom {





inline void WebChannelTransportRender_DispatchWebChannelMessage_ParamsDataView::GetBinaryJsonDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->binaryJson.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void WebChannelTransportHost_DispatchWebChannelMessage_ParamsDataView::GetBinaryJsonDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->binaryJson.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}



}  // namespace mojom
}  // namespace qtwebchannel

#endif  // QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_SHARED_H_