// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "qtwebengine/browser/qtwebchannel.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_JUMBO_H_
#define QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_JUMBO_H_
#endif


namespace qtwebchannel {
namespace mojom {


void WebChannelTransportRenderInterceptorForTesting::SetWorldId(uint32_t worldId) {
  GetForwardingInterface()->SetWorldId(std::move(worldId));
}
void WebChannelTransportRenderInterceptorForTesting::ResetWorldId() {
  GetForwardingInterface()->ResetWorldId();
}
void WebChannelTransportRenderInterceptorForTesting::DispatchWebChannelMessage(const std::vector<uint8_t>& binaryJson, uint32_t worldId) {
  GetForwardingInterface()->DispatchWebChannelMessage(std::move(binaryJson), std::move(worldId));
}
WebChannelTransportRenderAsyncWaiter::WebChannelTransportRenderAsyncWaiter(
    WebChannelTransportRender* proxy) : proxy_(proxy) {}

WebChannelTransportRenderAsyncWaiter::~WebChannelTransportRenderAsyncWaiter() = default;




void WebChannelTransportHostInterceptorForTesting::DispatchWebChannelMessage(const std::vector<uint8_t>& binaryJson) {
  GetForwardingInterface()->DispatchWebChannelMessage(std::move(binaryJson));
}
WebChannelTransportHostAsyncWaiter::WebChannelTransportHostAsyncWaiter(
    WebChannelTransportHost* proxy) : proxy_(proxy) {}

WebChannelTransportHostAsyncWaiter::~WebChannelTransportHostAsyncWaiter() = default;






}  // namespace mojom
}  // namespace qtwebchannel

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif