// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_TEST_UTILS_H_
#define QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_TEST_UTILS_H_

#include "qtwebengine/browser/qtwebchannel.mojom.h"


namespace qtwebchannel {
namespace mojom {


class  WebChannelTransportRenderInterceptorForTesting : public WebChannelTransportRender {
  virtual WebChannelTransportRender* GetForwardingInterface() = 0;
  void SetWorldId(uint32_t worldId) override;
  void ResetWorldId() override;
  void DispatchWebChannelMessage(const std::vector<uint8_t>& binaryJson, uint32_t worldId) override;
};
class  WebChannelTransportRenderAsyncWaiter {
 public:
  explicit WebChannelTransportRenderAsyncWaiter(WebChannelTransportRender* proxy);
  ~WebChannelTransportRenderAsyncWaiter();

 private:
  WebChannelTransportRender* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WebChannelTransportRenderAsyncWaiter);
};


class  WebChannelTransportHostInterceptorForTesting : public WebChannelTransportHost {
  virtual WebChannelTransportHost* GetForwardingInterface() = 0;
  void DispatchWebChannelMessage(const std::vector<uint8_t>& binaryJson) override;
};
class  WebChannelTransportHostAsyncWaiter {
 public:
  explicit WebChannelTransportHostAsyncWaiter(WebChannelTransportHost* proxy);
  ~WebChannelTransportHostAsyncWaiter();

 private:
  WebChannelTransportHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WebChannelTransportHostAsyncWaiter);
};




}  // namespace mojom
}  // namespace qtwebchannel

#endif  // QTWEBENGINE_BROWSER_QTWEBCHANNEL_MOJOM_TEST_UTILS_H_