// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef QTWEBENGINE_COMMON_RENDERER_CONFIGURATION_MOJOM_TEST_UTILS_H_
#define QTWEBENGINE_COMMON_RENDERER_CONFIGURATION_MOJOM_TEST_UTILS_H_

#include "qtwebengine/common/renderer_configuration.mojom.h"


namespace qtwebengine {
namespace mojom {


class  RendererConfigurationInterceptorForTesting : public RendererConfiguration {
  virtual RendererConfiguration* GetForwardingInterface() = 0;
  void SetInitialConfiguration(bool is_incognito_process) override;
};
class  RendererConfigurationAsyncWaiter {
 public:
  explicit RendererConfigurationAsyncWaiter(RendererConfiguration* proxy);
  ~RendererConfigurationAsyncWaiter();

 private:
  RendererConfiguration* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RendererConfigurationAsyncWaiter);
};




}  // namespace mojom
}  // namespace qtwebengine

#endif  // QTWEBENGINE_COMMON_RENDERER_CONFIGURATION_MOJOM_TEST_UTILS_H_