// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This is a generated file. Please see the "service_manifest" template in
// src/services/service_manager/public/service_manifest.gni for more details.

#include "services/audio/manifest.h"

#include <set>

#include "base/files/file_path.h"
#include "base/no_destructor.h"
#include "build/build_config.h"
#include "services/service_manager/public/cpp/manifest_builder.h"




namespace audio {


const service_manager::Manifest& GetManifest() {
  static base::NoDestructor<service_manager::Manifest> manifest{
      service_manager::ManifestBuilder()
          .WithServiceName("audio")
          .WithDisplayName("Audio")
          .WithOptions(service_manager::ManifestOptionsBuilder()
                           .WithSandboxType("audio")
                           .WithInstanceSharingPolicy(
                                service_manager::Manifest::InstanceSharingPolicy::
                                    kSharedAcrossGroups)
                           .Build())
          .ExposeCapability(
              "info", std::set<const char*>{
                  "audio.mojom.SystemInfo",})
          .ExposeCapability(
              "testing_api", std::set<const char*>{
                  "audio.mojom.TestingApi",})
          .ExposeCapability(
              "stream_factory", std::set<const char*>{
                  "audio.mojom.StreamFactory",})
          .ExposeCapability(
              "log_factory_manager", std::set<const char*>{
                  "audio.mojom.LogFactoryManager",})
          .ExposeCapability(
              "debug_recording", std::set<const char*>{
                  "audio.mojom.DebugRecording",})
          .ExposeCapability(
              "device_notifier", std::set<const char*>{
                  "audio.mojom.DeviceNotifier",})
          .Build() };
  return *manifest;
}

}  // namespace audio
