// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/catalog/public/mojom/catalog.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_CATALOG_PUBLIC_MOJOM_CATALOG_MOJOM_JUMBO_H_
#define SERVICES_CATALOG_PUBLIC_MOJOM_CATALOG_MOJOM_JUMBO_H_
#endif


namespace catalog {
namespace mojom {


void CatalogInterceptorForTesting::GetEntries(const base::Optional<std::vector<std::string>>& names, GetEntriesCallback callback) {
  GetForwardingInterface()->GetEntries(std::move(names), std::move(callback));
}
void CatalogInterceptorForTesting::GetEntriesProvidingCapability(const std::string& capability, GetEntriesProvidingCapabilityCallback callback) {
  GetForwardingInterface()->GetEntriesProvidingCapability(std::move(capability), std::move(callback));
}
CatalogAsyncWaiter::CatalogAsyncWaiter(
    Catalog* proxy) : proxy_(proxy) {}

CatalogAsyncWaiter::~CatalogAsyncWaiter() = default;

void CatalogAsyncWaiter::GetEntries(
    const base::Optional<std::vector<std::string>>& names, std::vector<EntryPtr>* out_entries) {
  base::RunLoop loop;
  proxy_->GetEntries(std::move(names),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<EntryPtr>* out_entries
,
             std::vector<EntryPtr> entries) {*out_entries = std::move(entries);
            loop->Quit();
          },
          &loop,
          out_entries));
  loop.Run();
}
void CatalogAsyncWaiter::GetEntriesProvidingCapability(
    const std::string& capability, std::vector<EntryPtr>* out_entries) {
  base::RunLoop loop;
  proxy_->GetEntriesProvidingCapability(std::move(capability),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<EntryPtr>* out_entries
,
             std::vector<EntryPtr> entries) {*out_entries = std::move(entries);
            loop->Quit();
          },
          &loop,
          out_entries));
  loop.Run();
}





}  // namespace mojom
}  // namespace catalog

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif