// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_CATALOG_PUBLIC_MOJOM_CATALOG_MOJOM_TEST_UTILS_H_
#define SERVICES_CATALOG_PUBLIC_MOJOM_CATALOG_MOJOM_TEST_UTILS_H_

#include "services/catalog/public/mojom/catalog.mojom.h"


namespace catalog {
namespace mojom {


class  CatalogInterceptorForTesting : public Catalog {
  virtual Catalog* GetForwardingInterface() = 0;
  void GetEntries(const base::Optional<std::vector<std::string>>& names, GetEntriesCallback callback) override;
  void GetEntriesProvidingCapability(const std::string& capability, GetEntriesProvidingCapabilityCallback callback) override;
};
class  CatalogAsyncWaiter {
 public:
  explicit CatalogAsyncWaiter(Catalog* proxy);
  ~CatalogAsyncWaiter();
  void GetEntries(
      const base::Optional<std::vector<std::string>>& names, std::vector<EntryPtr>* out_entries);
  void GetEntriesProvidingCapability(
      const std::string& capability, std::vector<EntryPtr>* out_entries);

 private:
  Catalog* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(CatalogAsyncWaiter);
};




}  // namespace mojom
}  // namespace catalog

#endif  // SERVICES_CATALOG_PUBLIC_MOJOM_CATALOG_MOJOM_TEST_UTILS_H_