// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared-internal.h"
#include "services/network/public/mojom/network_param.mojom-shared-internal.h"
#include "ui/accessibility/mojom/ax_tree_id.mojom-shared-internal.h"
#include "ui/base/mojo/window_open_disposition.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {
class NavigateParams_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigateParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigateParams_Data));
      new (data()) NavigateParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigateParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigateParams_Data>(index_);
    }
    NavigateParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t should_clear_session_history : 1;
  uint8_t padfinal_[7];

 private:
  NavigateParams_Data();
  ~NavigateParams_Data() = delete;
};
static_assert(sizeof(NavigateParams_Data) == 16,
              "Bad sizeof(NavigateParams_Data)");
// Used by NavigateParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct NavigateParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  NavigateParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~NavigateParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    NavigateParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    NavigateParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContents_Navigate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContents_Navigate_Params_Data));
      new (data()) NavigableContents_Navigate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContents_Navigate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContents_Navigate_Params_Data>(index_);
    }
    NavigableContents_Navigate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<internal::NavigateParams_Data> params;

 private:
  NavigableContents_Navigate_Params_Data();
  ~NavigableContents_Navigate_Params_Data() = delete;
};
static_assert(sizeof(NavigableContents_Navigate_Params_Data) == 24,
              "Bad sizeof(NavigableContents_Navigate_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContents_GoBack_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContents_GoBack_Params_Data));
      new (data()) NavigableContents_GoBack_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContents_GoBack_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContents_GoBack_Params_Data>(index_);
    }
    NavigableContents_GoBack_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NavigableContents_GoBack_Params_Data();
  ~NavigableContents_GoBack_Params_Data() = delete;
};
static_assert(sizeof(NavigableContents_GoBack_Params_Data) == 8,
              "Bad sizeof(NavigableContents_GoBack_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContents_GoBack_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContents_GoBack_ResponseParams_Data));
      new (data()) NavigableContents_GoBack_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContents_GoBack_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContents_GoBack_ResponseParams_Data>(index_);
    }
    NavigableContents_GoBack_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  NavigableContents_GoBack_ResponseParams_Data();
  ~NavigableContents_GoBack_ResponseParams_Data() = delete;
};
static_assert(sizeof(NavigableContents_GoBack_ResponseParams_Data) == 16,
              "Bad sizeof(NavigableContents_GoBack_ResponseParams_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContents_CreateView_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContents_CreateView_Params_Data));
      new (data()) NavigableContents_CreateView_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContents_CreateView_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContents_CreateView_Params_Data>(index_);
    }
    NavigableContents_CreateView_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t in_service_process : 1;
  uint8_t padfinal_[7];

 private:
  NavigableContents_CreateView_Params_Data();
  ~NavigableContents_CreateView_Params_Data() = delete;
};
static_assert(sizeof(NavigableContents_CreateView_Params_Data) == 16,
              "Bad sizeof(NavigableContents_CreateView_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContents_CreateView_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContents_CreateView_ResponseParams_Data));
      new (data()) NavigableContents_CreateView_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContents_CreateView_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContents_CreateView_ResponseParams_Data>(index_);
    }
    NavigableContents_CreateView_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> embed_token;

 private:
  NavigableContents_CreateView_ResponseParams_Data();
  ~NavigableContents_CreateView_ResponseParams_Data() = delete;
};
static_assert(sizeof(NavigableContents_CreateView_ResponseParams_Data) == 16,
              "Bad sizeof(NavigableContents_CreateView_ResponseParams_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContents_Focus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContents_Focus_Params_Data));
      new (data()) NavigableContents_Focus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContents_Focus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContents_Focus_Params_Data>(index_);
    }
    NavigableContents_Focus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NavigableContents_Focus_Params_Data();
  ~NavigableContents_Focus_Params_Data() = delete;
};
static_assert(sizeof(NavigableContents_Focus_Params_Data) == 8,
              "Bad sizeof(NavigableContents_Focus_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContents_FocusThroughTabTraversal_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContents_FocusThroughTabTraversal_Params_Data));
      new (data()) NavigableContents_FocusThroughTabTraversal_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContents_FocusThroughTabTraversal_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContents_FocusThroughTabTraversal_Params_Data>(index_);
    }
    NavigableContents_FocusThroughTabTraversal_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t reverse : 1;
  uint8_t padfinal_[7];

 private:
  NavigableContents_FocusThroughTabTraversal_Params_Data();
  ~NavigableContents_FocusThroughTabTraversal_Params_Data() = delete;
};
static_assert(sizeof(NavigableContents_FocusThroughTabTraversal_Params_Data) == 16,
              "Bad sizeof(NavigableContents_FocusThroughTabTraversal_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContentsClient_ClearViewFocus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContentsClient_ClearViewFocus_Params_Data));
      new (data()) NavigableContentsClient_ClearViewFocus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContentsClient_ClearViewFocus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContentsClient_ClearViewFocus_Params_Data>(index_);
    }
    NavigableContentsClient_ClearViewFocus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NavigableContentsClient_ClearViewFocus_Params_Data();
  ~NavigableContentsClient_ClearViewFocus_Params_Data() = delete;
};
static_assert(sizeof(NavigableContentsClient_ClearViewFocus_Params_Data) == 8,
              "Bad sizeof(NavigableContentsClient_ClearViewFocus_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContentsClient_DidFinishNavigation_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContentsClient_DidFinishNavigation_Params_Data));
      new (data()) NavigableContentsClient_DidFinishNavigation_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContentsClient_DidFinishNavigation_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContentsClient_DidFinishNavigation_Params_Data>(index_);
    }
    NavigableContentsClient_DidFinishNavigation_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  uint8_t is_main_frame : 1;
  uint8_t is_error_page : 1;
  uint8_t pad2_[7];
  mojo::internal::Pointer<::network::mojom::internal::HttpResponseHeaders_Data> response_headers;

 private:
  NavigableContentsClient_DidFinishNavigation_Params_Data();
  ~NavigableContentsClient_DidFinishNavigation_Params_Data() = delete;
};
static_assert(sizeof(NavigableContentsClient_DidFinishNavigation_Params_Data) == 32,
              "Bad sizeof(NavigableContentsClient_DidFinishNavigation_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContentsClient_DidStopLoading_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContentsClient_DidStopLoading_Params_Data));
      new (data()) NavigableContentsClient_DidStopLoading_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContentsClient_DidStopLoading_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContentsClient_DidStopLoading_Params_Data>(index_);
    }
    NavigableContentsClient_DidStopLoading_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NavigableContentsClient_DidStopLoading_Params_Data();
  ~NavigableContentsClient_DidStopLoading_Params_Data() = delete;
};
static_assert(sizeof(NavigableContentsClient_DidStopLoading_Params_Data) == 8,
              "Bad sizeof(NavigableContentsClient_DidStopLoading_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContentsClient_DidAutoResizeView_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContentsClient_DidAutoResizeView_Params_Data));
      new (data()) NavigableContentsClient_DidAutoResizeView_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContentsClient_DidAutoResizeView_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContentsClient_DidAutoResizeView_Params_Data>(index_);
    }
    NavigableContentsClient_DidAutoResizeView_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> new_size;

 private:
  NavigableContentsClient_DidAutoResizeView_Params_Data();
  ~NavigableContentsClient_DidAutoResizeView_Params_Data() = delete;
};
static_assert(sizeof(NavigableContentsClient_DidAutoResizeView_Params_Data) == 16,
              "Bad sizeof(NavigableContentsClient_DidAutoResizeView_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContentsClient_DidSuppressNavigation_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContentsClient_DidSuppressNavigation_Params_Data));
      new (data()) NavigableContentsClient_DidSuppressNavigation_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContentsClient_DidSuppressNavigation_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContentsClient_DidSuppressNavigation_Params_Data>(index_);
    }
    NavigableContentsClient_DidSuppressNavigation_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  int32_t disposition;
  uint8_t from_user_gesture : 1;
  uint8_t padfinal_[3];

 private:
  NavigableContentsClient_DidSuppressNavigation_Params_Data();
  ~NavigableContentsClient_DidSuppressNavigation_Params_Data() = delete;
};
static_assert(sizeof(NavigableContentsClient_DidSuppressNavigation_Params_Data) == 24,
              "Bad sizeof(NavigableContentsClient_DidSuppressNavigation_Params_Data)");
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContentsClient_UpdateContentAXTree_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContentsClient_UpdateContentAXTree_Params_Data));
      new (data()) NavigableContentsClient_UpdateContentAXTree_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContentsClient_UpdateContentAXTree_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContentsClient_UpdateContentAXTree_Params_Data>(index_);
    }
    NavigableContentsClient_UpdateContentAXTree_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  ::ax::mojom::internal::AXTreeID_Data id;

 private:
  NavigableContentsClient_UpdateContentAXTree_Params_Data();
  ~NavigableContentsClient_UpdateContentAXTree_Params_Data() = delete;
};
static_assert(sizeof(NavigableContentsClient_UpdateContentAXTree_Params_Data) == 24,
              "Bad sizeof(NavigableContentsClient_UpdateContentAXTree_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_MOJOM_SHARED_INTERNAL_H_