// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This is a generated file. Please see the "service_manifest" template in
// src/services/service_manager/public/service_manifest.gni for more details.

#include "services/device/manifest.h"

#include <set>

#include "base/files/file_path.h"
#include "base/no_destructor.h"
#include "build/build_config.h"
#include "services/service_manager/public/cpp/manifest_builder.h"




namespace device {


const service_manager::Manifest& GetManifest() {
  static base::NoDestructor<service_manager::Manifest> manifest{
      service_manager::ManifestBuilder()
          .WithServiceName("device")
          .WithDisplayName("Device Service")
          .WithOptions(service_manager::ManifestOptionsBuilder()
                           .WithInstanceSharingPolicy(
                                service_manager::Manifest::InstanceSharingPolicy::
                                    kSharedAcrossGroups)
                           .Build())
          .ExposeCapability(
              "device:wake_lock", std::set<const char*>{
                  "device.mojom.WakeLockProvider",})
          .ExposeCapability(
              "device:mtp", std::set<const char*>{
                  "device.mojom.MtpManager",})
          .ExposeCapability(
              "device:input_service", std::set<const char*>{
                  "device.mojom.InputDeviceManager",})
          .ExposeCapability(
              "device:screen_orientation", std::set<const char*>{
                  "device.mojom.ScreenOrientationListener",})
          .ExposeCapability(
              "device:serial", std::set<const char*>{
                  "device.mojom.SerialPortManager",})
          .ExposeCapability(
              "device:power_monitor", std::set<const char*>{
                  "device.mojom.PowerMonitor",})
          .ExposeCapability(
              "device:usb", std::set<const char*>{
                  "device.mojom.UsbDeviceManager",})
          .ExposeCapability(
              "device:nfc", std::set<const char*>{
                  "device.mojom.NFCProvider",})
          .ExposeCapability(
              "device:fingerprint", std::set<const char*>{
                  "device.mojom.Fingerprint",})
          .ExposeCapability(
              "device:usb_test", std::set<const char*>{
                  "device.mojom.UsbDeviceManagerTest",})
          .ExposeCapability(
              "device:ip_geolocator", std::set<const char*>{
                  "device.mojom.PublicIpAddressGeolocationProvider",})
          .ExposeCapability(
              "device:geolocation_config", std::set<const char*>{
                  "device.mojom.GeolocationConfig",})
          .ExposeCapability(
              "device:bluetooth_system", std::set<const char*>{
                  "device.mojom.BluetoothSystemFactory",})
          .ExposeCapability(
              "device:geolocation_control", std::set<const char*>{
                  "device.mojom.GeolocationControl",})
          .ExposeCapability(
              "device:time_zone_monitor", std::set<const char*>{
                  "device.mojom.TimeZoneMonitor",})
          .ExposeCapability(
              "device:geolocation", std::set<const char*>{
                  "device.mojom.GeolocationContext",})
          .ExposeCapability(
              "device:battery_monitor", std::set<const char*>{
                  "device.mojom.BatteryMonitor",})
          .ExposeCapability(
              "device:hid", std::set<const char*>{
                  "device.mojom.HidManager",})
          .ExposeCapability(
              "device:vibration", std::set<const char*>{
                  "device.mojom.VibrationManager",})
          .ExposeCapability(
              "device:generic_sensor", std::set<const char*>{
                  "device.mojom.SensorProvider",})
          .Build() };
  return *manifest;
}

}  // namespace device
