// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {
class BluetoothAddress_Data;
class BluetoothDeviceInfo_Data;

struct BluetoothDeviceInfo_ConnectionState_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct BluetoothDeviceInfo_DeviceType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
      case 6:
      case 7:
      case 8:
      case 9:
      case 10:
      case 11:
      case 12:
      case 13:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct BluetoothSystem_State_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct BluetoothSystem_SetPoweredResult_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct BluetoothSystem_ScanState_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct BluetoothSystem_StartScanResult_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct BluetoothSystem_StopScanResult_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  BluetoothAddress_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothAddress_Data));
      new (data()) BluetoothAddress_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothAddress_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothAddress_Data>(index_);
    }
    BluetoothAddress_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> address;

 private:
  BluetoothAddress_Data();
  ~BluetoothAddress_Data() = delete;
};
static_assert(sizeof(BluetoothAddress_Data) == 16,
              "Bad sizeof(BluetoothAddress_Data)");
// Used by BluetoothAddress::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct BluetoothAddress_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  BluetoothAddress_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~BluetoothAddress_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    BluetoothAddress_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    BluetoothAddress_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  BluetoothDeviceInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothDeviceInfo_Data));
      new (data()) BluetoothDeviceInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothDeviceInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothDeviceInfo_Data>(index_);
    }
    BluetoothDeviceInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::BluetoothAddress_Data> address;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  int32_t connection_state;
  uint8_t is_paired : 1;
  uint8_t pad3_[3];
  int32_t device_type;
  uint8_t padfinal_[4];

 private:
  BluetoothDeviceInfo_Data();
  ~BluetoothDeviceInfo_Data() = delete;
};
static_assert(sizeof(BluetoothDeviceInfo_Data) == 40,
              "Bad sizeof(BluetoothDeviceInfo_Data)");
// Used by BluetoothDeviceInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct BluetoothDeviceInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  BluetoothDeviceInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~BluetoothDeviceInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    BluetoothDeviceInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    BluetoothDeviceInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  BluetoothSystemFactory_Create_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystemFactory_Create_Params_Data));
      new (data()) BluetoothSystemFactory_Create_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystemFactory_Create_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystemFactory_Create_Params_Data>(index_);
    }
    BluetoothSystemFactory_Create_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data system;
  mojo::internal::Interface_Data system_client;
  uint8_t padfinal_[4];

 private:
  BluetoothSystemFactory_Create_Params_Data();
  ~BluetoothSystemFactory_Create_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystemFactory_Create_Params_Data) == 24,
              "Bad sizeof(BluetoothSystemFactory_Create_Params_Data)");
class  BluetoothSystem_GetState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_GetState_Params_Data));
      new (data()) BluetoothSystem_GetState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_GetState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_GetState_Params_Data>(index_);
    }
    BluetoothSystem_GetState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BluetoothSystem_GetState_Params_Data();
  ~BluetoothSystem_GetState_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_GetState_Params_Data) == 8,
              "Bad sizeof(BluetoothSystem_GetState_Params_Data)");
class  BluetoothSystem_GetState_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_GetState_ResponseParams_Data));
      new (data()) BluetoothSystem_GetState_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_GetState_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_GetState_ResponseParams_Data>(index_);
    }
    BluetoothSystem_GetState_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  BluetoothSystem_GetState_ResponseParams_Data();
  ~BluetoothSystem_GetState_ResponseParams_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_GetState_ResponseParams_Data) == 16,
              "Bad sizeof(BluetoothSystem_GetState_ResponseParams_Data)");
class  BluetoothSystem_SetPowered_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_SetPowered_Params_Data));
      new (data()) BluetoothSystem_SetPowered_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_SetPowered_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_SetPowered_Params_Data>(index_);
    }
    BluetoothSystem_SetPowered_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t powered : 1;
  uint8_t padfinal_[7];

 private:
  BluetoothSystem_SetPowered_Params_Data();
  ~BluetoothSystem_SetPowered_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_SetPowered_Params_Data) == 16,
              "Bad sizeof(BluetoothSystem_SetPowered_Params_Data)");
class  BluetoothSystem_SetPowered_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_SetPowered_ResponseParams_Data));
      new (data()) BluetoothSystem_SetPowered_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_SetPowered_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_SetPowered_ResponseParams_Data>(index_);
    }
    BluetoothSystem_SetPowered_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  BluetoothSystem_SetPowered_ResponseParams_Data();
  ~BluetoothSystem_SetPowered_ResponseParams_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_SetPowered_ResponseParams_Data) == 16,
              "Bad sizeof(BluetoothSystem_SetPowered_ResponseParams_Data)");
class  BluetoothSystem_GetScanState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_GetScanState_Params_Data));
      new (data()) BluetoothSystem_GetScanState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_GetScanState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_GetScanState_Params_Data>(index_);
    }
    BluetoothSystem_GetScanState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BluetoothSystem_GetScanState_Params_Data();
  ~BluetoothSystem_GetScanState_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_GetScanState_Params_Data) == 8,
              "Bad sizeof(BluetoothSystem_GetScanState_Params_Data)");
class  BluetoothSystem_GetScanState_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_GetScanState_ResponseParams_Data));
      new (data()) BluetoothSystem_GetScanState_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_GetScanState_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_GetScanState_ResponseParams_Data>(index_);
    }
    BluetoothSystem_GetScanState_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t scan_state;
  uint8_t padfinal_[4];

 private:
  BluetoothSystem_GetScanState_ResponseParams_Data();
  ~BluetoothSystem_GetScanState_ResponseParams_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_GetScanState_ResponseParams_Data) == 16,
              "Bad sizeof(BluetoothSystem_GetScanState_ResponseParams_Data)");
class  BluetoothSystem_StartScan_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_StartScan_Params_Data));
      new (data()) BluetoothSystem_StartScan_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_StartScan_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_StartScan_Params_Data>(index_);
    }
    BluetoothSystem_StartScan_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BluetoothSystem_StartScan_Params_Data();
  ~BluetoothSystem_StartScan_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_StartScan_Params_Data) == 8,
              "Bad sizeof(BluetoothSystem_StartScan_Params_Data)");
class  BluetoothSystem_StartScan_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_StartScan_ResponseParams_Data));
      new (data()) BluetoothSystem_StartScan_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_StartScan_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_StartScan_ResponseParams_Data>(index_);
    }
    BluetoothSystem_StartScan_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  BluetoothSystem_StartScan_ResponseParams_Data();
  ~BluetoothSystem_StartScan_ResponseParams_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_StartScan_ResponseParams_Data) == 16,
              "Bad sizeof(BluetoothSystem_StartScan_ResponseParams_Data)");
class  BluetoothSystem_StopScan_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_StopScan_Params_Data));
      new (data()) BluetoothSystem_StopScan_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_StopScan_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_StopScan_Params_Data>(index_);
    }
    BluetoothSystem_StopScan_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BluetoothSystem_StopScan_Params_Data();
  ~BluetoothSystem_StopScan_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_StopScan_Params_Data) == 8,
              "Bad sizeof(BluetoothSystem_StopScan_Params_Data)");
class  BluetoothSystem_StopScan_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_StopScan_ResponseParams_Data));
      new (data()) BluetoothSystem_StopScan_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_StopScan_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_StopScan_ResponseParams_Data>(index_);
    }
    BluetoothSystem_StopScan_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  BluetoothSystem_StopScan_ResponseParams_Data();
  ~BluetoothSystem_StopScan_ResponseParams_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_StopScan_ResponseParams_Data) == 16,
              "Bad sizeof(BluetoothSystem_StopScan_ResponseParams_Data)");
class  BluetoothSystem_GetAvailableDevices_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_GetAvailableDevices_Params_Data));
      new (data()) BluetoothSystem_GetAvailableDevices_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_GetAvailableDevices_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_GetAvailableDevices_Params_Data>(index_);
    }
    BluetoothSystem_GetAvailableDevices_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BluetoothSystem_GetAvailableDevices_Params_Data();
  ~BluetoothSystem_GetAvailableDevices_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_GetAvailableDevices_Params_Data) == 8,
              "Bad sizeof(BluetoothSystem_GetAvailableDevices_Params_Data)");
class  BluetoothSystem_GetAvailableDevices_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_GetAvailableDevices_ResponseParams_Data));
      new (data()) BluetoothSystem_GetAvailableDevices_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_GetAvailableDevices_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_GetAvailableDevices_ResponseParams_Data>(index_);
    }
    BluetoothSystem_GetAvailableDevices_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::BluetoothDeviceInfo_Data>>> devices;

 private:
  BluetoothSystem_GetAvailableDevices_ResponseParams_Data();
  ~BluetoothSystem_GetAvailableDevices_ResponseParams_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_GetAvailableDevices_ResponseParams_Data) == 16,
              "Bad sizeof(BluetoothSystem_GetAvailableDevices_ResponseParams_Data)");
class  BluetoothSystemClient_OnStateChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystemClient_OnStateChanged_Params_Data));
      new (data()) BluetoothSystemClient_OnStateChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystemClient_OnStateChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystemClient_OnStateChanged_Params_Data>(index_);
    }
    BluetoothSystemClient_OnStateChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t new_state;
  uint8_t padfinal_[4];

 private:
  BluetoothSystemClient_OnStateChanged_Params_Data();
  ~BluetoothSystemClient_OnStateChanged_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystemClient_OnStateChanged_Params_Data) == 16,
              "Bad sizeof(BluetoothSystemClient_OnStateChanged_Params_Data)");
class  BluetoothSystemClient_OnScanStateChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystemClient_OnScanStateChanged_Params_Data));
      new (data()) BluetoothSystemClient_OnScanStateChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystemClient_OnScanStateChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystemClient_OnScanStateChanged_Params_Data>(index_);
    }
    BluetoothSystemClient_OnScanStateChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t new_state;
  uint8_t padfinal_[4];

 private:
  BluetoothSystemClient_OnScanStateChanged_Params_Data();
  ~BluetoothSystemClient_OnScanStateChanged_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystemClient_OnScanStateChanged_Params_Data) == 16,
              "Bad sizeof(BluetoothSystemClient_OnScanStateChanged_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_INTERNAL_H_