// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_WAKE_LOCK_PROVIDER_MOJOM_TEST_UTILS_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_WAKE_LOCK_PROVIDER_MOJOM_TEST_UTILS_H_

#include "services/device/public/mojom/wake_lock_provider.mojom.h"


namespace device {
namespace mojom {


class  WakeLockProviderInterceptorForTesting : public WakeLockProvider {
  virtual WakeLockProvider* GetForwardingInterface() = 0;
  void GetWakeLockContextForID(int32_t context_id, ::device::mojom::WakeLockContextRequest context) override;
  void GetWakeLockWithoutContext(::device::mojom::WakeLockType type, ::device::mojom::WakeLockReason reason, const std::string& description, ::device::mojom::WakeLockRequest wake_lock) override;
};
class  WakeLockProviderAsyncWaiter {
 public:
  explicit WakeLockProviderAsyncWaiter(WakeLockProvider* proxy);
  ~WakeLockProviderAsyncWaiter();

 private:
  WakeLockProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WakeLockProviderAsyncWaiter);
};




}  // namespace mojom
}  // namespace device

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_WAKE_LOCK_PROVIDER_MOJOM_TEST_UTILS_H_