// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This is a generated file. Please see the "service_manifest" template in
// src/services/service_manager/public/service_manifest.gni for more details.

#include "services/file/manifest.h"

#include <set>

#include "base/files/file_path.h"
#include "base/no_destructor.h"
#include "build/build_config.h"
#include "services/service_manager/public/cpp/manifest_builder.h"




namespace file {


const service_manager::Manifest& GetManifest() {
  static base::NoDestructor<service_manager::Manifest> manifest{
      service_manager::ManifestBuilder()
          .WithServiceName("file")
          .WithDisplayName("File Service")
          .WithOptions(service_manager::ManifestOptionsBuilder()
                           .Build())
          .ExposeCapability(
              "file:leveldb", std::set<const char*>{
                  "leveldb.mojom.LevelDBService",})
          .ExposeCapability(
              "file:filesystem", std::set<const char*>{
                  "file.mojom.FileSystem",})
          .RequireCapability("*", "app")
          .Build() };
  return *manifest;
}

}  // namespace file
