// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_AUDIO_FOCUS_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_AUDIO_FOCUS_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared-internal.h"
#include "services/media_session/public/mojom/media_session.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace media_session {
namespace mojom {
namespace internal {
class AudioFocusRequestState_Data;

struct EnforcementMode_Data {
 public:
  static bool constexpr kIsExtensible = true;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct AudioFocusType_Data {
 public:
  static bool constexpr kIsExtensible = true;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  AudioFocusRequestState_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusRequestState_Data));
      new (data()) AudioFocusRequestState_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusRequestState_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusRequestState_Data>(index_);
    }
    AudioFocusRequestState_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media_session::mojom::internal::MediaSessionInfo_Data> session_info;
  int32_t audio_focus_type;
  uint8_t pad1_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> source_name;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> request_id;

 private:
  AudioFocusRequestState_Data();
  ~AudioFocusRequestState_Data() = delete;
};
static_assert(sizeof(AudioFocusRequestState_Data) == 40,
              "Bad sizeof(AudioFocusRequestState_Data)");
// Used by AudioFocusRequestState::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct AudioFocusRequestState_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  AudioFocusRequestState_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~AudioFocusRequestState_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    AudioFocusRequestState_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    AudioFocusRequestState_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  AudioFocusObserver_OnFocusGained_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusObserver_OnFocusGained_Params_Data));
      new (data()) AudioFocusObserver_OnFocusGained_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusObserver_OnFocusGained_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusObserver_OnFocusGained_Params_Data>(index_);
    }
    AudioFocusObserver_OnFocusGained_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::AudioFocusRequestState_Data> state;

 private:
  AudioFocusObserver_OnFocusGained_Params_Data();
  ~AudioFocusObserver_OnFocusGained_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusObserver_OnFocusGained_Params_Data) == 16,
              "Bad sizeof(AudioFocusObserver_OnFocusGained_Params_Data)");
class  AudioFocusObserver_OnFocusLost_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusObserver_OnFocusLost_Params_Data));
      new (data()) AudioFocusObserver_OnFocusLost_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusObserver_OnFocusLost_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusObserver_OnFocusLost_Params_Data>(index_);
    }
    AudioFocusObserver_OnFocusLost_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::AudioFocusRequestState_Data> state;

 private:
  AudioFocusObserver_OnFocusLost_Params_Data();
  ~AudioFocusObserver_OnFocusLost_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusObserver_OnFocusLost_Params_Data) == 16,
              "Bad sizeof(AudioFocusObserver_OnFocusLost_Params_Data)");
class  AudioFocusObserver_OnActiveSessionChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusObserver_OnActiveSessionChanged_Params_Data));
      new (data()) AudioFocusObserver_OnActiveSessionChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusObserver_OnActiveSessionChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusObserver_OnActiveSessionChanged_Params_Data>(index_);
    }
    AudioFocusObserver_OnActiveSessionChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::AudioFocusRequestState_Data> session;

 private:
  AudioFocusObserver_OnActiveSessionChanged_Params_Data();
  ~AudioFocusObserver_OnActiveSessionChanged_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusObserver_OnActiveSessionChanged_Params_Data) == 16,
              "Bad sizeof(AudioFocusObserver_OnActiveSessionChanged_Params_Data)");
class  AudioFocusRequestClient_RequestAudioFocus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusRequestClient_RequestAudioFocus_Params_Data));
      new (data()) AudioFocusRequestClient_RequestAudioFocus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusRequestClient_RequestAudioFocus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusRequestClient_RequestAudioFocus_Params_Data>(index_);
    }
    AudioFocusRequestClient_RequestAudioFocus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media_session::mojom::internal::MediaSessionInfo_Data> session_info;
  int32_t type;
  uint8_t padfinal_[4];

 private:
  AudioFocusRequestClient_RequestAudioFocus_Params_Data();
  ~AudioFocusRequestClient_RequestAudioFocus_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusRequestClient_RequestAudioFocus_Params_Data) == 24,
              "Bad sizeof(AudioFocusRequestClient_RequestAudioFocus_Params_Data)");
class  AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data));
      new (data()) AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data>(index_);
    }
    AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data();
  ~AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data() = delete;
};
static_assert(sizeof(AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data) == 8,
              "Bad sizeof(AudioFocusRequestClient_RequestAudioFocus_ResponseParams_Data)");
class  AudioFocusRequestClient_AbandonAudioFocus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusRequestClient_AbandonAudioFocus_Params_Data));
      new (data()) AudioFocusRequestClient_AbandonAudioFocus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusRequestClient_AbandonAudioFocus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusRequestClient_AbandonAudioFocus_Params_Data>(index_);
    }
    AudioFocusRequestClient_AbandonAudioFocus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AudioFocusRequestClient_AbandonAudioFocus_Params_Data();
  ~AudioFocusRequestClient_AbandonAudioFocus_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusRequestClient_AbandonAudioFocus_Params_Data) == 8,
              "Bad sizeof(AudioFocusRequestClient_AbandonAudioFocus_Params_Data)");
class  AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data));
      new (data()) AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data>(index_);
    }
    AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media_session::mojom::internal::MediaSessionInfo_Data> session_info;

 private:
  AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data();
  ~AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data) == 16,
              "Bad sizeof(AudioFocusRequestClient_MediaSessionInfoChanged_Params_Data)");
class  AudioFocusRequestClient_GetRequestId_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusRequestClient_GetRequestId_Params_Data));
      new (data()) AudioFocusRequestClient_GetRequestId_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusRequestClient_GetRequestId_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusRequestClient_GetRequestId_Params_Data>(index_);
    }
    AudioFocusRequestClient_GetRequestId_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AudioFocusRequestClient_GetRequestId_Params_Data();
  ~AudioFocusRequestClient_GetRequestId_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusRequestClient_GetRequestId_Params_Data) == 8,
              "Bad sizeof(AudioFocusRequestClient_GetRequestId_Params_Data)");
class  AudioFocusRequestClient_GetRequestId_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusRequestClient_GetRequestId_ResponseParams_Data));
      new (data()) AudioFocusRequestClient_GetRequestId_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusRequestClient_GetRequestId_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusRequestClient_GetRequestId_ResponseParams_Data>(index_);
    }
    AudioFocusRequestClient_GetRequestId_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> request_id;

 private:
  AudioFocusRequestClient_GetRequestId_ResponseParams_Data();
  ~AudioFocusRequestClient_GetRequestId_ResponseParams_Data() = delete;
};
static_assert(sizeof(AudioFocusRequestClient_GetRequestId_ResponseParams_Data) == 16,
              "Bad sizeof(AudioFocusRequestClient_GetRequestId_ResponseParams_Data)");
class  AudioFocusManager_RequestAudioFocus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_RequestAudioFocus_Params_Data));
      new (data()) AudioFocusManager_RequestAudioFocus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_RequestAudioFocus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_RequestAudioFocus_Params_Data>(index_);
    }
    AudioFocusManager_RequestAudioFocus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data client;
  mojo::internal::Interface_Data media_session;
  int32_t type;
  mojo::internal::Pointer<::media_session::mojom::internal::MediaSessionInfo_Data> session_info;

 private:
  AudioFocusManager_RequestAudioFocus_Params_Data();
  ~AudioFocusManager_RequestAudioFocus_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_RequestAudioFocus_Params_Data) == 32,
              "Bad sizeof(AudioFocusManager_RequestAudioFocus_Params_Data)");
class  AudioFocusManager_RequestAudioFocus_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_RequestAudioFocus_ResponseParams_Data));
      new (data()) AudioFocusManager_RequestAudioFocus_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_RequestAudioFocus_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_RequestAudioFocus_ResponseParams_Data>(index_);
    }
    AudioFocusManager_RequestAudioFocus_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AudioFocusManager_RequestAudioFocus_ResponseParams_Data();
  ~AudioFocusManager_RequestAudioFocus_ResponseParams_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_RequestAudioFocus_ResponseParams_Data) == 8,
              "Bad sizeof(AudioFocusManager_RequestAudioFocus_ResponseParams_Data)");
class  AudioFocusManager_RequestGroupedAudioFocus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_RequestGroupedAudioFocus_Params_Data));
      new (data()) AudioFocusManager_RequestGroupedAudioFocus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_RequestGroupedAudioFocus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_RequestGroupedAudioFocus_Params_Data>(index_);
    }
    AudioFocusManager_RequestGroupedAudioFocus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data client;
  mojo::internal::Interface_Data media_session;
  int32_t type;
  mojo::internal::Pointer<::media_session::mojom::internal::MediaSessionInfo_Data> session_info;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> group_id;

 private:
  AudioFocusManager_RequestGroupedAudioFocus_Params_Data();
  ~AudioFocusManager_RequestGroupedAudioFocus_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_RequestGroupedAudioFocus_Params_Data) == 40,
              "Bad sizeof(AudioFocusManager_RequestGroupedAudioFocus_Params_Data)");
class  AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data));
      new (data()) AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data>(index_);
    }
    AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data();
  ~AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data) == 8,
              "Bad sizeof(AudioFocusManager_RequestGroupedAudioFocus_ResponseParams_Data)");
class  AudioFocusManager_GetFocusRequests_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_GetFocusRequests_Params_Data));
      new (data()) AudioFocusManager_GetFocusRequests_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_GetFocusRequests_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_GetFocusRequests_Params_Data>(index_);
    }
    AudioFocusManager_GetFocusRequests_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  AudioFocusManager_GetFocusRequests_Params_Data();
  ~AudioFocusManager_GetFocusRequests_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_GetFocusRequests_Params_Data) == 8,
              "Bad sizeof(AudioFocusManager_GetFocusRequests_Params_Data)");
class  AudioFocusManager_GetFocusRequests_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_GetFocusRequests_ResponseParams_Data));
      new (data()) AudioFocusManager_GetFocusRequests_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_GetFocusRequests_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_GetFocusRequests_ResponseParams_Data>(index_);
    }
    AudioFocusManager_GetFocusRequests_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::AudioFocusRequestState_Data>>> requests;

 private:
  AudioFocusManager_GetFocusRequests_ResponseParams_Data();
  ~AudioFocusManager_GetFocusRequests_ResponseParams_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_GetFocusRequests_ResponseParams_Data) == 16,
              "Bad sizeof(AudioFocusManager_GetFocusRequests_ResponseParams_Data)");
class  AudioFocusManager_AddObserver_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_AddObserver_Params_Data));
      new (data()) AudioFocusManager_AddObserver_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_AddObserver_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_AddObserver_Params_Data>(index_);
    }
    AudioFocusManager_AddObserver_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data observer;

 private:
  AudioFocusManager_AddObserver_Params_Data();
  ~AudioFocusManager_AddObserver_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_AddObserver_Params_Data) == 16,
              "Bad sizeof(AudioFocusManager_AddObserver_Params_Data)");
class  AudioFocusManager_SetSourceName_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_SetSourceName_Params_Data));
      new (data()) AudioFocusManager_SetSourceName_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_SetSourceName_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_SetSourceName_Params_Data>(index_);
    }
    AudioFocusManager_SetSourceName_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> name;

 private:
  AudioFocusManager_SetSourceName_Params_Data();
  ~AudioFocusManager_SetSourceName_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_SetSourceName_Params_Data) == 16,
              "Bad sizeof(AudioFocusManager_SetSourceName_Params_Data)");
class  AudioFocusManager_SetEnforcementMode_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManager_SetEnforcementMode_Params_Data));
      new (data()) AudioFocusManager_SetEnforcementMode_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManager_SetEnforcementMode_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManager_SetEnforcementMode_Params_Data>(index_);
    }
    AudioFocusManager_SetEnforcementMode_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t mode;
  uint8_t padfinal_[4];

 private:
  AudioFocusManager_SetEnforcementMode_Params_Data();
  ~AudioFocusManager_SetEnforcementMode_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusManager_SetEnforcementMode_Params_Data) == 16,
              "Bad sizeof(AudioFocusManager_SetEnforcementMode_Params_Data)");
class  AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data));
      new (data()) AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data>(index_);
    }
    AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> request_id;

 private:
  AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data();
  ~AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data() = delete;
};
static_assert(sizeof(AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data) == 16,
              "Bad sizeof(AudioFocusManagerDebug_GetDebugInfoForRequest_Params_Data)");
class  AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data));
      new (data()) AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data>(index_);
    }
    AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media_session::mojom::internal::MediaSessionDebugInfo_Data> debug_info;

 private:
  AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data();
  ~AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data() = delete;
};
static_assert(sizeof(AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data) == 16,
              "Bad sizeof(AudioFocusManagerDebug_GetDebugInfoForRequest_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace media_session

#endif  // SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_AUDIO_FOCUS_MOJOM_SHARED_INTERNAL_H_