// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/media_session/public/mojom/media_controller.mojom-blink-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_MEDIA_CONTROLLER_MOJOM_BLINK_JUMBO_H_
#define SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_MEDIA_CONTROLLER_MOJOM_BLINK_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "third_party/blink/renderer/platform/mojo/geometry_struct_traits.h"
#include "third_party/blink/renderer/platform/mojo/kurl_struct_traits.h"
#include "third_party/blink/renderer/platform/mojo/string16_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#endif


namespace media_session {
namespace mojom {
namespace blink {


void MediaControllerManagerInterceptorForTesting::CreateMediaControllerForSession(MediaControllerRequest request, const base::UnguessableToken& request_id) {
  GetForwardingInterface()->CreateMediaControllerForSession(std::move(request), std::move(request_id));
}
void MediaControllerManagerInterceptorForTesting::CreateActiveMediaController(MediaControllerRequest request) {
  GetForwardingInterface()->CreateActiveMediaController(std::move(request));
}
MediaControllerManagerAsyncWaiter::MediaControllerManagerAsyncWaiter(
    MediaControllerManager* proxy) : proxy_(proxy) {}

MediaControllerManagerAsyncWaiter::~MediaControllerManagerAsyncWaiter() = default;




void MediaControllerInterceptorForTesting::Suspend() {
  GetForwardingInterface()->Suspend();
}
void MediaControllerInterceptorForTesting::Resume() {
  GetForwardingInterface()->Resume();
}
void MediaControllerInterceptorForTesting::Stop() {
  GetForwardingInterface()->Stop();
}
void MediaControllerInterceptorForTesting::ToggleSuspendResume() {
  GetForwardingInterface()->ToggleSuspendResume();
}
void MediaControllerInterceptorForTesting::AddObserver(MediaControllerObserverPtr observer) {
  GetForwardingInterface()->AddObserver(std::move(observer));
}
void MediaControllerInterceptorForTesting::PreviousTrack() {
  GetForwardingInterface()->PreviousTrack();
}
void MediaControllerInterceptorForTesting::NextTrack() {
  GetForwardingInterface()->NextTrack();
}
void MediaControllerInterceptorForTesting::Seek(base::TimeDelta seek_time) {
  GetForwardingInterface()->Seek(std::move(seek_time));
}
MediaControllerAsyncWaiter::MediaControllerAsyncWaiter(
    MediaController* proxy) : proxy_(proxy) {}

MediaControllerAsyncWaiter::~MediaControllerAsyncWaiter() = default;




void MediaControllerObserverInterceptorForTesting::MediaSessionInfoChanged(::media_session::mojom::blink::MediaSessionInfoPtr info) {
  GetForwardingInterface()->MediaSessionInfoChanged(std::move(info));
}
void MediaControllerObserverInterceptorForTesting::MediaSessionMetadataChanged(::media_session::mojom::blink::MediaMetadataPtr metadata) {
  GetForwardingInterface()->MediaSessionMetadataChanged(std::move(metadata));
}
void MediaControllerObserverInterceptorForTesting::MediaSessionActionsChanged(const WTF::Vector<::media_session::mojom::blink::MediaSessionAction>& action) {
  GetForwardingInterface()->MediaSessionActionsChanged(std::move(action));
}
MediaControllerObserverAsyncWaiter::MediaControllerObserverAsyncWaiter(
    MediaControllerObserver* proxy) : proxy_(proxy) {}

MediaControllerObserverAsyncWaiter::~MediaControllerObserverAsyncWaiter() = default;






}  // namespace blink
}  // namespace mojom
}  // namespace media_session

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif