// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_MEDIA_CONTROLLER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_MEDIA_CONTROLLER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared-internal.h"
#include "services/media_session/public/mojom/media_session.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace media_session {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  MediaControllerManager_CreateMediaControllerForSession_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaControllerManager_CreateMediaControllerForSession_Params_Data));
      new (data()) MediaControllerManager_CreateMediaControllerForSession_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaControllerManager_CreateMediaControllerForSession_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaControllerManager_CreateMediaControllerForSession_Params_Data>(index_);
    }
    MediaControllerManager_CreateMediaControllerForSession_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> request_id;

 private:
  MediaControllerManager_CreateMediaControllerForSession_Params_Data();
  ~MediaControllerManager_CreateMediaControllerForSession_Params_Data() = delete;
};
static_assert(sizeof(MediaControllerManager_CreateMediaControllerForSession_Params_Data) == 24,
              "Bad sizeof(MediaControllerManager_CreateMediaControllerForSession_Params_Data)");
class  MediaControllerManager_CreateActiveMediaController_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaControllerManager_CreateActiveMediaController_Params_Data));
      new (data()) MediaControllerManager_CreateActiveMediaController_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaControllerManager_CreateActiveMediaController_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaControllerManager_CreateActiveMediaController_Params_Data>(index_);
    }
    MediaControllerManager_CreateActiveMediaController_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  MediaControllerManager_CreateActiveMediaController_Params_Data();
  ~MediaControllerManager_CreateActiveMediaController_Params_Data() = delete;
};
static_assert(sizeof(MediaControllerManager_CreateActiveMediaController_Params_Data) == 16,
              "Bad sizeof(MediaControllerManager_CreateActiveMediaController_Params_Data)");
class  MediaController_Suspend_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaController_Suspend_Params_Data));
      new (data()) MediaController_Suspend_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaController_Suspend_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaController_Suspend_Params_Data>(index_);
    }
    MediaController_Suspend_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MediaController_Suspend_Params_Data();
  ~MediaController_Suspend_Params_Data() = delete;
};
static_assert(sizeof(MediaController_Suspend_Params_Data) == 8,
              "Bad sizeof(MediaController_Suspend_Params_Data)");
class  MediaController_Resume_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaController_Resume_Params_Data));
      new (data()) MediaController_Resume_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaController_Resume_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaController_Resume_Params_Data>(index_);
    }
    MediaController_Resume_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MediaController_Resume_Params_Data();
  ~MediaController_Resume_Params_Data() = delete;
};
static_assert(sizeof(MediaController_Resume_Params_Data) == 8,
              "Bad sizeof(MediaController_Resume_Params_Data)");
class  MediaController_Stop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaController_Stop_Params_Data));
      new (data()) MediaController_Stop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaController_Stop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaController_Stop_Params_Data>(index_);
    }
    MediaController_Stop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MediaController_Stop_Params_Data();
  ~MediaController_Stop_Params_Data() = delete;
};
static_assert(sizeof(MediaController_Stop_Params_Data) == 8,
              "Bad sizeof(MediaController_Stop_Params_Data)");
class  MediaController_ToggleSuspendResume_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaController_ToggleSuspendResume_Params_Data));
      new (data()) MediaController_ToggleSuspendResume_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaController_ToggleSuspendResume_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaController_ToggleSuspendResume_Params_Data>(index_);
    }
    MediaController_ToggleSuspendResume_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MediaController_ToggleSuspendResume_Params_Data();
  ~MediaController_ToggleSuspendResume_Params_Data() = delete;
};
static_assert(sizeof(MediaController_ToggleSuspendResume_Params_Data) == 8,
              "Bad sizeof(MediaController_ToggleSuspendResume_Params_Data)");
class  MediaController_AddObserver_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaController_AddObserver_Params_Data));
      new (data()) MediaController_AddObserver_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaController_AddObserver_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaController_AddObserver_Params_Data>(index_);
    }
    MediaController_AddObserver_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data observer;

 private:
  MediaController_AddObserver_Params_Data();
  ~MediaController_AddObserver_Params_Data() = delete;
};
static_assert(sizeof(MediaController_AddObserver_Params_Data) == 16,
              "Bad sizeof(MediaController_AddObserver_Params_Data)");
class  MediaController_PreviousTrack_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaController_PreviousTrack_Params_Data));
      new (data()) MediaController_PreviousTrack_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaController_PreviousTrack_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaController_PreviousTrack_Params_Data>(index_);
    }
    MediaController_PreviousTrack_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MediaController_PreviousTrack_Params_Data();
  ~MediaController_PreviousTrack_Params_Data() = delete;
};
static_assert(sizeof(MediaController_PreviousTrack_Params_Data) == 8,
              "Bad sizeof(MediaController_PreviousTrack_Params_Data)");
class  MediaController_NextTrack_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaController_NextTrack_Params_Data));
      new (data()) MediaController_NextTrack_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaController_NextTrack_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaController_NextTrack_Params_Data>(index_);
    }
    MediaController_NextTrack_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MediaController_NextTrack_Params_Data();
  ~MediaController_NextTrack_Params_Data() = delete;
};
static_assert(sizeof(MediaController_NextTrack_Params_Data) == 8,
              "Bad sizeof(MediaController_NextTrack_Params_Data)");
class  MediaController_Seek_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaController_Seek_Params_Data));
      new (data()) MediaController_Seek_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaController_Seek_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaController_Seek_Params_Data>(index_);
    }
    MediaController_Seek_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> seek_time;

 private:
  MediaController_Seek_Params_Data();
  ~MediaController_Seek_Params_Data() = delete;
};
static_assert(sizeof(MediaController_Seek_Params_Data) == 16,
              "Bad sizeof(MediaController_Seek_Params_Data)");
class  MediaControllerObserver_MediaSessionInfoChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaControllerObserver_MediaSessionInfoChanged_Params_Data));
      new (data()) MediaControllerObserver_MediaSessionInfoChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaControllerObserver_MediaSessionInfoChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaControllerObserver_MediaSessionInfoChanged_Params_Data>(index_);
    }
    MediaControllerObserver_MediaSessionInfoChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media_session::mojom::internal::MediaSessionInfo_Data> info;

 private:
  MediaControllerObserver_MediaSessionInfoChanged_Params_Data();
  ~MediaControllerObserver_MediaSessionInfoChanged_Params_Data() = delete;
};
static_assert(sizeof(MediaControllerObserver_MediaSessionInfoChanged_Params_Data) == 16,
              "Bad sizeof(MediaControllerObserver_MediaSessionInfoChanged_Params_Data)");
class  MediaControllerObserver_MediaSessionMetadataChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaControllerObserver_MediaSessionMetadataChanged_Params_Data));
      new (data()) MediaControllerObserver_MediaSessionMetadataChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaControllerObserver_MediaSessionMetadataChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaControllerObserver_MediaSessionMetadataChanged_Params_Data>(index_);
    }
    MediaControllerObserver_MediaSessionMetadataChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media_session::mojom::internal::MediaMetadata_Data> metadata;

 private:
  MediaControllerObserver_MediaSessionMetadataChanged_Params_Data();
  ~MediaControllerObserver_MediaSessionMetadataChanged_Params_Data() = delete;
};
static_assert(sizeof(MediaControllerObserver_MediaSessionMetadataChanged_Params_Data) == 16,
              "Bad sizeof(MediaControllerObserver_MediaSessionMetadataChanged_Params_Data)");
class  MediaControllerObserver_MediaSessionActionsChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MediaControllerObserver_MediaSessionActionsChanged_Params_Data));
      new (data()) MediaControllerObserver_MediaSessionActionsChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MediaControllerObserver_MediaSessionActionsChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MediaControllerObserver_MediaSessionActionsChanged_Params_Data>(index_);
    }
    MediaControllerObserver_MediaSessionActionsChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<int32_t>> action;

 private:
  MediaControllerObserver_MediaSessionActionsChanged_Params_Data();
  ~MediaControllerObserver_MediaSessionActionsChanged_Params_Data() = delete;
};
static_assert(sizeof(MediaControllerObserver_MediaSessionActionsChanged_Params_Data) == 16,
              "Bad sizeof(MediaControllerObserver_MediaSessionActionsChanged_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace media_session

#endif  // SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_MEDIA_CONTROLLER_MOJOM_SHARED_INTERNAL_H_