// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_MEDIA_CONTROLLER_MOJOM_SHARED_H_
#define SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_MEDIA_CONTROLLER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/media_session/public/mojom/media_controller.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared.h"
#include "services/media_session/public/mojom/media_session.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace media_session {
namespace mojom {


}  // namespace mojom
}  // namespace media_session

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace media_session {
namespace mojom {
// Interface base classes. They are used for type safety check.
class MediaControllerManagerInterfaceBase {};

using MediaControllerManagerPtrDataView =
    mojo::InterfacePtrDataView<MediaControllerManagerInterfaceBase>;
using MediaControllerManagerRequestDataView =
    mojo::InterfaceRequestDataView<MediaControllerManagerInterfaceBase>;
using MediaControllerManagerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MediaControllerManagerInterfaceBase>;
using MediaControllerManagerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MediaControllerManagerInterfaceBase>;
class MediaControllerInterfaceBase {};

using MediaControllerPtrDataView =
    mojo::InterfacePtrDataView<MediaControllerInterfaceBase>;
using MediaControllerRequestDataView =
    mojo::InterfaceRequestDataView<MediaControllerInterfaceBase>;
using MediaControllerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MediaControllerInterfaceBase>;
using MediaControllerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MediaControllerInterfaceBase>;
class MediaControllerObserverInterfaceBase {};

using MediaControllerObserverPtrDataView =
    mojo::InterfacePtrDataView<MediaControllerObserverInterfaceBase>;
using MediaControllerObserverRequestDataView =
    mojo::InterfaceRequestDataView<MediaControllerObserverInterfaceBase>;
using MediaControllerObserverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MediaControllerObserverInterfaceBase>;
using MediaControllerObserverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MediaControllerObserverInterfaceBase>;
class MediaControllerManager_CreateMediaControllerForSession_ParamsDataView {
 public:
  MediaControllerManager_CreateMediaControllerForSession_ParamsDataView() {}

  MediaControllerManager_CreateMediaControllerForSession_ParamsDataView(
      internal::MediaControllerManager_CreateMediaControllerForSession_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::media_session::mojom::MediaControllerRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetRequestIdDataView(
      ::mojo_base::mojom::UnguessableTokenDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRequestId(UserType* output) {
    auto* pointer = data_->request_id.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::UnguessableTokenDataView>(
        pointer, output, context_);
  }
 private:
  internal::MediaControllerManager_CreateMediaControllerForSession_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaControllerManager_CreateActiveMediaController_ParamsDataView {
 public:
  MediaControllerManager_CreateActiveMediaController_ParamsDataView() {}

  MediaControllerManager_CreateActiveMediaController_ParamsDataView(
      internal::MediaControllerManager_CreateActiveMediaController_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::media_session::mojom::MediaControllerRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::MediaControllerManager_CreateActiveMediaController_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaController_Suspend_ParamsDataView {
 public:
  MediaController_Suspend_ParamsDataView() {}

  MediaController_Suspend_ParamsDataView(
      internal::MediaController_Suspend_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MediaController_Suspend_Params_Data* data_ = nullptr;
};

class MediaController_Resume_ParamsDataView {
 public:
  MediaController_Resume_ParamsDataView() {}

  MediaController_Resume_ParamsDataView(
      internal::MediaController_Resume_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MediaController_Resume_Params_Data* data_ = nullptr;
};

class MediaController_Stop_ParamsDataView {
 public:
  MediaController_Stop_ParamsDataView() {}

  MediaController_Stop_ParamsDataView(
      internal::MediaController_Stop_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MediaController_Stop_Params_Data* data_ = nullptr;
};

class MediaController_ToggleSuspendResume_ParamsDataView {
 public:
  MediaController_ToggleSuspendResume_ParamsDataView() {}

  MediaController_ToggleSuspendResume_ParamsDataView(
      internal::MediaController_ToggleSuspendResume_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MediaController_ToggleSuspendResume_Params_Data* data_ = nullptr;
};

class MediaController_AddObserver_ParamsDataView {
 public:
  MediaController_AddObserver_ParamsDataView() {}

  MediaController_AddObserver_ParamsDataView(
      internal::MediaController_AddObserver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeObserver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::media_session::mojom::MediaControllerObserverPtrDataView>(
            &data_->observer, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::MediaController_AddObserver_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaController_PreviousTrack_ParamsDataView {
 public:
  MediaController_PreviousTrack_ParamsDataView() {}

  MediaController_PreviousTrack_ParamsDataView(
      internal::MediaController_PreviousTrack_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MediaController_PreviousTrack_Params_Data* data_ = nullptr;
};

class MediaController_NextTrack_ParamsDataView {
 public:
  MediaController_NextTrack_ParamsDataView() {}

  MediaController_NextTrack_ParamsDataView(
      internal::MediaController_NextTrack_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MediaController_NextTrack_Params_Data* data_ = nullptr;
};

class MediaController_Seek_ParamsDataView {
 public:
  MediaController_Seek_ParamsDataView() {}

  MediaController_Seek_ParamsDataView(
      internal::MediaController_Seek_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSeekTimeDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSeekTime(UserType* output) {
    auto* pointer = data_->seek_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
 private:
  internal::MediaController_Seek_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaControllerObserver_MediaSessionInfoChanged_ParamsDataView {
 public:
  MediaControllerObserver_MediaSessionInfoChanged_ParamsDataView() {}

  MediaControllerObserver_MediaSessionInfoChanged_ParamsDataView(
      internal::MediaControllerObserver_MediaSessionInfoChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetInfoDataView(
      ::media_session::mojom::MediaSessionInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInfo(UserType* output) {
    auto* pointer = data_->info.Get();
    return mojo::internal::Deserialize<::media_session::mojom::MediaSessionInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::MediaControllerObserver_MediaSessionInfoChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaControllerObserver_MediaSessionMetadataChanged_ParamsDataView {
 public:
  MediaControllerObserver_MediaSessionMetadataChanged_ParamsDataView() {}

  MediaControllerObserver_MediaSessionMetadataChanged_ParamsDataView(
      internal::MediaControllerObserver_MediaSessionMetadataChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMetadataDataView(
      ::media_session::mojom::MediaMetadataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMetadata(UserType* output) {
    auto* pointer = data_->metadata.Get();
    return mojo::internal::Deserialize<::media_session::mojom::MediaMetadataDataView>(
        pointer, output, context_);
  }
 private:
  internal::MediaControllerObserver_MediaSessionMetadataChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaControllerObserver_MediaSessionActionsChanged_ParamsDataView {
 public:
  MediaControllerObserver_MediaSessionActionsChanged_ParamsDataView() {}

  MediaControllerObserver_MediaSessionActionsChanged_ParamsDataView(
      internal::MediaControllerObserver_MediaSessionActionsChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetActionDataView(
      mojo::ArrayDataView<::media_session::mojom::MediaSessionAction>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAction(UserType* output) {
    auto* pointer = data_->action.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::media_session::mojom::MediaSessionAction>>(
        pointer, output, context_);
  }
 private:
  internal::MediaControllerObserver_MediaSessionActionsChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace media_session

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace media_session {
namespace mojom {

inline void MediaControllerManager_CreateMediaControllerForSession_ParamsDataView::GetRequestIdDataView(
    ::mojo_base::mojom::UnguessableTokenDataView* output) {
  auto pointer = data_->request_id.Get();
  *output = ::mojo_base::mojom::UnguessableTokenDataView(pointer, context_);
}


















inline void MediaController_Seek_ParamsDataView::GetSeekTimeDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->seek_time.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}


inline void MediaControllerObserver_MediaSessionInfoChanged_ParamsDataView::GetInfoDataView(
    ::media_session::mojom::MediaSessionInfoDataView* output) {
  auto pointer = data_->info.Get();
  *output = ::media_session::mojom::MediaSessionInfoDataView(pointer, context_);
}


inline void MediaControllerObserver_MediaSessionMetadataChanged_ParamsDataView::GetMetadataDataView(
    ::media_session::mojom::MediaMetadataDataView* output) {
  auto pointer = data_->metadata.Get();
  *output = ::media_session::mojom::MediaMetadataDataView(pointer, context_);
}


inline void MediaControllerObserver_MediaSessionActionsChanged_ParamsDataView::GetActionDataView(
    mojo::ArrayDataView<::media_session::mojom::MediaSessionAction>* output) {
  auto pointer = data_->action.Get();
  *output = mojo::ArrayDataView<::media_session::mojom::MediaSessionAction>(pointer, context_);
}



}  // namespace mojom
}  // namespace media_session

#endif  // SERVICES_MEDIA_SESSION_PUBLIC_MOJOM_MEDIA_CONTROLLER_MOJOM_SHARED_H_