// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This is a generated file. Please see the "service_manifest" template in
// src/services/service_manager/public/service_manifest.gni for more details.

#include "services/network/manifest.h"

#include <set>

#include "base/files/file_path.h"
#include "base/no_destructor.h"
#include "build/build_config.h"
#include "services/service_manager/public/cpp/manifest_builder.h"




namespace network {


const service_manager::Manifest& GetManifest() {
  static base::NoDestructor<service_manager::Manifest> manifest{
      service_manager::ManifestBuilder()
          .WithServiceName("network")
          .WithDisplayName("Network Service")
          .WithOptions(service_manager::ManifestOptionsBuilder()
                           .WithSandboxType("network")
                           .WithInstanceSharingPolicy(
                                service_manager::Manifest::InstanceSharingPolicy::
                                    kSharedAcrossGroups)
                           .Build())
          .ExposeCapability(
              "test", std::set<const char*>{
                  "network.mojom.NetworkServiceTest",})
          .ExposeCapability(
              "network_service", std::set<const char*>{
                  "network.mojom.NetworkService",})
          .ExposeCapability(
              "url_loader", std::set<const char*>{
                  "network.mojom.URLLoaderFactory",})
          .Build() };
  return *manifest;
}

}  // namespace network
