// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_MDNS_RESPONDER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_MDNS_RESPONDER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/network/public/mojom/ip_address.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  MdnsResponder_CreateNameForAddress_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MdnsResponder_CreateNameForAddress_Params_Data));
      new (data()) MdnsResponder_CreateNameForAddress_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MdnsResponder_CreateNameForAddress_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MdnsResponder_CreateNameForAddress_Params_Data>(index_);
    }
    MdnsResponder_CreateNameForAddress_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::IPAddress_Data> address;

 private:
  MdnsResponder_CreateNameForAddress_Params_Data();
  ~MdnsResponder_CreateNameForAddress_Params_Data() = delete;
};
static_assert(sizeof(MdnsResponder_CreateNameForAddress_Params_Data) == 16,
              "Bad sizeof(MdnsResponder_CreateNameForAddress_Params_Data)");
class  MdnsResponder_CreateNameForAddress_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MdnsResponder_CreateNameForAddress_ResponseParams_Data));
      new (data()) MdnsResponder_CreateNameForAddress_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MdnsResponder_CreateNameForAddress_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MdnsResponder_CreateNameForAddress_ResponseParams_Data>(index_);
    }
    MdnsResponder_CreateNameForAddress_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  uint8_t announcement_scheduled : 1;
  uint8_t padfinal_[7];

 private:
  MdnsResponder_CreateNameForAddress_ResponseParams_Data();
  ~MdnsResponder_CreateNameForAddress_ResponseParams_Data() = delete;
};
static_assert(sizeof(MdnsResponder_CreateNameForAddress_ResponseParams_Data) == 24,
              "Bad sizeof(MdnsResponder_CreateNameForAddress_ResponseParams_Data)");
class  MdnsResponder_RemoveNameForAddress_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MdnsResponder_RemoveNameForAddress_Params_Data));
      new (data()) MdnsResponder_RemoveNameForAddress_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MdnsResponder_RemoveNameForAddress_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MdnsResponder_RemoveNameForAddress_Params_Data>(index_);
    }
    MdnsResponder_RemoveNameForAddress_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::IPAddress_Data> address;

 private:
  MdnsResponder_RemoveNameForAddress_Params_Data();
  ~MdnsResponder_RemoveNameForAddress_Params_Data() = delete;
};
static_assert(sizeof(MdnsResponder_RemoveNameForAddress_Params_Data) == 16,
              "Bad sizeof(MdnsResponder_RemoveNameForAddress_Params_Data)");
class  MdnsResponder_RemoveNameForAddress_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MdnsResponder_RemoveNameForAddress_ResponseParams_Data));
      new (data()) MdnsResponder_RemoveNameForAddress_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MdnsResponder_RemoveNameForAddress_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MdnsResponder_RemoveNameForAddress_ResponseParams_Data>(index_);
    }
    MdnsResponder_RemoveNameForAddress_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t removed : 1;
  uint8_t goodbye_scheduled : 1;
  uint8_t padfinal_[7];

 private:
  MdnsResponder_RemoveNameForAddress_ResponseParams_Data();
  ~MdnsResponder_RemoveNameForAddress_ResponseParams_Data() = delete;
};
static_assert(sizeof(MdnsResponder_RemoveNameForAddress_ResponseParams_Data) == 16,
              "Bad sizeof(MdnsResponder_RemoveNameForAddress_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_MDNS_RESPONDER_MOJOM_SHARED_INTERNAL_H_