// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_MDNS_RESPONDER_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_MDNS_RESPONDER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/network/public/mojom/mdns_responder.mojom-shared-internal.h"
#include "services/network/public/mojom/ip_address.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace network {
namespace mojom {


}  // namespace mojom
}  // namespace network

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace network {
namespace mojom {
// Interface base classes. They are used for type safety check.
class MdnsResponderInterfaceBase {};

using MdnsResponderPtrDataView =
    mojo::InterfacePtrDataView<MdnsResponderInterfaceBase>;
using MdnsResponderRequestDataView =
    mojo::InterfaceRequestDataView<MdnsResponderInterfaceBase>;
using MdnsResponderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MdnsResponderInterfaceBase>;
using MdnsResponderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MdnsResponderInterfaceBase>;
class MdnsResponder_CreateNameForAddress_ParamsDataView {
 public:
  MdnsResponder_CreateNameForAddress_ParamsDataView() {}

  MdnsResponder_CreateNameForAddress_ParamsDataView(
      internal::MdnsResponder_CreateNameForAddress_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAddressDataView(
      ::network::mojom::IPAddressDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAddress(UserType* output) {
    auto* pointer = data_->address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPAddressDataView>(
        pointer, output, context_);
  }
 private:
  internal::MdnsResponder_CreateNameForAddress_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MdnsResponder_CreateNameForAddress_ResponseParamsDataView {
 public:
  MdnsResponder_CreateNameForAddress_ResponseParamsDataView() {}

  MdnsResponder_CreateNameForAddress_ResponseParamsDataView(
      internal::MdnsResponder_CreateNameForAddress_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool announcement_scheduled() const {
    return data_->announcement_scheduled;
  }
 private:
  internal::MdnsResponder_CreateNameForAddress_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MdnsResponder_RemoveNameForAddress_ParamsDataView {
 public:
  MdnsResponder_RemoveNameForAddress_ParamsDataView() {}

  MdnsResponder_RemoveNameForAddress_ParamsDataView(
      internal::MdnsResponder_RemoveNameForAddress_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAddressDataView(
      ::network::mojom::IPAddressDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAddress(UserType* output) {
    auto* pointer = data_->address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPAddressDataView>(
        pointer, output, context_);
  }
 private:
  internal::MdnsResponder_RemoveNameForAddress_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MdnsResponder_RemoveNameForAddress_ResponseParamsDataView {
 public:
  MdnsResponder_RemoveNameForAddress_ResponseParamsDataView() {}

  MdnsResponder_RemoveNameForAddress_ResponseParamsDataView(
      internal::MdnsResponder_RemoveNameForAddress_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool removed() const {
    return data_->removed;
  }
  bool goodbye_scheduled() const {
    return data_->goodbye_scheduled;
  }
 private:
  internal::MdnsResponder_RemoveNameForAddress_ResponseParams_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace network

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace network {
namespace mojom {

inline void MdnsResponder_CreateNameForAddress_ParamsDataView::GetAddressDataView(
    ::network::mojom::IPAddressDataView* output) {
  auto pointer = data_->address.Get();
  *output = ::network::mojom::IPAddressDataView(pointer, context_);
}


inline void MdnsResponder_CreateNameForAddress_ResponseParamsDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void MdnsResponder_RemoveNameForAddress_ParamsDataView::GetAddressDataView(
    ::network::mojom::IPAddressDataView* output) {
  auto pointer = data_->address.Get();
  *output = ::network::mojom::IPAddressDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_MDNS_RESPONDER_MOJOM_SHARED_H_