// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_QUALITY_ESTIMATOR_MANAGER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_QUALITY_ESTIMATOR_MANAGER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "services/network/public/mojom/network_types.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data));
      new (data()) NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data>(index_);
    }
    NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t type;
  int32_t downlink_bandwidth_kbps;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> http_rtt;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> transport_rtt;

 private:
  NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data();
  ~NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data() = delete;
};
static_assert(sizeof(NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data) == 32,
              "Bad sizeof(NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data)");
class  NetworkQualityEstimatorManager_RequestNotifications_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkQualityEstimatorManager_RequestNotifications_Params_Data));
      new (data()) NetworkQualityEstimatorManager_RequestNotifications_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkQualityEstimatorManager_RequestNotifications_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkQualityEstimatorManager_RequestNotifications_Params_Data>(index_);
    }
    NetworkQualityEstimatorManager_RequestNotifications_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client_ptr;

 private:
  NetworkQualityEstimatorManager_RequestNotifications_Params_Data();
  ~NetworkQualityEstimatorManager_RequestNotifications_Params_Data() = delete;
};
static_assert(sizeof(NetworkQualityEstimatorManager_RequestNotifications_Params_Data) == 16,
              "Bad sizeof(NetworkQualityEstimatorManager_RequestNotifications_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_QUALITY_ESTIMATOR_MANAGER_MOJOM_SHARED_INTERNAL_H_