// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/file.mojom-shared-internal.h"
#include "mojo/public/mojom/base/file_path.mojom-shared-internal.h"
#include "mojo/public/mojom/base/memory_pressure_level.mojom-shared-internal.h"
#include "mojo/public/mojom/base/read_only_buffer.mojom-shared-internal.h"
#include "mojo/public/mojom/base/string16.mojom-shared-internal.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared-internal.h"
#include "mojo/public/mojom/base/values.mojom-shared-internal.h"
#include "services/network/public/mojom/cookie_manager.mojom-shared-internal.h"
#include "services/network/public/mojom/host_resolver.mojom-shared-internal.h"
#include "services/network/public/mojom/net_log.mojom-shared-internal.h"
#include "services/network/public/mojom/network_change_manager.mojom-shared-internal.h"
#include "services/network/public/mojom/network_context.mojom-shared-internal.h"
#include "services/network/public/mojom/network_interface.mojom-shared-internal.h"
#include "services/network/public/mojom/network_param.mojom-shared-internal.h"
#include "services/network/public/mojom/network_quality_estimator_manager.mojom-shared-internal.h"
#include "services/network/public/mojom/url_loader.mojom-shared-internal.h"
#include "services/network/public/mojom/url_loader_factory.mojom-shared-internal.h"
#include "url/mojom/origin.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "services/network/public/mojom/signed_tree_head.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {
class LoadInfo_Data;
class HttpAuthStaticParams_Data;
class HttpAuthDynamicParams_Data;
class CryptConfig_Data;
class EnvironmentVariable_Data;
class NetworkServiceParams_Data;

#pragma pack(push, 1)
class  LoadInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(LoadInfo_Data));
      new (data()) LoadInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    LoadInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<LoadInfo_Data>(index_);
    }
    LoadInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t process_id;
  uint32_t routing_id;
  mojo::internal::Pointer<mojo::internal::String_Data> host;
  uint32_t load_state;
  uint8_t pad3_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data> state_param;
  uint64_t upload_position;
  uint64_t upload_size;

 private:
  LoadInfo_Data();
  ~LoadInfo_Data() = delete;
};
static_assert(sizeof(LoadInfo_Data) == 56,
              "Bad sizeof(LoadInfo_Data)");
// Used by LoadInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct LoadInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  LoadInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~LoadInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    LoadInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    LoadInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  HttpAuthStaticParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(HttpAuthStaticParams_Data));
      new (data()) HttpAuthStaticParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    HttpAuthStaticParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<HttpAuthStaticParams_Data>(index_);
    }
    HttpAuthStaticParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> supported_schemes;
  mojo::internal::Pointer<mojo::internal::String_Data> gssapi_library_name;
  uint8_t allow_gssapi_library_load : 1;
  uint8_t padfinal_[7];

 private:
  HttpAuthStaticParams_Data();
  ~HttpAuthStaticParams_Data() = delete;
};
static_assert(sizeof(HttpAuthStaticParams_Data) == 32,
              "Bad sizeof(HttpAuthStaticParams_Data)");
// Used by HttpAuthStaticParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct HttpAuthStaticParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  HttpAuthStaticParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~HttpAuthStaticParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    HttpAuthStaticParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    HttpAuthStaticParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  HttpAuthDynamicParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(HttpAuthDynamicParams_Data));
      new (data()) HttpAuthDynamicParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    HttpAuthDynamicParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<HttpAuthDynamicParams_Data>(index_);
    }
    HttpAuthDynamicParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> server_whitelist;
  mojo::internal::Pointer<mojo::internal::String_Data> delegate_whitelist;
  uint8_t negotiate_disable_cname_lookup : 1;
  uint8_t enable_negotiate_port : 1;
  uint8_t ntlm_v2_enabled : 1;
  uint8_t pad4_[7];
  mojo::internal::Pointer<mojo::internal::String_Data> android_negotiate_account_type;

 private:
  HttpAuthDynamicParams_Data();
  ~HttpAuthDynamicParams_Data() = delete;
};
static_assert(sizeof(HttpAuthDynamicParams_Data) == 40,
              "Bad sizeof(HttpAuthDynamicParams_Data)");
// Used by HttpAuthDynamicParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct HttpAuthDynamicParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  HttpAuthDynamicParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~HttpAuthDynamicParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    HttpAuthDynamicParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    HttpAuthDynamicParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  CryptConfig_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CryptConfig_Data));
      new (data()) CryptConfig_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CryptConfig_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CryptConfig_Data>(index_);
    }
    CryptConfig_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> store;
  mojo::internal::Pointer<mojo::internal::String_Data> product_name;
  uint8_t should_use_preference : 1;
  uint8_t pad2_[7];
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> user_data_path;

 private:
  CryptConfig_Data();
  ~CryptConfig_Data() = delete;
};
static_assert(sizeof(CryptConfig_Data) == 40,
              "Bad sizeof(CryptConfig_Data)");
// Used by CryptConfig::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct CryptConfig_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  CryptConfig_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~CryptConfig_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    CryptConfig_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    CryptConfig_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  EnvironmentVariable_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(EnvironmentVariable_Data));
      new (data()) EnvironmentVariable_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    EnvironmentVariable_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<EnvironmentVariable_Data>(index_);
    }
    EnvironmentVariable_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::String_Data> value;

 private:
  EnvironmentVariable_Data();
  ~EnvironmentVariable_Data() = delete;
};
static_assert(sizeof(EnvironmentVariable_Data) == 24,
              "Bad sizeof(EnvironmentVariable_Data)");
// Used by EnvironmentVariable::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct EnvironmentVariable_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  EnvironmentVariable_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~EnvironmentVariable_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    EnvironmentVariable_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    EnvironmentVariable_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  NetworkServiceParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceParams_Data));
      new (data()) NetworkServiceParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceParams_Data>(index_);
    }
    NetworkServiceParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t initial_connection_type;
  int32_t initial_connection_subtype;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::EnvironmentVariable_Data>>> environment;

 private:
  NetworkServiceParams_Data();
  ~NetworkServiceParams_Data() = delete;
};
static_assert(sizeof(NetworkServiceParams_Data) == 24,
              "Bad sizeof(NetworkServiceParams_Data)");
// Used by NetworkServiceParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct NetworkServiceParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  NetworkServiceParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~NetworkServiceParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    NetworkServiceParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    NetworkServiceParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  SSLPrivateKey_Sign_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SSLPrivateKey_Sign_Params_Data));
      new (data()) SSLPrivateKey_Sign_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SSLPrivateKey_Sign_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SSLPrivateKey_Sign_Params_Data>(index_);
    }
    SSLPrivateKey_Sign_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint16_t algorithm;
  uint8_t pad0_[6];
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> input;

 private:
  SSLPrivateKey_Sign_Params_Data();
  ~SSLPrivateKey_Sign_Params_Data() = delete;
};
static_assert(sizeof(SSLPrivateKey_Sign_Params_Data) == 24,
              "Bad sizeof(SSLPrivateKey_Sign_Params_Data)");
class  SSLPrivateKey_Sign_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SSLPrivateKey_Sign_ResponseParams_Data));
      new (data()) SSLPrivateKey_Sign_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SSLPrivateKey_Sign_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SSLPrivateKey_Sign_ResponseParams_Data>(index_);
    }
    SSLPrivateKey_Sign_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> signature;

 private:
  SSLPrivateKey_Sign_ResponseParams_Data();
  ~SSLPrivateKey_Sign_ResponseParams_Data() = delete;
};
static_assert(sizeof(SSLPrivateKey_Sign_ResponseParams_Data) == 24,
              "Bad sizeof(SSLPrivateKey_Sign_ResponseParams_Data)");
class  AuthChallengeResponder_OnAuthCredentials_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AuthChallengeResponder_OnAuthCredentials_Params_Data));
      new (data()) AuthChallengeResponder_OnAuthCredentials_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AuthChallengeResponder_OnAuthCredentials_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AuthChallengeResponder_OnAuthCredentials_Params_Data>(index_);
    }
    AuthChallengeResponder_OnAuthCredentials_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::AuthCredentials_Data> credentials;

 private:
  AuthChallengeResponder_OnAuthCredentials_Params_Data();
  ~AuthChallengeResponder_OnAuthCredentials_Params_Data() = delete;
};
static_assert(sizeof(AuthChallengeResponder_OnAuthCredentials_Params_Data) == 16,
              "Bad sizeof(AuthChallengeResponder_OnAuthCredentials_Params_Data)");
class  NetworkServiceClient_OnAuthRequired_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnAuthRequired_Params_Data));
      new (data()) NetworkServiceClient_OnAuthRequired_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnAuthRequired_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnAuthRequired_Params_Data>(index_);
    }
    NetworkServiceClient_OnAuthRequired_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t process_id;
  uint32_t routing_id;
  uint32_t request_id;
  uint8_t first_auth_attempt : 1;
  uint8_t pad3_[3];
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> site_for_cookies;
  mojo::internal::Pointer<::network::mojom::internal::AuthChallengeInfo_Data> auth_info;
  int32_t resource_type;
  uint8_t pad7_[4];
  mojo::internal::Pointer<::network::mojom::internal::URLResponseHead_Data> head;
  mojo::internal::Interface_Data auth_challenge_responder;

 private:
  NetworkServiceClient_OnAuthRequired_Params_Data();
  ~NetworkServiceClient_OnAuthRequired_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnAuthRequired_Params_Data) == 72,
              "Bad sizeof(NetworkServiceClient_OnAuthRequired_Params_Data)");
class  NetworkServiceClient_OnCertificateRequested_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnCertificateRequested_Params_Data));
      new (data()) NetworkServiceClient_OnCertificateRequested_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnCertificateRequested_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnCertificateRequested_Params_Data>(index_);
    }
    NetworkServiceClient_OnCertificateRequested_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> window_id;
  uint32_t process_id;
  uint32_t routing_id;
  uint32_t request_id;
  uint8_t pad3_[4];
  mojo::internal::Pointer<::network::mojom::internal::SSLCertRequestInfo_Data> cert_info;

 private:
  NetworkServiceClient_OnCertificateRequested_Params_Data();
  ~NetworkServiceClient_OnCertificateRequested_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnCertificateRequested_Params_Data) == 40,
              "Bad sizeof(NetworkServiceClient_OnCertificateRequested_Params_Data)");
class  NetworkServiceClient_OnCertificateRequested_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnCertificateRequested_ResponseParams_Data));
      new (data()) NetworkServiceClient_OnCertificateRequested_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnCertificateRequested_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnCertificateRequested_ResponseParams_Data>(index_);
    }
    NetworkServiceClient_OnCertificateRequested_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::X509Certificate_Data> x509_certificate;
  mojo::internal::Pointer<mojo::internal::String_Data> provider_name;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint16_t>> algorithm_preferences;
  mojo::internal::Interface_Data ssl_private_key;
  uint8_t cancel_certificate_selection : 1;
  uint8_t padfinal_[7];

 private:
  NetworkServiceClient_OnCertificateRequested_ResponseParams_Data();
  ~NetworkServiceClient_OnCertificateRequested_ResponseParams_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnCertificateRequested_ResponseParams_Data) == 48,
              "Bad sizeof(NetworkServiceClient_OnCertificateRequested_ResponseParams_Data)");
class  NetworkServiceClient_OnSSLCertificateError_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnSSLCertificateError_Params_Data));
      new (data()) NetworkServiceClient_OnSSLCertificateError_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnSSLCertificateError_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnSSLCertificateError_Params_Data>(index_);
    }
    NetworkServiceClient_OnSSLCertificateError_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t process_id;
  uint32_t routing_id;
  uint32_t request_id;
  int32_t resource_type;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<::network::mojom::internal::SSLInfo_Data> ssl_info;
  uint8_t fatal : 1;
  uint8_t padfinal_[7];

 private:
  NetworkServiceClient_OnSSLCertificateError_Params_Data();
  ~NetworkServiceClient_OnSSLCertificateError_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnSSLCertificateError_Params_Data) == 48,
              "Bad sizeof(NetworkServiceClient_OnSSLCertificateError_Params_Data)");
class  NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data));
      new (data()) NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data>(index_);
    }
    NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t padfinal_[4];

 private:
  NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data();
  ~NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data) == 16,
              "Bad sizeof(NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data)");
class  NetworkServiceClient_OnFileUploadRequested_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnFileUploadRequested_Params_Data));
      new (data()) NetworkServiceClient_OnFileUploadRequested_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnFileUploadRequested_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnFileUploadRequested_Params_Data>(index_);
    }
    NetworkServiceClient_OnFileUploadRequested_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t process_id;
  uint8_t async : 1;
  uint8_t pad1_[3];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data>>> file_paths;

 private:
  NetworkServiceClient_OnFileUploadRequested_Params_Data();
  ~NetworkServiceClient_OnFileUploadRequested_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnFileUploadRequested_Params_Data) == 24,
              "Bad sizeof(NetworkServiceClient_OnFileUploadRequested_Params_Data)");
class  NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data));
      new (data()) NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data>(index_);
    }
    NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::mojo_base::mojom::internal::File_Data>>> files;

 private:
  NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data();
  ~NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data) == 24,
              "Bad sizeof(NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data)");
class  NetworkServiceClient_OnCookieChange_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnCookieChange_Params_Data));
      new (data()) NetworkServiceClient_OnCookieChange_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnCookieChange_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnCookieChange_Params_Data>(index_);
    }
    NetworkServiceClient_OnCookieChange_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t process_id;
  int32_t routing_id;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> frame_url;
  mojo::internal::Pointer<::network::mojom::internal::CanonicalCookie_Data> cookie;
  uint8_t blocked_by_policy : 1;
  uint8_t padfinal_[7];

 private:
  NetworkServiceClient_OnCookieChange_Params_Data();
  ~NetworkServiceClient_OnCookieChange_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnCookieChange_Params_Data) == 48,
              "Bad sizeof(NetworkServiceClient_OnCookieChange_Params_Data)");
class  NetworkServiceClient_OnCookiesRead_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnCookiesRead_Params_Data));
      new (data()) NetworkServiceClient_OnCookiesRead_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnCookiesRead_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnCookiesRead_Params_Data>(index_);
    }
    NetworkServiceClient_OnCookiesRead_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t process_id;
  int32_t routing_id;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> frame_url;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::network::mojom::internal::CanonicalCookie_Data>>> cookie_list;
  uint8_t blocked_by_policy : 1;
  uint8_t padfinal_[7];

 private:
  NetworkServiceClient_OnCookiesRead_Params_Data();
  ~NetworkServiceClient_OnCookiesRead_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnCookiesRead_Params_Data) == 48,
              "Bad sizeof(NetworkServiceClient_OnCookiesRead_Params_Data)");
class  NetworkServiceClient_OnLoadingStateUpdate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnLoadingStateUpdate_Params_Data));
      new (data()) NetworkServiceClient_OnLoadingStateUpdate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnLoadingStateUpdate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnLoadingStateUpdate_Params_Data>(index_);
    }
    NetworkServiceClient_OnLoadingStateUpdate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::LoadInfo_Data>>> infos;

 private:
  NetworkServiceClient_OnLoadingStateUpdate_Params_Data();
  ~NetworkServiceClient_OnLoadingStateUpdate_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnLoadingStateUpdate_Params_Data) == 16,
              "Bad sizeof(NetworkServiceClient_OnLoadingStateUpdate_Params_Data)");
class  NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data));
      new (data()) NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data>(index_);
    }
    NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data();
  ~NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data) == 8,
              "Bad sizeof(NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data)");
class  NetworkServiceClient_OnClearSiteData_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnClearSiteData_Params_Data));
      new (data()) NetworkServiceClient_OnClearSiteData_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnClearSiteData_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnClearSiteData_Params_Data>(index_);
    }
    NetworkServiceClient_OnClearSiteData_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t process_id;
  int32_t routing_id;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<mojo::internal::String_Data> header_value;
  int32_t load_flags;
  uint8_t padfinal_[4];

 private:
  NetworkServiceClient_OnClearSiteData_Params_Data();
  ~NetworkServiceClient_OnClearSiteData_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnClearSiteData_Params_Data) == 40,
              "Bad sizeof(NetworkServiceClient_OnClearSiteData_Params_Data)");
class  NetworkServiceClient_OnClearSiteData_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnClearSiteData_ResponseParams_Data));
      new (data()) NetworkServiceClient_OnClearSiteData_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnClearSiteData_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnClearSiteData_ResponseParams_Data>(index_);
    }
    NetworkServiceClient_OnClearSiteData_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NetworkServiceClient_OnClearSiteData_ResponseParams_Data();
  ~NetworkServiceClient_OnClearSiteData_ResponseParams_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnClearSiteData_ResponseParams_Data) == 8,
              "Bad sizeof(NetworkServiceClient_OnClearSiteData_ResponseParams_Data)");
class  NetworkServiceClient_OnDataUseUpdate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkServiceClient_OnDataUseUpdate_Params_Data));
      new (data()) NetworkServiceClient_OnDataUseUpdate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkServiceClient_OnDataUseUpdate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkServiceClient_OnDataUseUpdate_Params_Data>(index_);
    }
    NetworkServiceClient_OnDataUseUpdate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t network_traffic_annotation_id_hash;
  uint8_t pad0_[4];
  int64_t recv_bytes;
  int64_t sent_bytes;

 private:
  NetworkServiceClient_OnDataUseUpdate_Params_Data();
  ~NetworkServiceClient_OnDataUseUpdate_Params_Data() = delete;
};
static_assert(sizeof(NetworkServiceClient_OnDataUseUpdate_Params_Data) == 32,
              "Bad sizeof(NetworkServiceClient_OnDataUseUpdate_Params_Data)");
class  NetworkService_SetClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_SetClient_Params_Data));
      new (data()) NetworkService_SetClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_SetClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_SetClient_Params_Data>(index_);
    }
    NetworkService_SetClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client;
  mojo::internal::Pointer<internal::NetworkServiceParams_Data> params;

 private:
  NetworkService_SetClient_Params_Data();
  ~NetworkService_SetClient_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_SetClient_Params_Data) == 24,
              "Bad sizeof(NetworkService_SetClient_Params_Data)");
class  NetworkService_StartNetLog_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_StartNetLog_Params_Data));
      new (data()) NetworkService_StartNetLog_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_StartNetLog_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_StartNetLog_Params_Data>(index_);
    }
    NetworkService_StartNetLog_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::File_Data> file;
  int32_t capture_mode;
  uint8_t pad1_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::DictionaryValue_Data> constants;

 private:
  NetworkService_StartNetLog_Params_Data();
  ~NetworkService_StartNetLog_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_StartNetLog_Params_Data) == 32,
              "Bad sizeof(NetworkService_StartNetLog_Params_Data)");
class  NetworkService_SetSSLKeyLogFile_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_SetSSLKeyLogFile_Params_Data));
      new (data()) NetworkService_SetSSLKeyLogFile_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_SetSSLKeyLogFile_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_SetSSLKeyLogFile_Params_Data>(index_);
    }
    NetworkService_SetSSLKeyLogFile_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> file;

 private:
  NetworkService_SetSSLKeyLogFile_Params_Data();
  ~NetworkService_SetSSLKeyLogFile_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_SetSSLKeyLogFile_Params_Data) == 16,
              "Bad sizeof(NetworkService_SetSSLKeyLogFile_Params_Data)");
class  NetworkService_CreateNetworkContext_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_CreateNetworkContext_Params_Data));
      new (data()) NetworkService_CreateNetworkContext_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_CreateNetworkContext_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_CreateNetworkContext_Params_Data>(index_);
    }
    NetworkService_CreateNetworkContext_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data context;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::network::mojom::internal::NetworkContextParams_Data> params;

 private:
  NetworkService_CreateNetworkContext_Params_Data();
  ~NetworkService_CreateNetworkContext_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_CreateNetworkContext_Params_Data) == 24,
              "Bad sizeof(NetworkService_CreateNetworkContext_Params_Data)");
class  NetworkService_ConfigureStubHostResolver_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_ConfigureStubHostResolver_Params_Data));
      new (data()) NetworkService_ConfigureStubHostResolver_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_ConfigureStubHostResolver_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_ConfigureStubHostResolver_Params_Data>(index_);
    }
    NetworkService_ConfigureStubHostResolver_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t stub_resolver_enabled : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::network::mojom::internal::DnsOverHttpsServer_Data>>> dns_over_https_servers;

 private:
  NetworkService_ConfigureStubHostResolver_Params_Data();
  ~NetworkService_ConfigureStubHostResolver_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_ConfigureStubHostResolver_Params_Data) == 24,
              "Bad sizeof(NetworkService_ConfigureStubHostResolver_Params_Data)");
class  NetworkService_DisableQuic_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_DisableQuic_Params_Data));
      new (data()) NetworkService_DisableQuic_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_DisableQuic_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_DisableQuic_Params_Data>(index_);
    }
    NetworkService_DisableQuic_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NetworkService_DisableQuic_Params_Data();
  ~NetworkService_DisableQuic_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_DisableQuic_Params_Data) == 8,
              "Bad sizeof(NetworkService_DisableQuic_Params_Data)");
class  NetworkService_SetUpHttpAuth_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_SetUpHttpAuth_Params_Data));
      new (data()) NetworkService_SetUpHttpAuth_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_SetUpHttpAuth_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_SetUpHttpAuth_Params_Data>(index_);
    }
    NetworkService_SetUpHttpAuth_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::HttpAuthStaticParams_Data> http_auth_static_params;

 private:
  NetworkService_SetUpHttpAuth_Params_Data();
  ~NetworkService_SetUpHttpAuth_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_SetUpHttpAuth_Params_Data) == 16,
              "Bad sizeof(NetworkService_SetUpHttpAuth_Params_Data)");
class  NetworkService_ConfigureHttpAuthPrefs_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_ConfigureHttpAuthPrefs_Params_Data));
      new (data()) NetworkService_ConfigureHttpAuthPrefs_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_ConfigureHttpAuthPrefs_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_ConfigureHttpAuthPrefs_Params_Data>(index_);
    }
    NetworkService_ConfigureHttpAuthPrefs_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::HttpAuthDynamicParams_Data> http_auth_dynamic_params;

 private:
  NetworkService_ConfigureHttpAuthPrefs_Params_Data();
  ~NetworkService_ConfigureHttpAuthPrefs_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_ConfigureHttpAuthPrefs_Params_Data) == 16,
              "Bad sizeof(NetworkService_ConfigureHttpAuthPrefs_Params_Data)");
class  NetworkService_SetRawHeadersAccess_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_SetRawHeadersAccess_Params_Data));
      new (data()) NetworkService_SetRawHeadersAccess_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_SetRawHeadersAccess_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_SetRawHeadersAccess_Params_Data>(index_);
    }
    NetworkService_SetRawHeadersAccess_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t process_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::url::mojom::internal::Origin_Data>>> origins;

 private:
  NetworkService_SetRawHeadersAccess_Params_Data();
  ~NetworkService_SetRawHeadersAccess_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_SetRawHeadersAccess_Params_Data) == 24,
              "Bad sizeof(NetworkService_SetRawHeadersAccess_Params_Data)");
class  NetworkService_GetNetworkChangeManager_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_GetNetworkChangeManager_Params_Data));
      new (data()) NetworkService_GetNetworkChangeManager_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_GetNetworkChangeManager_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_GetNetworkChangeManager_Params_Data>(index_);
    }
    NetworkService_GetNetworkChangeManager_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data network_change_manager;
  uint8_t padfinal_[4];

 private:
  NetworkService_GetNetworkChangeManager_Params_Data();
  ~NetworkService_GetNetworkChangeManager_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_GetNetworkChangeManager_Params_Data) == 16,
              "Bad sizeof(NetworkService_GetNetworkChangeManager_Params_Data)");
class  NetworkService_GetNetworkQualityEstimatorManager_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_GetNetworkQualityEstimatorManager_Params_Data));
      new (data()) NetworkService_GetNetworkQualityEstimatorManager_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_GetNetworkQualityEstimatorManager_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_GetNetworkQualityEstimatorManager_Params_Data>(index_);
    }
    NetworkService_GetNetworkQualityEstimatorManager_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data network_quality_estimator_manager;
  uint8_t padfinal_[4];

 private:
  NetworkService_GetNetworkQualityEstimatorManager_Params_Data();
  ~NetworkService_GetNetworkQualityEstimatorManager_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_GetNetworkQualityEstimatorManager_Params_Data) == 16,
              "Bad sizeof(NetworkService_GetNetworkQualityEstimatorManager_Params_Data)");
class  NetworkService_GetDnsConfigChangeManager_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_GetDnsConfigChangeManager_Params_Data));
      new (data()) NetworkService_GetDnsConfigChangeManager_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_GetDnsConfigChangeManager_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_GetDnsConfigChangeManager_Params_Data>(index_);
    }
    NetworkService_GetDnsConfigChangeManager_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data dns_config_change_manager;
  uint8_t padfinal_[4];

 private:
  NetworkService_GetDnsConfigChangeManager_Params_Data();
  ~NetworkService_GetDnsConfigChangeManager_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_GetDnsConfigChangeManager_Params_Data) == 16,
              "Bad sizeof(NetworkService_GetDnsConfigChangeManager_Params_Data)");
class  NetworkService_GetTotalNetworkUsages_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_GetTotalNetworkUsages_Params_Data));
      new (data()) NetworkService_GetTotalNetworkUsages_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_GetTotalNetworkUsages_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_GetTotalNetworkUsages_Params_Data>(index_);
    }
    NetworkService_GetTotalNetworkUsages_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NetworkService_GetTotalNetworkUsages_Params_Data();
  ~NetworkService_GetTotalNetworkUsages_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_GetTotalNetworkUsages_Params_Data) == 8,
              "Bad sizeof(NetworkService_GetTotalNetworkUsages_Params_Data)");
class  NetworkService_GetTotalNetworkUsages_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_GetTotalNetworkUsages_ResponseParams_Data));
      new (data()) NetworkService_GetTotalNetworkUsages_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_GetTotalNetworkUsages_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_GetTotalNetworkUsages_ResponseParams_Data>(index_);
    }
    NetworkService_GetTotalNetworkUsages_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::network::mojom::internal::NetworkUsage_Data>>> total_network_usages;

 private:
  NetworkService_GetTotalNetworkUsages_ResponseParams_Data();
  ~NetworkService_GetTotalNetworkUsages_ResponseParams_Data() = delete;
};
static_assert(sizeof(NetworkService_GetTotalNetworkUsages_ResponseParams_Data) == 16,
              "Bad sizeof(NetworkService_GetTotalNetworkUsages_ResponseParams_Data)");
class  NetworkService_GetNetworkList_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_GetNetworkList_Params_Data));
      new (data()) NetworkService_GetNetworkList_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_GetNetworkList_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_GetNetworkList_Params_Data>(index_);
    }
    NetworkService_GetNetworkList_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t policy;
  uint8_t padfinal_[4];

 private:
  NetworkService_GetNetworkList_Params_Data();
  ~NetworkService_GetNetworkList_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_GetNetworkList_Params_Data) == 16,
              "Bad sizeof(NetworkService_GetNetworkList_Params_Data)");
class  NetworkService_GetNetworkList_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_GetNetworkList_ResponseParams_Data));
      new (data()) NetworkService_GetNetworkList_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_GetNetworkList_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_GetNetworkList_ResponseParams_Data>(index_);
    }
    NetworkService_GetNetworkList_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::network::mojom::internal::NetworkInterface_Data>>> networks;

 private:
  NetworkService_GetNetworkList_ResponseParams_Data();
  ~NetworkService_GetNetworkList_ResponseParams_Data() = delete;
};
static_assert(sizeof(NetworkService_GetNetworkList_ResponseParams_Data) == 16,
              "Bad sizeof(NetworkService_GetNetworkList_ResponseParams_Data)");
class  NetworkService_UpdateSignedTreeHead_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_UpdateSignedTreeHead_Params_Data));
      new (data()) NetworkService_UpdateSignedTreeHead_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_UpdateSignedTreeHead_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_UpdateSignedTreeHead_Params_Data>(index_);
    }
    NetworkService_UpdateSignedTreeHead_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::SignedTreeHead_Data> signed_tree_head;

 private:
  NetworkService_UpdateSignedTreeHead_Params_Data();
  ~NetworkService_UpdateSignedTreeHead_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_UpdateSignedTreeHead_Params_Data) == 16,
              "Bad sizeof(NetworkService_UpdateSignedTreeHead_Params_Data)");
class  NetworkService_UpdateCRLSet_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_UpdateCRLSet_Params_Data));
      new (data()) NetworkService_UpdateCRLSet_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_UpdateCRLSet_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_UpdateCRLSet_Params_Data>(index_);
    }
    NetworkService_UpdateCRLSet_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlyBuffer_Data> crl_set;

 private:
  NetworkService_UpdateCRLSet_Params_Data();
  ~NetworkService_UpdateCRLSet_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_UpdateCRLSet_Params_Data) == 16,
              "Bad sizeof(NetworkService_UpdateCRLSet_Params_Data)");
class  NetworkService_OnCertDBChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_OnCertDBChanged_Params_Data));
      new (data()) NetworkService_OnCertDBChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_OnCertDBChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_OnCertDBChanged_Params_Data>(index_);
    }
    NetworkService_OnCertDBChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NetworkService_OnCertDBChanged_Params_Data();
  ~NetworkService_OnCertDBChanged_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_OnCertDBChanged_Params_Data) == 8,
              "Bad sizeof(NetworkService_OnCertDBChanged_Params_Data)");
class  NetworkService_SetCryptConfig_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_SetCryptConfig_Params_Data));
      new (data()) NetworkService_SetCryptConfig_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_SetCryptConfig_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_SetCryptConfig_Params_Data>(index_);
    }
    NetworkService_SetCryptConfig_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CryptConfig_Data> crypt_config;

 private:
  NetworkService_SetCryptConfig_Params_Data();
  ~NetworkService_SetCryptConfig_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_SetCryptConfig_Params_Data) == 16,
              "Bad sizeof(NetworkService_SetCryptConfig_Params_Data)");
class  NetworkService_AddCorbExceptionForPlugin_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_AddCorbExceptionForPlugin_Params_Data));
      new (data()) NetworkService_AddCorbExceptionForPlugin_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_AddCorbExceptionForPlugin_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_AddCorbExceptionForPlugin_Params_Data>(index_);
    }
    NetworkService_AddCorbExceptionForPlugin_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t process_id;
  uint8_t padfinal_[4];

 private:
  NetworkService_AddCorbExceptionForPlugin_Params_Data();
  ~NetworkService_AddCorbExceptionForPlugin_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_AddCorbExceptionForPlugin_Params_Data) == 16,
              "Bad sizeof(NetworkService_AddCorbExceptionForPlugin_Params_Data)");
class  NetworkService_RemoveCorbExceptionForPlugin_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_RemoveCorbExceptionForPlugin_Params_Data));
      new (data()) NetworkService_RemoveCorbExceptionForPlugin_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_RemoveCorbExceptionForPlugin_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_RemoveCorbExceptionForPlugin_Params_Data>(index_);
    }
    NetworkService_RemoveCorbExceptionForPlugin_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t process_id;
  uint8_t padfinal_[4];

 private:
  NetworkService_RemoveCorbExceptionForPlugin_Params_Data();
  ~NetworkService_RemoveCorbExceptionForPlugin_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_RemoveCorbExceptionForPlugin_Params_Data) == 16,
              "Bad sizeof(NetworkService_RemoveCorbExceptionForPlugin_Params_Data)");
class  NetworkService_OnMemoryPressure_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_OnMemoryPressure_Params_Data));
      new (data()) NetworkService_OnMemoryPressure_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_OnMemoryPressure_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_OnMemoryPressure_Params_Data>(index_);
    }
    NetworkService_OnMemoryPressure_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t memory_pressure_level;
  uint8_t padfinal_[4];

 private:
  NetworkService_OnMemoryPressure_Params_Data();
  ~NetworkService_OnMemoryPressure_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_OnMemoryPressure_Params_Data) == 16,
              "Bad sizeof(NetworkService_OnMemoryPressure_Params_Data)");
class  NetworkService_SetEnvironment_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkService_SetEnvironment_Params_Data));
      new (data()) NetworkService_SetEnvironment_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkService_SetEnvironment_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkService_SetEnvironment_Params_Data>(index_);
    }
    NetworkService_SetEnvironment_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::EnvironmentVariable_Data>>> environment;

 private:
  NetworkService_SetEnvironment_Params_Data();
  ~NetworkService_SetEnvironment_Params_Data() = delete;
};
static_assert(sizeof(NetworkService_SetEnvironment_Params_Data) == 16,
              "Bad sizeof(NetworkService_SetEnvironment_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_SERVICE_MOJOM_SHARED_INTERNAL_H_