// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_SERVICE_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/network/public/mojom/network_service.mojom-shared-internal.h"
#include "mojo/public/mojom/base/file.mojom-shared.h"
#include "mojo/public/mojom/base/file_path.mojom-shared.h"
#include "mojo/public/mojom/base/memory_pressure_level.mojom-shared.h"
#include "mojo/public/mojom/base/read_only_buffer.mojom-shared.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared.h"
#include "mojo/public/mojom/base/values.mojom-shared.h"
#include "services/network/public/mojom/cookie_manager.mojom-shared.h"
#include "services/network/public/mojom/host_resolver.mojom-shared.h"
#include "services/network/public/mojom/net_log.mojom-shared.h"
#include "services/network/public/mojom/network_change_manager.mojom-shared.h"
#include "services/network/public/mojom/network_context.mojom-shared.h"
#include "services/network/public/mojom/network_interface.mojom-shared.h"
#include "services/network/public/mojom/network_param.mojom-shared.h"
#include "services/network/public/mojom/network_quality_estimator_manager.mojom-shared.h"
#include "services/network/public/mojom/url_loader.mojom-shared.h"
#include "services/network/public/mojom/url_loader_factory.mojom-shared.h"
#include "url/mojom/origin.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"
#include "services/network/public/mojom/signed_tree_head.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace network {
namespace mojom {
class LoadInfoDataView;

class HttpAuthStaticParamsDataView;

class HttpAuthDynamicParamsDataView;

class CryptConfigDataView;

class EnvironmentVariableDataView;

class NetworkServiceParamsDataView;



}  // namespace mojom
}  // namespace network

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::network::mojom::LoadInfoDataView> {
  using Data = ::network::mojom::internal::LoadInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::network::mojom::HttpAuthStaticParamsDataView> {
  using Data = ::network::mojom::internal::HttpAuthStaticParams_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::network::mojom::HttpAuthDynamicParamsDataView> {
  using Data = ::network::mojom::internal::HttpAuthDynamicParams_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::network::mojom::CryptConfigDataView> {
  using Data = ::network::mojom::internal::CryptConfig_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::network::mojom::EnvironmentVariableDataView> {
  using Data = ::network::mojom::internal::EnvironmentVariable_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::network::mojom::NetworkServiceParamsDataView> {
  using Data = ::network::mojom::internal::NetworkServiceParams_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace network {
namespace mojom {
// Interface base classes. They are used for type safety check.
class SSLPrivateKeyInterfaceBase {};

using SSLPrivateKeyPtrDataView =
    mojo::InterfacePtrDataView<SSLPrivateKeyInterfaceBase>;
using SSLPrivateKeyRequestDataView =
    mojo::InterfaceRequestDataView<SSLPrivateKeyInterfaceBase>;
using SSLPrivateKeyAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<SSLPrivateKeyInterfaceBase>;
using SSLPrivateKeyAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<SSLPrivateKeyInterfaceBase>;
class AuthChallengeResponderInterfaceBase {};

using AuthChallengeResponderPtrDataView =
    mojo::InterfacePtrDataView<AuthChallengeResponderInterfaceBase>;
using AuthChallengeResponderRequestDataView =
    mojo::InterfaceRequestDataView<AuthChallengeResponderInterfaceBase>;
using AuthChallengeResponderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AuthChallengeResponderInterfaceBase>;
using AuthChallengeResponderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AuthChallengeResponderInterfaceBase>;
class NetworkServiceClientInterfaceBase {};

using NetworkServiceClientPtrDataView =
    mojo::InterfacePtrDataView<NetworkServiceClientInterfaceBase>;
using NetworkServiceClientRequestDataView =
    mojo::InterfaceRequestDataView<NetworkServiceClientInterfaceBase>;
using NetworkServiceClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NetworkServiceClientInterfaceBase>;
using NetworkServiceClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NetworkServiceClientInterfaceBase>;
class NetworkServiceInterfaceBase {};

using NetworkServicePtrDataView =
    mojo::InterfacePtrDataView<NetworkServiceInterfaceBase>;
using NetworkServiceRequestDataView =
    mojo::InterfaceRequestDataView<NetworkServiceInterfaceBase>;
using NetworkServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NetworkServiceInterfaceBase>;
using NetworkServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NetworkServiceInterfaceBase>;
class LoadInfoDataView {
 public:
  LoadInfoDataView() {}

  LoadInfoDataView(
      internal::LoadInfo_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t process_id() const {
    return data_->process_id;
  }
  uint32_t routing_id() const {
    return data_->routing_id;
  }
  inline void GetHostDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHost(UserType* output) {
    auto* pointer = data_->host.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  uint32_t load_state() const {
    return data_->load_state;
  }
  inline void GetStateParamDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStateParam(UserType* output) {
    auto* pointer = data_->state_param.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  uint64_t upload_position() const {
    return data_->upload_position;
  }
  uint64_t upload_size() const {
    return data_->upload_size;
  }
 private:
  internal::LoadInfo_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class HttpAuthStaticParamsDataView {
 public:
  HttpAuthStaticParamsDataView() {}

  HttpAuthStaticParamsDataView(
      internal::HttpAuthStaticParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSupportedSchemesDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSupportedSchemes(UserType* output) {
    auto* pointer = data_->supported_schemes.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
  inline void GetGssapiLibraryNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGssapiLibraryName(UserType* output) {
    auto* pointer = data_->gssapi_library_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool allow_gssapi_library_load() const {
    return data_->allow_gssapi_library_load;
  }
 private:
  internal::HttpAuthStaticParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class HttpAuthDynamicParamsDataView {
 public:
  HttpAuthDynamicParamsDataView() {}

  HttpAuthDynamicParamsDataView(
      internal::HttpAuthDynamicParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServerWhitelistDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServerWhitelist(UserType* output) {
    auto* pointer = data_->server_whitelist.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDelegateWhitelistDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDelegateWhitelist(UserType* output) {
    auto* pointer = data_->delegate_whitelist.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool negotiate_disable_cname_lookup() const {
    return data_->negotiate_disable_cname_lookup;
  }
  bool enable_negotiate_port() const {
    return data_->enable_negotiate_port;
  }
  bool ntlm_v2_enabled() const {
    return data_->ntlm_v2_enabled;
  }
  inline void GetAndroidNegotiateAccountTypeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAndroidNegotiateAccountType(UserType* output) {
    auto* pointer = data_->android_negotiate_account_type.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::HttpAuthDynamicParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class CryptConfigDataView {
 public:
  CryptConfigDataView() {}

  CryptConfigDataView(
      internal::CryptConfig_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetStoreDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStore(UserType* output) {
    auto* pointer = data_->store.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetProductNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadProductName(UserType* output) {
    auto* pointer = data_->product_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool should_use_preference() const {
    return data_->should_use_preference;
  }
  inline void GetUserDataPathDataView(
      ::mojo_base::mojom::FilePathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUserDataPath(UserType* output) {
    auto* pointer = data_->user_data_path.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FilePathDataView>(
        pointer, output, context_);
  }
 private:
  internal::CryptConfig_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class EnvironmentVariableDataView {
 public:
  EnvironmentVariableDataView() {}

  EnvironmentVariableDataView(
      internal::EnvironmentVariable_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::EnvironmentVariable_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceParamsDataView {
 public:
  NetworkServiceParamsDataView() {}

  NetworkServiceParamsDataView(
      internal::NetworkServiceParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInitialConnectionType(UserType* output) const {
    auto data_value = data_->initial_connection_type;
    return mojo::internal::Deserialize<::network::mojom::ConnectionType>(
        data_value, output);
  }

  ::network::mojom::ConnectionType initial_connection_type() const {
    return static_cast<::network::mojom::ConnectionType>(data_->initial_connection_type);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInitialConnectionSubtype(UserType* output) const {
    auto data_value = data_->initial_connection_subtype;
    return mojo::internal::Deserialize<::network::mojom::ConnectionSubtype>(
        data_value, output);
  }

  ::network::mojom::ConnectionSubtype initial_connection_subtype() const {
    return static_cast<::network::mojom::ConnectionSubtype>(data_->initial_connection_subtype);
  }
  inline void GetEnvironmentDataView(
      mojo::ArrayDataView<EnvironmentVariableDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEnvironment(UserType* output) {
    auto* pointer = data_->environment.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::EnvironmentVariableDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkServiceParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SSLPrivateKey_Sign_ParamsDataView {
 public:
  SSLPrivateKey_Sign_ParamsDataView() {}

  SSLPrivateKey_Sign_ParamsDataView(
      internal::SSLPrivateKey_Sign_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint16_t algorithm() const {
    return data_->algorithm;
  }
  inline void GetInputDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInput(UserType* output) {
    auto* pointer = data_->input.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::SSLPrivateKey_Sign_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SSLPrivateKey_Sign_ResponseParamsDataView {
 public:
  SSLPrivateKey_Sign_ResponseParamsDataView() {}

  SSLPrivateKey_Sign_ResponseParamsDataView(
      internal::SSLPrivateKey_Sign_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t net_error() const {
    return data_->net_error;
  }
  inline void GetSignatureDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSignature(UserType* output) {
    auto* pointer = data_->signature.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::SSLPrivateKey_Sign_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AuthChallengeResponder_OnAuthCredentials_ParamsDataView {
 public:
  AuthChallengeResponder_OnAuthCredentials_ParamsDataView() {}

  AuthChallengeResponder_OnAuthCredentials_ParamsDataView(
      internal::AuthChallengeResponder_OnAuthCredentials_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCredentialsDataView(
      ::network::mojom::AuthCredentialsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCredentials(UserType* output) {
    auto* pointer = data_->credentials.Get();
    return mojo::internal::Deserialize<::network::mojom::AuthCredentialsDataView>(
        pointer, output, context_);
  }
 private:
  internal::AuthChallengeResponder_OnAuthCredentials_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnAuthRequired_ParamsDataView {
 public:
  NetworkServiceClient_OnAuthRequired_ParamsDataView() {}

  NetworkServiceClient_OnAuthRequired_ParamsDataView(
      internal::NetworkServiceClient_OnAuthRequired_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t process_id() const {
    return data_->process_id;
  }
  uint32_t routing_id() const {
    return data_->routing_id;
  }
  uint32_t request_id() const {
    return data_->request_id;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetSiteForCookiesDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSiteForCookies(UserType* output) {
    auto* pointer = data_->site_for_cookies.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  bool first_auth_attempt() const {
    return data_->first_auth_attempt;
  }
  inline void GetAuthInfoDataView(
      ::network::mojom::AuthChallengeInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAuthInfo(UserType* output) {
    auto* pointer = data_->auth_info.Get();
    return mojo::internal::Deserialize<::network::mojom::AuthChallengeInfoDataView>(
        pointer, output, context_);
  }
  int32_t resource_type() const {
    return data_->resource_type;
  }
  inline void GetHeadDataView(
      ::network::mojom::URLResponseHeadDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHead(UserType* output) {
    auto* pointer = data_->head.Get();
    return mojo::internal::Deserialize<::network::mojom::URLResponseHeadDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeAuthChallengeResponder() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::AuthChallengeResponderPtrDataView>(
            &data_->auth_challenge_responder, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::NetworkServiceClient_OnAuthRequired_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnCertificateRequested_ParamsDataView {
 public:
  NetworkServiceClient_OnCertificateRequested_ParamsDataView() {}

  NetworkServiceClient_OnCertificateRequested_ParamsDataView(
      internal::NetworkServiceClient_OnCertificateRequested_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWindowIdDataView(
      ::mojo_base::mojom::UnguessableTokenDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWindowId(UserType* output) {
    auto* pointer = data_->window_id.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::UnguessableTokenDataView>(
        pointer, output, context_);
  }
  uint32_t process_id() const {
    return data_->process_id;
  }
  uint32_t routing_id() const {
    return data_->routing_id;
  }
  uint32_t request_id() const {
    return data_->request_id;
  }
  inline void GetCertInfoDataView(
      ::network::mojom::SSLCertRequestInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCertInfo(UserType* output) {
    auto* pointer = data_->cert_info.Get();
    return mojo::internal::Deserialize<::network::mojom::SSLCertRequestInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkServiceClient_OnCertificateRequested_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnCertificateRequested_ResponseParamsDataView {
 public:
  NetworkServiceClient_OnCertificateRequested_ResponseParamsDataView() {}

  NetworkServiceClient_OnCertificateRequested_ResponseParamsDataView(
      internal::NetworkServiceClient_OnCertificateRequested_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetX509CertificateDataView(
      ::network::mojom::X509CertificateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadX509Certificate(UserType* output) {
    auto* pointer = data_->x509_certificate.Get();
    return mojo::internal::Deserialize<::network::mojom::X509CertificateDataView>(
        pointer, output, context_);
  }
  inline void GetProviderNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadProviderName(UserType* output) {
    auto* pointer = data_->provider_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetAlgorithmPreferencesDataView(
      mojo::ArrayDataView<uint16_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAlgorithmPreferences(UserType* output) {
    auto* pointer = data_->algorithm_preferences.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint16_t>>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeSslPrivateKey() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::SSLPrivateKeyPtrDataView>(
            &data_->ssl_private_key, &result, context_);
    DCHECK(ret);
    return result;
  }
  bool cancel_certificate_selection() const {
    return data_->cancel_certificate_selection;
  }
 private:
  internal::NetworkServiceClient_OnCertificateRequested_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnSSLCertificateError_ParamsDataView {
 public:
  NetworkServiceClient_OnSSLCertificateError_ParamsDataView() {}

  NetworkServiceClient_OnSSLCertificateError_ParamsDataView(
      internal::NetworkServiceClient_OnSSLCertificateError_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t process_id() const {
    return data_->process_id;
  }
  uint32_t routing_id() const {
    return data_->routing_id;
  }
  uint32_t request_id() const {
    return data_->request_id;
  }
  int32_t resource_type() const {
    return data_->resource_type;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetSslInfoDataView(
      ::network::mojom::SSLInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSslInfo(UserType* output) {
    auto* pointer = data_->ssl_info.Get();
    return mojo::internal::Deserialize<::network::mojom::SSLInfoDataView>(
        pointer, output, context_);
  }
  bool fatal() const {
    return data_->fatal;
  }
 private:
  internal::NetworkServiceClient_OnSSLCertificateError_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnSSLCertificateError_ResponseParamsDataView {
 public:
  NetworkServiceClient_OnSSLCertificateError_ResponseParamsDataView() {}

  NetworkServiceClient_OnSSLCertificateError_ResponseParamsDataView(
      internal::NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t net_error() const {
    return data_->net_error;
  }
 private:
  internal::NetworkServiceClient_OnSSLCertificateError_ResponseParams_Data* data_ = nullptr;
};

class NetworkServiceClient_OnFileUploadRequested_ParamsDataView {
 public:
  NetworkServiceClient_OnFileUploadRequested_ParamsDataView() {}

  NetworkServiceClient_OnFileUploadRequested_ParamsDataView(
      internal::NetworkServiceClient_OnFileUploadRequested_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t process_id() const {
    return data_->process_id;
  }
  bool async() const {
    return data_->async;
  }
  inline void GetFilePathsDataView(
      mojo::ArrayDataView<::mojo_base::mojom::FilePathDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFilePaths(UserType* output) {
    auto* pointer = data_->file_paths.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::mojo_base::mojom::FilePathDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkServiceClient_OnFileUploadRequested_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnFileUploadRequested_ResponseParamsDataView {
 public:
  NetworkServiceClient_OnFileUploadRequested_ResponseParamsDataView() {}

  NetworkServiceClient_OnFileUploadRequested_ResponseParamsDataView(
      internal::NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t net_error() const {
    return data_->net_error;
  }
  inline void GetFilesDataView(
      mojo::ArrayDataView<::mojo_base::mojom::FileDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFiles(UserType* output) {
    auto* pointer = data_->files.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::mojo_base::mojom::FileDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkServiceClient_OnFileUploadRequested_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnCookieChange_ParamsDataView {
 public:
  NetworkServiceClient_OnCookieChange_ParamsDataView() {}

  NetworkServiceClient_OnCookieChange_ParamsDataView(
      internal::NetworkServiceClient_OnCookieChange_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t process_id() const {
    return data_->process_id;
  }
  int32_t routing_id() const {
    return data_->routing_id;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetFrameUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrameUrl(UserType* output) {
    auto* pointer = data_->frame_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetCookieDataView(
      ::network::mojom::CanonicalCookieDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCookie(UserType* output) {
    auto* pointer = data_->cookie.Get();
    return mojo::internal::Deserialize<::network::mojom::CanonicalCookieDataView>(
        pointer, output, context_);
  }
  bool blocked_by_policy() const {
    return data_->blocked_by_policy;
  }
 private:
  internal::NetworkServiceClient_OnCookieChange_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnCookiesRead_ParamsDataView {
 public:
  NetworkServiceClient_OnCookiesRead_ParamsDataView() {}

  NetworkServiceClient_OnCookiesRead_ParamsDataView(
      internal::NetworkServiceClient_OnCookiesRead_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t process_id() const {
    return data_->process_id;
  }
  int32_t routing_id() const {
    return data_->routing_id;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetFrameUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrameUrl(UserType* output) {
    auto* pointer = data_->frame_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetCookieListDataView(
      mojo::ArrayDataView<::network::mojom::CanonicalCookieDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCookieList(UserType* output) {
    auto* pointer = data_->cookie_list.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::CanonicalCookieDataView>>(
        pointer, output, context_);
  }
  bool blocked_by_policy() const {
    return data_->blocked_by_policy;
  }
 private:
  internal::NetworkServiceClient_OnCookiesRead_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnLoadingStateUpdate_ParamsDataView {
 public:
  NetworkServiceClient_OnLoadingStateUpdate_ParamsDataView() {}

  NetworkServiceClient_OnLoadingStateUpdate_ParamsDataView(
      internal::NetworkServiceClient_OnLoadingStateUpdate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetInfosDataView(
      mojo::ArrayDataView<LoadInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInfos(UserType* output) {
    auto* pointer = data_->infos.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::LoadInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkServiceClient_OnLoadingStateUpdate_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnLoadingStateUpdate_ResponseParamsDataView {
 public:
  NetworkServiceClient_OnLoadingStateUpdate_ResponseParamsDataView() {}

  NetworkServiceClient_OnLoadingStateUpdate_ResponseParamsDataView(
      internal::NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::NetworkServiceClient_OnLoadingStateUpdate_ResponseParams_Data* data_ = nullptr;
};

class NetworkServiceClient_OnClearSiteData_ParamsDataView {
 public:
  NetworkServiceClient_OnClearSiteData_ParamsDataView() {}

  NetworkServiceClient_OnClearSiteData_ParamsDataView(
      internal::NetworkServiceClient_OnClearSiteData_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t process_id() const {
    return data_->process_id;
  }
  int32_t routing_id() const {
    return data_->routing_id;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetHeaderValueDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHeaderValue(UserType* output) {
    auto* pointer = data_->header_value.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  int32_t load_flags() const {
    return data_->load_flags;
  }
 private:
  internal::NetworkServiceClient_OnClearSiteData_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkServiceClient_OnClearSiteData_ResponseParamsDataView {
 public:
  NetworkServiceClient_OnClearSiteData_ResponseParamsDataView() {}

  NetworkServiceClient_OnClearSiteData_ResponseParamsDataView(
      internal::NetworkServiceClient_OnClearSiteData_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::NetworkServiceClient_OnClearSiteData_ResponseParams_Data* data_ = nullptr;
};

class NetworkServiceClient_OnDataUseUpdate_ParamsDataView {
 public:
  NetworkServiceClient_OnDataUseUpdate_ParamsDataView() {}

  NetworkServiceClient_OnDataUseUpdate_ParamsDataView(
      internal::NetworkServiceClient_OnDataUseUpdate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t network_traffic_annotation_id_hash() const {
    return data_->network_traffic_annotation_id_hash;
  }
  int64_t recv_bytes() const {
    return data_->recv_bytes;
  }
  int64_t sent_bytes() const {
    return data_->sent_bytes;
  }
 private:
  internal::NetworkServiceClient_OnDataUseUpdate_Params_Data* data_ = nullptr;
};

class NetworkService_SetClient_ParamsDataView {
 public:
  NetworkService_SetClient_ParamsDataView() {}

  NetworkService_SetClient_ParamsDataView(
      internal::NetworkService_SetClient_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::NetworkServiceClientPtrDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetParamsDataView(
      NetworkServiceParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadParams(UserType* output) {
    auto* pointer = data_->params.Get();
    return mojo::internal::Deserialize<::network::mojom::NetworkServiceParamsDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_SetClient_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_StartNetLog_ParamsDataView {
 public:
  NetworkService_StartNetLog_ParamsDataView() {}

  NetworkService_StartNetLog_ParamsDataView(
      internal::NetworkService_StartNetLog_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFileDataView(
      ::mojo_base::mojom::FileDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFile(UserType* output) {
    auto* pointer = data_->file.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FileDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCaptureMode(UserType* output) const {
    auto data_value = data_->capture_mode;
    return mojo::internal::Deserialize<::network::mojom::NetLogCaptureMode>(
        data_value, output);
  }

  ::network::mojom::NetLogCaptureMode capture_mode() const {
    return static_cast<::network::mojom::NetLogCaptureMode>(data_->capture_mode);
  }
  inline void GetConstantsDataView(
      ::mojo_base::mojom::DictionaryValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConstants(UserType* output) {
    auto* pointer = data_->constants.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::DictionaryValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_StartNetLog_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_SetSSLKeyLogFile_ParamsDataView {
 public:
  NetworkService_SetSSLKeyLogFile_ParamsDataView() {}

  NetworkService_SetSSLKeyLogFile_ParamsDataView(
      internal::NetworkService_SetSSLKeyLogFile_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFileDataView(
      ::mojo_base::mojom::FilePathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFile(UserType* output) {
    auto* pointer = data_->file.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FilePathDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_SetSSLKeyLogFile_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_CreateNetworkContext_ParamsDataView {
 public:
  NetworkService_CreateNetworkContext_ParamsDataView() {}

  NetworkService_CreateNetworkContext_ParamsDataView(
      internal::NetworkService_CreateNetworkContext_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeContext() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::NetworkContextRequestDataView>(
            &data_->context, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetParamsDataView(
      ::network::mojom::NetworkContextParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadParams(UserType* output) {
    auto* pointer = data_->params.Get();
    return mojo::internal::Deserialize<::network::mojom::NetworkContextParamsDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_CreateNetworkContext_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_ConfigureStubHostResolver_ParamsDataView {
 public:
  NetworkService_ConfigureStubHostResolver_ParamsDataView() {}

  NetworkService_ConfigureStubHostResolver_ParamsDataView(
      internal::NetworkService_ConfigureStubHostResolver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool stub_resolver_enabled() const {
    return data_->stub_resolver_enabled;
  }
  inline void GetDnsOverHttpsServersDataView(
      mojo::ArrayDataView<::network::mojom::DnsOverHttpsServerDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDnsOverHttpsServers(UserType* output) {
    auto* pointer = data_->dns_over_https_servers.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::DnsOverHttpsServerDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_ConfigureStubHostResolver_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_DisableQuic_ParamsDataView {
 public:
  NetworkService_DisableQuic_ParamsDataView() {}

  NetworkService_DisableQuic_ParamsDataView(
      internal::NetworkService_DisableQuic_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::NetworkService_DisableQuic_Params_Data* data_ = nullptr;
};

class NetworkService_SetUpHttpAuth_ParamsDataView {
 public:
  NetworkService_SetUpHttpAuth_ParamsDataView() {}

  NetworkService_SetUpHttpAuth_ParamsDataView(
      internal::NetworkService_SetUpHttpAuth_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetHttpAuthStaticParamsDataView(
      HttpAuthStaticParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHttpAuthStaticParams(UserType* output) {
    auto* pointer = data_->http_auth_static_params.Get();
    return mojo::internal::Deserialize<::network::mojom::HttpAuthStaticParamsDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_SetUpHttpAuth_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_ConfigureHttpAuthPrefs_ParamsDataView {
 public:
  NetworkService_ConfigureHttpAuthPrefs_ParamsDataView() {}

  NetworkService_ConfigureHttpAuthPrefs_ParamsDataView(
      internal::NetworkService_ConfigureHttpAuthPrefs_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetHttpAuthDynamicParamsDataView(
      HttpAuthDynamicParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHttpAuthDynamicParams(UserType* output) {
    auto* pointer = data_->http_auth_dynamic_params.Get();
    return mojo::internal::Deserialize<::network::mojom::HttpAuthDynamicParamsDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_ConfigureHttpAuthPrefs_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_SetRawHeadersAccess_ParamsDataView {
 public:
  NetworkService_SetRawHeadersAccess_ParamsDataView() {}

  NetworkService_SetRawHeadersAccess_ParamsDataView(
      internal::NetworkService_SetRawHeadersAccess_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t process_id() const {
    return data_->process_id;
  }
  inline void GetOriginsDataView(
      mojo::ArrayDataView<::url::mojom::OriginDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOrigins(UserType* output) {
    auto* pointer = data_->origins.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::url::mojom::OriginDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_SetRawHeadersAccess_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_GetNetworkChangeManager_ParamsDataView {
 public:
  NetworkService_GetNetworkChangeManager_ParamsDataView() {}

  NetworkService_GetNetworkChangeManager_ParamsDataView(
      internal::NetworkService_GetNetworkChangeManager_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeNetworkChangeManager() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::NetworkChangeManagerRequestDataView>(
            &data_->network_change_manager, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::NetworkService_GetNetworkChangeManager_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_GetNetworkQualityEstimatorManager_ParamsDataView {
 public:
  NetworkService_GetNetworkQualityEstimatorManager_ParamsDataView() {}

  NetworkService_GetNetworkQualityEstimatorManager_ParamsDataView(
      internal::NetworkService_GetNetworkQualityEstimatorManager_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeNetworkQualityEstimatorManager() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::NetworkQualityEstimatorManagerRequestDataView>(
            &data_->network_quality_estimator_manager, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::NetworkService_GetNetworkQualityEstimatorManager_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_GetDnsConfigChangeManager_ParamsDataView {
 public:
  NetworkService_GetDnsConfigChangeManager_ParamsDataView() {}

  NetworkService_GetDnsConfigChangeManager_ParamsDataView(
      internal::NetworkService_GetDnsConfigChangeManager_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeDnsConfigChangeManager() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::DnsConfigChangeManagerRequestDataView>(
            &data_->dns_config_change_manager, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::NetworkService_GetDnsConfigChangeManager_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_GetTotalNetworkUsages_ParamsDataView {
 public:
  NetworkService_GetTotalNetworkUsages_ParamsDataView() {}

  NetworkService_GetTotalNetworkUsages_ParamsDataView(
      internal::NetworkService_GetTotalNetworkUsages_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::NetworkService_GetTotalNetworkUsages_Params_Data* data_ = nullptr;
};

class NetworkService_GetTotalNetworkUsages_ResponseParamsDataView {
 public:
  NetworkService_GetTotalNetworkUsages_ResponseParamsDataView() {}

  NetworkService_GetTotalNetworkUsages_ResponseParamsDataView(
      internal::NetworkService_GetTotalNetworkUsages_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTotalNetworkUsagesDataView(
      mojo::ArrayDataView<::network::mojom::NetworkUsageDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTotalNetworkUsages(UserType* output) {
    auto* pointer = data_->total_network_usages.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::NetworkUsageDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_GetTotalNetworkUsages_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_GetNetworkList_ParamsDataView {
 public:
  NetworkService_GetNetworkList_ParamsDataView() {}

  NetworkService_GetNetworkList_ParamsDataView(
      internal::NetworkService_GetNetworkList_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t policy() const {
    return data_->policy;
  }
 private:
  internal::NetworkService_GetNetworkList_Params_Data* data_ = nullptr;
};

class NetworkService_GetNetworkList_ResponseParamsDataView {
 public:
  NetworkService_GetNetworkList_ResponseParamsDataView() {}

  NetworkService_GetNetworkList_ResponseParamsDataView(
      internal::NetworkService_GetNetworkList_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNetworksDataView(
      mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNetworks(UserType* output) {
    auto* pointer = data_->networks.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_GetNetworkList_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_UpdateSignedTreeHead_ParamsDataView {
 public:
  NetworkService_UpdateSignedTreeHead_ParamsDataView() {}

  NetworkService_UpdateSignedTreeHead_ParamsDataView(
      internal::NetworkService_UpdateSignedTreeHead_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSignedTreeHeadDataView(
      ::network::mojom::SignedTreeHeadDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSignedTreeHead(UserType* output) {
    auto* pointer = data_->signed_tree_head.Get();
    return mojo::internal::Deserialize<::network::mojom::SignedTreeHeadDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_UpdateSignedTreeHead_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_UpdateCRLSet_ParamsDataView {
 public:
  NetworkService_UpdateCRLSet_ParamsDataView() {}

  NetworkService_UpdateCRLSet_ParamsDataView(
      internal::NetworkService_UpdateCRLSet_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCrlSetDataView(
      ::mojo_base::mojom::ReadOnlyBufferDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCrlSet(UserType* output) {
    auto* pointer = data_->crl_set.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::ReadOnlyBufferDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_UpdateCRLSet_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_OnCertDBChanged_ParamsDataView {
 public:
  NetworkService_OnCertDBChanged_ParamsDataView() {}

  NetworkService_OnCertDBChanged_ParamsDataView(
      internal::NetworkService_OnCertDBChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::NetworkService_OnCertDBChanged_Params_Data* data_ = nullptr;
};

class NetworkService_SetCryptConfig_ParamsDataView {
 public:
  NetworkService_SetCryptConfig_ParamsDataView() {}

  NetworkService_SetCryptConfig_ParamsDataView(
      internal::NetworkService_SetCryptConfig_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCryptConfigDataView(
      CryptConfigDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCryptConfig(UserType* output) {
    auto* pointer = data_->crypt_config.Get();
    return mojo::internal::Deserialize<::network::mojom::CryptConfigDataView>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_SetCryptConfig_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkService_AddCorbExceptionForPlugin_ParamsDataView {
 public:
  NetworkService_AddCorbExceptionForPlugin_ParamsDataView() {}

  NetworkService_AddCorbExceptionForPlugin_ParamsDataView(
      internal::NetworkService_AddCorbExceptionForPlugin_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t process_id() const {
    return data_->process_id;
  }
 private:
  internal::NetworkService_AddCorbExceptionForPlugin_Params_Data* data_ = nullptr;
};

class NetworkService_RemoveCorbExceptionForPlugin_ParamsDataView {
 public:
  NetworkService_RemoveCorbExceptionForPlugin_ParamsDataView() {}

  NetworkService_RemoveCorbExceptionForPlugin_ParamsDataView(
      internal::NetworkService_RemoveCorbExceptionForPlugin_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t process_id() const {
    return data_->process_id;
  }
 private:
  internal::NetworkService_RemoveCorbExceptionForPlugin_Params_Data* data_ = nullptr;
};

class NetworkService_OnMemoryPressure_ParamsDataView {
 public:
  NetworkService_OnMemoryPressure_ParamsDataView() {}

  NetworkService_OnMemoryPressure_ParamsDataView(
      internal::NetworkService_OnMemoryPressure_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMemoryPressureLevel(UserType* output) const {
    auto data_value = data_->memory_pressure_level;
    return mojo::internal::Deserialize<::mojo_base::mojom::MemoryPressureLevel>(
        data_value, output);
  }

  ::mojo_base::mojom::MemoryPressureLevel memory_pressure_level() const {
    return static_cast<::mojo_base::mojom::MemoryPressureLevel>(data_->memory_pressure_level);
  }
 private:
  internal::NetworkService_OnMemoryPressure_Params_Data* data_ = nullptr;
};

class NetworkService_SetEnvironment_ParamsDataView {
 public:
  NetworkService_SetEnvironment_ParamsDataView() {}

  NetworkService_SetEnvironment_ParamsDataView(
      internal::NetworkService_SetEnvironment_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetEnvironmentDataView(
      mojo::ArrayDataView<EnvironmentVariableDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEnvironment(UserType* output) {
    auto* pointer = data_->environment.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::EnvironmentVariableDataView>>(
        pointer, output, context_);
  }
 private:
  internal::NetworkService_SetEnvironment_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace network

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::LoadInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::LoadInfoDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::network::mojom::internal::LoadInfo_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->process_id = CallWithContext(Traits::process_id, input, custom_context);
    (*output)->routing_id = CallWithContext(Traits::routing_id, input, custom_context);
    decltype(CallWithContext(Traits::host, input, custom_context)) in_host = CallWithContext(Traits::host, input, custom_context);
    typename decltype((*output)->host)::BaseType::BufferWriter
        host_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_host, buffer, &host_writer, context);
    (*output)->host.Set(
        host_writer.is_null() ? nullptr : host_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->host.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null host in LoadInfo struct");
    (*output)->load_state = CallWithContext(Traits::load_state, input, custom_context);
    decltype(CallWithContext(Traits::state_param, input, custom_context)) in_state_param = CallWithContext(Traits::state_param, input, custom_context);
    typename decltype((*output)->state_param)::BaseType::BufferWriter
        state_param_writer;
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_state_param, buffer, &state_param_writer, context);
    (*output)->state_param.Set(
        state_param_writer.is_null() ? nullptr : state_param_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->state_param.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null state_param in LoadInfo struct");
    (*output)->upload_position = CallWithContext(Traits::upload_position, input, custom_context);
    (*output)->upload_size = CallWithContext(Traits::upload_size, input, custom_context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::network::mojom::internal::LoadInfo_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::LoadInfoDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::HttpAuthStaticParamsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::HttpAuthStaticParamsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::network::mojom::internal::HttpAuthStaticParams_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::supported_schemes, input, custom_context)) in_supported_schemes = CallWithContext(Traits::supported_schemes, input, custom_context);
    typename decltype((*output)->supported_schemes)::BaseType::BufferWriter
        supported_schemes_writer;
    const mojo::internal::ContainerValidateParams supported_schemes_validate_params(
        0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_supported_schemes, buffer, &supported_schemes_writer, &supported_schemes_validate_params,
        context);
    (*output)->supported_schemes.Set(
        supported_schemes_writer.is_null() ? nullptr : supported_schemes_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->supported_schemes.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null supported_schemes in HttpAuthStaticParams struct");
    decltype(CallWithContext(Traits::gssapi_library_name, input, custom_context)) in_gssapi_library_name = CallWithContext(Traits::gssapi_library_name, input, custom_context);
    typename decltype((*output)->gssapi_library_name)::BaseType::BufferWriter
        gssapi_library_name_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_gssapi_library_name, buffer, &gssapi_library_name_writer, context);
    (*output)->gssapi_library_name.Set(
        gssapi_library_name_writer.is_null() ? nullptr : gssapi_library_name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->gssapi_library_name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null gssapi_library_name in HttpAuthStaticParams struct");
    (*output)->allow_gssapi_library_load = CallWithContext(Traits::allow_gssapi_library_load, input, custom_context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::network::mojom::internal::HttpAuthStaticParams_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::HttpAuthStaticParamsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::HttpAuthDynamicParamsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::HttpAuthDynamicParamsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::network::mojom::internal::HttpAuthDynamicParams_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::server_whitelist, input, custom_context)) in_server_whitelist = CallWithContext(Traits::server_whitelist, input, custom_context);
    typename decltype((*output)->server_whitelist)::BaseType::BufferWriter
        server_whitelist_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_server_whitelist, buffer, &server_whitelist_writer, context);
    (*output)->server_whitelist.Set(
        server_whitelist_writer.is_null() ? nullptr : server_whitelist_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->server_whitelist.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null server_whitelist in HttpAuthDynamicParams struct");
    decltype(CallWithContext(Traits::delegate_whitelist, input, custom_context)) in_delegate_whitelist = CallWithContext(Traits::delegate_whitelist, input, custom_context);
    typename decltype((*output)->delegate_whitelist)::BaseType::BufferWriter
        delegate_whitelist_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_delegate_whitelist, buffer, &delegate_whitelist_writer, context);
    (*output)->delegate_whitelist.Set(
        delegate_whitelist_writer.is_null() ? nullptr : delegate_whitelist_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->delegate_whitelist.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null delegate_whitelist in HttpAuthDynamicParams struct");
    (*output)->negotiate_disable_cname_lookup = CallWithContext(Traits::negotiate_disable_cname_lookup, input, custom_context);
    (*output)->enable_negotiate_port = CallWithContext(Traits::enable_negotiate_port, input, custom_context);
    (*output)->ntlm_v2_enabled = CallWithContext(Traits::ntlm_v2_enabled, input, custom_context);
    decltype(CallWithContext(Traits::android_negotiate_account_type, input, custom_context)) in_android_negotiate_account_type = CallWithContext(Traits::android_negotiate_account_type, input, custom_context);
    typename decltype((*output)->android_negotiate_account_type)::BaseType::BufferWriter
        android_negotiate_account_type_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_android_negotiate_account_type, buffer, &android_negotiate_account_type_writer, context);
    (*output)->android_negotiate_account_type.Set(
        android_negotiate_account_type_writer.is_null() ? nullptr : android_negotiate_account_type_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->android_negotiate_account_type.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null android_negotiate_account_type in HttpAuthDynamicParams struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::network::mojom::internal::HttpAuthDynamicParams_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::HttpAuthDynamicParamsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::CryptConfigDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::CryptConfigDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::network::mojom::internal::CryptConfig_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::store, input, custom_context)) in_store = CallWithContext(Traits::store, input, custom_context);
    typename decltype((*output)->store)::BaseType::BufferWriter
        store_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_store, buffer, &store_writer, context);
    (*output)->store.Set(
        store_writer.is_null() ? nullptr : store_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->store.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null store in CryptConfig struct");
    decltype(CallWithContext(Traits::product_name, input, custom_context)) in_product_name = CallWithContext(Traits::product_name, input, custom_context);
    typename decltype((*output)->product_name)::BaseType::BufferWriter
        product_name_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_product_name, buffer, &product_name_writer, context);
    (*output)->product_name.Set(
        product_name_writer.is_null() ? nullptr : product_name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->product_name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null product_name in CryptConfig struct");
    (*output)->should_use_preference = CallWithContext(Traits::should_use_preference, input, custom_context);
    decltype(CallWithContext(Traits::user_data_path, input, custom_context)) in_user_data_path = CallWithContext(Traits::user_data_path, input, custom_context);
    typename decltype((*output)->user_data_path)::BaseType::BufferWriter
        user_data_path_writer;
    mojo::internal::Serialize<::mojo_base::mojom::FilePathDataView>(
        in_user_data_path, buffer, &user_data_path_writer, context);
    (*output)->user_data_path.Set(
        user_data_path_writer.is_null() ? nullptr : user_data_path_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->user_data_path.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null user_data_path in CryptConfig struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::network::mojom::internal::CryptConfig_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::CryptConfigDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::EnvironmentVariableDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::EnvironmentVariableDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::network::mojom::internal::EnvironmentVariable_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::name, input, custom_context)) in_name = CallWithContext(Traits::name, input, custom_context);
    typename decltype((*output)->name)::BaseType::BufferWriter
        name_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name, buffer, &name_writer, context);
    (*output)->name.Set(
        name_writer.is_null() ? nullptr : name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in EnvironmentVariable struct");
    decltype(CallWithContext(Traits::value, input, custom_context)) in_value = CallWithContext(Traits::value, input, custom_context);
    typename decltype((*output)->value)::BaseType::BufferWriter
        value_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_value, buffer, &value_writer, context);
    (*output)->value.Set(
        value_writer.is_null() ? nullptr : value_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->value.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null value in EnvironmentVariable struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::network::mojom::internal::EnvironmentVariable_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::EnvironmentVariableDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::NetworkServiceParamsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::NetworkServiceParamsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::network::mojom::internal::NetworkServiceParams_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    mojo::internal::Serialize<::network::mojom::ConnectionType>(
        CallWithContext(Traits::initial_connection_type, input, custom_context), &(*output)->initial_connection_type);
    mojo::internal::Serialize<::network::mojom::ConnectionSubtype>(
        CallWithContext(Traits::initial_connection_subtype, input, custom_context), &(*output)->initial_connection_subtype);
    decltype(CallWithContext(Traits::environment, input, custom_context)) in_environment = CallWithContext(Traits::environment, input, custom_context);
    typename decltype((*output)->environment)::BaseType::BufferWriter
        environment_writer;
    const mojo::internal::ContainerValidateParams environment_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::network::mojom::EnvironmentVariableDataView>>(
        in_environment, buffer, &environment_writer, &environment_validate_params,
        context);
    (*output)->environment.Set(
        environment_writer.is_null() ? nullptr : environment_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->environment.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null environment in NetworkServiceParams struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::network::mojom::internal::NetworkServiceParams_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::NetworkServiceParamsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace network {
namespace mojom {

inline void LoadInfoDataView::GetHostDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->host.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void LoadInfoDataView::GetStateParamDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->state_param.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void HttpAuthStaticParamsDataView::GetSupportedSchemesDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->supported_schemes.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}
inline void HttpAuthStaticParamsDataView::GetGssapiLibraryNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->gssapi_library_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void HttpAuthDynamicParamsDataView::GetServerWhitelistDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->server_whitelist.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void HttpAuthDynamicParamsDataView::GetDelegateWhitelistDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->delegate_whitelist.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void HttpAuthDynamicParamsDataView::GetAndroidNegotiateAccountTypeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->android_negotiate_account_type.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void CryptConfigDataView::GetStoreDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->store.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void CryptConfigDataView::GetProductNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->product_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void CryptConfigDataView::GetUserDataPathDataView(
    ::mojo_base::mojom::FilePathDataView* output) {
  auto pointer = data_->user_data_path.Get();
  *output = ::mojo_base::mojom::FilePathDataView(pointer, context_);
}


inline void EnvironmentVariableDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void EnvironmentVariableDataView::GetValueDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->value.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void NetworkServiceParamsDataView::GetEnvironmentDataView(
    mojo::ArrayDataView<EnvironmentVariableDataView>* output) {
  auto pointer = data_->environment.Get();
  *output = mojo::ArrayDataView<EnvironmentVariableDataView>(pointer, context_);
}


inline void SSLPrivateKey_Sign_ParamsDataView::GetInputDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->input.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void SSLPrivateKey_Sign_ResponseParamsDataView::GetSignatureDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->signature.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void AuthChallengeResponder_OnAuthCredentials_ParamsDataView::GetCredentialsDataView(
    ::network::mojom::AuthCredentialsDataView* output) {
  auto pointer = data_->credentials.Get();
  *output = ::network::mojom::AuthCredentialsDataView(pointer, context_);
}


inline void NetworkServiceClient_OnAuthRequired_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void NetworkServiceClient_OnAuthRequired_ParamsDataView::GetSiteForCookiesDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->site_for_cookies.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void NetworkServiceClient_OnAuthRequired_ParamsDataView::GetAuthInfoDataView(
    ::network::mojom::AuthChallengeInfoDataView* output) {
  auto pointer = data_->auth_info.Get();
  *output = ::network::mojom::AuthChallengeInfoDataView(pointer, context_);
}
inline void NetworkServiceClient_OnAuthRequired_ParamsDataView::GetHeadDataView(
    ::network::mojom::URLResponseHeadDataView* output) {
  auto pointer = data_->head.Get();
  *output = ::network::mojom::URLResponseHeadDataView(pointer, context_);
}


inline void NetworkServiceClient_OnCertificateRequested_ParamsDataView::GetWindowIdDataView(
    ::mojo_base::mojom::UnguessableTokenDataView* output) {
  auto pointer = data_->window_id.Get();
  *output = ::mojo_base::mojom::UnguessableTokenDataView(pointer, context_);
}
inline void NetworkServiceClient_OnCertificateRequested_ParamsDataView::GetCertInfoDataView(
    ::network::mojom::SSLCertRequestInfoDataView* output) {
  auto pointer = data_->cert_info.Get();
  *output = ::network::mojom::SSLCertRequestInfoDataView(pointer, context_);
}


inline void NetworkServiceClient_OnCertificateRequested_ResponseParamsDataView::GetX509CertificateDataView(
    ::network::mojom::X509CertificateDataView* output) {
  auto pointer = data_->x509_certificate.Get();
  *output = ::network::mojom::X509CertificateDataView(pointer, context_);
}
inline void NetworkServiceClient_OnCertificateRequested_ResponseParamsDataView::GetProviderNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->provider_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void NetworkServiceClient_OnCertificateRequested_ResponseParamsDataView::GetAlgorithmPreferencesDataView(
    mojo::ArrayDataView<uint16_t>* output) {
  auto pointer = data_->algorithm_preferences.Get();
  *output = mojo::ArrayDataView<uint16_t>(pointer, context_);
}


inline void NetworkServiceClient_OnSSLCertificateError_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void NetworkServiceClient_OnSSLCertificateError_ParamsDataView::GetSslInfoDataView(
    ::network::mojom::SSLInfoDataView* output) {
  auto pointer = data_->ssl_info.Get();
  *output = ::network::mojom::SSLInfoDataView(pointer, context_);
}




inline void NetworkServiceClient_OnFileUploadRequested_ParamsDataView::GetFilePathsDataView(
    mojo::ArrayDataView<::mojo_base::mojom::FilePathDataView>* output) {
  auto pointer = data_->file_paths.Get();
  *output = mojo::ArrayDataView<::mojo_base::mojom::FilePathDataView>(pointer, context_);
}


inline void NetworkServiceClient_OnFileUploadRequested_ResponseParamsDataView::GetFilesDataView(
    mojo::ArrayDataView<::mojo_base::mojom::FileDataView>* output) {
  auto pointer = data_->files.Get();
  *output = mojo::ArrayDataView<::mojo_base::mojom::FileDataView>(pointer, context_);
}


inline void NetworkServiceClient_OnCookieChange_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void NetworkServiceClient_OnCookieChange_ParamsDataView::GetFrameUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->frame_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void NetworkServiceClient_OnCookieChange_ParamsDataView::GetCookieDataView(
    ::network::mojom::CanonicalCookieDataView* output) {
  auto pointer = data_->cookie.Get();
  *output = ::network::mojom::CanonicalCookieDataView(pointer, context_);
}


inline void NetworkServiceClient_OnCookiesRead_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void NetworkServiceClient_OnCookiesRead_ParamsDataView::GetFrameUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->frame_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void NetworkServiceClient_OnCookiesRead_ParamsDataView::GetCookieListDataView(
    mojo::ArrayDataView<::network::mojom::CanonicalCookieDataView>* output) {
  auto pointer = data_->cookie_list.Get();
  *output = mojo::ArrayDataView<::network::mojom::CanonicalCookieDataView>(pointer, context_);
}


inline void NetworkServiceClient_OnLoadingStateUpdate_ParamsDataView::GetInfosDataView(
    mojo::ArrayDataView<LoadInfoDataView>* output) {
  auto pointer = data_->infos.Get();
  *output = mojo::ArrayDataView<LoadInfoDataView>(pointer, context_);
}




inline void NetworkServiceClient_OnClearSiteData_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void NetworkServiceClient_OnClearSiteData_ParamsDataView::GetHeaderValueDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->header_value.Get();
  *output = mojo::StringDataView(pointer, context_);
}






inline void NetworkService_SetClient_ParamsDataView::GetParamsDataView(
    NetworkServiceParamsDataView* output) {
  auto pointer = data_->params.Get();
  *output = NetworkServiceParamsDataView(pointer, context_);
}


inline void NetworkService_StartNetLog_ParamsDataView::GetFileDataView(
    ::mojo_base::mojom::FileDataView* output) {
  auto pointer = data_->file.Get();
  *output = ::mojo_base::mojom::FileDataView(pointer, context_);
}
inline void NetworkService_StartNetLog_ParamsDataView::GetConstantsDataView(
    ::mojo_base::mojom::DictionaryValueDataView* output) {
  auto pointer = data_->constants.Get();
  *output = ::mojo_base::mojom::DictionaryValueDataView(pointer, context_);
}


inline void NetworkService_SetSSLKeyLogFile_ParamsDataView::GetFileDataView(
    ::mojo_base::mojom::FilePathDataView* output) {
  auto pointer = data_->file.Get();
  *output = ::mojo_base::mojom::FilePathDataView(pointer, context_);
}


inline void NetworkService_CreateNetworkContext_ParamsDataView::GetParamsDataView(
    ::network::mojom::NetworkContextParamsDataView* output) {
  auto pointer = data_->params.Get();
  *output = ::network::mojom::NetworkContextParamsDataView(pointer, context_);
}


inline void NetworkService_ConfigureStubHostResolver_ParamsDataView::GetDnsOverHttpsServersDataView(
    mojo::ArrayDataView<::network::mojom::DnsOverHttpsServerDataView>* output) {
  auto pointer = data_->dns_over_https_servers.Get();
  *output = mojo::ArrayDataView<::network::mojom::DnsOverHttpsServerDataView>(pointer, context_);
}




inline void NetworkService_SetUpHttpAuth_ParamsDataView::GetHttpAuthStaticParamsDataView(
    HttpAuthStaticParamsDataView* output) {
  auto pointer = data_->http_auth_static_params.Get();
  *output = HttpAuthStaticParamsDataView(pointer, context_);
}


inline void NetworkService_ConfigureHttpAuthPrefs_ParamsDataView::GetHttpAuthDynamicParamsDataView(
    HttpAuthDynamicParamsDataView* output) {
  auto pointer = data_->http_auth_dynamic_params.Get();
  *output = HttpAuthDynamicParamsDataView(pointer, context_);
}


inline void NetworkService_SetRawHeadersAccess_ParamsDataView::GetOriginsDataView(
    mojo::ArrayDataView<::url::mojom::OriginDataView>* output) {
  auto pointer = data_->origins.Get();
  *output = mojo::ArrayDataView<::url::mojom::OriginDataView>(pointer, context_);
}










inline void NetworkService_GetTotalNetworkUsages_ResponseParamsDataView::GetTotalNetworkUsagesDataView(
    mojo::ArrayDataView<::network::mojom::NetworkUsageDataView>* output) {
  auto pointer = data_->total_network_usages.Get();
  *output = mojo::ArrayDataView<::network::mojom::NetworkUsageDataView>(pointer, context_);
}




inline void NetworkService_GetNetworkList_ResponseParamsDataView::GetNetworksDataView(
    mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>* output) {
  auto pointer = data_->networks.Get();
  *output = mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>(pointer, context_);
}


inline void NetworkService_UpdateSignedTreeHead_ParamsDataView::GetSignedTreeHeadDataView(
    ::network::mojom::SignedTreeHeadDataView* output) {
  auto pointer = data_->signed_tree_head.Get();
  *output = ::network::mojom::SignedTreeHeadDataView(pointer, context_);
}


inline void NetworkService_UpdateCRLSet_ParamsDataView::GetCrlSetDataView(
    ::mojo_base::mojom::ReadOnlyBufferDataView* output) {
  auto pointer = data_->crl_set.Get();
  *output = ::mojo_base::mojom::ReadOnlyBufferDataView(pointer, context_);
}




inline void NetworkService_SetCryptConfig_ParamsDataView::GetCryptConfigDataView(
    CryptConfigDataView* output) {
  auto pointer = data_->crypt_config.Get();
  *output = CryptConfigDataView(pointer, context_);
}








inline void NetworkService_SetEnvironment_ParamsDataView::GetEnvironmentDataView(
    mojo::ArrayDataView<EnvironmentVariableDataView>* output) {
  auto pointer = data_->environment.Get();
  *output = mojo::ArrayDataView<EnvironmentVariableDataView>(pointer, context_);
}



}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_SERVICE_MOJOM_SHARED_H_