// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_P2P_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_P2P_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "services/network/public/mojom/network_interface.mojom-shared-internal.h"
#include "services/network/public/mojom/ip_address.mojom-shared-internal.h"
#include "services/network/public/mojom/ip_endpoint.mojom-shared-internal.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {
using P2PHostAndIPEndPoint_Data = mojo::native::internal::NativeStruct_Data;
using P2PPacketInfo_Data = mojo::native::internal::NativeStruct_Data;
using P2PPortRange_Data = mojo::native::internal::NativeStruct_Data;
using P2PSendPacketMetrics_Data = mojo::native::internal::NativeStruct_Data;
using P2PSocketType_Data =
    mojo::internal::NativeEnum_Data;
using P2PSocketOption_Data =
    mojo::internal::NativeEnum_Data;

#pragma pack(push, 1)
class  P2PNetworkNotificationClient_NetworkListChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PNetworkNotificationClient_NetworkListChanged_Params_Data));
      new (data()) P2PNetworkNotificationClient_NetworkListChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PNetworkNotificationClient_NetworkListChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PNetworkNotificationClient_NetworkListChanged_Params_Data>(index_);
    }
    P2PNetworkNotificationClient_NetworkListChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::network::mojom::internal::NetworkInterface_Data>>> networks;
  mojo::internal::Pointer<::network::mojom::internal::IPAddress_Data> default_ipv4_local_address;
  mojo::internal::Pointer<::network::mojom::internal::IPAddress_Data> default_ipv6_local_address;

 private:
  P2PNetworkNotificationClient_NetworkListChanged_Params_Data();
  ~P2PNetworkNotificationClient_NetworkListChanged_Params_Data() = delete;
};
static_assert(sizeof(P2PNetworkNotificationClient_NetworkListChanged_Params_Data) == 32,
              "Bad sizeof(P2PNetworkNotificationClient_NetworkListChanged_Params_Data)");
class  P2PSocketManager_StartNetworkNotifications_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocketManager_StartNetworkNotifications_Params_Data));
      new (data()) P2PSocketManager_StartNetworkNotifications_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocketManager_StartNetworkNotifications_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocketManager_StartNetworkNotifications_Params_Data>(index_);
    }
    P2PSocketManager_StartNetworkNotifications_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client;

 private:
  P2PSocketManager_StartNetworkNotifications_Params_Data();
  ~P2PSocketManager_StartNetworkNotifications_Params_Data() = delete;
};
static_assert(sizeof(P2PSocketManager_StartNetworkNotifications_Params_Data) == 16,
              "Bad sizeof(P2PSocketManager_StartNetworkNotifications_Params_Data)");
class  P2PSocketManager_GetHostAddress_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocketManager_GetHostAddress_Params_Data));
      new (data()) P2PSocketManager_GetHostAddress_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocketManager_GetHostAddress_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocketManager_GetHostAddress_Params_Data>(index_);
    }
    P2PSocketManager_GetHostAddress_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> host_name;
  uint8_t enable_mdns : 1;
  uint8_t padfinal_[7];

 private:
  P2PSocketManager_GetHostAddress_Params_Data();
  ~P2PSocketManager_GetHostAddress_Params_Data() = delete;
};
static_assert(sizeof(P2PSocketManager_GetHostAddress_Params_Data) == 24,
              "Bad sizeof(P2PSocketManager_GetHostAddress_Params_Data)");
class  P2PSocketManager_GetHostAddress_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocketManager_GetHostAddress_ResponseParams_Data));
      new (data()) P2PSocketManager_GetHostAddress_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocketManager_GetHostAddress_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocketManager_GetHostAddress_ResponseParams_Data>(index_);
    }
    P2PSocketManager_GetHostAddress_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::network::mojom::internal::IPAddress_Data>>> addresses;

 private:
  P2PSocketManager_GetHostAddress_ResponseParams_Data();
  ~P2PSocketManager_GetHostAddress_ResponseParams_Data() = delete;
};
static_assert(sizeof(P2PSocketManager_GetHostAddress_ResponseParams_Data) == 16,
              "Bad sizeof(P2PSocketManager_GetHostAddress_ResponseParams_Data)");
class  P2PSocketManager_CreateSocket_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocketManager_CreateSocket_Params_Data));
      new (data()) P2PSocketManager_CreateSocket_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocketManager_CreateSocket_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocketManager_CreateSocket_Params_Data>(index_);
    }
    P2PSocketManager_CreateSocket_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t type;
  mojo::internal::Handle_Data socket;
  mojo::internal::Pointer<::network::mojom::internal::IPEndPoint_Data> local_address;
  mojo::internal::Pointer<internal::P2PPortRange_Data> port_range;
  mojo::internal::Pointer<internal::P2PHostAndIPEndPoint_Data> remote_address;
  mojo::internal::Interface_Data client;

 private:
  P2PSocketManager_CreateSocket_Params_Data();
  ~P2PSocketManager_CreateSocket_Params_Data() = delete;
};
static_assert(sizeof(P2PSocketManager_CreateSocket_Params_Data) == 48,
              "Bad sizeof(P2PSocketManager_CreateSocket_Params_Data)");
class  P2PSocket_Send_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocket_Send_Params_Data));
      new (data()) P2PSocket_Send_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocket_Send_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocket_Send_Params_Data>(index_);
    }
    P2PSocket_Send_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<int8_t>> data;
  mojo::internal::Pointer<internal::P2PPacketInfo_Data> packet_info;
  mojo::internal::Pointer<::network::mojom::internal::MutableNetworkTrafficAnnotationTag_Data> traffic_annotation;

 private:
  P2PSocket_Send_Params_Data();
  ~P2PSocket_Send_Params_Data() = delete;
};
static_assert(sizeof(P2PSocket_Send_Params_Data) == 32,
              "Bad sizeof(P2PSocket_Send_Params_Data)");
class  P2PSocket_SetOption_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocket_SetOption_Params_Data));
      new (data()) P2PSocket_SetOption_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocket_SetOption_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocket_SetOption_Params_Data>(index_);
    }
    P2PSocket_SetOption_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t option;
  int32_t value;

 private:
  P2PSocket_SetOption_Params_Data();
  ~P2PSocket_SetOption_Params_Data() = delete;
};
static_assert(sizeof(P2PSocket_SetOption_Params_Data) == 16,
              "Bad sizeof(P2PSocket_SetOption_Params_Data)");
class  P2PSocketClient_SocketCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocketClient_SocketCreated_Params_Data));
      new (data()) P2PSocketClient_SocketCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocketClient_SocketCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocketClient_SocketCreated_Params_Data>(index_);
    }
    P2PSocketClient_SocketCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::IPEndPoint_Data> local_address;
  mojo::internal::Pointer<::network::mojom::internal::IPEndPoint_Data> remote_address;

 private:
  P2PSocketClient_SocketCreated_Params_Data();
  ~P2PSocketClient_SocketCreated_Params_Data() = delete;
};
static_assert(sizeof(P2PSocketClient_SocketCreated_Params_Data) == 24,
              "Bad sizeof(P2PSocketClient_SocketCreated_Params_Data)");
class  P2PSocketClient_SendComplete_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocketClient_SendComplete_Params_Data));
      new (data()) P2PSocketClient_SendComplete_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocketClient_SendComplete_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocketClient_SendComplete_Params_Data>(index_);
    }
    P2PSocketClient_SendComplete_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::P2PSendPacketMetrics_Data> send_metrics;

 private:
  P2PSocketClient_SendComplete_Params_Data();
  ~P2PSocketClient_SendComplete_Params_Data() = delete;
};
static_assert(sizeof(P2PSocketClient_SendComplete_Params_Data) == 16,
              "Bad sizeof(P2PSocketClient_SendComplete_Params_Data)");
class  P2PSocketClient_IncomingTcpConnection_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocketClient_IncomingTcpConnection_Params_Data));
      new (data()) P2PSocketClient_IncomingTcpConnection_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocketClient_IncomingTcpConnection_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocketClient_IncomingTcpConnection_Params_Data>(index_);
    }
    P2PSocketClient_IncomingTcpConnection_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::IPEndPoint_Data> socket_address;
  mojo::internal::Interface_Data socket;
  mojo::internal::Handle_Data client;
  uint8_t padfinal_[4];

 private:
  P2PSocketClient_IncomingTcpConnection_Params_Data();
  ~P2PSocketClient_IncomingTcpConnection_Params_Data() = delete;
};
static_assert(sizeof(P2PSocketClient_IncomingTcpConnection_Params_Data) == 32,
              "Bad sizeof(P2PSocketClient_IncomingTcpConnection_Params_Data)");
class  P2PSocketClient_DataReceived_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PSocketClient_DataReceived_Params_Data));
      new (data()) P2PSocketClient_DataReceived_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PSocketClient_DataReceived_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PSocketClient_DataReceived_Params_Data>(index_);
    }
    P2PSocketClient_DataReceived_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::IPEndPoint_Data> socket_address;
  mojo::internal::Pointer<mojo::internal::Array_Data<int8_t>> data;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeTicks_Data> timestamp;

 private:
  P2PSocketClient_DataReceived_Params_Data();
  ~P2PSocketClient_DataReceived_Params_Data() = delete;
};
static_assert(sizeof(P2PSocketClient_DataReceived_Params_Data) == 32,
              "Bad sizeof(P2PSocketClient_DataReceived_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_P2P_MOJOM_SHARED_INTERNAL_H_