// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_P2P_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_P2P_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/network/public/mojom/p2p.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "services/network/public/mojom/network_interface.mojom-shared.h"
#include "services/network/public/mojom/ip_address.mojom-shared.h"
#include "services/network/public/mojom/ip_endpoint.mojom-shared.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace network {
namespace mojom {
using P2PHostAndIPEndPointDataView = mojo::native::NativeStructDataView;

using P2PPacketInfoDataView = mojo::native::NativeStructDataView;

using P2PPortRangeDataView = mojo::native::NativeStructDataView;

using P2PSendPacketMetricsDataView = mojo::native::NativeStructDataView;



}  // namespace mojom
}  // namespace network

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace network {
namespace mojom {
using P2PSocketType = mojo::NativeEnum;
using P2PSocketOption = mojo::NativeEnum;
// Interface base classes. They are used for type safety check.
class P2PNetworkNotificationClientInterfaceBase {};

using P2PNetworkNotificationClientPtrDataView =
    mojo::InterfacePtrDataView<P2PNetworkNotificationClientInterfaceBase>;
using P2PNetworkNotificationClientRequestDataView =
    mojo::InterfaceRequestDataView<P2PNetworkNotificationClientInterfaceBase>;
using P2PNetworkNotificationClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<P2PNetworkNotificationClientInterfaceBase>;
using P2PNetworkNotificationClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<P2PNetworkNotificationClientInterfaceBase>;
class P2PSocketManagerInterfaceBase {};

using P2PSocketManagerPtrDataView =
    mojo::InterfacePtrDataView<P2PSocketManagerInterfaceBase>;
using P2PSocketManagerRequestDataView =
    mojo::InterfaceRequestDataView<P2PSocketManagerInterfaceBase>;
using P2PSocketManagerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<P2PSocketManagerInterfaceBase>;
using P2PSocketManagerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<P2PSocketManagerInterfaceBase>;
class P2PSocketInterfaceBase {};

using P2PSocketPtrDataView =
    mojo::InterfacePtrDataView<P2PSocketInterfaceBase>;
using P2PSocketRequestDataView =
    mojo::InterfaceRequestDataView<P2PSocketInterfaceBase>;
using P2PSocketAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<P2PSocketInterfaceBase>;
using P2PSocketAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<P2PSocketInterfaceBase>;
class P2PSocketClientInterfaceBase {};

using P2PSocketClientPtrDataView =
    mojo::InterfacePtrDataView<P2PSocketClientInterfaceBase>;
using P2PSocketClientRequestDataView =
    mojo::InterfaceRequestDataView<P2PSocketClientInterfaceBase>;
using P2PSocketClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<P2PSocketClientInterfaceBase>;
using P2PSocketClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<P2PSocketClientInterfaceBase>;
class P2PNetworkNotificationClient_NetworkListChanged_ParamsDataView {
 public:
  P2PNetworkNotificationClient_NetworkListChanged_ParamsDataView() {}

  P2PNetworkNotificationClient_NetworkListChanged_ParamsDataView(
      internal::P2PNetworkNotificationClient_NetworkListChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNetworksDataView(
      mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNetworks(UserType* output) {
    auto* pointer = data_->networks.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>>(
        pointer, output, context_);
  }
  inline void GetDefaultIpv4LocalAddressDataView(
      ::network::mojom::IPAddressDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDefaultIpv4LocalAddress(UserType* output) {
    auto* pointer = data_->default_ipv4_local_address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPAddressDataView>(
        pointer, output, context_);
  }
  inline void GetDefaultIpv6LocalAddressDataView(
      ::network::mojom::IPAddressDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDefaultIpv6LocalAddress(UserType* output) {
    auto* pointer = data_->default_ipv6_local_address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPAddressDataView>(
        pointer, output, context_);
  }
 private:
  internal::P2PNetworkNotificationClient_NetworkListChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocketManager_StartNetworkNotifications_ParamsDataView {
 public:
  P2PSocketManager_StartNetworkNotifications_ParamsDataView() {}

  P2PSocketManager_StartNetworkNotifications_ParamsDataView(
      internal::P2PSocketManager_StartNetworkNotifications_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::P2PNetworkNotificationClientPtrDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::P2PSocketManager_StartNetworkNotifications_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocketManager_GetHostAddress_ParamsDataView {
 public:
  P2PSocketManager_GetHostAddress_ParamsDataView() {}

  P2PSocketManager_GetHostAddress_ParamsDataView(
      internal::P2PSocketManager_GetHostAddress_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetHostNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHostName(UserType* output) {
    auto* pointer = data_->host_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool enable_mdns() const {
    return data_->enable_mdns;
  }
 private:
  internal::P2PSocketManager_GetHostAddress_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocketManager_GetHostAddress_ResponseParamsDataView {
 public:
  P2PSocketManager_GetHostAddress_ResponseParamsDataView() {}

  P2PSocketManager_GetHostAddress_ResponseParamsDataView(
      internal::P2PSocketManager_GetHostAddress_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAddressesDataView(
      mojo::ArrayDataView<::network::mojom::IPAddressDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAddresses(UserType* output) {
    auto* pointer = data_->addresses.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::IPAddressDataView>>(
        pointer, output, context_);
  }
 private:
  internal::P2PSocketManager_GetHostAddress_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocketManager_CreateSocket_ParamsDataView {
 public:
  P2PSocketManager_CreateSocket_ParamsDataView() {}

  P2PSocketManager_CreateSocket_ParamsDataView(
      internal::P2PSocketManager_CreateSocket_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::network::mojom::P2PSocketType>(
        data_value, output);
  }

  P2PSocketType type() const {
    return static_cast<P2PSocketType>(data_->type);
  }
  inline void GetLocalAddressDataView(
      ::network::mojom::IPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLocalAddress(UserType* output) {
    auto* pointer = data_->local_address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPEndPointDataView>(
        pointer, output, context_);
  }
  inline void GetPortRangeDataView(
      P2PPortRangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPortRange(UserType* output) {
    auto* pointer = data_->port_range.Get();
    return mojo::internal::Deserialize<::network::mojom::P2PPortRangeDataView>(
        pointer, output, context_);
  }
  inline void GetRemoteAddressDataView(
      P2PHostAndIPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRemoteAddress(UserType* output) {
    auto* pointer = data_->remote_address.Get();
    return mojo::internal::Deserialize<::network::mojom::P2PHostAndIPEndPointDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::P2PSocketClientPtrDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeSocket() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::P2PSocketRequestDataView>(
            &data_->socket, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::P2PSocketManager_CreateSocket_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocket_Send_ParamsDataView {
 public:
  P2PSocket_Send_ParamsDataView() {}

  P2PSocket_Send_ParamsDataView(
      internal::P2PSocket_Send_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDataDataView(
      mojo::ArrayDataView<int8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<int8_t>>(
        pointer, output, context_);
  }
  inline void GetPacketInfoDataView(
      P2PPacketInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPacketInfo(UserType* output) {
    auto* pointer = data_->packet_info.Get();
    return mojo::internal::Deserialize<::network::mojom::P2PPacketInfoDataView>(
        pointer, output, context_);
  }
  inline void GetTrafficAnnotationDataView(
      ::network::mojom::MutableNetworkTrafficAnnotationTagDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTrafficAnnotation(UserType* output) {
    auto* pointer = data_->traffic_annotation.Get();
    return mojo::internal::Deserialize<::network::mojom::MutableNetworkTrafficAnnotationTagDataView>(
        pointer, output, context_);
  }
 private:
  internal::P2PSocket_Send_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocket_SetOption_ParamsDataView {
 public:
  P2PSocket_SetOption_ParamsDataView() {}

  P2PSocket_SetOption_ParamsDataView(
      internal::P2PSocket_SetOption_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOption(UserType* output) const {
    auto data_value = data_->option;
    return mojo::internal::Deserialize<::network::mojom::P2PSocketOption>(
        data_value, output);
  }

  P2PSocketOption option() const {
    return static_cast<P2PSocketOption>(data_->option);
  }
  int32_t value() const {
    return data_->value;
  }
 private:
  internal::P2PSocket_SetOption_Params_Data* data_ = nullptr;
};

class P2PSocketClient_SocketCreated_ParamsDataView {
 public:
  P2PSocketClient_SocketCreated_ParamsDataView() {}

  P2PSocketClient_SocketCreated_ParamsDataView(
      internal::P2PSocketClient_SocketCreated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetLocalAddressDataView(
      ::network::mojom::IPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLocalAddress(UserType* output) {
    auto* pointer = data_->local_address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPEndPointDataView>(
        pointer, output, context_);
  }
  inline void GetRemoteAddressDataView(
      ::network::mojom::IPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRemoteAddress(UserType* output) {
    auto* pointer = data_->remote_address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPEndPointDataView>(
        pointer, output, context_);
  }
 private:
  internal::P2PSocketClient_SocketCreated_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocketClient_SendComplete_ParamsDataView {
 public:
  P2PSocketClient_SendComplete_ParamsDataView() {}

  P2PSocketClient_SendComplete_ParamsDataView(
      internal::P2PSocketClient_SendComplete_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSendMetricsDataView(
      P2PSendPacketMetricsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSendMetrics(UserType* output) {
    auto* pointer = data_->send_metrics.Get();
    return mojo::internal::Deserialize<::network::mojom::P2PSendPacketMetricsDataView>(
        pointer, output, context_);
  }
 private:
  internal::P2PSocketClient_SendComplete_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocketClient_IncomingTcpConnection_ParamsDataView {
 public:
  P2PSocketClient_IncomingTcpConnection_ParamsDataView() {}

  P2PSocketClient_IncomingTcpConnection_ParamsDataView(
      internal::P2PSocketClient_IncomingTcpConnection_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSocketAddressDataView(
      ::network::mojom::IPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSocketAddress(UserType* output) {
    auto* pointer = data_->socket_address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPEndPointDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeSocket() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::P2PSocketPtrDataView>(
            &data_->socket, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::P2PSocketClientRequestDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::P2PSocketClient_IncomingTcpConnection_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class P2PSocketClient_DataReceived_ParamsDataView {
 public:
  P2PSocketClient_DataReceived_ParamsDataView() {}

  P2PSocketClient_DataReceived_ParamsDataView(
      internal::P2PSocketClient_DataReceived_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSocketAddressDataView(
      ::network::mojom::IPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSocketAddress(UserType* output) {
    auto* pointer = data_->socket_address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPEndPointDataView>(
        pointer, output, context_);
  }
  inline void GetDataDataView(
      mojo::ArrayDataView<int8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<int8_t>>(
        pointer, output, context_);
  }
  inline void GetTimestampDataView(
      ::mojo_base::mojom::TimeTicksDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTimestamp(UserType* output) {
    auto* pointer = data_->timestamp.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeTicksDataView>(
        pointer, output, context_);
  }
 private:
  internal::P2PSocketClient_DataReceived_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace network

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace network {
namespace mojom {

inline void P2PNetworkNotificationClient_NetworkListChanged_ParamsDataView::GetNetworksDataView(
    mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>* output) {
  auto pointer = data_->networks.Get();
  *output = mojo::ArrayDataView<::network::mojom::NetworkInterfaceDataView>(pointer, context_);
}
inline void P2PNetworkNotificationClient_NetworkListChanged_ParamsDataView::GetDefaultIpv4LocalAddressDataView(
    ::network::mojom::IPAddressDataView* output) {
  auto pointer = data_->default_ipv4_local_address.Get();
  *output = ::network::mojom::IPAddressDataView(pointer, context_);
}
inline void P2PNetworkNotificationClient_NetworkListChanged_ParamsDataView::GetDefaultIpv6LocalAddressDataView(
    ::network::mojom::IPAddressDataView* output) {
  auto pointer = data_->default_ipv6_local_address.Get();
  *output = ::network::mojom::IPAddressDataView(pointer, context_);
}




inline void P2PSocketManager_GetHostAddress_ParamsDataView::GetHostNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->host_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void P2PSocketManager_GetHostAddress_ResponseParamsDataView::GetAddressesDataView(
    mojo::ArrayDataView<::network::mojom::IPAddressDataView>* output) {
  auto pointer = data_->addresses.Get();
  *output = mojo::ArrayDataView<::network::mojom::IPAddressDataView>(pointer, context_);
}


inline void P2PSocketManager_CreateSocket_ParamsDataView::GetLocalAddressDataView(
    ::network::mojom::IPEndPointDataView* output) {
  auto pointer = data_->local_address.Get();
  *output = ::network::mojom::IPEndPointDataView(pointer, context_);
}
inline void P2PSocketManager_CreateSocket_ParamsDataView::GetPortRangeDataView(
    P2PPortRangeDataView* output) {
  auto pointer = data_->port_range.Get();
  *output = P2PPortRangeDataView(pointer, context_);
}
inline void P2PSocketManager_CreateSocket_ParamsDataView::GetRemoteAddressDataView(
    P2PHostAndIPEndPointDataView* output) {
  auto pointer = data_->remote_address.Get();
  *output = P2PHostAndIPEndPointDataView(pointer, context_);
}


inline void P2PSocket_Send_ParamsDataView::GetDataDataView(
    mojo::ArrayDataView<int8_t>* output) {
  auto pointer = data_->data.Get();
  *output = mojo::ArrayDataView<int8_t>(pointer, context_);
}
inline void P2PSocket_Send_ParamsDataView::GetPacketInfoDataView(
    P2PPacketInfoDataView* output) {
  auto pointer = data_->packet_info.Get();
  *output = P2PPacketInfoDataView(pointer, context_);
}
inline void P2PSocket_Send_ParamsDataView::GetTrafficAnnotationDataView(
    ::network::mojom::MutableNetworkTrafficAnnotationTagDataView* output) {
  auto pointer = data_->traffic_annotation.Get();
  *output = ::network::mojom::MutableNetworkTrafficAnnotationTagDataView(pointer, context_);
}




inline void P2PSocketClient_SocketCreated_ParamsDataView::GetLocalAddressDataView(
    ::network::mojom::IPEndPointDataView* output) {
  auto pointer = data_->local_address.Get();
  *output = ::network::mojom::IPEndPointDataView(pointer, context_);
}
inline void P2PSocketClient_SocketCreated_ParamsDataView::GetRemoteAddressDataView(
    ::network::mojom::IPEndPointDataView* output) {
  auto pointer = data_->remote_address.Get();
  *output = ::network::mojom::IPEndPointDataView(pointer, context_);
}


inline void P2PSocketClient_SendComplete_ParamsDataView::GetSendMetricsDataView(
    P2PSendPacketMetricsDataView* output) {
  auto pointer = data_->send_metrics.Get();
  *output = P2PSendPacketMetricsDataView(pointer, context_);
}


inline void P2PSocketClient_IncomingTcpConnection_ParamsDataView::GetSocketAddressDataView(
    ::network::mojom::IPEndPointDataView* output) {
  auto pointer = data_->socket_address.Get();
  *output = ::network::mojom::IPEndPointDataView(pointer, context_);
}


inline void P2PSocketClient_DataReceived_ParamsDataView::GetSocketAddressDataView(
    ::network::mojom::IPEndPointDataView* output) {
  auto pointer = data_->socket_address.Get();
  *output = ::network::mojom::IPEndPointDataView(pointer, context_);
}
inline void P2PSocketClient_DataReceived_ParamsDataView::GetDataDataView(
    mojo::ArrayDataView<int8_t>* output) {
  auto pointer = data_->data.Get();
  *output = mojo::ArrayDataView<int8_t>(pointer, context_);
}
inline void P2PSocketClient_DataReceived_ParamsDataView::GetTimestampDataView(
    ::mojo_base::mojom::TimeTicksDataView* output) {
  auto pointer = data_->timestamp.Get();
  *output = ::mojo_base::mojom::TimeTicksDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_P2P_MOJOM_SHARED_H_