// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_P2P_TRUSTED_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_P2P_TRUSTED_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/network/public/mojom/p2p.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data));
      new (data()) P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data>(index_);
    }
    P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data();
  ~P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data() = delete;
};
static_assert(sizeof(P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data) == 8,
              "Bad sizeof(P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data)");
class  P2PTrustedSocketManagerClient_DumpPacket_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PTrustedSocketManagerClient_DumpPacket_Params_Data));
      new (data()) P2PTrustedSocketManagerClient_DumpPacket_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PTrustedSocketManagerClient_DumpPacket_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PTrustedSocketManagerClient_DumpPacket_Params_Data>(index_);
    }
    P2PTrustedSocketManagerClient_DumpPacket_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> packet_header;
  uint64_t packet_length;
  uint8_t incoming : 1;
  uint8_t padfinal_[7];

 private:
  P2PTrustedSocketManagerClient_DumpPacket_Params_Data();
  ~P2PTrustedSocketManagerClient_DumpPacket_Params_Data() = delete;
};
static_assert(sizeof(P2PTrustedSocketManagerClient_DumpPacket_Params_Data) == 32,
              "Bad sizeof(P2PTrustedSocketManagerClient_DumpPacket_Params_Data)");
class  P2PTrustedSocketManager_StartRtpDump_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PTrustedSocketManager_StartRtpDump_Params_Data));
      new (data()) P2PTrustedSocketManager_StartRtpDump_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PTrustedSocketManager_StartRtpDump_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PTrustedSocketManager_StartRtpDump_Params_Data>(index_);
    }
    P2PTrustedSocketManager_StartRtpDump_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t incoming : 1;
  uint8_t outgoing : 1;
  uint8_t padfinal_[7];

 private:
  P2PTrustedSocketManager_StartRtpDump_Params_Data();
  ~P2PTrustedSocketManager_StartRtpDump_Params_Data() = delete;
};
static_assert(sizeof(P2PTrustedSocketManager_StartRtpDump_Params_Data) == 16,
              "Bad sizeof(P2PTrustedSocketManager_StartRtpDump_Params_Data)");
class  P2PTrustedSocketManager_StopRtpDump_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(P2PTrustedSocketManager_StopRtpDump_Params_Data));
      new (data()) P2PTrustedSocketManager_StopRtpDump_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    P2PTrustedSocketManager_StopRtpDump_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<P2PTrustedSocketManager_StopRtpDump_Params_Data>(index_);
    }
    P2PTrustedSocketManager_StopRtpDump_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t incoming : 1;
  uint8_t outgoing : 1;
  uint8_t padfinal_[7];

 private:
  P2PTrustedSocketManager_StopRtpDump_Params_Data();
  ~P2PTrustedSocketManager_StopRtpDump_Params_Data() = delete;
};
static_assert(sizeof(P2PTrustedSocketManager_StopRtpDump_Params_Data) == 16,
              "Bad sizeof(P2PTrustedSocketManager_StopRtpDump_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_P2P_TRUSTED_MOJOM_SHARED_INTERNAL_H_