// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_LOOKUP_CLIENT_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_LOOKUP_CLIENT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/network/public/mojom/proxy_lookup_client.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared.h"
#include "services/proxy_resolver/public/mojom/proxy_resolver.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace network {
namespace mojom {


}  // namespace mojom
}  // namespace network

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace network {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ProxyLookupClientInterfaceBase {};

using ProxyLookupClientPtrDataView =
    mojo::InterfacePtrDataView<ProxyLookupClientInterfaceBase>;
using ProxyLookupClientRequestDataView =
    mojo::InterfaceRequestDataView<ProxyLookupClientInterfaceBase>;
using ProxyLookupClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ProxyLookupClientInterfaceBase>;
using ProxyLookupClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ProxyLookupClientInterfaceBase>;
class ProxyLookupClient_OnProxyLookupComplete_ParamsDataView {
 public:
  ProxyLookupClient_OnProxyLookupComplete_ParamsDataView() {}

  ProxyLookupClient_OnProxyLookupComplete_ParamsDataView(
      internal::ProxyLookupClient_OnProxyLookupComplete_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t net_error() const {
    return data_->net_error;
  }
  inline void GetProxyInfoDataView(
      ::proxy_resolver::mojom::ProxyInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadProxyInfo(UserType* output) {
    auto* pointer = data_->proxy_info.Get();
    return mojo::internal::Deserialize<::proxy_resolver::mojom::ProxyInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProxyLookupClient_OnProxyLookupComplete_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace network

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace network {
namespace mojom {

inline void ProxyLookupClient_OnProxyLookupComplete_ParamsDataView::GetProxyInfoDataView(
    ::proxy_resolver::mojom::ProxyInfoDataView* output) {
  auto pointer = data_->proxy_info.Get();
  *output = ::proxy_resolver::mojom::ProxyInfoDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_LOOKUP_CLIENT_MOJOM_SHARED_H_