// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_TCP_SOCKET_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_TCP_SOCKET_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/network/public/mojom/address_list.mojom-shared-internal.h"
#include "services/network/public/mojom/ip_endpoint.mojom-shared-internal.h"
#include "services/network/public/mojom/ssl_config.mojom-shared-internal.h"
#include "services/network/public/mojom/tls_socket.mojom-shared-internal.h"
#include "services/network/public/mojom/network_param.mojom-shared-internal.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {
class TCPConnectedSocketOptions_Data;

#pragma pack(push, 1)
class  TCPConnectedSocketOptions_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocketOptions_Data));
      new (data()) TCPConnectedSocketOptions_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocketOptions_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocketOptions_Data>(index_);
    }
    TCPConnectedSocketOptions_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t send_buffer_size;
  int32_t receive_buffer_size;
  uint8_t no_delay : 1;
  uint8_t padfinal_[7];

 private:
  TCPConnectedSocketOptions_Data();
  ~TCPConnectedSocketOptions_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocketOptions_Data) == 24,
              "Bad sizeof(TCPConnectedSocketOptions_Data)");
// Used by TCPConnectedSocketOptions::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct TCPConnectedSocketOptions_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  TCPConnectedSocketOptions_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~TCPConnectedSocketOptions_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    TCPConnectedSocketOptions_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    TCPConnectedSocketOptions_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  TCPBoundSocket_Listen_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPBoundSocket_Listen_Params_Data));
      new (data()) TCPBoundSocket_Listen_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPBoundSocket_Listen_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPBoundSocket_Listen_Params_Data>(index_);
    }
    TCPBoundSocket_Listen_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t backlog;
  mojo::internal::Handle_Data socket;

 private:
  TCPBoundSocket_Listen_Params_Data();
  ~TCPBoundSocket_Listen_Params_Data() = delete;
};
static_assert(sizeof(TCPBoundSocket_Listen_Params_Data) == 16,
              "Bad sizeof(TCPBoundSocket_Listen_Params_Data)");
class  TCPBoundSocket_Listen_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPBoundSocket_Listen_ResponseParams_Data));
      new (data()) TCPBoundSocket_Listen_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPBoundSocket_Listen_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPBoundSocket_Listen_ResponseParams_Data>(index_);
    }
    TCPBoundSocket_Listen_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t padfinal_[4];

 private:
  TCPBoundSocket_Listen_ResponseParams_Data();
  ~TCPBoundSocket_Listen_ResponseParams_Data() = delete;
};
static_assert(sizeof(TCPBoundSocket_Listen_ResponseParams_Data) == 16,
              "Bad sizeof(TCPBoundSocket_Listen_ResponseParams_Data)");
class  TCPBoundSocket_Connect_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPBoundSocket_Connect_Params_Data));
      new (data()) TCPBoundSocket_Connect_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPBoundSocket_Connect_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPBoundSocket_Connect_Params_Data>(index_);
    }
    TCPBoundSocket_Connect_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::AddressList_Data> remote_addr_list;
  mojo::internal::Pointer<internal::TCPConnectedSocketOptions_Data> tcp_connected_socket_options;
  mojo::internal::Handle_Data socket;
  mojo::internal::Interface_Data observer;
  uint8_t padfinal_[4];

 private:
  TCPBoundSocket_Connect_Params_Data();
  ~TCPBoundSocket_Connect_Params_Data() = delete;
};
static_assert(sizeof(TCPBoundSocket_Connect_Params_Data) == 40,
              "Bad sizeof(TCPBoundSocket_Connect_Params_Data)");
class  TCPBoundSocket_Connect_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPBoundSocket_Connect_ResponseParams_Data));
      new (data()) TCPBoundSocket_Connect_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPBoundSocket_Connect_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPBoundSocket_Connect_ResponseParams_Data>(index_);
    }
    TCPBoundSocket_Connect_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  mojo::internal::Handle_Data receive_stream;
  mojo::internal::Pointer<::network::mojom::internal::IPEndPoint_Data> local_addr;
  mojo::internal::Pointer<::network::mojom::internal::IPEndPoint_Data> peer_addr;
  mojo::internal::Handle_Data send_stream;
  uint8_t padfinal_[4];

 private:
  TCPBoundSocket_Connect_ResponseParams_Data();
  ~TCPBoundSocket_Connect_ResponseParams_Data() = delete;
};
static_assert(sizeof(TCPBoundSocket_Connect_ResponseParams_Data) == 40,
              "Bad sizeof(TCPBoundSocket_Connect_ResponseParams_Data)");
class  TCPConnectedSocket_UpgradeToTLS_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_UpgradeToTLS_Params_Data));
      new (data()) TCPConnectedSocket_UpgradeToTLS_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_UpgradeToTLS_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_UpgradeToTLS_Params_Data>(index_);
    }
    TCPConnectedSocket_UpgradeToTLS_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::HostPortPair_Data> host_port_pair;
  mojo::internal::Pointer<::network::mojom::internal::TLSClientSocketOptions_Data> options;
  mojo::internal::Pointer<::network::mojom::internal::MutableNetworkTrafficAnnotationTag_Data> traffic_annotation;
  mojo::internal::Handle_Data request;
  mojo::internal::Interface_Data observer;
  uint8_t padfinal_[4];

 private:
  TCPConnectedSocket_UpgradeToTLS_Params_Data();
  ~TCPConnectedSocket_UpgradeToTLS_Params_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_UpgradeToTLS_Params_Data) == 48,
              "Bad sizeof(TCPConnectedSocket_UpgradeToTLS_Params_Data)");
class  TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data));
      new (data()) TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data>(index_);
    }
    TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  mojo::internal::Handle_Data receive_stream;
  mojo::internal::Handle_Data send_stream;
  uint8_t pad2_[4];
  mojo::internal::Pointer<::network::mojom::internal::SSLInfo_Data> ssl_info;

 private:
  TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data();
  ~TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data) == 32,
              "Bad sizeof(TCPConnectedSocket_UpgradeToTLS_ResponseParams_Data)");
class  TCPConnectedSocket_SetSendBufferSize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_SetSendBufferSize_Params_Data));
      new (data()) TCPConnectedSocket_SetSendBufferSize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_SetSendBufferSize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_SetSendBufferSize_Params_Data>(index_);
    }
    TCPConnectedSocket_SetSendBufferSize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t send_buffer_size;
  uint8_t padfinal_[4];

 private:
  TCPConnectedSocket_SetSendBufferSize_Params_Data();
  ~TCPConnectedSocket_SetSendBufferSize_Params_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_SetSendBufferSize_Params_Data) == 16,
              "Bad sizeof(TCPConnectedSocket_SetSendBufferSize_Params_Data)");
class  TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data));
      new (data()) TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data>(index_);
    }
    TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t padfinal_[4];

 private:
  TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data();
  ~TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data) == 16,
              "Bad sizeof(TCPConnectedSocket_SetSendBufferSize_ResponseParams_Data)");
class  TCPConnectedSocket_SetReceiveBufferSize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_SetReceiveBufferSize_Params_Data));
      new (data()) TCPConnectedSocket_SetReceiveBufferSize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_SetReceiveBufferSize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_SetReceiveBufferSize_Params_Data>(index_);
    }
    TCPConnectedSocket_SetReceiveBufferSize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t receive_buffer_size;
  uint8_t padfinal_[4];

 private:
  TCPConnectedSocket_SetReceiveBufferSize_Params_Data();
  ~TCPConnectedSocket_SetReceiveBufferSize_Params_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_SetReceiveBufferSize_Params_Data) == 16,
              "Bad sizeof(TCPConnectedSocket_SetReceiveBufferSize_Params_Data)");
class  TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data));
      new (data()) TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data>(index_);
    }
    TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t padfinal_[4];

 private:
  TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data();
  ~TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data) == 16,
              "Bad sizeof(TCPConnectedSocket_SetReceiveBufferSize_ResponseParams_Data)");
class  TCPConnectedSocket_SetNoDelay_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_SetNoDelay_Params_Data));
      new (data()) TCPConnectedSocket_SetNoDelay_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_SetNoDelay_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_SetNoDelay_Params_Data>(index_);
    }
    TCPConnectedSocket_SetNoDelay_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t no_delay : 1;
  uint8_t padfinal_[7];

 private:
  TCPConnectedSocket_SetNoDelay_Params_Data();
  ~TCPConnectedSocket_SetNoDelay_Params_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_SetNoDelay_Params_Data) == 16,
              "Bad sizeof(TCPConnectedSocket_SetNoDelay_Params_Data)");
class  TCPConnectedSocket_SetNoDelay_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_SetNoDelay_ResponseParams_Data));
      new (data()) TCPConnectedSocket_SetNoDelay_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_SetNoDelay_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_SetNoDelay_ResponseParams_Data>(index_);
    }
    TCPConnectedSocket_SetNoDelay_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  TCPConnectedSocket_SetNoDelay_ResponseParams_Data();
  ~TCPConnectedSocket_SetNoDelay_ResponseParams_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_SetNoDelay_ResponseParams_Data) == 16,
              "Bad sizeof(TCPConnectedSocket_SetNoDelay_ResponseParams_Data)");
class  TCPConnectedSocket_SetKeepAlive_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_SetKeepAlive_Params_Data));
      new (data()) TCPConnectedSocket_SetKeepAlive_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_SetKeepAlive_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_SetKeepAlive_Params_Data>(index_);
    }
    TCPConnectedSocket_SetKeepAlive_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t enable : 1;
  uint8_t pad0_[3];
  int32_t delay_secs;

 private:
  TCPConnectedSocket_SetKeepAlive_Params_Data();
  ~TCPConnectedSocket_SetKeepAlive_Params_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_SetKeepAlive_Params_Data) == 16,
              "Bad sizeof(TCPConnectedSocket_SetKeepAlive_Params_Data)");
class  TCPConnectedSocket_SetKeepAlive_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPConnectedSocket_SetKeepAlive_ResponseParams_Data));
      new (data()) TCPConnectedSocket_SetKeepAlive_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPConnectedSocket_SetKeepAlive_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPConnectedSocket_SetKeepAlive_ResponseParams_Data>(index_);
    }
    TCPConnectedSocket_SetKeepAlive_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  TCPConnectedSocket_SetKeepAlive_ResponseParams_Data();
  ~TCPConnectedSocket_SetKeepAlive_ResponseParams_Data() = delete;
};
static_assert(sizeof(TCPConnectedSocket_SetKeepAlive_ResponseParams_Data) == 16,
              "Bad sizeof(TCPConnectedSocket_SetKeepAlive_ResponseParams_Data)");
class  SocketObserver_OnReadError_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SocketObserver_OnReadError_Params_Data));
      new (data()) SocketObserver_OnReadError_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SocketObserver_OnReadError_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SocketObserver_OnReadError_Params_Data>(index_);
    }
    SocketObserver_OnReadError_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t padfinal_[4];

 private:
  SocketObserver_OnReadError_Params_Data();
  ~SocketObserver_OnReadError_Params_Data() = delete;
};
static_assert(sizeof(SocketObserver_OnReadError_Params_Data) == 16,
              "Bad sizeof(SocketObserver_OnReadError_Params_Data)");
class  SocketObserver_OnWriteError_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SocketObserver_OnWriteError_Params_Data));
      new (data()) SocketObserver_OnWriteError_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SocketObserver_OnWriteError_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SocketObserver_OnWriteError_Params_Data>(index_);
    }
    SocketObserver_OnWriteError_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t padfinal_[4];

 private:
  SocketObserver_OnWriteError_Params_Data();
  ~SocketObserver_OnWriteError_Params_Data() = delete;
};
static_assert(sizeof(SocketObserver_OnWriteError_Params_Data) == 16,
              "Bad sizeof(SocketObserver_OnWriteError_Params_Data)");
class  TCPServerSocket_Accept_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPServerSocket_Accept_Params_Data));
      new (data()) TCPServerSocket_Accept_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPServerSocket_Accept_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPServerSocket_Accept_Params_Data>(index_);
    }
    TCPServerSocket_Accept_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data observer;

 private:
  TCPServerSocket_Accept_Params_Data();
  ~TCPServerSocket_Accept_Params_Data() = delete;
};
static_assert(sizeof(TCPServerSocket_Accept_Params_Data) == 16,
              "Bad sizeof(TCPServerSocket_Accept_Params_Data)");
class  TCPServerSocket_Accept_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TCPServerSocket_Accept_ResponseParams_Data));
      new (data()) TCPServerSocket_Accept_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TCPServerSocket_Accept_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TCPServerSocket_Accept_ResponseParams_Data>(index_);
    }
    TCPServerSocket_Accept_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  mojo::internal::Handle_Data send_stream;
  mojo::internal::Pointer<::network::mojom::internal::IPEndPoint_Data> remote_addr;
  mojo::internal::Interface_Data connected_socket;
  mojo::internal::Handle_Data receive_stream;
  uint8_t padfinal_[4];

 private:
  TCPServerSocket_Accept_ResponseParams_Data();
  ~TCPServerSocket_Accept_ResponseParams_Data() = delete;
};
static_assert(sizeof(TCPServerSocket_Accept_ResponseParams_Data) == 40,
              "Bad sizeof(TCPServerSocket_Accept_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_TCP_SOCKET_MOJOM_SHARED_INTERNAL_H_