// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_PREFERENCES_PUBLIC_MOJOM_TRACKED_PREFERENCE_VALIDATION_DELEGATE_MOJOM_TEST_UTILS_H_
#define SERVICES_PREFERENCES_PUBLIC_MOJOM_TRACKED_PREFERENCE_VALIDATION_DELEGATE_MOJOM_TEST_UTILS_H_

#include "services/preferences/public/mojom/tracked_preference_validation_delegate.mojom.h"


namespace prefs {
namespace mojom {


class  TrackedPreferenceValidationDelegateInterceptorForTesting : public TrackedPreferenceValidationDelegate {
  virtual TrackedPreferenceValidationDelegate* GetForwardingInterface() = 0;
  void OnAtomicPreferenceValidation(const std::string& pref_path, base::Optional<base::Value> value, TrackedPreferenceValidationDelegate::ValueState value_state, TrackedPreferenceValidationDelegate::ValueState external_validation_value_state, bool is_personal) override;
  void OnSplitPreferenceValidation(const std::string& pref_path, const std::vector<std::string>& invalid_keys, const std::vector<std::string>& external_validation_invalid_keys, TrackedPreferenceValidationDelegate::ValueState value_state, TrackedPreferenceValidationDelegate::ValueState external_validation_value_state, bool is_personal) override;
};
class  TrackedPreferenceValidationDelegateAsyncWaiter {
 public:
  explicit TrackedPreferenceValidationDelegateAsyncWaiter(TrackedPreferenceValidationDelegate* proxy);
  ~TrackedPreferenceValidationDelegateAsyncWaiter();

 private:
  TrackedPreferenceValidationDelegate* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(TrackedPreferenceValidationDelegateAsyncWaiter);
};




}  // namespace mojom
}  // namespace prefs

#endif  // SERVICES_PREFERENCES_PUBLIC_MOJOM_TRACKED_PREFERENCE_VALIDATION_DELEGATE_MOJOM_TEST_UTILS_H_