// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This is a generated file. Please see the "service_manifest" template in
// src/services/service_manager/public/service_manifest.gni for more details.

#include "services/resource_coordinator/manifest.h"

#include <set>

#include "base/files/file_path.h"
#include "base/no_destructor.h"
#include "build/build_config.h"
#include "services/service_manager/public/cpp/manifest_builder.h"




namespace resource_coordinator {


const service_manager::Manifest& GetManifest() {
  static base::NoDestructor<service_manager::Manifest> manifest{
      service_manager::ManifestBuilder()
          .WithServiceName("resource_coordinator")
          .WithDisplayName("Global Resource Coordinator")
          .WithOptions(service_manager::ManifestOptionsBuilder()
                           .WithInstanceSharingPolicy(
                                service_manager::Manifest::InstanceSharingPolicy::
                                    kSharedAcrossGroups)
                           .Build())
          .ExposeCapability(
              "tests", std::set<const char*>{
                  "*",})
          .ExposeCapability(
              "page_signal", std::set<const char*>{
                  "resource_coordinator.mojom.PageSignalGenerator",})
          .ExposeCapability(
              "coordination_unit_introspector", std::set<const char*>{
                  "resource_coordinator.mojom.CoordinationUnitIntrospector",})
          .ExposeCapability(
              "app", std::set<const char*>{
                  "memory_instrumentation.mojom.Coordinator",})
          .ExposeCapability(
              "webui_graph_dump", std::set<const char*>{
                  "resource_coordinator.mojom.WebUIGraphDump",})
          .ExposeCapability(
              "heap_profiler_helper", std::set<const char*>{
                  "memory_instrumentation.mojom.HeapProfilerHelper",})
          .ExposeCapability(
              "coordination_unit", std::set<const char*>{
                  "resource_coordinator.mojom.CoordinationUnitProvider",})
          .RequireCapability("metrics", "url_keyed_metrics")
          .RequireCapability("service_manager", "service_manager:service_manager")
          .Build() };
  return *manifest;
}

}  // namespace resource_coordinator
