// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/resource_coordinator/public/mojom/coordination_unit.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_MOJOM_JUMBO_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/process_id_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "services/resource_coordinator/public/cpp/coordination_unit_mojom_traits.h"
#endif


namespace resource_coordinator {
namespace mojom {


void FrameCoordinationUnitInterceptorForTesting::GetID(GetIDCallback callback) {
  GetForwardingInterface()->GetID(std::move(callback));
}
void FrameCoordinationUnitInterceptorForTesting::SetProcess(const ::resource_coordinator::CoordinationUnitID& id) {
  GetForwardingInterface()->SetProcess(std::move(id));
}
void FrameCoordinationUnitInterceptorForTesting::AddBinding(FrameCoordinationUnitRequest request) {
  GetForwardingInterface()->AddBinding(std::move(request));
}
void FrameCoordinationUnitInterceptorForTesting::AddChildFrame(const ::resource_coordinator::CoordinationUnitID& cu_id) {
  GetForwardingInterface()->AddChildFrame(std::move(cu_id));
}
void FrameCoordinationUnitInterceptorForTesting::RemoveChildFrame(const ::resource_coordinator::CoordinationUnitID& cu_id) {
  GetForwardingInterface()->RemoveChildFrame(std::move(cu_id));
}
void FrameCoordinationUnitInterceptorForTesting::SetNetworkAlmostIdle(bool idle) {
  GetForwardingInterface()->SetNetworkAlmostIdle(std::move(idle));
}
void FrameCoordinationUnitInterceptorForTesting::SetLifecycleState(::resource_coordinator::mojom::LifecycleState state) {
  GetForwardingInterface()->SetLifecycleState(std::move(state));
}
void FrameCoordinationUnitInterceptorForTesting::SetHasNonEmptyBeforeUnload(bool has_nonempty_beforeunload) {
  GetForwardingInterface()->SetHasNonEmptyBeforeUnload(std::move(has_nonempty_beforeunload));
}
void FrameCoordinationUnitInterceptorForTesting::SetInterventionPolicy(PolicyControlledIntervention intervention, InterventionPolicy policy) {
  GetForwardingInterface()->SetInterventionPolicy(std::move(intervention), std::move(policy));
}
void FrameCoordinationUnitInterceptorForTesting::OnNonPersistentNotificationCreated() {
  GetForwardingInterface()->OnNonPersistentNotificationCreated();
}
FrameCoordinationUnitAsyncWaiter::FrameCoordinationUnitAsyncWaiter(
    FrameCoordinationUnit* proxy) : proxy_(proxy) {}

FrameCoordinationUnitAsyncWaiter::~FrameCoordinationUnitAsyncWaiter() = default;

void FrameCoordinationUnitAsyncWaiter::GetID(
    ::resource_coordinator::CoordinationUnitID* out_id) {
  base::RunLoop loop;
  proxy_->GetID(
      base::BindOnce(
          [](base::RunLoop* loop,
             ::resource_coordinator::CoordinationUnitID* out_id
,
             const ::resource_coordinator::CoordinationUnitID& id) {*out_id = std::move(id);
            loop->Quit();
          },
          &loop,
          out_id));
  loop.Run();
}



void PageCoordinationUnitInterceptorForTesting::GetID(GetIDCallback callback) {
  GetForwardingInterface()->GetID(std::move(callback));
}
void PageCoordinationUnitInterceptorForTesting::AddBinding(PageCoordinationUnitRequest request) {
  GetForwardingInterface()->AddBinding(std::move(request));
}
void PageCoordinationUnitInterceptorForTesting::AddFrame(const ::resource_coordinator::CoordinationUnitID& cu_id) {
  GetForwardingInterface()->AddFrame(std::move(cu_id));
}
void PageCoordinationUnitInterceptorForTesting::RemoveFrame(const ::resource_coordinator::CoordinationUnitID& cu_id) {
  GetForwardingInterface()->RemoveFrame(std::move(cu_id));
}
void PageCoordinationUnitInterceptorForTesting::SetIsLoading(bool is_loading) {
  GetForwardingInterface()->SetIsLoading(std::move(is_loading));
}
void PageCoordinationUnitInterceptorForTesting::SetVisibility(bool visible) {
  GetForwardingInterface()->SetVisibility(std::move(visible));
}
void PageCoordinationUnitInterceptorForTesting::SetUKMSourceId(int64_t ukm_source_id) {
  GetForwardingInterface()->SetUKMSourceId(std::move(ukm_source_id));
}
void PageCoordinationUnitInterceptorForTesting::OnFaviconUpdated() {
  GetForwardingInterface()->OnFaviconUpdated();
}
void PageCoordinationUnitInterceptorForTesting::OnTitleUpdated() {
  GetForwardingInterface()->OnTitleUpdated();
}
void PageCoordinationUnitInterceptorForTesting::OnMainFrameNavigationCommitted(base::TimeTicks navigation_committed_time, int64_t navigation_id, const std::string& url) {
  GetForwardingInterface()->OnMainFrameNavigationCommitted(std::move(navigation_committed_time), std::move(navigation_id), std::move(url));
}
PageCoordinationUnitAsyncWaiter::PageCoordinationUnitAsyncWaiter(
    PageCoordinationUnit* proxy) : proxy_(proxy) {}

PageCoordinationUnitAsyncWaiter::~PageCoordinationUnitAsyncWaiter() = default;

void PageCoordinationUnitAsyncWaiter::GetID(
    ::resource_coordinator::CoordinationUnitID* out_id) {
  base::RunLoop loop;
  proxy_->GetID(
      base::BindOnce(
          [](base::RunLoop* loop,
             ::resource_coordinator::CoordinationUnitID* out_id
,
             const ::resource_coordinator::CoordinationUnitID& id) {*out_id = std::move(id);
            loop->Quit();
          },
          &loop,
          out_id));
  loop.Run();
}



void ProcessCoordinationUnitInterceptorForTesting::GetID(GetIDCallback callback) {
  GetForwardingInterface()->GetID(std::move(callback));
}
void ProcessCoordinationUnitInterceptorForTesting::AddBinding(ProcessCoordinationUnitRequest request) {
  GetForwardingInterface()->AddBinding(std::move(request));
}
void ProcessCoordinationUnitInterceptorForTesting::SetCPUUsage(double cpu_usage) {
  GetForwardingInterface()->SetCPUUsage(std::move(cpu_usage));
}
void ProcessCoordinationUnitInterceptorForTesting::SetExpectedTaskQueueingDuration(base::TimeDelta duration) {
  GetForwardingInterface()->SetExpectedTaskQueueingDuration(std::move(duration));
}
void ProcessCoordinationUnitInterceptorForTesting::SetLaunchTime(base::Time launch_time) {
  GetForwardingInterface()->SetLaunchTime(std::move(launch_time));
}
void ProcessCoordinationUnitInterceptorForTesting::SetMainThreadTaskLoadIsLow(bool main_thread_task_load_is_low) {
  GetForwardingInterface()->SetMainThreadTaskLoadIsLow(std::move(main_thread_task_load_is_low));
}
void ProcessCoordinationUnitInterceptorForTesting::SetPID(base::ProcessId pid) {
  GetForwardingInterface()->SetPID(std::move(pid));
}
void ProcessCoordinationUnitInterceptorForTesting::SetProcessExitStatus(int32_t exit_status) {
  GetForwardingInterface()->SetProcessExitStatus(std::move(exit_status));
}
void ProcessCoordinationUnitInterceptorForTesting::OnRendererIsBloated() {
  GetForwardingInterface()->OnRendererIsBloated();
}
ProcessCoordinationUnitAsyncWaiter::ProcessCoordinationUnitAsyncWaiter(
    ProcessCoordinationUnit* proxy) : proxy_(proxy) {}

ProcessCoordinationUnitAsyncWaiter::~ProcessCoordinationUnitAsyncWaiter() = default;

void ProcessCoordinationUnitAsyncWaiter::GetID(
    ::resource_coordinator::CoordinationUnitID* out_id) {
  base::RunLoop loop;
  proxy_->GetID(
      base::BindOnce(
          [](base::RunLoop* loop,
             ::resource_coordinator::CoordinationUnitID* out_id
,
             const ::resource_coordinator::CoordinationUnitID& id) {*out_id = std::move(id);
            loop->Quit();
          },
          &loop,
          out_id));
  loop.Run();
}



void SystemCoordinationUnitInterceptorForTesting::GetID(GetIDCallback callback) {
  GetForwardingInterface()->GetID(std::move(callback));
}
void SystemCoordinationUnitInterceptorForTesting::AddBinding(SystemCoordinationUnitRequest request) {
  GetForwardingInterface()->AddBinding(std::move(request));
}
void SystemCoordinationUnitInterceptorForTesting::OnProcessCPUUsageReady() {
  GetForwardingInterface()->OnProcessCPUUsageReady();
}
void SystemCoordinationUnitInterceptorForTesting::DistributeMeasurementBatch(ProcessResourceMeasurementBatchPtr measurement_batch) {
  GetForwardingInterface()->DistributeMeasurementBatch(std::move(measurement_batch));
}
SystemCoordinationUnitAsyncWaiter::SystemCoordinationUnitAsyncWaiter(
    SystemCoordinationUnit* proxy) : proxy_(proxy) {}

SystemCoordinationUnitAsyncWaiter::~SystemCoordinationUnitAsyncWaiter() = default;

void SystemCoordinationUnitAsyncWaiter::GetID(
    ::resource_coordinator::CoordinationUnitID* out_id) {
  base::RunLoop loop;
  proxy_->GetID(
      base::BindOnce(
          [](base::RunLoop* loop,
             ::resource_coordinator::CoordinationUnitID* out_id
,
             const ::resource_coordinator::CoordinationUnitID& id) {*out_id = std::move(id);
            loop->Quit();
          },
          &loop,
          out_id));
  loop.Run();
}





}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif