// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/resource_coordinator/public/mojom/coordination_unit_introspector.mojom-blink-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_INTROSPECTOR_MOJOM_BLINK_JUMBO_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_INTROSPECTOR_MOJOM_BLINK_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#endif


namespace resource_coordinator {
namespace mojom {
namespace blink {


void CoordinationUnitIntrospectorInterceptorForTesting::GetProcessToURLMap(GetProcessToURLMapCallback callback) {
  GetForwardingInterface()->GetProcessToURLMap(std::move(callback));
}
CoordinationUnitIntrospectorAsyncWaiter::CoordinationUnitIntrospectorAsyncWaiter(
    CoordinationUnitIntrospector* proxy) : proxy_(proxy) {}

CoordinationUnitIntrospectorAsyncWaiter::~CoordinationUnitIntrospectorAsyncWaiter() = default;

void CoordinationUnitIntrospectorAsyncWaiter::GetProcessToURLMap(
    WTF::Vector<ProcessInfoPtr>* out_process_infos) {
  base::RunLoop loop;
  proxy_->GetProcessToURLMap(
      base::BindOnce(
          [](base::RunLoop* loop,
             WTF::Vector<ProcessInfoPtr>* out_process_infos
,
             WTF::Vector<ProcessInfoPtr> process_infos) {*out_process_infos = std::move(process_infos);
            loop->Quit();
          },
          &loop,
          out_process_infos));
  loop.Run();
}





}  // namespace blink
}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif