// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_INTROSPECTOR_MOJOM_BLINK_TEST_UTILS_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_INTROSPECTOR_MOJOM_BLINK_TEST_UTILS_H_

#include "services/resource_coordinator/public/mojom/coordination_unit_introspector.mojom-blink.h"
#include "base/component_export.h"


namespace resource_coordinator {
namespace mojom {
namespace blink {


class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_BLINK) CoordinationUnitIntrospectorInterceptorForTesting : public CoordinationUnitIntrospector {
  virtual CoordinationUnitIntrospector* GetForwardingInterface() = 0;
  void GetProcessToURLMap(GetProcessToURLMapCallback callback) override;
};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_BLINK) CoordinationUnitIntrospectorAsyncWaiter {
 public:
  explicit CoordinationUnitIntrospectorAsyncWaiter(CoordinationUnitIntrospector* proxy);
  ~CoordinationUnitIntrospectorAsyncWaiter();
  void GetProcessToURLMap(
      WTF::Vector<ProcessInfoPtr>* out_process_infos);

 private:
  CoordinationUnitIntrospector* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(CoordinationUnitIntrospectorAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_INTROSPECTOR_MOJOM_BLINK_TEST_UTILS_H_