// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_PROVIDER_MOJOM_BLINK_TEST_UTILS_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_PROVIDER_MOJOM_BLINK_TEST_UTILS_H_

#include "services/resource_coordinator/public/mojom/coordination_unit_provider.mojom-blink.h"
#include "base/component_export.h"


namespace resource_coordinator {
namespace mojom {
namespace blink {


class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_BLINK) CoordinationUnitProviderInterceptorForTesting : public CoordinationUnitProvider {
  virtual CoordinationUnitProvider* GetForwardingInterface() = 0;
  void CreateFrameCoordinationUnit(::resource_coordinator::mojom::blink::FrameCoordinationUnitRequest request, ::resource_coordinator::mojom::blink::CoordinationUnitIDPtr id) override;
  void CreatePageCoordinationUnit(::resource_coordinator::mojom::blink::PageCoordinationUnitRequest request, ::resource_coordinator::mojom::blink::CoordinationUnitIDPtr id) override;
  void CreateProcessCoordinationUnit(::resource_coordinator::mojom::blink::ProcessCoordinationUnitRequest request, ::resource_coordinator::mojom::blink::CoordinationUnitIDPtr id) override;
  void GetSystemCoordinationUnit(::resource_coordinator::mojom::blink::SystemCoordinationUnitRequest request) override;
};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_BLINK) CoordinationUnitProviderAsyncWaiter {
 public:
  explicit CoordinationUnitProviderAsyncWaiter(CoordinationUnitProvider* proxy);
  ~CoordinationUnitProviderAsyncWaiter();

 private:
  CoordinationUnitProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(CoordinationUnitProviderAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_PROVIDER_MOJOM_BLINK_TEST_UTILS_H_