// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/resource_coordinator/public/mojom/coordination_unit_provider.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_PROVIDER_MOJOM_JUMBO_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_PROVIDER_MOJOM_JUMBO_H_
#include "services/resource_coordinator/public/cpp/coordination_unit_mojom_traits.h"
#endif


namespace resource_coordinator {
namespace mojom {


void CoordinationUnitProviderInterceptorForTesting::CreateFrameCoordinationUnit(::resource_coordinator::mojom::FrameCoordinationUnitRequest request, const ::resource_coordinator::CoordinationUnitID& id) {
  GetForwardingInterface()->CreateFrameCoordinationUnit(std::move(request), std::move(id));
}
void CoordinationUnitProviderInterceptorForTesting::CreatePageCoordinationUnit(::resource_coordinator::mojom::PageCoordinationUnitRequest request, const ::resource_coordinator::CoordinationUnitID& id) {
  GetForwardingInterface()->CreatePageCoordinationUnit(std::move(request), std::move(id));
}
void CoordinationUnitProviderInterceptorForTesting::CreateProcessCoordinationUnit(::resource_coordinator::mojom::ProcessCoordinationUnitRequest request, const ::resource_coordinator::CoordinationUnitID& id) {
  GetForwardingInterface()->CreateProcessCoordinationUnit(std::move(request), std::move(id));
}
void CoordinationUnitProviderInterceptorForTesting::GetSystemCoordinationUnit(::resource_coordinator::mojom::SystemCoordinationUnitRequest request) {
  GetForwardingInterface()->GetSystemCoordinationUnit(std::move(request));
}
CoordinationUnitProviderAsyncWaiter::CoordinationUnitProviderAsyncWaiter(
    CoordinationUnitProvider* proxy) : proxy_(proxy) {}

CoordinationUnitProviderAsyncWaiter::~CoordinationUnitProviderAsyncWaiter() = default;






}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif