// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/resource_coordinator/public/mojom/page_signal.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_PAGE_SIGNAL_MOJOM_JUMBO_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_PAGE_SIGNAL_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "services/resource_coordinator/public/cpp/coordination_unit_mojom_traits.h"
#endif


namespace resource_coordinator {
namespace mojom {


void PageSignalReceiverInterceptorForTesting::NotifyPageAlmostIdle(const ::resource_coordinator::PageNavigationIdentity& page_navigation_id) {
  GetForwardingInterface()->NotifyPageAlmostIdle(std::move(page_navigation_id));
}
void PageSignalReceiverInterceptorForTesting::NotifyRendererIsBloated(const ::resource_coordinator::PageNavigationIdentity& page_navigation_id) {
  GetForwardingInterface()->NotifyRendererIsBloated(std::move(page_navigation_id));
}
void PageSignalReceiverInterceptorForTesting::SetExpectedTaskQueueingDuration(const ::resource_coordinator::PageNavigationIdentity& page_navigation_id, base::TimeDelta duration) {
  GetForwardingInterface()->SetExpectedTaskQueueingDuration(std::move(page_navigation_id), std::move(duration));
}
void PageSignalReceiverInterceptorForTesting::SetLifecycleState(const ::resource_coordinator::PageNavigationIdentity& page_navigation_id, ::resource_coordinator::mojom::LifecycleState state) {
  GetForwardingInterface()->SetLifecycleState(std::move(page_navigation_id), std::move(state));
}
void PageSignalReceiverInterceptorForTesting::NotifyNonPersistentNotificationCreated(const ::resource_coordinator::PageNavigationIdentity& page_navigation_id) {
  GetForwardingInterface()->NotifyNonPersistentNotificationCreated(std::move(page_navigation_id));
}
void PageSignalReceiverInterceptorForTesting::OnLoadTimePerformanceEstimate(const ::resource_coordinator::PageNavigationIdentity& page_navigation_id, base::TimeDelta load_duration, base::TimeDelta cpu_usage_estimate, uint64_t private_footprint_kb_estimate) {
  GetForwardingInterface()->OnLoadTimePerformanceEstimate(std::move(page_navigation_id), std::move(load_duration), std::move(cpu_usage_estimate), std::move(private_footprint_kb_estimate));
}
PageSignalReceiverAsyncWaiter::PageSignalReceiverAsyncWaiter(
    PageSignalReceiver* proxy) : proxy_(proxy) {}

PageSignalReceiverAsyncWaiter::~PageSignalReceiverAsyncWaiter() = default;




void PageSignalGeneratorInterceptorForTesting::AddReceiver(PageSignalReceiverPtr receiver) {
  GetForwardingInterface()->AddReceiver(std::move(receiver));
}
PageSignalGeneratorAsyncWaiter::PageSignalGeneratorAsyncWaiter(
    PageSignalGenerator* proxy) : proxy_(proxy) {}

PageSignalGeneratorAsyncWaiter::~PageSignalGeneratorAsyncWaiter() = default;






}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif