// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "services/resource_coordinator/public/mojom/signals.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
namespace resource_coordinator {
namespace mojom {

std::ostream& operator<<(std::ostream& os, Event value) {
  switch(value) {
    case Event::kTestEvent:
      return os << "Event::kTestEvent";
    case Event::kFaviconUpdated:
      return os << "Event::kFaviconUpdated";
    case Event::kNavigationCommitted:
      return os << "Event::kNavigationCommitted";
    case Event::kNonPersistentNotificationCreated:
      return os << "Event::kNonPersistentNotificationCreated";
    case Event::kTitleUpdated:
      return os << "Event::kTitleUpdated";
    case Event::kProcessCPUUsageReady:
      return os << "Event::kProcessCPUUsageReady";
    case Event::kRendererIsBloated:
      return os << "Event::kRendererIsBloated";
    default:
      return os << "Unknown Event value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, PropertyType value) {
  switch(value) {
    case PropertyType::kTest:
      return os << "PropertyType::kTest";
    case PropertyType::kCPUUsage:
      return os << "PropertyType::kCPUUsage";
    case PropertyType::kExpectedTaskQueueingDuration:
      return os << "PropertyType::kExpectedTaskQueueingDuration";
    case PropertyType::kMainThreadTaskLoadIsLow:
      return os << "PropertyType::kMainThreadTaskLoadIsLow";
    case PropertyType::kNetworkAlmostIdle:
      return os << "PropertyType::kNetworkAlmostIdle";
    case PropertyType::kPID:
      return os << "PropertyType::kPID";
    case PropertyType::kVisible:
      return os << "PropertyType::kVisible";
    case PropertyType::kUKMSourceId:
      return os << "PropertyType::kUKMSourceId";
    case PropertyType::kIsLoading:
      return os << "PropertyType::kIsLoading";
    case PropertyType::kLifecycleState:
      return os << "PropertyType::kLifecycleState";
    default:
      return os << "Unknown PropertyType value: " << static_cast<int32_t>(value);
  }
}

namespace internal {

}  // namespace internal
}  // namespace mojom
}  // namespace resource_coordinator

#if defined(_MSC_VER)
#pragma warning(pop)
#endif