// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/process_id.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace resource_coordinator {
namespace mojom {
namespace internal {
class WebUIPageInfo_Data;
class WebUIFrameInfo_Data;
class WebUIProcessInfo_Data;
class WebUIGraph_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) WebUIPageInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIPageInfo_Data));
      new (data()) WebUIPageInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIPageInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIPageInfo_Data>(index_);
    }
    WebUIPageInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t id;
  int64_t main_frame_id;
  mojo::internal::Pointer<mojo::internal::String_Data> main_frame_url;

 private:
  WebUIPageInfo_Data();
  ~WebUIPageInfo_Data() = delete;
};
static_assert(sizeof(WebUIPageInfo_Data) == 32,
              "Bad sizeof(WebUIPageInfo_Data)");
// Used by WebUIPageInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WebUIPageInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WebUIPageInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WebUIPageInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WebUIPageInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WebUIPageInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) WebUIFrameInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIFrameInfo_Data));
      new (data()) WebUIFrameInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIFrameInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIFrameInfo_Data>(index_);
    }
    WebUIFrameInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t id;
  int64_t parent_frame_id;
  int64_t process_id;

 private:
  WebUIFrameInfo_Data();
  ~WebUIFrameInfo_Data() = delete;
};
static_assert(sizeof(WebUIFrameInfo_Data) == 32,
              "Bad sizeof(WebUIFrameInfo_Data)");
// Used by WebUIFrameInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WebUIFrameInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WebUIFrameInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WebUIFrameInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WebUIFrameInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WebUIFrameInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) WebUIProcessInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIProcessInfo_Data));
      new (data()) WebUIProcessInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIProcessInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIProcessInfo_Data>(index_);
    }
    WebUIProcessInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t id;
  mojo::internal::Pointer<::mojo_base::mojom::internal::ProcessId_Data> pid;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> cumulative_cpu_usage;
  uint64_t private_footprint_kb;

 private:
  WebUIProcessInfo_Data();
  ~WebUIProcessInfo_Data() = delete;
};
static_assert(sizeof(WebUIProcessInfo_Data) == 40,
              "Bad sizeof(WebUIProcessInfo_Data)");
// Used by WebUIProcessInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WebUIProcessInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WebUIProcessInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WebUIProcessInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WebUIProcessInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WebUIProcessInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) WebUIGraph_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraph_Data));
      new (data()) WebUIGraph_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraph_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraph_Data>(index_);
    }
    WebUIGraph_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::WebUIPageInfo_Data>>> pages;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::WebUIFrameInfo_Data>>> frames;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::WebUIProcessInfo_Data>>> processes;

 private:
  WebUIGraph_Data();
  ~WebUIGraph_Data() = delete;
};
static_assert(sizeof(WebUIGraph_Data) == 32,
              "Bad sizeof(WebUIGraph_Data)");
// Used by WebUIGraph::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WebUIGraph_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WebUIGraph_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WebUIGraph_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WebUIGraph_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WebUIGraph_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) WebUIGraphDump_GetCurrentGraph_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphDump_GetCurrentGraph_Params_Data));
      new (data()) WebUIGraphDump_GetCurrentGraph_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphDump_GetCurrentGraph_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphDump_GetCurrentGraph_Params_Data>(index_);
    }
    WebUIGraphDump_GetCurrentGraph_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WebUIGraphDump_GetCurrentGraph_Params_Data();
  ~WebUIGraphDump_GetCurrentGraph_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphDump_GetCurrentGraph_Params_Data) == 8,
              "Bad sizeof(WebUIGraphDump_GetCurrentGraph_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) WebUIGraphDump_GetCurrentGraph_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphDump_GetCurrentGraph_ResponseParams_Data));
      new (data()) WebUIGraphDump_GetCurrentGraph_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphDump_GetCurrentGraph_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphDump_GetCurrentGraph_ResponseParams_Data>(index_);
    }
    WebUIGraphDump_GetCurrentGraph_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIGraph_Data> graph;

 private:
  WebUIGraphDump_GetCurrentGraph_ResponseParams_Data();
  ~WebUIGraphDump_GetCurrentGraph_ResponseParams_Data() = delete;
};
static_assert(sizeof(WebUIGraphDump_GetCurrentGraph_ResponseParams_Data) == 16,
              "Bad sizeof(WebUIGraphDump_GetCurrentGraph_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_SHARED_INTERNAL_H_