// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/resource_coordinator/public/mojom/webui_graph_dump.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_JUMBO_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/process_id_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#endif


namespace resource_coordinator {
namespace mojom {


void WebUIGraphDumpInterceptorForTesting::GetCurrentGraph(GetCurrentGraphCallback callback) {
  GetForwardingInterface()->GetCurrentGraph(std::move(callback));
}
WebUIGraphDumpAsyncWaiter::WebUIGraphDumpAsyncWaiter(
    WebUIGraphDump* proxy) : proxy_(proxy) {}

WebUIGraphDumpAsyncWaiter::~WebUIGraphDumpAsyncWaiter() = default;

void WebUIGraphDumpAsyncWaiter::GetCurrentGraph(
    WebUIGraphPtr* out_graph) {
  base::RunLoop loop;
  proxy_->GetCurrentGraph(
      base::BindOnce(
          [](base::RunLoop* loop,
             WebUIGraphPtr* out_graph
,
             WebUIGraphPtr graph) {*out_graph = std::move(graph);
            loop->Quit();
          },
          &loop,
          out_graph));
  loop.Run();
}





}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif