// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/tracing/public/mojom/perfetto_service.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_TRACING_PUBLIC_MOJOM_PERFETTO_SERVICE_MOJOM_JUMBO_H_
#define SERVICES_TRACING_PUBLIC_MOJOM_PERFETTO_SERVICE_MOJOM_JUMBO_H_
#endif


namespace tracing {
namespace mojom {


void ProducerHostInterceptorForTesting::CommitData(CommitDataRequestPtr data_request) {
  GetForwardingInterface()->CommitData(std::move(data_request));
}
void ProducerHostInterceptorForTesting::RegisterDataSource(DataSourceRegistrationPtr registration_info) {
  GetForwardingInterface()->RegisterDataSource(std::move(registration_info));
}
void ProducerHostInterceptorForTesting::NotifyFlushComplete(uint64_t flush_request_id) {
  GetForwardingInterface()->NotifyFlushComplete(std::move(flush_request_id));
}
void ProducerHostInterceptorForTesting::RegisterTraceWriter(uint32_t writer_id, uint32_t target_buffer) {
  GetForwardingInterface()->RegisterTraceWriter(std::move(writer_id), std::move(target_buffer));
}
void ProducerHostInterceptorForTesting::UnregisterTraceWriter(uint32_t writer_id) {
  GetForwardingInterface()->UnregisterTraceWriter(std::move(writer_id));
}
ProducerHostAsyncWaiter::ProducerHostAsyncWaiter(
    ProducerHost* proxy) : proxy_(proxy) {}

ProducerHostAsyncWaiter::~ProducerHostAsyncWaiter() = default;




void ProducerClientInterceptorForTesting::OnTracingStart(mojo::ScopedSharedBufferHandle shared_memory) {
  GetForwardingInterface()->OnTracingStart(std::move(shared_memory));
}
void ProducerClientInterceptorForTesting::StartDataSource(uint64_t id, DataSourceConfigPtr data_source_config) {
  GetForwardingInterface()->StartDataSource(std::move(id), std::move(data_source_config));
}
void ProducerClientInterceptorForTesting::StopDataSource(uint64_t id, StopDataSourceCallback callback) {
  GetForwardingInterface()->StopDataSource(std::move(id), std::move(callback));
}
void ProducerClientInterceptorForTesting::Flush(uint64_t flush_request_id, const std::vector<uint64_t>& data_source_ids) {
  GetForwardingInterface()->Flush(std::move(flush_request_id), std::move(data_source_ids));
}
ProducerClientAsyncWaiter::ProducerClientAsyncWaiter(
    ProducerClient* proxy) : proxy_(proxy) {}

ProducerClientAsyncWaiter::~ProducerClientAsyncWaiter() = default;

void ProducerClientAsyncWaiter::StopDataSource(
    uint64_t id) {
  base::RunLoop loop;
  proxy_->StopDataSource(std::move(id),
      base::BindOnce(
          [](base::RunLoop* loop) {
            loop->Quit();
          },
          &loop));
  loop.Run();
}



void PerfettoServiceInterceptorForTesting::ConnectToProducerHost(ProducerClientPtr producer_client, ProducerHostRequest producer_host) {
  GetForwardingInterface()->ConnectToProducerHost(std::move(producer_client), std::move(producer_host));
}
PerfettoServiceAsyncWaiter::PerfettoServiceAsyncWaiter(
    PerfettoService* proxy) : proxy_(proxy) {}

PerfettoServiceAsyncWaiter::~PerfettoServiceAsyncWaiter() = default;






}  // namespace mojom
}  // namespace tracing

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif