// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_MOJOM_TEST_UTILS_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_MOJOM_TEST_UTILS_H_

#include "services/video_capture/public/mojom/device.mojom.h"


namespace video_capture {
namespace mojom {


class  DeviceInterceptorForTesting : public Device {
  virtual Device* GetForwardingInterface() = 0;
  void Start(const media::VideoCaptureParams& requested_settings, ::video_capture::mojom::ReceiverPtr receiver) override;
  void OnReceiverReportingUtilization(int32_t frame_feedback_id, double utilization) override;
  void RequestRefreshFrame() override;
  void MaybeSuspend() override;
  void Resume() override;
  void GetPhotoState(GetPhotoStateCallback callback) override;
  void SetPhotoOptions(::media::mojom::PhotoSettingsPtr settings, SetPhotoOptionsCallback callback) override;
  void TakePhoto(TakePhotoCallback callback) override;
};
class  DeviceAsyncWaiter {
 public:
  explicit DeviceAsyncWaiter(Device* proxy);
  ~DeviceAsyncWaiter();
  void GetPhotoState(
      ::media::mojom::PhotoStatePtr* out_capabilities);
  void SetPhotoOptions(
      ::media::mojom::PhotoSettingsPtr settings, bool* out_success);
  void TakePhoto(
      ::media::mojom::BlobPtr* out_blob);

 private:
  Device* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DeviceAsyncWaiter);
};




}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_MOJOM_TEST_UTILS_H_