// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/video_capture/public/mojom/device_factory.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_MOJOM_JUMBO_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_MOJOM_JUMBO_H_
#include "media/capture/mojom/video_capture_types_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#endif


namespace video_capture {
namespace mojom {


void DevicesChangedObserverInterceptorForTesting::OnDevicesChanged() {
  GetForwardingInterface()->OnDevicesChanged();
}
DevicesChangedObserverAsyncWaiter::DevicesChangedObserverAsyncWaiter(
    DevicesChangedObserver* proxy) : proxy_(proxy) {}

DevicesChangedObserverAsyncWaiter::~DevicesChangedObserverAsyncWaiter() = default;




void DeviceFactoryInterceptorForTesting::GetDeviceInfos(GetDeviceInfosCallback callback) {
  GetForwardingInterface()->GetDeviceInfos(std::move(callback));
}
void DeviceFactoryInterceptorForTesting::CreateDevice(const std::string& device_id, ::video_capture::mojom::DeviceRequest device_request, CreateDeviceCallback callback) {
  GetForwardingInterface()->CreateDevice(std::move(device_id), std::move(device_request), std::move(callback));
}
void DeviceFactoryInterceptorForTesting::AddSharedMemoryVirtualDevice(const media::VideoCaptureDeviceInfo& device_info, ::video_capture::mojom::ProducerPtr producer, bool send_buffer_handles_to_producer_as_raw_file_descriptors, ::video_capture::mojom::SharedMemoryVirtualDeviceRequest virtual_device) {
  GetForwardingInterface()->AddSharedMemoryVirtualDevice(std::move(device_info), std::move(producer), std::move(send_buffer_handles_to_producer_as_raw_file_descriptors), std::move(virtual_device));
}
void DeviceFactoryInterceptorForTesting::AddTextureVirtualDevice(const media::VideoCaptureDeviceInfo& device_info, ::video_capture::mojom::TextureVirtualDeviceRequest virtual_device) {
  GetForwardingInterface()->AddTextureVirtualDevice(std::move(device_info), std::move(virtual_device));
}
void DeviceFactoryInterceptorForTesting::RegisterVirtualDevicesChangedObserver(DevicesChangedObserverPtr observer, bool raise_event_if_virtual_devices_already_present) {
  GetForwardingInterface()->RegisterVirtualDevicesChangedObserver(std::move(observer), std::move(raise_event_if_virtual_devices_already_present));
}
DeviceFactoryAsyncWaiter::DeviceFactoryAsyncWaiter(
    DeviceFactory* proxy) : proxy_(proxy) {}

DeviceFactoryAsyncWaiter::~DeviceFactoryAsyncWaiter() = default;

void DeviceFactoryAsyncWaiter::GetDeviceInfos(
    std::vector<media::VideoCaptureDeviceInfo>* out_device_infos) {
  base::RunLoop loop;
  proxy_->GetDeviceInfos(
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<media::VideoCaptureDeviceInfo>* out_device_infos
,
             const std::vector<media::VideoCaptureDeviceInfo>& device_infos) {*out_device_infos = std::move(device_infos);
            loop->Quit();
          },
          &loop,
          out_device_infos));
  loop.Run();
}
void DeviceFactoryAsyncWaiter::CreateDevice(
    const std::string& device_id, ::video_capture::mojom::DeviceRequest device_request, DeviceAccessResultCode* out_result_code) {
  base::RunLoop loop;
  proxy_->CreateDevice(std::move(device_id),std::move(device_request),
      base::BindOnce(
          [](base::RunLoop* loop,
             DeviceAccessResultCode* out_result_code
,
             DeviceAccessResultCode result_code) {*out_result_code = std::move(result_code);
            loop->Quit();
          },
          &loop,
          out_result_code));
  loop.Run();
}





}  // namespace mojom
}  // namespace video_capture

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif