// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "media/mojo/interfaces/jpeg_decode_accelerator.mojom-shared-internal.h"
#include "services/video_capture/public/mojom/device_factory.mojom-shared-internal.h"
#include "services/video_capture/public/mojom/video_source_provider.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace video_capture {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data));
      new (data()) AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data>(index_);
    }
    AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data jda;
  uint8_t padfinal_[4];

 private:
  AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data();
  ~AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data() = delete;
};
static_assert(sizeof(AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data) == 16,
              "Bad sizeof(AcceleratorFactory_CreateJpegDecodeAccelerator_Params_Data)");
class  DeviceFactoryProvider_InjectGpuDependencies_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_InjectGpuDependencies_Params_Data));
      new (data()) DeviceFactoryProvider_InjectGpuDependencies_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_InjectGpuDependencies_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_InjectGpuDependencies_Params_Data>(index_);
    }
    DeviceFactoryProvider_InjectGpuDependencies_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data accelerator_factory;

 private:
  DeviceFactoryProvider_InjectGpuDependencies_Params_Data();
  ~DeviceFactoryProvider_InjectGpuDependencies_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_InjectGpuDependencies_Params_Data) == 16,
              "Bad sizeof(DeviceFactoryProvider_InjectGpuDependencies_Params_Data)");
class  DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data));
      new (data()) DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data>(index_);
    }
    DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data();
  ~DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data) == 16,
              "Bad sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data)");
class  DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data));
      new (data()) DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data>(index_);
    }
    DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data();
  ~DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data) == 16,
              "Bad sizeof(DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_SHARED_INTERNAL_H_