// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_TEST_UTILS_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_TEST_UTILS_H_

#include "services/video_capture/public/mojom/device_factory_provider.mojom.h"


namespace video_capture {
namespace mojom {


class  AcceleratorFactoryInterceptorForTesting : public AcceleratorFactory {
  virtual AcceleratorFactory* GetForwardingInterface() = 0;
  void CreateJpegDecodeAccelerator(::media::mojom::JpegDecodeAcceleratorRequest jda) override;
};
class  AcceleratorFactoryAsyncWaiter {
 public:
  explicit AcceleratorFactoryAsyncWaiter(AcceleratorFactory* proxy);
  ~AcceleratorFactoryAsyncWaiter();

 private:
  AcceleratorFactory* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AcceleratorFactoryAsyncWaiter);
};


class  DeviceFactoryProviderInterceptorForTesting : public DeviceFactoryProvider {
  virtual DeviceFactoryProvider* GetForwardingInterface() = 0;
  void InjectGpuDependencies(AcceleratorFactoryPtr accelerator_factory) override;
  void ConnectToDeviceFactory(::video_capture::mojom::DeviceFactoryRequest request) override;
  void ConnectToVideoSourceProvider(::video_capture::mojom::VideoSourceProviderRequest request) override;
};
class  DeviceFactoryProviderAsyncWaiter {
 public:
  explicit DeviceFactoryProviderAsyncWaiter(DeviceFactoryProvider* proxy);
  ~DeviceFactoryProviderAsyncWaiter();

 private:
  DeviceFactoryProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DeviceFactoryProviderAsyncWaiter);
};




}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_TEST_UTILS_H_