// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_RECEIVER_MOJOM_TEST_UTILS_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_RECEIVER_MOJOM_TEST_UTILS_H_

#include "services/video_capture/public/mojom/receiver.mojom.h"


namespace video_capture {
namespace mojom {


class  ReceiverInterceptorForTesting : public Receiver {
  virtual Receiver* GetForwardingInterface() = 0;
  void OnNewBuffer(int32_t buffer_id, ::media::mojom::VideoBufferHandlePtr buffer_handle) override;
  void OnFrameReadyInBuffer(int32_t buffer_id, int32_t frame_feedback_id, ::video_capture::mojom::ScopedAccessPermissionPtr access_permission, ::media::mojom::VideoFrameInfoPtr frame_info) override;
  void OnBufferRetired(int32_t buffer_id) override;
  void OnError(media::VideoCaptureError error) override;
  void OnFrameDropped(media::VideoCaptureFrameDropReason reason) override;
  void OnLog(const std::string& message) override;
  void OnStarted() override;
  void OnStartedUsingGpuDecode() override;
};
class  ReceiverAsyncWaiter {
 public:
  explicit ReceiverAsyncWaiter(Receiver* proxy);
  ~ReceiverAsyncWaiter();

 private:
  Receiver* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ReceiverAsyncWaiter);
};




}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_RECEIVER_MOJOM_TEST_UTILS_H_