// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "media/capture/mojom/image_capture.mojom-shared-internal.h"
#include "media/capture/mojom/video_capture_types.mojom-shared-internal.h"
#include "services/video_capture/public/mojom/receiver.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace video_capture {
namespace mojom {
namespace internal {

struct CreatePushSubscriptionResultCode_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  PushVideoStreamSubscription_Activate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_Activate_Params_Data));
      new (data()) PushVideoStreamSubscription_Activate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_Activate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_Activate_Params_Data>(index_);
    }
    PushVideoStreamSubscription_Activate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PushVideoStreamSubscription_Activate_Params_Data();
  ~PushVideoStreamSubscription_Activate_Params_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_Activate_Params_Data) == 8,
              "Bad sizeof(PushVideoStreamSubscription_Activate_Params_Data)");
class  PushVideoStreamSubscription_Suspend_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_Suspend_Params_Data));
      new (data()) PushVideoStreamSubscription_Suspend_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_Suspend_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_Suspend_Params_Data>(index_);
    }
    PushVideoStreamSubscription_Suspend_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PushVideoStreamSubscription_Suspend_Params_Data();
  ~PushVideoStreamSubscription_Suspend_Params_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_Suspend_Params_Data) == 8,
              "Bad sizeof(PushVideoStreamSubscription_Suspend_Params_Data)");
class  PushVideoStreamSubscription_Suspend_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_Suspend_ResponseParams_Data));
      new (data()) PushVideoStreamSubscription_Suspend_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_Suspend_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_Suspend_ResponseParams_Data>(index_);
    }
    PushVideoStreamSubscription_Suspend_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PushVideoStreamSubscription_Suspend_ResponseParams_Data();
  ~PushVideoStreamSubscription_Suspend_ResponseParams_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_Suspend_ResponseParams_Data) == 8,
              "Bad sizeof(PushVideoStreamSubscription_Suspend_ResponseParams_Data)");
class  PushVideoStreamSubscription_Resume_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_Resume_Params_Data));
      new (data()) PushVideoStreamSubscription_Resume_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_Resume_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_Resume_Params_Data>(index_);
    }
    PushVideoStreamSubscription_Resume_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PushVideoStreamSubscription_Resume_Params_Data();
  ~PushVideoStreamSubscription_Resume_Params_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_Resume_Params_Data) == 8,
              "Bad sizeof(PushVideoStreamSubscription_Resume_Params_Data)");
class  PushVideoStreamSubscription_GetPhotoState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_GetPhotoState_Params_Data));
      new (data()) PushVideoStreamSubscription_GetPhotoState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_GetPhotoState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_GetPhotoState_Params_Data>(index_);
    }
    PushVideoStreamSubscription_GetPhotoState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PushVideoStreamSubscription_GetPhotoState_Params_Data();
  ~PushVideoStreamSubscription_GetPhotoState_Params_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_GetPhotoState_Params_Data) == 8,
              "Bad sizeof(PushVideoStreamSubscription_GetPhotoState_Params_Data)");
class  PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data));
      new (data()) PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data>(index_);
    }
    PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media::mojom::internal::PhotoState_Data> capabilities;

 private:
  PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data();
  ~PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data) == 16,
              "Bad sizeof(PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data)");
class  PushVideoStreamSubscription_SetPhotoOptions_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_SetPhotoOptions_Params_Data));
      new (data()) PushVideoStreamSubscription_SetPhotoOptions_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_SetPhotoOptions_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_SetPhotoOptions_Params_Data>(index_);
    }
    PushVideoStreamSubscription_SetPhotoOptions_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media::mojom::internal::PhotoSettings_Data> settings;

 private:
  PushVideoStreamSubscription_SetPhotoOptions_Params_Data();
  ~PushVideoStreamSubscription_SetPhotoOptions_Params_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_SetPhotoOptions_Params_Data) == 16,
              "Bad sizeof(PushVideoStreamSubscription_SetPhotoOptions_Params_Data)");
class  PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data));
      new (data()) PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data>(index_);
    }
    PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data();
  ~PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data) == 16,
              "Bad sizeof(PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data)");
class  PushVideoStreamSubscription_TakePhoto_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_TakePhoto_Params_Data));
      new (data()) PushVideoStreamSubscription_TakePhoto_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_TakePhoto_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_TakePhoto_Params_Data>(index_);
    }
    PushVideoStreamSubscription_TakePhoto_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PushVideoStreamSubscription_TakePhoto_Params_Data();
  ~PushVideoStreamSubscription_TakePhoto_Params_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_TakePhoto_Params_Data) == 8,
              "Bad sizeof(PushVideoStreamSubscription_TakePhoto_Params_Data)");
class  PushVideoStreamSubscription_TakePhoto_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_TakePhoto_ResponseParams_Data));
      new (data()) PushVideoStreamSubscription_TakePhoto_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_TakePhoto_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_TakePhoto_ResponseParams_Data>(index_);
    }
    PushVideoStreamSubscription_TakePhoto_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media::mojom::internal::Blob_Data> blob;

 private:
  PushVideoStreamSubscription_TakePhoto_ResponseParams_Data();
  ~PushVideoStreamSubscription_TakePhoto_ResponseParams_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_TakePhoto_ResponseParams_Data) == 16,
              "Bad sizeof(PushVideoStreamSubscription_TakePhoto_ResponseParams_Data)");
class  PushVideoStreamSubscription_Close_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_Close_Params_Data));
      new (data()) PushVideoStreamSubscription_Close_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_Close_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_Close_Params_Data>(index_);
    }
    PushVideoStreamSubscription_Close_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PushVideoStreamSubscription_Close_Params_Data();
  ~PushVideoStreamSubscription_Close_Params_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_Close_Params_Data) == 8,
              "Bad sizeof(PushVideoStreamSubscription_Close_Params_Data)");
class  PushVideoStreamSubscription_Close_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PushVideoStreamSubscription_Close_ResponseParams_Data));
      new (data()) PushVideoStreamSubscription_Close_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PushVideoStreamSubscription_Close_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PushVideoStreamSubscription_Close_ResponseParams_Data>(index_);
    }
    PushVideoStreamSubscription_Close_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PushVideoStreamSubscription_Close_ResponseParams_Data();
  ~PushVideoStreamSubscription_Close_ResponseParams_Data() = delete;
};
static_assert(sizeof(PushVideoStreamSubscription_Close_ResponseParams_Data) == 8,
              "Bad sizeof(PushVideoStreamSubscription_Close_ResponseParams_Data)");
class  VideoSource_CreatePushSubscription_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(VideoSource_CreatePushSubscription_Params_Data));
      new (data()) VideoSource_CreatePushSubscription_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    VideoSource_CreatePushSubscription_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<VideoSource_CreatePushSubscription_Params_Data>(index_);
    }
    VideoSource_CreatePushSubscription_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data subscriber;
  mojo::internal::Pointer<::media::mojom::internal::VideoCaptureParams_Data> requested_settings;
  uint8_t force_reopen_with_new_settings : 1;
  uint8_t pad2_[3];
  mojo::internal::Handle_Data subscription;

 private:
  VideoSource_CreatePushSubscription_Params_Data();
  ~VideoSource_CreatePushSubscription_Params_Data() = delete;
};
static_assert(sizeof(VideoSource_CreatePushSubscription_Params_Data) == 32,
              "Bad sizeof(VideoSource_CreatePushSubscription_Params_Data)");
class  VideoSource_CreatePushSubscription_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(VideoSource_CreatePushSubscription_ResponseParams_Data));
      new (data()) VideoSource_CreatePushSubscription_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    VideoSource_CreatePushSubscription_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<VideoSource_CreatePushSubscription_ResponseParams_Data>(index_);
    }
    VideoSource_CreatePushSubscription_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result_code;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::media::mojom::internal::VideoCaptureParams_Data> settings_source_was_opened_with;

 private:
  VideoSource_CreatePushSubscription_ResponseParams_Data();
  ~VideoSource_CreatePushSubscription_ResponseParams_Data() = delete;
};
static_assert(sizeof(VideoSource_CreatePushSubscription_ResponseParams_Data) == 24,
              "Bad sizeof(VideoSource_CreatePushSubscription_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_INTERNAL_H_