// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/video_capture/public/mojom/video_source.mojom-shared-internal.h"
#include "media/capture/mojom/image_capture.mojom-shared.h"
#include "media/capture/mojom/video_capture_types.mojom-shared.h"
#include "services/video_capture/public/mojom/receiver.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace video_capture {
namespace mojom {


}  // namespace mojom
}  // namespace video_capture

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace video_capture {
namespace mojom {

enum class CreatePushSubscriptionResultCode : int32_t {
  kCreatedWithRequestedSettings,
  kCreatedWithDifferentSettings,
  kFailed,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, CreatePushSubscriptionResultCode value);
inline bool IsKnownEnumValue(CreatePushSubscriptionResultCode value) {
  return internal::CreatePushSubscriptionResultCode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class PushVideoStreamSubscriptionInterfaceBase {};

using PushVideoStreamSubscriptionPtrDataView =
    mojo::InterfacePtrDataView<PushVideoStreamSubscriptionInterfaceBase>;
using PushVideoStreamSubscriptionRequestDataView =
    mojo::InterfaceRequestDataView<PushVideoStreamSubscriptionInterfaceBase>;
using PushVideoStreamSubscriptionAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PushVideoStreamSubscriptionInterfaceBase>;
using PushVideoStreamSubscriptionAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PushVideoStreamSubscriptionInterfaceBase>;
class VideoSourceInterfaceBase {};

using VideoSourcePtrDataView =
    mojo::InterfacePtrDataView<VideoSourceInterfaceBase>;
using VideoSourceRequestDataView =
    mojo::InterfaceRequestDataView<VideoSourceInterfaceBase>;
using VideoSourceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<VideoSourceInterfaceBase>;
using VideoSourceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<VideoSourceInterfaceBase>;
class PushVideoStreamSubscription_Activate_ParamsDataView {
 public:
  PushVideoStreamSubscription_Activate_ParamsDataView() {}

  PushVideoStreamSubscription_Activate_ParamsDataView(
      internal::PushVideoStreamSubscription_Activate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PushVideoStreamSubscription_Activate_Params_Data* data_ = nullptr;
};

class PushVideoStreamSubscription_Suspend_ParamsDataView {
 public:
  PushVideoStreamSubscription_Suspend_ParamsDataView() {}

  PushVideoStreamSubscription_Suspend_ParamsDataView(
      internal::PushVideoStreamSubscription_Suspend_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PushVideoStreamSubscription_Suspend_Params_Data* data_ = nullptr;
};

class PushVideoStreamSubscription_Suspend_ResponseParamsDataView {
 public:
  PushVideoStreamSubscription_Suspend_ResponseParamsDataView() {}

  PushVideoStreamSubscription_Suspend_ResponseParamsDataView(
      internal::PushVideoStreamSubscription_Suspend_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PushVideoStreamSubscription_Suspend_ResponseParams_Data* data_ = nullptr;
};

class PushVideoStreamSubscription_Resume_ParamsDataView {
 public:
  PushVideoStreamSubscription_Resume_ParamsDataView() {}

  PushVideoStreamSubscription_Resume_ParamsDataView(
      internal::PushVideoStreamSubscription_Resume_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PushVideoStreamSubscription_Resume_Params_Data* data_ = nullptr;
};

class PushVideoStreamSubscription_GetPhotoState_ParamsDataView {
 public:
  PushVideoStreamSubscription_GetPhotoState_ParamsDataView() {}

  PushVideoStreamSubscription_GetPhotoState_ParamsDataView(
      internal::PushVideoStreamSubscription_GetPhotoState_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PushVideoStreamSubscription_GetPhotoState_Params_Data* data_ = nullptr;
};

class PushVideoStreamSubscription_GetPhotoState_ResponseParamsDataView {
 public:
  PushVideoStreamSubscription_GetPhotoState_ResponseParamsDataView() {}

  PushVideoStreamSubscription_GetPhotoState_ResponseParamsDataView(
      internal::PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCapabilitiesDataView(
      ::media::mojom::PhotoStateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCapabilities(UserType* output) {
    auto* pointer = data_->capabilities.Get();
    return mojo::internal::Deserialize<::media::mojom::PhotoStateDataView>(
        pointer, output, context_);
  }
 private:
  internal::PushVideoStreamSubscription_GetPhotoState_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PushVideoStreamSubscription_SetPhotoOptions_ParamsDataView {
 public:
  PushVideoStreamSubscription_SetPhotoOptions_ParamsDataView() {}

  PushVideoStreamSubscription_SetPhotoOptions_ParamsDataView(
      internal::PushVideoStreamSubscription_SetPhotoOptions_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSettingsDataView(
      ::media::mojom::PhotoSettingsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSettings(UserType* output) {
    auto* pointer = data_->settings.Get();
    return mojo::internal::Deserialize<::media::mojom::PhotoSettingsDataView>(
        pointer, output, context_);
  }
 private:
  internal::PushVideoStreamSubscription_SetPhotoOptions_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PushVideoStreamSubscription_SetPhotoOptions_ResponseParamsDataView {
 public:
  PushVideoStreamSubscription_SetPhotoOptions_ResponseParamsDataView() {}

  PushVideoStreamSubscription_SetPhotoOptions_ResponseParamsDataView(
      internal::PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::PushVideoStreamSubscription_SetPhotoOptions_ResponseParams_Data* data_ = nullptr;
};

class PushVideoStreamSubscription_TakePhoto_ParamsDataView {
 public:
  PushVideoStreamSubscription_TakePhoto_ParamsDataView() {}

  PushVideoStreamSubscription_TakePhoto_ParamsDataView(
      internal::PushVideoStreamSubscription_TakePhoto_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PushVideoStreamSubscription_TakePhoto_Params_Data* data_ = nullptr;
};

class PushVideoStreamSubscription_TakePhoto_ResponseParamsDataView {
 public:
  PushVideoStreamSubscription_TakePhoto_ResponseParamsDataView() {}

  PushVideoStreamSubscription_TakePhoto_ResponseParamsDataView(
      internal::PushVideoStreamSubscription_TakePhoto_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetBlobDataView(
      ::media::mojom::BlobDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBlob(UserType* output) {
    auto* pointer = data_->blob.Get();
    return mojo::internal::Deserialize<::media::mojom::BlobDataView>(
        pointer, output, context_);
  }
 private:
  internal::PushVideoStreamSubscription_TakePhoto_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PushVideoStreamSubscription_Close_ParamsDataView {
 public:
  PushVideoStreamSubscription_Close_ParamsDataView() {}

  PushVideoStreamSubscription_Close_ParamsDataView(
      internal::PushVideoStreamSubscription_Close_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PushVideoStreamSubscription_Close_Params_Data* data_ = nullptr;
};

class PushVideoStreamSubscription_Close_ResponseParamsDataView {
 public:
  PushVideoStreamSubscription_Close_ResponseParamsDataView() {}

  PushVideoStreamSubscription_Close_ResponseParamsDataView(
      internal::PushVideoStreamSubscription_Close_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PushVideoStreamSubscription_Close_ResponseParams_Data* data_ = nullptr;
};

class VideoSource_CreatePushSubscription_ParamsDataView {
 public:
  VideoSource_CreatePushSubscription_ParamsDataView() {}

  VideoSource_CreatePushSubscription_ParamsDataView(
      internal::VideoSource_CreatePushSubscription_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeSubscriber() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::ReceiverPtrDataView>(
            &data_->subscriber, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetRequestedSettingsDataView(
      ::media::mojom::VideoCaptureParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRequestedSettings(UserType* output) {
    auto* pointer = data_->requested_settings.Get();
    return mojo::internal::Deserialize<::media::mojom::VideoCaptureParamsDataView>(
        pointer, output, context_);
  }
  bool force_reopen_with_new_settings() const {
    return data_->force_reopen_with_new_settings;
  }
  template <typename UserType>
  UserType TakeSubscription() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::PushVideoStreamSubscriptionRequestDataView>(
            &data_->subscription, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::VideoSource_CreatePushSubscription_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class VideoSource_CreatePushSubscription_ResponseParamsDataView {
 public:
  VideoSource_CreatePushSubscription_ResponseParamsDataView() {}

  VideoSource_CreatePushSubscription_ResponseParamsDataView(
      internal::VideoSource_CreatePushSubscription_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResultCode(UserType* output) const {
    auto data_value = data_->result_code;
    return mojo::internal::Deserialize<::video_capture::mojom::CreatePushSubscriptionResultCode>(
        data_value, output);
  }

  CreatePushSubscriptionResultCode result_code() const {
    return static_cast<CreatePushSubscriptionResultCode>(data_->result_code);
  }
  inline void GetSettingsSourceWasOpenedWithDataView(
      ::media::mojom::VideoCaptureParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSettingsSourceWasOpenedWith(UserType* output) {
    auto* pointer = data_->settings_source_was_opened_with.Get();
    return mojo::internal::Deserialize<::media::mojom::VideoCaptureParamsDataView>(
        pointer, output, context_);
  }
 private:
  internal::VideoSource_CreatePushSubscription_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace video_capture

namespace std {

template <>
struct hash<::video_capture::mojom::CreatePushSubscriptionResultCode>
    : public mojo::internal::EnumHashImpl<::video_capture::mojom::CreatePushSubscriptionResultCode> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::video_capture::mojom::CreatePushSubscriptionResultCode, ::video_capture::mojom::CreatePushSubscriptionResultCode> {
  static ::video_capture::mojom::CreatePushSubscriptionResultCode ToMojom(::video_capture::mojom::CreatePushSubscriptionResultCode input) { return input; }
  static bool FromMojom(::video_capture::mojom::CreatePushSubscriptionResultCode input, ::video_capture::mojom::CreatePushSubscriptionResultCode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::video_capture::mojom::CreatePushSubscriptionResultCode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::video_capture::mojom::CreatePushSubscriptionResultCode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::video_capture::mojom::CreatePushSubscriptionResultCode>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace video_capture {
namespace mojom {











inline void PushVideoStreamSubscription_GetPhotoState_ResponseParamsDataView::GetCapabilitiesDataView(
    ::media::mojom::PhotoStateDataView* output) {
  auto pointer = data_->capabilities.Get();
  *output = ::media::mojom::PhotoStateDataView(pointer, context_);
}


inline void PushVideoStreamSubscription_SetPhotoOptions_ParamsDataView::GetSettingsDataView(
    ::media::mojom::PhotoSettingsDataView* output) {
  auto pointer = data_->settings.Get();
  *output = ::media::mojom::PhotoSettingsDataView(pointer, context_);
}






inline void PushVideoStreamSubscription_TakePhoto_ResponseParamsDataView::GetBlobDataView(
    ::media::mojom::BlobDataView* output) {
  auto pointer = data_->blob.Get();
  *output = ::media::mojom::BlobDataView(pointer, context_);
}






inline void VideoSource_CreatePushSubscription_ParamsDataView::GetRequestedSettingsDataView(
    ::media::mojom::VideoCaptureParamsDataView* output) {
  auto pointer = data_->requested_settings.Get();
  *output = ::media::mojom::VideoCaptureParamsDataView(pointer, context_);
}


inline void VideoSource_CreatePushSubscription_ResponseParamsDataView::GetSettingsSourceWasOpenedWithDataView(
    ::media::mojom::VideoCaptureParamsDataView* output) {
  auto pointer = data_->settings_source_was_opened_with.Get();
  *output = ::media::mojom::VideoCaptureParamsDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_H_