// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_PROVIDER_MOJOM_SHARED_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_PROVIDER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/video_capture/public/mojom/video_source_provider.mojom-shared-internal.h"
#include "media/capture/mojom/video_capture_types.mojom-shared.h"
#include "services/video_capture/public/mojom/producer.mojom-shared.h"
#include "services/video_capture/public/mojom/video_source.mojom-shared.h"
#include "services/video_capture/public/mojom/virtual_device.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace video_capture {
namespace mojom {


}  // namespace mojom
}  // namespace video_capture

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace video_capture {
namespace mojom {
// Interface base classes. They are used for type safety check.
class VideoSourceProviderInterfaceBase {};

using VideoSourceProviderPtrDataView =
    mojo::InterfacePtrDataView<VideoSourceProviderInterfaceBase>;
using VideoSourceProviderRequestDataView =
    mojo::InterfaceRequestDataView<VideoSourceProviderInterfaceBase>;
using VideoSourceProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<VideoSourceProviderInterfaceBase>;
using VideoSourceProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<VideoSourceProviderInterfaceBase>;
class VideoSourceProvider_GetSourceInfos_ParamsDataView {
 public:
  VideoSourceProvider_GetSourceInfos_ParamsDataView() {}

  VideoSourceProvider_GetSourceInfos_ParamsDataView(
      internal::VideoSourceProvider_GetSourceInfos_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::VideoSourceProvider_GetSourceInfos_Params_Data* data_ = nullptr;
};

class VideoSourceProvider_GetSourceInfos_ResponseParamsDataView {
 public:
  VideoSourceProvider_GetSourceInfos_ResponseParamsDataView() {}

  VideoSourceProvider_GetSourceInfos_ResponseParamsDataView(
      internal::VideoSourceProvider_GetSourceInfos_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSourceInfosDataView(
      mojo::ArrayDataView<::media::mojom::VideoCaptureDeviceInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSourceInfos(UserType* output) {
    auto* pointer = data_->source_infos.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::media::mojom::VideoCaptureDeviceInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::VideoSourceProvider_GetSourceInfos_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class VideoSourceProvider_GetVideoSource_ParamsDataView {
 public:
  VideoSourceProvider_GetVideoSource_ParamsDataView() {}

  VideoSourceProvider_GetVideoSource_ParamsDataView(
      internal::VideoSourceProvider_GetVideoSource_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSourceIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSourceId(UserType* output) {
    auto* pointer = data_->source_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeStream() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::VideoSourceRequestDataView>(
            &data_->stream, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::VideoSourceProvider_GetVideoSource_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class VideoSourceProvider_AddSharedMemoryVirtualDevice_ParamsDataView {
 public:
  VideoSourceProvider_AddSharedMemoryVirtualDevice_ParamsDataView() {}

  VideoSourceProvider_AddSharedMemoryVirtualDevice_ParamsDataView(
      internal::VideoSourceProvider_AddSharedMemoryVirtualDevice_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDeviceInfoDataView(
      ::media::mojom::VideoCaptureDeviceInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDeviceInfo(UserType* output) {
    auto* pointer = data_->device_info.Get();
    return mojo::internal::Deserialize<::media::mojom::VideoCaptureDeviceInfoDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeProducer() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::ProducerPtrDataView>(
            &data_->producer, &result, context_);
    DCHECK(ret);
    return result;
  }
  bool send_buffer_handles_to_producer_as_raw_file_descriptors() const {
    return data_->send_buffer_handles_to_producer_as_raw_file_descriptors;
  }
  template <typename UserType>
  UserType TakeVirtualDevice() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::SharedMemoryVirtualDeviceRequestDataView>(
            &data_->virtual_device, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::VideoSourceProvider_AddSharedMemoryVirtualDevice_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class VideoSourceProvider_AddTextureVirtualDevice_ParamsDataView {
 public:
  VideoSourceProvider_AddTextureVirtualDevice_ParamsDataView() {}

  VideoSourceProvider_AddTextureVirtualDevice_ParamsDataView(
      internal::VideoSourceProvider_AddTextureVirtualDevice_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDeviceInfoDataView(
      ::media::mojom::VideoCaptureDeviceInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDeviceInfo(UserType* output) {
    auto* pointer = data_->device_info.Get();
    return mojo::internal::Deserialize<::media::mojom::VideoCaptureDeviceInfoDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeVirtualDevice() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::TextureVirtualDeviceRequestDataView>(
            &data_->virtual_device, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::VideoSourceProvider_AddTextureVirtualDevice_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace video_capture

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace video_capture {
namespace mojom {



inline void VideoSourceProvider_GetSourceInfos_ResponseParamsDataView::GetSourceInfosDataView(
    mojo::ArrayDataView<::media::mojom::VideoCaptureDeviceInfoDataView>* output) {
  auto pointer = data_->source_infos.Get();
  *output = mojo::ArrayDataView<::media::mojom::VideoCaptureDeviceInfoDataView>(pointer, context_);
}


inline void VideoSourceProvider_GetVideoSource_ParamsDataView::GetSourceIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->source_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void VideoSourceProvider_AddSharedMemoryVirtualDevice_ParamsDataView::GetDeviceInfoDataView(
    ::media::mojom::VideoCaptureDeviceInfoDataView* output) {
  auto pointer = data_->device_info.Get();
  *output = ::media::mojom::VideoCaptureDeviceInfoDataView(pointer, context_);
}


inline void VideoSourceProvider_AddTextureVirtualDevice_ParamsDataView::GetDeviceInfoDataView(
    ::media::mojom::VideoCaptureDeviceInfoDataView* output) {
  auto pointer = data_->device_info.Get();
  *output = ::media::mojom::VideoCaptureDeviceInfoDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_PROVIDER_MOJOM_SHARED_H_