// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/video_capture/public/mojom/video_source_provider.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_PROVIDER_MOJOM_JUMBO_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_PROVIDER_MOJOM_JUMBO_H_
#include "media/capture/mojom/video_capture_types_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#endif


namespace video_capture {
namespace mojom {


void VideoSourceProviderInterceptorForTesting::GetSourceInfos(GetSourceInfosCallback callback) {
  GetForwardingInterface()->GetSourceInfos(std::move(callback));
}
void VideoSourceProviderInterceptorForTesting::GetVideoSource(const std::string& source_id, ::video_capture::mojom::VideoSourceRequest stream) {
  GetForwardingInterface()->GetVideoSource(std::move(source_id), std::move(stream));
}
void VideoSourceProviderInterceptorForTesting::AddSharedMemoryVirtualDevice(const media::VideoCaptureDeviceInfo& device_info, ::video_capture::mojom::ProducerPtr producer, bool send_buffer_handles_to_producer_as_raw_file_descriptors, ::video_capture::mojom::SharedMemoryVirtualDeviceRequest virtual_device) {
  GetForwardingInterface()->AddSharedMemoryVirtualDevice(std::move(device_info), std::move(producer), std::move(send_buffer_handles_to_producer_as_raw_file_descriptors), std::move(virtual_device));
}
void VideoSourceProviderInterceptorForTesting::AddTextureVirtualDevice(const media::VideoCaptureDeviceInfo& device_info, ::video_capture::mojom::TextureVirtualDeviceRequest virtual_device) {
  GetForwardingInterface()->AddTextureVirtualDevice(std::move(device_info), std::move(virtual_device));
}
VideoSourceProviderAsyncWaiter::VideoSourceProviderAsyncWaiter(
    VideoSourceProvider* proxy) : proxy_(proxy) {}

VideoSourceProviderAsyncWaiter::~VideoSourceProviderAsyncWaiter() = default;

void VideoSourceProviderAsyncWaiter::GetSourceInfos(
    std::vector<media::VideoCaptureDeviceInfo>* out_source_infos) {
  base::RunLoop loop;
  proxy_->GetSourceInfos(
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<media::VideoCaptureDeviceInfo>* out_source_infos
,
             const std::vector<media::VideoCaptureDeviceInfo>& source_infos) {*out_source_infos = std::move(source_infos);
            loop->Quit();
          },
          &loop,
          out_source_infos));
  loop.Run();
}





}  // namespace mojom
}  // namespace video_capture

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif