// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/viz/privileged/interfaces/compositing/display_private.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_DISPLAY_PRIVATE_MOJOM_JUMBO_H_
#define SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_DISPLAY_PRIVATE_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/ipc/color/gfx_param_traits.h"
#include "ui/gfx/mojo/transform_struct_traits.h"
#include "ui/latency/mojo/latency_info_struct_traits.h"
#endif


namespace viz {
namespace mojom {


void DisplayPrivateInterceptorForTesting::SetDisplayVisible(bool visible) {
  GetForwardingInterface()->SetDisplayVisible(std::move(visible));
}
void DisplayPrivateInterceptorForTesting::DisableSwapUntilResize(DisableSwapUntilResizeCallback callback) {
  GetForwardingInterface()->DisableSwapUntilResize(std::move(callback));
}
void DisplayPrivateInterceptorForTesting::Resize(const gfx::Size& size) {
  GetForwardingInterface()->Resize(std::move(size));
}
void DisplayPrivateInterceptorForTesting::SetDisplayColorMatrix(const gfx::Transform& color_matrix) {
  GetForwardingInterface()->SetDisplayColorMatrix(std::move(color_matrix));
}
void DisplayPrivateInterceptorForTesting::SetDisplayColorSpace(const gfx::ColorSpace& blending_color_space, const gfx::ColorSpace& device_color_space) {
  GetForwardingInterface()->SetDisplayColorSpace(std::move(blending_color_space), std::move(device_color_space));
}
void DisplayPrivateInterceptorForTesting::SetOutputIsSecure(bool secure) {
  GetForwardingInterface()->SetOutputIsSecure(std::move(secure));
}
void DisplayPrivateInterceptorForTesting::SetDisplayVSyncParameters(base::TimeTicks timebase, base::TimeDelta interval) {
  GetForwardingInterface()->SetDisplayVSyncParameters(std::move(timebase), std::move(interval));
}
void DisplayPrivateInterceptorForTesting::ForceImmediateDrawAndSwapIfPossible() {
  GetForwardingInterface()->ForceImmediateDrawAndSwapIfPossible();
}
DisplayPrivateAsyncWaiter::DisplayPrivateAsyncWaiter(
    DisplayPrivate* proxy) : proxy_(proxy) {}

DisplayPrivateAsyncWaiter::~DisplayPrivateAsyncWaiter() = default;

void DisplayPrivateAsyncWaiter::DisableSwapUntilResize(
    ) {
  base::RunLoop loop;
  proxy_->DisableSwapUntilResize(
      base::BindOnce(
          [](base::RunLoop* loop) {
            loop->Quit();
          },
          &loop));
  loop.Run();
}



void DisplayClientInterceptorForTesting::DidSwapAfterSnapshotRequestReceived(const std::vector<ui::LatencyInfo>& latency_info) {
  GetForwardingInterface()->DidSwapAfterSnapshotRequestReceived(std::move(latency_info));
}
DisplayClientAsyncWaiter::DisplayClientAsyncWaiter(
    DisplayClient* proxy) : proxy_(proxy) {}

DisplayClientAsyncWaiter::~DisplayClientAsyncWaiter() = default;






}  // namespace mojom
}  // namespace viz

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif