// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_DISPLAY_PRIVATE_MOJOM_TEST_UTILS_H_
#define SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_DISPLAY_PRIVATE_MOJOM_TEST_UTILS_H_

#include "services/viz/privileged/interfaces/compositing/display_private.mojom.h"


namespace viz {
namespace mojom {


class  DisplayPrivateInterceptorForTesting : public DisplayPrivate {
  virtual DisplayPrivate* GetForwardingInterface() = 0;
  void SetDisplayVisible(bool visible) override;
  void DisableSwapUntilResize(DisableSwapUntilResizeCallback callback) override;
  void Resize(const gfx::Size& size) override;
  void SetDisplayColorMatrix(const gfx::Transform& color_matrix) override;
  void SetDisplayColorSpace(const gfx::ColorSpace& blending_color_space, const gfx::ColorSpace& device_color_space) override;
  void SetOutputIsSecure(bool secure) override;
  void SetDisplayVSyncParameters(base::TimeTicks timebase, base::TimeDelta interval) override;
  void ForceImmediateDrawAndSwapIfPossible() override;
};
class  DisplayPrivateAsyncWaiter {
 public:
  explicit DisplayPrivateAsyncWaiter(DisplayPrivate* proxy);
  ~DisplayPrivateAsyncWaiter();
  void DisableSwapUntilResize(
      );

 private:
  DisplayPrivate* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DisplayPrivateAsyncWaiter);
};


class  DisplayClientInterceptorForTesting : public DisplayClient {
  virtual DisplayClient* GetForwardingInterface() = 0;
  void DidSwapAfterSnapshotRequestReceived(const std::vector<ui::LatencyInfo>& latency_info) override;
};
class  DisplayClientAsyncWaiter {
 public:
  explicit DisplayClientAsyncWaiter(DisplayClient* proxy);
  ~DisplayClientAsyncWaiter();

 private:
  DisplayClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DisplayClientAsyncWaiter);
};




}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_DISPLAY_PRIVATE_MOJOM_TEST_UTILS_H_