// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "services/viz/privileged/interfaces/gl/context_lost_reason.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
namespace viz {
namespace mojom {

std::ostream& operator<<(std::ostream& os, ContextLostReason value) {
  switch(value) {
    case ContextLostReason::GUILTY:
      return os << "ContextLostReason::GUILTY";
    case ContextLostReason::INNOCENT:
      return os << "ContextLostReason::INNOCENT";
    case ContextLostReason::UNKNOWN:
      return os << "ContextLostReason::UNKNOWN";
    case ContextLostReason::OUT_OF_MEMORY:
      return os << "ContextLostReason::OUT_OF_MEMORY";
    case ContextLostReason::MAKE_CURRENT_FAILED:
      return os << "ContextLostReason::MAKE_CURRENT_FAILED";
    case ContextLostReason::GPU_CHANNEL_LOST:
      return os << "ContextLostReason::GPU_CHANNEL_LOST";
    case ContextLostReason::INVALID_GPU_MESSAGE:
      return os << "ContextLostReason::INVALID_GPU_MESSAGE";
    default:
      return os << "Unknown ContextLostReason value: " << static_cast<int32_t>(value);
  }
}

namespace internal {

}  // namespace internal
}  // namespace mojom
}  // namespace viz

#if defined(_MSC_VER)
#pragma warning(pop)
#endif