// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PRIVILEGED_INTERFACES_VIZ_MAIN_MOJOM_TEST_UTILS_H_
#define SERVICES_VIZ_PRIVILEGED_INTERFACES_VIZ_MAIN_MOJOM_TEST_UTILS_H_

#include "services/viz/privileged/interfaces/viz_main.mojom.h"


namespace viz {
namespace mojom {


class  VizMainInterceptorForTesting : public VizMain {
  virtual VizMain* GetForwardingInterface() = 0;
  void CreateFrameSinkManager(FrameSinkManagerParamsPtr params) override;
  void CreateGpuService(::viz::mojom::GpuServiceRequest gpu_service, ::viz::mojom::GpuHostPtr gpu_host, ::discardable_memory::mojom::DiscardableSharedMemoryManagerPtr discardable_memory_manager, mojo::ScopedSharedBufferHandle activity_flags, gfx::FontRenderParams::SubpixelRendering subpixel_rendering) override;
  void CreateVizDevTools(VizDevToolsParamsPtr params) override;
};
class  VizMainAsyncWaiter {
 public:
  explicit VizMainAsyncWaiter(VizMain* proxy);
  ~VizMainAsyncWaiter();

 private:
  VizMain* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VizMainAsyncWaiter);
};




}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PRIVILEGED_INTERFACES_VIZ_MAIN_MOJOM_TEST_UTILS_H_