// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WS_PUBLIC_MOJOM_SCREEN_PROVIDER_OBSERVER_MOJOM_SHARED_H_
#define SERVICES_WS_PUBLIC_MOJOM_SCREEN_PROVIDER_OBSERVER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/ws/public/mojom/screen_provider_observer.mojom-shared-internal.h"
#include "services/ws/public/mojom/window_tree_constants.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace ws {
namespace mojom {


}  // namespace mojom
}  // namespace ws

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace ws {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ScreenProviderObserverInterfaceBase {};

using ScreenProviderObserverPtrDataView =
    mojo::InterfacePtrDataView<ScreenProviderObserverInterfaceBase>;
using ScreenProviderObserverRequestDataView =
    mojo::InterfaceRequestDataView<ScreenProviderObserverInterfaceBase>;
using ScreenProviderObserverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ScreenProviderObserverInterfaceBase>;
using ScreenProviderObserverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ScreenProviderObserverInterfaceBase>;
class ScreenProviderObserver_OnDisplaysChanged_ParamsDataView {
 public:
  ScreenProviderObserver_OnDisplaysChanged_ParamsDataView() {}

  ScreenProviderObserver_OnDisplaysChanged_ParamsDataView(
      internal::ScreenProviderObserver_OnDisplaysChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDisplaysDataView(
      mojo::ArrayDataView<::ws::mojom::WsDisplayDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDisplays(UserType* output) {
    auto* pointer = data_->displays.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ws::mojom::WsDisplayDataView>>(
        pointer, output, context_);
  }
  int64_t primary_display_id() const {
    return data_->primary_display_id;
  }
  int64_t internal_display_id() const {
    return data_->internal_display_id;
  }
  int64_t display_id_for_new_windows() const {
    return data_->display_id_for_new_windows;
  }
 private:
  internal::ScreenProviderObserver_OnDisplaysChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace ws

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace ws {
namespace mojom {

inline void ScreenProviderObserver_OnDisplaysChanged_ParamsDataView::GetDisplaysDataView(
    mojo::ArrayDataView<::ws::mojom::WsDisplayDataView>* output) {
  auto pointer = data_->displays.Get();
  *output = mojo::ArrayDataView<::ws::mojom::WsDisplayDataView>(pointer, context_);
}



}  // namespace mojom
}  // namespace ws

#endif  // SERVICES_WS_PUBLIC_MOJOM_SCREEN_PROVIDER_OBSERVER_MOJOM_SHARED_H_