// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WS_PUBLIC_MOJOM_USER_ACTIVITY_MONITOR_MOJOM_SHARED_H_
#define SERVICES_WS_PUBLIC_MOJOM_USER_ACTIVITY_MONITOR_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/ws/public/mojom/user_activity_monitor.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace ws {
namespace mojom {


}  // namespace mojom
}  // namespace ws

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace ws {
namespace mojom {

enum class UserIdleObserver_IdleState : int32_t {
  ACTIVE,
  IDLE,
  kMinValue = 0,
  kMaxValue = 1,
};

 std::ostream& operator<<(std::ostream& os, UserIdleObserver_IdleState value);
inline bool IsKnownEnumValue(UserIdleObserver_IdleState value) {
  return internal::UserIdleObserver_IdleState_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class UserActivityObserverInterfaceBase {};

using UserActivityObserverPtrDataView =
    mojo::InterfacePtrDataView<UserActivityObserverInterfaceBase>;
using UserActivityObserverRequestDataView =
    mojo::InterfaceRequestDataView<UserActivityObserverInterfaceBase>;
using UserActivityObserverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<UserActivityObserverInterfaceBase>;
using UserActivityObserverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<UserActivityObserverInterfaceBase>;
class UserIdleObserverInterfaceBase {};

using UserIdleObserverPtrDataView =
    mojo::InterfacePtrDataView<UserIdleObserverInterfaceBase>;
using UserIdleObserverRequestDataView =
    mojo::InterfaceRequestDataView<UserIdleObserverInterfaceBase>;
using UserIdleObserverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<UserIdleObserverInterfaceBase>;
using UserIdleObserverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<UserIdleObserverInterfaceBase>;
class UserActivityMonitorInterfaceBase {};

using UserActivityMonitorPtrDataView =
    mojo::InterfacePtrDataView<UserActivityMonitorInterfaceBase>;
using UserActivityMonitorRequestDataView =
    mojo::InterfaceRequestDataView<UserActivityMonitorInterfaceBase>;
using UserActivityMonitorAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<UserActivityMonitorInterfaceBase>;
using UserActivityMonitorAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<UserActivityMonitorInterfaceBase>;
class UserActivityObserver_OnUserActivity_ParamsDataView {
 public:
  UserActivityObserver_OnUserActivity_ParamsDataView() {}

  UserActivityObserver_OnUserActivity_ParamsDataView(
      internal::UserActivityObserver_OnUserActivity_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::UserActivityObserver_OnUserActivity_Params_Data* data_ = nullptr;
};

class UserIdleObserver_OnUserIdleStateChanged_ParamsDataView {
 public:
  UserIdleObserver_OnUserIdleStateChanged_ParamsDataView() {}

  UserIdleObserver_OnUserIdleStateChanged_ParamsDataView(
      internal::UserIdleObserver_OnUserIdleStateChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNewState(UserType* output) const {
    auto data_value = data_->new_state;
    return mojo::internal::Deserialize<::ws::mojom::UserIdleObserver_IdleState>(
        data_value, output);
  }

  UserIdleObserver_IdleState new_state() const {
    return static_cast<UserIdleObserver_IdleState>(data_->new_state);
  }
 private:
  internal::UserIdleObserver_OnUserIdleStateChanged_Params_Data* data_ = nullptr;
};

class UserActivityMonitor_AddUserActivityObserver_ParamsDataView {
 public:
  UserActivityMonitor_AddUserActivityObserver_ParamsDataView() {}

  UserActivityMonitor_AddUserActivityObserver_ParamsDataView(
      internal::UserActivityMonitor_AddUserActivityObserver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t delay_between_notify_secs() const {
    return data_->delay_between_notify_secs;
  }
  template <typename UserType>
  UserType TakeObserver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::ws::mojom::UserActivityObserverPtrDataView>(
            &data_->observer, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::UserActivityMonitor_AddUserActivityObserver_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class UserActivityMonitor_AddUserIdleObserver_ParamsDataView {
 public:
  UserActivityMonitor_AddUserIdleObserver_ParamsDataView() {}

  UserActivityMonitor_AddUserIdleObserver_ParamsDataView(
      internal::UserActivityMonitor_AddUserIdleObserver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t idle_time_in_minutes() const {
    return data_->idle_time_in_minutes;
  }
  template <typename UserType>
  UserType TakeObserver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::ws::mojom::UserIdleObserverPtrDataView>(
            &data_->observer, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::UserActivityMonitor_AddUserIdleObserver_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace ws

namespace std {

template <>
struct hash<::ws::mojom::UserIdleObserver_IdleState>
    : public mojo::internal::EnumHashImpl<::ws::mojom::UserIdleObserver_IdleState> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::ws::mojom::UserIdleObserver_IdleState, ::ws::mojom::UserIdleObserver_IdleState> {
  static ::ws::mojom::UserIdleObserver_IdleState ToMojom(::ws::mojom::UserIdleObserver_IdleState input) { return input; }
  static bool FromMojom(::ws::mojom::UserIdleObserver_IdleState input, ::ws::mojom::UserIdleObserver_IdleState* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::ws::mojom::UserIdleObserver_IdleState, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::ws::mojom::UserIdleObserver_IdleState, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::ws::mojom::UserIdleObserver_IdleState>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace ws {
namespace mojom {










}  // namespace mojom
}  // namespace ws

#endif  // SERVICES_WS_PUBLIC_MOJOM_USER_ACTIVITY_MONITOR_MOJOM_SHARED_H_