// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "third_party/blink/public/mojom/appcache/appcache.mojom-blink-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_APPCACHE_APPCACHE_MOJOM_BLINK_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_APPCACHE_APPCACHE_MOJOM_BLINK_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "third_party/blink/renderer/platform/mojo/kurl_struct_traits.h"
#endif


namespace blink {
namespace mojom {
namespace blink {


void AppCacheBackendInterceptorForTesting::RegisterHost(int32_t host_id) {
  GetForwardingInterface()->RegisterHost(std::move(host_id));
}
void AppCacheBackendInterceptorForTesting::UnregisterHost(int32_t host_id) {
  GetForwardingInterface()->UnregisterHost(std::move(host_id));
}
void AppCacheBackendInterceptorForTesting::SetSpawningHostId(int32_t host_id, int32_t spawning_host_id) {
  GetForwardingInterface()->SetSpawningHostId(std::move(host_id), std::move(spawning_host_id));
}
void AppCacheBackendInterceptorForTesting::SelectCache(int32_t host_id, const ::blink::KURL& document_url, int64_t appcache_document_was_loaded_from, const ::blink::KURL& opt_manifest_url) {
  GetForwardingInterface()->SelectCache(std::move(host_id), std::move(document_url), std::move(appcache_document_was_loaded_from), std::move(opt_manifest_url));
}
void AppCacheBackendInterceptorForTesting::SelectCacheForSharedWorker(int32_t host_id, int64_t appcache_id) {
  GetForwardingInterface()->SelectCacheForSharedWorker(std::move(host_id), std::move(appcache_id));
}
void AppCacheBackendInterceptorForTesting::MarkAsForeignEntry(int32_t host_id, const ::blink::KURL& document_url, int64_t appcache_document_was_loaded_from) {
  GetForwardingInterface()->MarkAsForeignEntry(std::move(host_id), std::move(document_url), std::move(appcache_document_was_loaded_from));
}
void AppCacheBackendInterceptorForTesting::GetStatus(int32_t host_id, GetStatusCallback callback) {
  GetForwardingInterface()->GetStatus(std::move(host_id), std::move(callback));
}
void AppCacheBackendInterceptorForTesting::StartUpdate(int32_t host_id, StartUpdateCallback callback) {
  GetForwardingInterface()->StartUpdate(std::move(host_id), std::move(callback));
}
void AppCacheBackendInterceptorForTesting::SwapCache(int32_t host_id, SwapCacheCallback callback) {
  GetForwardingInterface()->SwapCache(std::move(host_id), std::move(callback));
}
void AppCacheBackendInterceptorForTesting::GetResourceList(int32_t host_id, GetResourceListCallback callback) {
  GetForwardingInterface()->GetResourceList(std::move(host_id), std::move(callback));
}
AppCacheBackendAsyncWaiter::AppCacheBackendAsyncWaiter(
    AppCacheBackend* proxy) : proxy_(proxy) {}

AppCacheBackendAsyncWaiter::~AppCacheBackendAsyncWaiter() = default;

void AppCacheBackendAsyncWaiter::GetStatus(
    int32_t host_id, ::blink::mojom::blink::AppCacheStatus* out_status) {
  base::RunLoop loop;
  proxy_->GetStatus(std::move(host_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::blink::mojom::blink::AppCacheStatus* out_status
,
             ::blink::mojom::blink::AppCacheStatus status) {*out_status = std::move(status);
            loop->Quit();
          },
          &loop,
          out_status));
  loop.Run();
}
void AppCacheBackendAsyncWaiter::StartUpdate(
    int32_t host_id, bool* out_success) {
  base::RunLoop loop;
  proxy_->StartUpdate(std::move(host_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}
void AppCacheBackendAsyncWaiter::SwapCache(
    int32_t host_id, bool* out_success) {
  base::RunLoop loop;
  proxy_->SwapCache(std::move(host_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}
void AppCacheBackendAsyncWaiter::GetResourceList(
    int32_t host_id, WTF::Vector<AppCacheResourceInfoPtr>* out_resources) {
  base::RunLoop loop;
  proxy_->GetResourceList(std::move(host_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             WTF::Vector<AppCacheResourceInfoPtr>* out_resources
,
             WTF::Vector<AppCacheResourceInfoPtr> resources) {*out_resources = std::move(resources);
            loop->Quit();
          },
          &loop,
          out_resources));
  loop.Run();
}



void AppCacheFrontendInterceptorForTesting::CacheSelected(int32_t host_id, ::blink::mojom::blink::AppCacheInfoPtr info) {
  GetForwardingInterface()->CacheSelected(std::move(host_id), std::move(info));
}
void AppCacheFrontendInterceptorForTesting::StatusChanged(const WTF::Vector<int32_t>& host_ids, ::blink::mojom::blink::AppCacheStatus status) {
  GetForwardingInterface()->StatusChanged(std::move(host_ids), std::move(status));
}
void AppCacheFrontendInterceptorForTesting::EventRaised(const WTF::Vector<int32_t>& host_ids, AppCacheEventID event_id) {
  GetForwardingInterface()->EventRaised(std::move(host_ids), std::move(event_id));
}
void AppCacheFrontendInterceptorForTesting::ProgressEventRaised(const WTF::Vector<int32_t>& host_ids, const ::blink::KURL& url, int32_t total, int32_t complete) {
  GetForwardingInterface()->ProgressEventRaised(std::move(host_ids), std::move(url), std::move(total), std::move(complete));
}
void AppCacheFrontendInterceptorForTesting::ErrorEventRaised(const WTF::Vector<int32_t>& host_ids, AppCacheErrorDetailsPtr error_details) {
  GetForwardingInterface()->ErrorEventRaised(std::move(host_ids), std::move(error_details));
}
void AppCacheFrontendInterceptorForTesting::LogMessage(int32_t host_id, int32_t log_level, const WTF::String& message) {
  GetForwardingInterface()->LogMessage(std::move(host_id), std::move(log_level), std::move(message));
}
void AppCacheFrontendInterceptorForTesting::ContentBlocked(int32_t host_id, const ::blink::KURL& manifest_url) {
  GetForwardingInterface()->ContentBlocked(std::move(host_id), std::move(manifest_url));
}
void AppCacheFrontendInterceptorForTesting::SetSubresourceFactory(int32_t host_id, ::network::mojom::blink::URLLoaderFactoryPtr url_loader_factory) {
  GetForwardingInterface()->SetSubresourceFactory(std::move(host_id), std::move(url_loader_factory));
}
AppCacheFrontendAsyncWaiter::AppCacheFrontendAsyncWaiter(
    AppCacheFrontend* proxy) : proxy_(proxy) {}

AppCacheFrontendAsyncWaiter::~AppCacheFrontendAsyncWaiter() = default;






}  // namespace blink
}  // namespace mojom
}  // namespace blink

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif