// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_CHOOSERS_FILE_CHOOSER_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_CHOOSERS_FILE_CHOOSER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/file_path.mojom-shared-internal.h"
#include "mojo/public/mojom/base/string16.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class FileChooserParams_Data;
class NativeFileInfo_Data;
class FileSystemFileInfo_Data;
class FileChooserResult_Data;
class FileChooserFileInfo_Data;

struct FileChooserParams_Mode_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)


class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileChooserFileInfo_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  FileChooserFileInfo_Data() {}
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~FileChooserFileInfo_Data() {}

  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileChooserFileInfo_Data));
      new (data()) FileChooserFileInfo_Data();
    }

    void AllocateInline(mojo::internal::Buffer* serialization_buffer,
                        void* ptr) {
      const char* start = static_cast<const char*>(
          serialization_buffer->data());
      const char* slot = static_cast<const char*>(ptr);
      DCHECK_GT(slot, start);
      serialization_buffer_ = serialization_buffer;
      index_ = slot - start;
      new (data()) FileChooserFileInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileChooserFileInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileChooserFileInfo_Data>(index_);
    }
    FileChooserFileInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<FileChooserFileInfo_Tag>(0);
    data.unknown = 0U;
  }

  enum class FileChooserFileInfo_Tag : uint32_t {

    NATIVE_FILE,
    FILE_SYSTEM,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    Union_() : unknown(0) {}
    mojo::internal::Pointer<internal::NativeFileInfo_Data> f_native_file;
    mojo::internal::Pointer<internal::FileSystemFileInfo_Data> f_file_system;
    uint64_t unknown;
  };

  uint32_t size;
  FileChooserFileInfo_Tag tag;
  Union_ data;
};
static_assert(sizeof(FileChooserFileInfo_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(FileChooserFileInfo_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileChooserParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileChooserParams_Data));
      new (data()) FileChooserParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileChooserParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileChooserParams_Data>(index_);
    }
    FileChooserParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t mode;
  uint8_t need_local_path : 1;
  uint8_t use_media_capture : 1;
  uint8_t pad2_[3];
  mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data> title;
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> default_file_name;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data>>> selected_files;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data>>> accept_types;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> requestor;

 private:
  FileChooserParams_Data();
  ~FileChooserParams_Data() = delete;
};
static_assert(sizeof(FileChooserParams_Data) == 56,
              "Bad sizeof(FileChooserParams_Data)");
// Used by FileChooserParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct FileChooserParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  FileChooserParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~FileChooserParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    FileChooserParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    FileChooserParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) NativeFileInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NativeFileInfo_Data));
      new (data()) NativeFileInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NativeFileInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NativeFileInfo_Data>(index_);
    }
    NativeFileInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> file_path;
  mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data> display_name;

 private:
  NativeFileInfo_Data();
  ~NativeFileInfo_Data() = delete;
};
static_assert(sizeof(NativeFileInfo_Data) == 24,
              "Bad sizeof(NativeFileInfo_Data)");
// Used by NativeFileInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct NativeFileInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  NativeFileInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~NativeFileInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    NativeFileInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    NativeFileInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileSystemFileInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileSystemFileInfo_Data));
      new (data()) FileSystemFileInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileSystemFileInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileSystemFileInfo_Data>(index_);
    }
    FileSystemFileInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<::mojo_base::mojom::internal::Time_Data> modification_time;
  int64_t length;

 private:
  FileSystemFileInfo_Data();
  ~FileSystemFileInfo_Data() = delete;
};
static_assert(sizeof(FileSystemFileInfo_Data) == 32,
              "Bad sizeof(FileSystemFileInfo_Data)");
// Used by FileSystemFileInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct FileSystemFileInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  FileSystemFileInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~FileSystemFileInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    FileSystemFileInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    FileSystemFileInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileChooserResult_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileChooserResult_Data));
      new (data()) FileChooserResult_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileChooserResult_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileChooserResult_Data>(index_);
    }
    FileChooserResult_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<internal::FileChooserFileInfo_Data>> files;
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> base_directory;

 private:
  FileChooserResult_Data();
  ~FileChooserResult_Data() = delete;
};
static_assert(sizeof(FileChooserResult_Data) == 24,
              "Bad sizeof(FileChooserResult_Data)");
// Used by FileChooserResult::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct FileChooserResult_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  FileChooserResult_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~FileChooserResult_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    FileChooserResult_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    FileChooserResult_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileChooser_OpenFileChooser_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileChooser_OpenFileChooser_Params_Data));
      new (data()) FileChooser_OpenFileChooser_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileChooser_OpenFileChooser_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileChooser_OpenFileChooser_Params_Data>(index_);
    }
    FileChooser_OpenFileChooser_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::FileChooserParams_Data> params;

 private:
  FileChooser_OpenFileChooser_Params_Data();
  ~FileChooser_OpenFileChooser_Params_Data() = delete;
};
static_assert(sizeof(FileChooser_OpenFileChooser_Params_Data) == 16,
              "Bad sizeof(FileChooser_OpenFileChooser_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileChooser_OpenFileChooser_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileChooser_OpenFileChooser_ResponseParams_Data));
      new (data()) FileChooser_OpenFileChooser_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileChooser_OpenFileChooser_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileChooser_OpenFileChooser_ResponseParams_Data>(index_);
    }
    FileChooser_OpenFileChooser_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::FileChooserResult_Data> result;

 private:
  FileChooser_OpenFileChooser_ResponseParams_Data();
  ~FileChooser_OpenFileChooser_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileChooser_OpenFileChooser_ResponseParams_Data) == 16,
              "Bad sizeof(FileChooser_OpenFileChooser_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileChooser_EnumerateChosenDirectory_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileChooser_EnumerateChosenDirectory_Params_Data));
      new (data()) FileChooser_EnumerateChosenDirectory_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileChooser_EnumerateChosenDirectory_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileChooser_EnumerateChosenDirectory_Params_Data>(index_);
    }
    FileChooser_EnumerateChosenDirectory_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> directory_path;

 private:
  FileChooser_EnumerateChosenDirectory_Params_Data();
  ~FileChooser_EnumerateChosenDirectory_Params_Data() = delete;
};
static_assert(sizeof(FileChooser_EnumerateChosenDirectory_Params_Data) == 16,
              "Bad sizeof(FileChooser_EnumerateChosenDirectory_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileChooser_EnumerateChosenDirectory_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileChooser_EnumerateChosenDirectory_ResponseParams_Data));
      new (data()) FileChooser_EnumerateChosenDirectory_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileChooser_EnumerateChosenDirectory_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileChooser_EnumerateChosenDirectory_ResponseParams_Data>(index_);
    }
    FileChooser_EnumerateChosenDirectory_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::FileChooserResult_Data> result;

 private:
  FileChooser_EnumerateChosenDirectory_ResponseParams_Data();
  ~FileChooser_EnumerateChosenDirectory_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileChooser_EnumerateChosenDirectory_ResponseParams_Data) == 16,
              "Bad sizeof(FileChooser_EnumerateChosenDirectory_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_CHOOSERS_FILE_CHOOSER_MOJOM_SHARED_INTERNAL_H_