// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_DEVTOOLS_AGENT_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_DEVTOOLS_AGENT_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/big_string.mojom-shared-internal.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class DevToolsSessionState_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsSessionState_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsSessionState_Data));
      new (data()) DevToolsSessionState_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsSessionState_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsSessionState_Data>(index_);
    }
    DevToolsSessionState_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::String_Data>>> entries;

 private:
  DevToolsSessionState_Data();
  ~DevToolsSessionState_Data() = delete;
};
static_assert(sizeof(DevToolsSessionState_Data) == 16,
              "Bad sizeof(DevToolsSessionState_Data)");
// Used by DevToolsSessionState::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct DevToolsSessionState_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  DevToolsSessionState_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~DevToolsSessionState_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    DevToolsSessionState_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    DevToolsSessionState_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsAgent_AttachDevToolsSession_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsAgent_AttachDevToolsSession_Params_Data));
      new (data()) DevToolsAgent_AttachDevToolsSession_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsAgent_AttachDevToolsSession_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsAgent_AttachDevToolsSession_Params_Data>(index_);
    }
    DevToolsAgent_AttachDevToolsSession_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data host;
  mojo::internal::AssociatedEndpointHandle_Data session;
  mojo::internal::Handle_Data io_session;
  mojo::internal::Pointer<internal::DevToolsSessionState_Data> reattach_session_state;

 private:
  DevToolsAgent_AttachDevToolsSession_Params_Data();
  ~DevToolsAgent_AttachDevToolsSession_Params_Data() = delete;
};
static_assert(sizeof(DevToolsAgent_AttachDevToolsSession_Params_Data) == 32,
              "Bad sizeof(DevToolsAgent_AttachDevToolsSession_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsAgent_InspectElement_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsAgent_InspectElement_Params_Data));
      new (data()) DevToolsAgent_InspectElement_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsAgent_InspectElement_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsAgent_InspectElement_Params_Data>(index_);
    }
    DevToolsAgent_InspectElement_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> point;

 private:
  DevToolsAgent_InspectElement_Params_Data();
  ~DevToolsAgent_InspectElement_Params_Data() = delete;
};
static_assert(sizeof(DevToolsAgent_InspectElement_Params_Data) == 16,
              "Bad sizeof(DevToolsAgent_InspectElement_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsAgent_ReportChildWorkers_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsAgent_ReportChildWorkers_Params_Data));
      new (data()) DevToolsAgent_ReportChildWorkers_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsAgent_ReportChildWorkers_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsAgent_ReportChildWorkers_Params_Data>(index_);
    }
    DevToolsAgent_ReportChildWorkers_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t report : 1;
  uint8_t wait_for_debugger : 1;
  uint8_t padfinal_[7];

 private:
  DevToolsAgent_ReportChildWorkers_Params_Data();
  ~DevToolsAgent_ReportChildWorkers_Params_Data() = delete;
};
static_assert(sizeof(DevToolsAgent_ReportChildWorkers_Params_Data) == 16,
              "Bad sizeof(DevToolsAgent_ReportChildWorkers_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsAgent_ReportChildWorkers_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsAgent_ReportChildWorkers_ResponseParams_Data));
      new (data()) DevToolsAgent_ReportChildWorkers_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsAgent_ReportChildWorkers_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsAgent_ReportChildWorkers_ResponseParams_Data>(index_);
    }
    DevToolsAgent_ReportChildWorkers_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DevToolsAgent_ReportChildWorkers_ResponseParams_Data();
  ~DevToolsAgent_ReportChildWorkers_ResponseParams_Data() = delete;
};
static_assert(sizeof(DevToolsAgent_ReportChildWorkers_ResponseParams_Data) == 8,
              "Bad sizeof(DevToolsAgent_ReportChildWorkers_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsAgentHost_ChildWorkerCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsAgentHost_ChildWorkerCreated_Params_Data));
      new (data()) DevToolsAgentHost_ChildWorkerCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsAgentHost_ChildWorkerCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsAgentHost_ChildWorkerCreated_Params_Data>(index_);
    }
    DevToolsAgentHost_ChildWorkerCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data worker_devtools_agent;
  mojo::internal::Handle_Data worker_devtools_agent_host;
  uint8_t waiting_for_debugger : 1;
  uint8_t pad2_[3];
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> devtools_worker_token;

 private:
  DevToolsAgentHost_ChildWorkerCreated_Params_Data();
  ~DevToolsAgentHost_ChildWorkerCreated_Params_Data() = delete;
};
static_assert(sizeof(DevToolsAgentHost_ChildWorkerCreated_Params_Data) == 40,
              "Bad sizeof(DevToolsAgentHost_ChildWorkerCreated_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsSession_DispatchProtocolCommand_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsSession_DispatchProtocolCommand_Params_Data));
      new (data()) DevToolsSession_DispatchProtocolCommand_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsSession_DispatchProtocolCommand_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsSession_DispatchProtocolCommand_Params_Data>(index_);
    }
    DevToolsSession_DispatchProtocolCommand_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t call_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> method;
  mojo::internal::Pointer<mojo::internal::String_Data> message;

 private:
  DevToolsSession_DispatchProtocolCommand_Params_Data();
  ~DevToolsSession_DispatchProtocolCommand_Params_Data() = delete;
};
static_assert(sizeof(DevToolsSession_DispatchProtocolCommand_Params_Data) == 32,
              "Bad sizeof(DevToolsSession_DispatchProtocolCommand_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsSessionHost_DispatchProtocolResponse_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsSessionHost_DispatchProtocolResponse_Params_Data));
      new (data()) DevToolsSessionHost_DispatchProtocolResponse_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsSessionHost_DispatchProtocolResponse_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsSessionHost_DispatchProtocolResponse_Params_Data>(index_);
    }
    DevToolsSessionHost_DispatchProtocolResponse_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::BigString_Data> message;
  int32_t call_id;
  uint8_t pad1_[4];
  mojo::internal::Pointer<internal::DevToolsSessionState_Data> updates;

 private:
  DevToolsSessionHost_DispatchProtocolResponse_Params_Data();
  ~DevToolsSessionHost_DispatchProtocolResponse_Params_Data() = delete;
};
static_assert(sizeof(DevToolsSessionHost_DispatchProtocolResponse_Params_Data) == 32,
              "Bad sizeof(DevToolsSessionHost_DispatchProtocolResponse_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) DevToolsSessionHost_DispatchProtocolNotification_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsSessionHost_DispatchProtocolNotification_Params_Data));
      new (data()) DevToolsSessionHost_DispatchProtocolNotification_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsSessionHost_DispatchProtocolNotification_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsSessionHost_DispatchProtocolNotification_Params_Data>(index_);
    }
    DevToolsSessionHost_DispatchProtocolNotification_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::BigString_Data> message;
  mojo::internal::Pointer<internal::DevToolsSessionState_Data> updates;

 private:
  DevToolsSessionHost_DispatchProtocolNotification_Params_Data();
  ~DevToolsSessionHost_DispatchProtocolNotification_Params_Data() = delete;
};
static_assert(sizeof(DevToolsSessionHost_DispatchProtocolNotification_Params_Data) == 24,
              "Bad sizeof(DevToolsSessionHost_DispatchProtocolNotification_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_DEVTOOLS_AGENT_MOJOM_SHARED_INTERNAL_H_