// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_DEVTOOLS_AGENT_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_DEVTOOLS_AGENT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/mojom/devtools/devtools_agent.mojom-shared-internal.h"
#include "mojo/public/mojom/base/big_string.mojom-shared.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace blink {
namespace mojom {
class DevToolsSessionStateDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::DevToolsSessionStateDataView> {
  using Data = ::blink::mojom::internal::DevToolsSessionState_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class DevToolsAgentInterfaceBase {};

using DevToolsAgentPtrDataView =
    mojo::InterfacePtrDataView<DevToolsAgentInterfaceBase>;
using DevToolsAgentRequestDataView =
    mojo::InterfaceRequestDataView<DevToolsAgentInterfaceBase>;
using DevToolsAgentAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DevToolsAgentInterfaceBase>;
using DevToolsAgentAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DevToolsAgentInterfaceBase>;
class DevToolsAgentHostInterfaceBase {};

using DevToolsAgentHostPtrDataView =
    mojo::InterfacePtrDataView<DevToolsAgentHostInterfaceBase>;
using DevToolsAgentHostRequestDataView =
    mojo::InterfaceRequestDataView<DevToolsAgentHostInterfaceBase>;
using DevToolsAgentHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DevToolsAgentHostInterfaceBase>;
using DevToolsAgentHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DevToolsAgentHostInterfaceBase>;
class DevToolsSessionInterfaceBase {};

using DevToolsSessionPtrDataView =
    mojo::InterfacePtrDataView<DevToolsSessionInterfaceBase>;
using DevToolsSessionRequestDataView =
    mojo::InterfaceRequestDataView<DevToolsSessionInterfaceBase>;
using DevToolsSessionAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DevToolsSessionInterfaceBase>;
using DevToolsSessionAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DevToolsSessionInterfaceBase>;
class DevToolsSessionHostInterfaceBase {};

using DevToolsSessionHostPtrDataView =
    mojo::InterfacePtrDataView<DevToolsSessionHostInterfaceBase>;
using DevToolsSessionHostRequestDataView =
    mojo::InterfaceRequestDataView<DevToolsSessionHostInterfaceBase>;
using DevToolsSessionHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DevToolsSessionHostInterfaceBase>;
using DevToolsSessionHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DevToolsSessionHostInterfaceBase>;
class DevToolsSessionStateDataView {
 public:
  DevToolsSessionStateDataView() {}

  DevToolsSessionStateDataView(
      internal::DevToolsSessionState_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetEntriesDataView(
      mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEntries(UserType* output) {
    auto* pointer = data_->entries.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsSessionState_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsAgent_AttachDevToolsSession_ParamsDataView {
 public:
  DevToolsAgent_AttachDevToolsSession_ParamsDataView() {}

  DevToolsAgent_AttachDevToolsSession_ParamsDataView(
      internal::DevToolsAgent_AttachDevToolsSession_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeHost() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::DevToolsSessionHostAssociatedPtrInfoDataView>(
            &data_->host, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeSession() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::DevToolsSessionAssociatedRequestDataView>(
            &data_->session, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeIoSession() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::DevToolsSessionRequestDataView>(
            &data_->io_session, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetReattachSessionStateDataView(
      DevToolsSessionStateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReattachSessionState(UserType* output) {
    auto* pointer = data_->reattach_session_state.Get();
    return mojo::internal::Deserialize<::blink::mojom::DevToolsSessionStateDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsAgent_AttachDevToolsSession_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsAgent_InspectElement_ParamsDataView {
 public:
  DevToolsAgent_InspectElement_ParamsDataView() {}

  DevToolsAgent_InspectElement_ParamsDataView(
      internal::DevToolsAgent_InspectElement_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPointDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPoint(UserType* output) {
    auto* pointer = data_->point.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsAgent_InspectElement_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsAgent_ReportChildWorkers_ParamsDataView {
 public:
  DevToolsAgent_ReportChildWorkers_ParamsDataView() {}

  DevToolsAgent_ReportChildWorkers_ParamsDataView(
      internal::DevToolsAgent_ReportChildWorkers_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool report() const {
    return data_->report;
  }
  bool wait_for_debugger() const {
    return data_->wait_for_debugger;
  }
 private:
  internal::DevToolsAgent_ReportChildWorkers_Params_Data* data_ = nullptr;
};

class DevToolsAgent_ReportChildWorkers_ResponseParamsDataView {
 public:
  DevToolsAgent_ReportChildWorkers_ResponseParamsDataView() {}

  DevToolsAgent_ReportChildWorkers_ResponseParamsDataView(
      internal::DevToolsAgent_ReportChildWorkers_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DevToolsAgent_ReportChildWorkers_ResponseParams_Data* data_ = nullptr;
};

class DevToolsAgentHost_ChildWorkerCreated_ParamsDataView {
 public:
  DevToolsAgentHost_ChildWorkerCreated_ParamsDataView() {}

  DevToolsAgentHost_ChildWorkerCreated_ParamsDataView(
      internal::DevToolsAgentHost_ChildWorkerCreated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeWorkerDevtoolsAgent() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::DevToolsAgentPtrDataView>(
            &data_->worker_devtools_agent, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeWorkerDevtoolsAgentHost() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::DevToolsAgentHostRequestDataView>(
            &data_->worker_devtools_agent_host, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetDevtoolsWorkerTokenDataView(
      ::mojo_base::mojom::UnguessableTokenDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDevtoolsWorkerToken(UserType* output) {
    auto* pointer = data_->devtools_worker_token.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::UnguessableTokenDataView>(
        pointer, output, context_);
  }
  bool waiting_for_debugger() const {
    return data_->waiting_for_debugger;
  }
 private:
  internal::DevToolsAgentHost_ChildWorkerCreated_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsSession_DispatchProtocolCommand_ParamsDataView {
 public:
  DevToolsSession_DispatchProtocolCommand_ParamsDataView() {}

  DevToolsSession_DispatchProtocolCommand_ParamsDataView(
      internal::DevToolsSession_DispatchProtocolCommand_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t call_id() const {
    return data_->call_id;
  }
  inline void GetMethodDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMethod(UserType* output) {
    auto* pointer = data_->method.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetMessageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsSession_DispatchProtocolCommand_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsSessionHost_DispatchProtocolResponse_ParamsDataView {
 public:
  DevToolsSessionHost_DispatchProtocolResponse_ParamsDataView() {}

  DevToolsSessionHost_DispatchProtocolResponse_ParamsDataView(
      internal::DevToolsSessionHost_DispatchProtocolResponse_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMessageDataView(
      ::mojo_base::mojom::BigStringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::BigStringDataView>(
        pointer, output, context_);
  }
  int32_t call_id() const {
    return data_->call_id;
  }
  inline void GetUpdatesDataView(
      DevToolsSessionStateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdates(UserType* output) {
    auto* pointer = data_->updates.Get();
    return mojo::internal::Deserialize<::blink::mojom::DevToolsSessionStateDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsSessionHost_DispatchProtocolResponse_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsSessionHost_DispatchProtocolNotification_ParamsDataView {
 public:
  DevToolsSessionHost_DispatchProtocolNotification_ParamsDataView() {}

  DevToolsSessionHost_DispatchProtocolNotification_ParamsDataView(
      internal::DevToolsSessionHost_DispatchProtocolNotification_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMessageDataView(
      ::mojo_base::mojom::BigStringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::BigStringDataView>(
        pointer, output, context_);
  }
  inline void GetUpdatesDataView(
      DevToolsSessionStateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdates(UserType* output) {
    auto* pointer = data_->updates.Get();
    return mojo::internal::Deserialize<::blink::mojom::DevToolsSessionStateDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsSessionHost_DispatchProtocolNotification_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::DevToolsSessionStateDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::DevToolsSessionStateDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::DevToolsSessionState_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::entries, input, custom_context)) in_entries = CallWithContext(Traits::entries, input, custom_context);
    typename decltype((*output)->entries)::BaseType::BufferWriter
        entries_writer;
    const mojo::internal::ContainerValidateParams entries_validate_params(
        new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)), new mojo::internal::ContainerValidateParams(0, true, new mojo::internal::ContainerValidateParams(0, false, nullptr)));
    mojo::internal::Serialize<mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>>(
        in_entries, buffer, &entries_writer, &entries_validate_params,
        context);
    (*output)->entries.Set(
        entries_writer.is_null() ? nullptr : entries_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->entries.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null entries in DevToolsSessionState struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::DevToolsSessionState_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::DevToolsSessionStateDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void DevToolsSessionStateDataView::GetEntriesDataView(
    mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>* output) {
  auto pointer = data_->entries.Get();
  *output = mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>(pointer, context_);
}


inline void DevToolsAgent_AttachDevToolsSession_ParamsDataView::GetReattachSessionStateDataView(
    DevToolsSessionStateDataView* output) {
  auto pointer = data_->reattach_session_state.Get();
  *output = DevToolsSessionStateDataView(pointer, context_);
}


inline void DevToolsAgent_InspectElement_ParamsDataView::GetPointDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->point.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}






inline void DevToolsAgentHost_ChildWorkerCreated_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void DevToolsAgentHost_ChildWorkerCreated_ParamsDataView::GetDevtoolsWorkerTokenDataView(
    ::mojo_base::mojom::UnguessableTokenDataView* output) {
  auto pointer = data_->devtools_worker_token.Get();
  *output = ::mojo_base::mojom::UnguessableTokenDataView(pointer, context_);
}


inline void DevToolsSession_DispatchProtocolCommand_ParamsDataView::GetMethodDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->method.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void DevToolsSession_DispatchProtocolCommand_ParamsDataView::GetMessageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->message.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void DevToolsSessionHost_DispatchProtocolResponse_ParamsDataView::GetMessageDataView(
    ::mojo_base::mojom::BigStringDataView* output) {
  auto pointer = data_->message.Get();
  *output = ::mojo_base::mojom::BigStringDataView(pointer, context_);
}
inline void DevToolsSessionHost_DispatchProtocolResponse_ParamsDataView::GetUpdatesDataView(
    DevToolsSessionStateDataView* output) {
  auto pointer = data_->updates.Get();
  *output = DevToolsSessionStateDataView(pointer, context_);
}


inline void DevToolsSessionHost_DispatchProtocolNotification_ParamsDataView::GetMessageDataView(
    ::mojo_base::mojom::BigStringDataView* output) {
  auto pointer = data_->message.Get();
  *output = ::mojo_base::mojom::BigStringDataView(pointer, context_);
}
inline void DevToolsSessionHost_DispatchProtocolNotification_ParamsDataView::GetUpdatesDataView(
    DevToolsSessionStateDataView* output) {
  auto pointer = data_->updates.Get();
  *output = DevToolsSessionStateDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_DEVTOOLS_AGENT_MOJOM_SHARED_H_