// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "third_party/blink/public/mojom/filesystem/file_writer.mojom-blink-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_BLINK_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_BLINK_JUMBO_H_
#include "mojo/public/cpp/base/file_error_mojom_traits.h"
#endif


namespace blink {
namespace mojom {
namespace blink {


void FileWriterInterceptorForTesting::Write(uint64_t position, ::blink::mojom::blink::BlobPtr blob, WriteCallback callback) {
  GetForwardingInterface()->Write(std::move(position), std::move(blob), std::move(callback));
}
void FileWriterInterceptorForTesting::WriteStream(uint64_t position, mojo::ScopedDataPipeConsumerHandle stream, WriteStreamCallback callback) {
  GetForwardingInterface()->WriteStream(std::move(position), std::move(stream), std::move(callback));
}
void FileWriterInterceptorForTesting::Truncate(uint64_t length, TruncateCallback callback) {
  GetForwardingInterface()->Truncate(std::move(length), std::move(callback));
}
FileWriterAsyncWaiter::FileWriterAsyncWaiter(
    FileWriter* proxy) : proxy_(proxy) {}

FileWriterAsyncWaiter::~FileWriterAsyncWaiter() = default;

void FileWriterAsyncWaiter::Write(
    uint64_t position, ::blink::mojom::blink::BlobPtr blob, ::base::File::Error* out_result, uint64_t* out_bytes_written) {
  base::RunLoop loop;
  proxy_->Write(std::move(position),std::move(blob),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::base::File::Error* out_result
,
             uint64_t* out_bytes_written
,
             ::base::File::Error result,
             uint64_t bytes_written) {*out_result = std::move(result);*out_bytes_written = std::move(bytes_written);
            loop->Quit();
          },
          &loop,
          out_result,
          out_bytes_written));
  loop.Run();
}
void FileWriterAsyncWaiter::WriteStream(
    uint64_t position, mojo::ScopedDataPipeConsumerHandle stream, ::base::File::Error* out_result, uint64_t* out_bytes_written) {
  base::RunLoop loop;
  proxy_->WriteStream(std::move(position),std::move(stream),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::base::File::Error* out_result
,
             uint64_t* out_bytes_written
,
             ::base::File::Error result,
             uint64_t bytes_written) {*out_result = std::move(result);*out_bytes_written = std::move(bytes_written);
            loop->Quit();
          },
          &loop,
          out_result,
          out_bytes_written));
  loop.Run();
}
void FileWriterAsyncWaiter::Truncate(
    uint64_t length, ::base::File::Error* out_result) {
  base::RunLoop loop;
  proxy_->Truncate(std::move(length),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::base::File::Error* out_result
,
             ::base::File::Error result) {*out_result = std::move(result);
            loop->Quit();
          },
          &loop,
          out_result));
  loop.Run();
}





}  // namespace blink
}  // namespace mojom
}  // namespace blink

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif