// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/filesystem/file_writer.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink {
namespace mojom {
namespace blink {


class PLATFORM_EXPORT FileWriterInterceptorForTesting : public FileWriter {
  virtual FileWriter* GetForwardingInterface() = 0;
  void Write(uint64_t position, ::blink::mojom::blink::BlobPtr blob, WriteCallback callback) override;
  void WriteStream(uint64_t position, mojo::ScopedDataPipeConsumerHandle stream, WriteStreamCallback callback) override;
  void Truncate(uint64_t length, TruncateCallback callback) override;
};
class PLATFORM_EXPORT FileWriterAsyncWaiter {
 public:
  explicit FileWriterAsyncWaiter(FileWriter* proxy);
  ~FileWriterAsyncWaiter();
  void Write(
      uint64_t position, ::blink::mojom::blink::BlobPtr blob, ::base::File::Error* out_result, uint64_t* out_bytes_written);
  void WriteStream(
      uint64_t position, mojo::ScopedDataPipeConsumerHandle stream, ::base::File::Error* out_result, uint64_t* out_bytes_written);
  void Truncate(
      uint64_t length, ::base::File::Error* out_result);

 private:
  FileWriter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FileWriterAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_BLINK_TEST_UTILS_H_