// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/file_error.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/blob/blob.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_Write_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_Write_Params_Data));
      new (data()) FileWriter_Write_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_Write_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_Write_Params_Data>(index_);
    }
    FileWriter_Write_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t position;
  mojo::internal::Interface_Data blob;

 private:
  FileWriter_Write_Params_Data();
  ~FileWriter_Write_Params_Data() = delete;
};
static_assert(sizeof(FileWriter_Write_Params_Data) == 24,
              "Bad sizeof(FileWriter_Write_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_Write_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_Write_ResponseParams_Data));
      new (data()) FileWriter_Write_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_Write_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_Write_ResponseParams_Data>(index_);
    }
    FileWriter_Write_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t pad0_[4];
  uint64_t bytes_written;

 private:
  FileWriter_Write_ResponseParams_Data();
  ~FileWriter_Write_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileWriter_Write_ResponseParams_Data) == 24,
              "Bad sizeof(FileWriter_Write_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_WriteStream_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_WriteStream_Params_Data));
      new (data()) FileWriter_WriteStream_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_WriteStream_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_WriteStream_Params_Data>(index_);
    }
    FileWriter_WriteStream_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t position;
  mojo::internal::Handle_Data stream;
  uint8_t padfinal_[4];

 private:
  FileWriter_WriteStream_Params_Data();
  ~FileWriter_WriteStream_Params_Data() = delete;
};
static_assert(sizeof(FileWriter_WriteStream_Params_Data) == 24,
              "Bad sizeof(FileWriter_WriteStream_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_WriteStream_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_WriteStream_ResponseParams_Data));
      new (data()) FileWriter_WriteStream_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_WriteStream_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_WriteStream_ResponseParams_Data>(index_);
    }
    FileWriter_WriteStream_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t pad0_[4];
  uint64_t bytes_written;

 private:
  FileWriter_WriteStream_ResponseParams_Data();
  ~FileWriter_WriteStream_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileWriter_WriteStream_ResponseParams_Data) == 24,
              "Bad sizeof(FileWriter_WriteStream_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_Truncate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_Truncate_Params_Data));
      new (data()) FileWriter_Truncate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_Truncate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_Truncate_Params_Data>(index_);
    }
    FileWriter_Truncate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t length;

 private:
  FileWriter_Truncate_Params_Data();
  ~FileWriter_Truncate_Params_Data() = delete;
};
static_assert(sizeof(FileWriter_Truncate_Params_Data) == 16,
              "Bad sizeof(FileWriter_Truncate_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_Truncate_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_Truncate_ResponseParams_Data));
      new (data()) FileWriter_Truncate_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_Truncate_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_Truncate_ResponseParams_Data>(index_);
    }
    FileWriter_Truncate_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  FileWriter_Truncate_ResponseParams_Data();
  ~FileWriter_Truncate_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileWriter_Truncate_ResponseParams_Data) == 16,
              "Bad sizeof(FileWriter_Truncate_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_SHARED_INTERNAL_H_