// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_INDEXEDDB_INDEXEDDB_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_INDEXEDDB_INDEXEDDB_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/mojom/indexeddb/indexeddb.mojom-shared-internal.h"
#include "mojo/public/mojom/base/file_path.mojom-shared.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "third_party/blink/public/mojom/blob/blob.mojom-shared.h"
#include "url/mojom/origin.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace blink {
namespace mojom {
class IDBKeyDataView;

class IDBKeyPathDataView;

class IDBKeyRangeDataView;

class IDBIndexMetadataDataView;

class IDBObjectStoreMetadataDataView;

class IDBDatabaseMetadataDataView;

class IDBNameAndVersionDataView;

class IDBIndexKeysDataView;

class IDBFileInfoDataView;

class IDBBlobInfoDataView;

class IDBValueDataView;

class IDBReturnValueDataView;

class IDBObservationDataView;

class IDBObserverTransactionDataView;

class IDBObserverChangesDataView;

class IDBErrorDataView;

class IDBCursorValueDataView;

class IDBKeyDataDataView;
class IDBKeyPathDataDataView;


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::IDBKeyDataView> {
  using Data = ::blink::mojom::internal::IDBKey_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBKeyPathDataView> {
  using Data = ::blink::mojom::internal::IDBKeyPath_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBKeyRangeDataView> {
  using Data = ::blink::mojom::internal::IDBKeyRange_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBIndexMetadataDataView> {
  using Data = ::blink::mojom::internal::IDBIndexMetadata_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBObjectStoreMetadataDataView> {
  using Data = ::blink::mojom::internal::IDBObjectStoreMetadata_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBDatabaseMetadataDataView> {
  using Data = ::blink::mojom::internal::IDBDatabaseMetadata_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBNameAndVersionDataView> {
  using Data = ::blink::mojom::internal::IDBNameAndVersion_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBIndexKeysDataView> {
  using Data = ::blink::mojom::internal::IDBIndexKeys_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBFileInfoDataView> {
  using Data = ::blink::mojom::internal::IDBFileInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBBlobInfoDataView> {
  using Data = ::blink::mojom::internal::IDBBlobInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBValueDataView> {
  using Data = ::blink::mojom::internal::IDBValue_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBReturnValueDataView> {
  using Data = ::blink::mojom::internal::IDBReturnValue_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBObservationDataView> {
  using Data = ::blink::mojom::internal::IDBObservation_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBObserverTransactionDataView> {
  using Data = ::blink::mojom::internal::IDBObserverTransaction_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBObserverChangesDataView> {
  using Data = ::blink::mojom::internal::IDBObserverChanges_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBErrorDataView> {
  using Data = ::blink::mojom::internal::IDBError_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBCursorValueDataView> {
  using Data = ::blink::mojom::internal::IDBCursorValue_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBKeyDataDataView> {
  using Data = ::blink::mojom::internal::IDBKeyData_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::UNION;
};

template <>
struct MojomTypeTraits<::blink::mojom::IDBKeyPathDataDataView> {
  using Data = ::blink::mojom::internal::IDBKeyPathData_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::UNION;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {

enum class IDBCursorDirection : int32_t {
  Next,
  NextNoDuplicate,
  Prev,
  PrevNoDuplicate,
  kMinValue = 0,
  kMaxValue = 3,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBCursorDirection value);
inline bool IsKnownEnumValue(IDBCursorDirection value) {
  return internal::IDBCursorDirection_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class IDBDataLoss : int32_t {
  None,
  Total,
  kMinValue = 0,
  kMaxValue = 1,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBDataLoss value);
inline bool IsKnownEnumValue(IDBDataLoss value) {
  return internal::IDBDataLoss_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class IDBKeyType : int32_t {
  Invalid,
  Array,
  Binary,
  String,
  Date,
  Number,
  Null,
  Min,
  kMinValue = 0,
  kMaxValue = 7,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBKeyType value);
inline bool IsKnownEnumValue(IDBKeyType value) {
  return internal::IDBKeyType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class IDBKeyPathType : int32_t {
  Null,
  String,
  Array,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBKeyPathType value);
inline bool IsKnownEnumValue(IDBKeyPathType value) {
  return internal::IDBKeyPathType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class IDBOperationType : int32_t {
  Add,
  Put,
  Delete,
  Clear,
  kMinValue = 0,
  kMaxValue = 3,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBOperationType value);
inline bool IsKnownEnumValue(IDBOperationType value) {
  return internal::IDBOperationType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class IDBPutMode : int32_t {
  AddOrUpdate,
  AddOnly,
  CursorUpdate,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBPutMode value);
inline bool IsKnownEnumValue(IDBPutMode value) {
  return internal::IDBPutMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class IDBTaskType : int32_t {
  Normal,
  Preemptive,
  kMinValue = 0,
  kMaxValue = 1,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBTaskType value);
inline bool IsKnownEnumValue(IDBTaskType value) {
  return internal::IDBTaskType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class IDBTransactionMode : int32_t {
  ReadOnly,
  ReadWrite,
  VersionChange,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBTransactionMode value);
inline bool IsKnownEnumValue(IDBTransactionMode value) {
  return internal::IDBTransactionMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class IDBStatus : int32_t {
  OK,
  NotFound,
  Corruption,
  NotSupported,
  InvalidArgument,
  IOError,
  kMinValue = 0,
  kMaxValue = 5,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, IDBStatus value);
inline bool IsKnownEnumValue(IDBStatus value) {
  return internal::IDBStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class IDBCallbacksInterfaceBase {};

using IDBCallbacksPtrDataView =
    mojo::InterfacePtrDataView<IDBCallbacksInterfaceBase>;
using IDBCallbacksRequestDataView =
    mojo::InterfaceRequestDataView<IDBCallbacksInterfaceBase>;
using IDBCallbacksAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IDBCallbacksInterfaceBase>;
using IDBCallbacksAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IDBCallbacksInterfaceBase>;
class IDBDatabaseCallbacksInterfaceBase {};

using IDBDatabaseCallbacksPtrDataView =
    mojo::InterfacePtrDataView<IDBDatabaseCallbacksInterfaceBase>;
using IDBDatabaseCallbacksRequestDataView =
    mojo::InterfaceRequestDataView<IDBDatabaseCallbacksInterfaceBase>;
using IDBDatabaseCallbacksAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IDBDatabaseCallbacksInterfaceBase>;
using IDBDatabaseCallbacksAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IDBDatabaseCallbacksInterfaceBase>;
class IDBCursorInterfaceBase {};

using IDBCursorPtrDataView =
    mojo::InterfacePtrDataView<IDBCursorInterfaceBase>;
using IDBCursorRequestDataView =
    mojo::InterfaceRequestDataView<IDBCursorInterfaceBase>;
using IDBCursorAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IDBCursorInterfaceBase>;
using IDBCursorAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IDBCursorInterfaceBase>;
class IDBDatabaseInterfaceBase {};

using IDBDatabasePtrDataView =
    mojo::InterfacePtrDataView<IDBDatabaseInterfaceBase>;
using IDBDatabaseRequestDataView =
    mojo::InterfaceRequestDataView<IDBDatabaseInterfaceBase>;
using IDBDatabaseAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IDBDatabaseInterfaceBase>;
using IDBDatabaseAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IDBDatabaseInterfaceBase>;
class IDBFactoryInterfaceBase {};

using IDBFactoryPtrDataView =
    mojo::InterfacePtrDataView<IDBFactoryInterfaceBase>;
using IDBFactoryRequestDataView =
    mojo::InterfaceRequestDataView<IDBFactoryInterfaceBase>;
using IDBFactoryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<IDBFactoryInterfaceBase>;
using IDBFactoryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<IDBFactoryInterfaceBase>;
class IDBKeyDataView {
 public:
  IDBKeyDataView() {}

  IDBKeyDataView(
      internal::IDBKey_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDataDataView(
      IDBKeyDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = !data_->data.is_null() ? &data_->data : nullptr;
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBKey_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBKeyPathDataView {
 public:
  IDBKeyPathDataView() {}

  IDBKeyPathDataView(
      internal::IDBKeyPath_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDataDataView(
      IDBKeyPathDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = !data_->data.is_null() ? &data_->data : nullptr;
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyPathDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBKeyPath_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBKeyRangeDataView {
 public:
  IDBKeyRangeDataView() {}

  IDBKeyRangeDataView(
      internal::IDBKeyRange_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetLowerDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLower(UserType* output) {
    auto* pointer = data_->lower.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetUpperDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpper(UserType* output) {
    auto* pointer = data_->upper.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  bool lower_open() const {
    return data_->lower_open;
  }
  bool upper_open() const {
    return data_->upper_open;
  }
 private:
  internal::IDBKeyRange_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBIndexMetadataDataView {
 public:
  IDBIndexMetadataDataView() {}

  IDBIndexMetadataDataView(
      internal::IDBIndexMetadata_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t id() const {
    return data_->id;
  }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetKeyPathDataView(
      IDBKeyPathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyPath(UserType* output) {
    auto* pointer = data_->key_path.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyPathDataView>(
        pointer, output, context_);
  }
  bool unique() const {
    return data_->unique;
  }
  bool multi_entry() const {
    return data_->multi_entry;
  }
 private:
  internal::IDBIndexMetadata_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBObjectStoreMetadataDataView {
 public:
  IDBObjectStoreMetadataDataView() {}

  IDBObjectStoreMetadataDataView(
      internal::IDBObjectStoreMetadata_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t id() const {
    return data_->id;
  }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetKeyPathDataView(
      IDBKeyPathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyPath(UserType* output) {
    auto* pointer = data_->key_path.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyPathDataView>(
        pointer, output, context_);
  }
  bool auto_increment() const {
    return data_->auto_increment;
  }
  int64_t max_index_id() const {
    return data_->max_index_id;
  }
  inline void GetIndexesDataView(
      mojo::MapDataView<int64_t, IDBIndexMetadataDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIndexes(UserType* output) {
    auto* pointer = data_->indexes.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<int64_t, ::blink::mojom::IDBIndexMetadataDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBObjectStoreMetadata_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabaseMetadataDataView {
 public:
  IDBDatabaseMetadataDataView() {}

  IDBDatabaseMetadataDataView(
      internal::IDBDatabaseMetadata_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t id() const {
    return data_->id;
  }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  int64_t version() const {
    return data_->version;
  }
  int64_t max_object_store_id() const {
    return data_->max_object_store_id;
  }
  inline void GetObjectStoresDataView(
      mojo::MapDataView<int64_t, IDBObjectStoreMetadataDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadObjectStores(UserType* output) {
    auto* pointer = data_->object_stores.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<int64_t, ::blink::mojom::IDBObjectStoreMetadataDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBDatabaseMetadata_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBNameAndVersionDataView {
 public:
  IDBNameAndVersionDataView() {}

  IDBNameAndVersionDataView(
      internal::IDBNameAndVersion_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  int64_t version() const {
    return data_->version;
  }
 private:
  internal::IDBNameAndVersion_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBIndexKeysDataView {
 public:
  IDBIndexKeysDataView() {}

  IDBIndexKeysDataView(
      internal::IDBIndexKeys_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t index_id() const {
    return data_->index_id;
  }
  inline void GetIndexKeysDataView(
      mojo::ArrayDataView<IDBKeyDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIndexKeys(UserType* output) {
    auto* pointer = data_->index_keys.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBKeyDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBIndexKeys_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBFileInfoDataView {
 public:
  IDBFileInfoDataView() {}

  IDBFileInfoDataView(
      internal::IDBFileInfo_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPathDataView(
      ::mojo_base::mojom::FilePathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPath(UserType* output) {
    auto* pointer = data_->path.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FilePathDataView>(
        pointer, output, context_);
  }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetLastModifiedDataView(
      ::mojo_base::mojom::TimeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLastModified(UserType* output) {
    auto* pointer = data_->last_modified.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBFileInfo_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBBlobInfoDataView {
 public:
  IDBBlobInfoDataView() {}

  IDBBlobInfoDataView(
      internal::IDBBlobInfo_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeBlob() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::BlobPtrDataView>(
            &data_->blob, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetUuidDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUuid(UserType* output) {
    auto* pointer = data_->uuid.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetMimeTypeDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMimeType(UserType* output) {
    auto* pointer = data_->mime_type.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  int64_t size() const {
    return data_->size;
  }
  inline void GetFileDataView(
      IDBFileInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFile(UserType* output) {
    auto* pointer = data_->file.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBFileInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBBlobInfo_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBValueDataView {
 public:
  IDBValueDataView() {}

  IDBValueDataView(
      internal::IDBValue_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetBitsDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBits(UserType* output) {
    auto* pointer = data_->bits.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
  inline void GetBlobOrFileInfoDataView(
      mojo::ArrayDataView<IDBBlobInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBlobOrFileInfo(UserType* output) {
    auto* pointer = data_->blob_or_file_info.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBBlobInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBValue_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBReturnValueDataView {
 public:
  IDBReturnValueDataView() {}

  IDBReturnValueDataView(
      internal::IDBReturnValue_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetValueDataView(
      IDBValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBValueDataView>(
        pointer, output, context_);
  }
  inline void GetPrimaryKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPrimaryKey(UserType* output) {
    auto* pointer = data_->primary_key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetKeyPathDataView(
      IDBKeyPathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyPath(UserType* output) {
    auto* pointer = data_->key_path.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyPathDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBReturnValue_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBObservationDataView {
 public:
  IDBObservationDataView() {}

  IDBObservationDataView(
      internal::IDBObservation_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::blink::mojom::IDBOperationType>(
        data_value, output);
  }

  IDBOperationType type() const {
    return static_cast<IDBOperationType>(data_->type);
  }
  inline void GetKeyRangeDataView(
      IDBKeyRangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyRange(UserType* output) {
    auto* pointer = data_->key_range.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyRangeDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      IDBValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBObservation_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBObserverTransactionDataView {
 public:
  IDBObserverTransactionDataView() {}

  IDBObserverTransactionDataView(
      internal::IDBObserverTransaction_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t id() const {
    return data_->id;
  }
  inline void GetScopeDataView(
      mojo::ArrayDataView<int64_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadScope(UserType* output) {
    auto* pointer = data_->scope.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<int64_t>>(
        pointer, output, context_);
  }
 private:
  internal::IDBObserverTransaction_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBObserverChangesDataView {
 public:
  IDBObserverChangesDataView() {}

  IDBObserverChangesDataView(
      internal::IDBObserverChanges_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetObservationIndexMapDataView(
      mojo::MapDataView<int32_t, mojo::ArrayDataView<int32_t>>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadObservationIndexMap(UserType* output) {
    auto* pointer = data_->observation_index_map.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<int32_t, mojo::ArrayDataView<int32_t>>>(
        pointer, output, context_);
  }
  inline void GetTransactionMapDataView(
      mojo::MapDataView<int32_t, IDBObserverTransactionDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTransactionMap(UserType* output) {
    auto* pointer = data_->transaction_map.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<int32_t, ::blink::mojom::IDBObserverTransactionDataView>>(
        pointer, output, context_);
  }
  inline void GetObservationsDataView(
      mojo::ArrayDataView<IDBObservationDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadObservations(UserType* output) {
    auto* pointer = data_->observations.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBObservationDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBObserverChanges_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBErrorDataView {
 public:
  IDBErrorDataView() {}

  IDBErrorDataView(
      internal::IDBError_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t error_code() const {
    return data_->error_code;
  }
  inline void GetErrorMessageDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadErrorMessage(UserType* output) {
    auto* pointer = data_->error_message.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBError_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCursorValueDataView {
 public:
  IDBCursorValueDataView() {}

  IDBCursorValueDataView(
      internal::IDBCursorValue_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetPrimaryKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPrimaryKey(UserType* output) {
    auto* pointer = data_->primary_key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      IDBValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCursorValue_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_Error_ParamsDataView {
 public:
  IDBCallbacks_Error_ParamsDataView() {}

  IDBCallbacks_Error_ParamsDataView(
      internal::IDBCallbacks_Error_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t code() const {
    return data_->code;
  }
  inline void GetMessageDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_Error_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessNamesAndVersionsList_ParamsDataView {
 public:
  IDBCallbacks_SuccessNamesAndVersionsList_ParamsDataView() {}

  IDBCallbacks_SuccessNamesAndVersionsList_ParamsDataView(
      internal::IDBCallbacks_SuccessNamesAndVersionsList_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetValueDataView(
      mojo::ArrayDataView<IDBNameAndVersionDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBNameAndVersionDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessNamesAndVersionsList_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessStringList_ParamsDataView {
 public:
  IDBCallbacks_SuccessStringList_ParamsDataView() {}

  IDBCallbacks_SuccessStringList_ParamsDataView(
      internal::IDBCallbacks_SuccessStringList_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetValueDataView(
      mojo::ArrayDataView<::mojo_base::mojom::String16DataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::mojo_base::mojom::String16DataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessStringList_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_Blocked_ParamsDataView {
 public:
  IDBCallbacks_Blocked_ParamsDataView() {}

  IDBCallbacks_Blocked_ParamsDataView(
      internal::IDBCallbacks_Blocked_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t existing_version() const {
    return data_->existing_version;
  }
 private:
  internal::IDBCallbacks_Blocked_Params_Data* data_ = nullptr;
};

class IDBCallbacks_UpgradeNeeded_ParamsDataView {
 public:
  IDBCallbacks_UpgradeNeeded_ParamsDataView() {}

  IDBCallbacks_UpgradeNeeded_ParamsDataView(
      internal::IDBCallbacks_UpgradeNeeded_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeDatabase() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBDatabaseAssociatedPtrInfoDataView>(
            &data_->database, &result, context_);
    DCHECK(ret);
    return result;
  }
  int64_t old_version() const {
    return data_->old_version;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDataLoss(UserType* output) const {
    auto data_value = data_->data_loss;
    return mojo::internal::Deserialize<::blink::mojom::IDBDataLoss>(
        data_value, output);
  }

  IDBDataLoss data_loss() const {
    return static_cast<IDBDataLoss>(data_->data_loss);
  }
  inline void GetDataLossMessageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDataLossMessage(UserType* output) {
    auto* pointer = data_->data_loss_message.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDbMetadataDataView(
      IDBDatabaseMetadataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDbMetadata(UserType* output) {
    auto* pointer = data_->db_metadata.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBDatabaseMetadataDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_UpgradeNeeded_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessDatabase_ParamsDataView {
 public:
  IDBCallbacks_SuccessDatabase_ParamsDataView() {}

  IDBCallbacks_SuccessDatabase_ParamsDataView(
      internal::IDBCallbacks_SuccessDatabase_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeDatabase() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBDatabaseAssociatedPtrInfoDataView>(
            &data_->database, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetMetadataDataView(
      IDBDatabaseMetadataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMetadata(UserType* output) {
    auto* pointer = data_->metadata.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBDatabaseMetadataDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessDatabase_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessCursor_ParamsDataView {
 public:
  IDBCallbacks_SuccessCursor_ParamsDataView() {}

  IDBCallbacks_SuccessCursor_ParamsDataView(
      internal::IDBCallbacks_SuccessCursor_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeCursor() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCursorAssociatedPtrInfoDataView>(
            &data_->cursor, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetPrimaryKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPrimaryKey(UserType* output) {
    auto* pointer = data_->primary_key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      IDBValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessCursor_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessValue_ParamsDataView {
 public:
  IDBCallbacks_SuccessValue_ParamsDataView() {}

  IDBCallbacks_SuccessValue_ParamsDataView(
      internal::IDBCallbacks_SuccessValue_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetValueDataView(
      IDBReturnValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBReturnValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessValue_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessCursorContinue_ParamsDataView {
 public:
  IDBCallbacks_SuccessCursorContinue_ParamsDataView() {}

  IDBCallbacks_SuccessCursorContinue_ParamsDataView(
      internal::IDBCallbacks_SuccessCursorContinue_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetPrimaryKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPrimaryKey(UserType* output) {
    auto* pointer = data_->primary_key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      IDBValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessCursorContinue_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessCursorPrefetch_ParamsDataView {
 public:
  IDBCallbacks_SuccessCursorPrefetch_ParamsDataView() {}

  IDBCallbacks_SuccessCursorPrefetch_ParamsDataView(
      internal::IDBCallbacks_SuccessCursorPrefetch_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeysDataView(
      mojo::ArrayDataView<IDBKeyDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeys(UserType* output) {
    auto* pointer = data_->keys.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBKeyDataView>>(
        pointer, output, context_);
  }
  inline void GetPrimaryKeysDataView(
      mojo::ArrayDataView<IDBKeyDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPrimaryKeys(UserType* output) {
    auto* pointer = data_->primary_keys.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBKeyDataView>>(
        pointer, output, context_);
  }
  inline void GetValuesDataView(
      mojo::ArrayDataView<IDBValueDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValues(UserType* output) {
    auto* pointer = data_->values.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBValueDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessCursorPrefetch_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessArray_ParamsDataView {
 public:
  IDBCallbacks_SuccessArray_ParamsDataView() {}

  IDBCallbacks_SuccessArray_ParamsDataView(
      internal::IDBCallbacks_SuccessArray_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetValuesDataView(
      mojo::ArrayDataView<IDBReturnValueDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValues(UserType* output) {
    auto* pointer = data_->values.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBReturnValueDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessArray_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessKey_ParamsDataView {
 public:
  IDBCallbacks_SuccessKey_ParamsDataView() {}

  IDBCallbacks_SuccessKey_ParamsDataView(
      internal::IDBCallbacks_SuccessKey_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCallbacks_SuccessKey_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCallbacks_SuccessInteger_ParamsDataView {
 public:
  IDBCallbacks_SuccessInteger_ParamsDataView() {}

  IDBCallbacks_SuccessInteger_ParamsDataView(
      internal::IDBCallbacks_SuccessInteger_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t value() const {
    return data_->value;
  }
 private:
  internal::IDBCallbacks_SuccessInteger_Params_Data* data_ = nullptr;
};

class IDBCallbacks_Success_ParamsDataView {
 public:
  IDBCallbacks_Success_ParamsDataView() {}

  IDBCallbacks_Success_ParamsDataView(
      internal::IDBCallbacks_Success_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IDBCallbacks_Success_Params_Data* data_ = nullptr;
};

class IDBDatabaseCallbacks_ForcedClose_ParamsDataView {
 public:
  IDBDatabaseCallbacks_ForcedClose_ParamsDataView() {}

  IDBDatabaseCallbacks_ForcedClose_ParamsDataView(
      internal::IDBDatabaseCallbacks_ForcedClose_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IDBDatabaseCallbacks_ForcedClose_Params_Data* data_ = nullptr;
};

class IDBDatabaseCallbacks_VersionChange_ParamsDataView {
 public:
  IDBDatabaseCallbacks_VersionChange_ParamsDataView() {}

  IDBDatabaseCallbacks_VersionChange_ParamsDataView(
      internal::IDBDatabaseCallbacks_VersionChange_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t old_version() const {
    return data_->old_version;
  }
  int64_t new_version() const {
    return data_->new_version;
  }
 private:
  internal::IDBDatabaseCallbacks_VersionChange_Params_Data* data_ = nullptr;
};

class IDBDatabaseCallbacks_Abort_ParamsDataView {
 public:
  IDBDatabaseCallbacks_Abort_ParamsDataView() {}

  IDBDatabaseCallbacks_Abort_ParamsDataView(
      internal::IDBDatabaseCallbacks_Abort_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int32_t code() const {
    return data_->code;
  }
  inline void GetMessageDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBDatabaseCallbacks_Abort_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabaseCallbacks_Complete_ParamsDataView {
 public:
  IDBDatabaseCallbacks_Complete_ParamsDataView() {}

  IDBDatabaseCallbacks_Complete_ParamsDataView(
      internal::IDBDatabaseCallbacks_Complete_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
 private:
  internal::IDBDatabaseCallbacks_Complete_Params_Data* data_ = nullptr;
};

class IDBDatabaseCallbacks_Changes_ParamsDataView {
 public:
  IDBDatabaseCallbacks_Changes_ParamsDataView() {}

  IDBDatabaseCallbacks_Changes_ParamsDataView(
      internal::IDBDatabaseCallbacks_Changes_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetChangesDataView(
      IDBObserverChangesDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadChanges(UserType* output) {
    auto* pointer = data_->changes.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBObserverChangesDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBDatabaseCallbacks_Changes_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCursor_Advance_ParamsDataView {
 public:
  IDBCursor_Advance_ParamsDataView() {}

  IDBCursor_Advance_ParamsDataView(
      internal::IDBCursor_Advance_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t count() const {
    return data_->count;
  }
 private:
  internal::IDBCursor_Advance_Params_Data* data_ = nullptr;
};

class IDBCursor_Advance_ResponseParamsDataView {
 public:
  IDBCursor_Advance_ResponseParamsDataView() {}

  IDBCursor_Advance_ResponseParamsDataView(
      internal::IDBCursor_Advance_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetErrorDataView(
      IDBErrorDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadError(UserType* output) {
    auto* pointer = data_->error.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBErrorDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      IDBCursorValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBCursorValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBCursor_Advance_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCursor_CursorContinue_ParamsDataView {
 public:
  IDBCursor_CursorContinue_ParamsDataView() {}

  IDBCursor_CursorContinue_ParamsDataView(
      internal::IDBCursor_CursorContinue_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetPrimaryKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPrimaryKey(UserType* output) {
    auto* pointer = data_->primary_key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBCursor_CursorContinue_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCursor_Prefetch_ParamsDataView {
 public:
  IDBCursor_Prefetch_ParamsDataView() {}

  IDBCursor_Prefetch_ParamsDataView(
      internal::IDBCursor_Prefetch_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t count() const {
    return data_->count;
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBCursor_Prefetch_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBCursor_PrefetchReset_ParamsDataView {
 public:
  IDBCursor_PrefetchReset_ParamsDataView() {}

  IDBCursor_PrefetchReset_ParamsDataView(
      internal::IDBCursor_PrefetchReset_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t used_prefetches() const {
    return data_->used_prefetches;
  }
  int32_t unused_prefetches() const {
    return data_->unused_prefetches;
  }
 private:
  internal::IDBCursor_PrefetchReset_Params_Data* data_ = nullptr;
};

class IDBDatabase_CreateObjectStore_ParamsDataView {
 public:
  IDBDatabase_CreateObjectStore_ParamsDataView() {}

  IDBDatabase_CreateObjectStore_ParamsDataView(
      internal::IDBDatabase_CreateObjectStore_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetKeyPathDataView(
      IDBKeyPathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyPath(UserType* output) {
    auto* pointer = data_->key_path.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyPathDataView>(
        pointer, output, context_);
  }
  bool auto_increment() const {
    return data_->auto_increment;
  }
 private:
  internal::IDBDatabase_CreateObjectStore_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_DeleteObjectStore_ParamsDataView {
 public:
  IDBDatabase_DeleteObjectStore_ParamsDataView() {}

  IDBDatabase_DeleteObjectStore_ParamsDataView(
      internal::IDBDatabase_DeleteObjectStore_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
 private:
  internal::IDBDatabase_DeleteObjectStore_Params_Data* data_ = nullptr;
};

class IDBDatabase_RenameObjectStore_ParamsDataView {
 public:
  IDBDatabase_RenameObjectStore_ParamsDataView() {}

  IDBDatabase_RenameObjectStore_ParamsDataView(
      internal::IDBDatabase_RenameObjectStore_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  inline void GetNewNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNewName(UserType* output) {
    auto* pointer = data_->new_name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBDatabase_RenameObjectStore_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_CreateTransaction_ParamsDataView {
 public:
  IDBDatabase_CreateTransaction_ParamsDataView() {}

  IDBDatabase_CreateTransaction_ParamsDataView(
      internal::IDBDatabase_CreateTransaction_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  inline void GetObjectStoreIdsDataView(
      mojo::ArrayDataView<int64_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadObjectStoreIds(UserType* output) {
    auto* pointer = data_->object_store_ids.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<int64_t>>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMode(UserType* output) const {
    auto data_value = data_->mode;
    return mojo::internal::Deserialize<::blink::mojom::IDBTransactionMode>(
        data_value, output);
  }

  IDBTransactionMode mode() const {
    return static_cast<IDBTransactionMode>(data_->mode);
  }
 private:
  internal::IDBDatabase_CreateTransaction_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_Close_ParamsDataView {
 public:
  IDBDatabase_Close_ParamsDataView() {}

  IDBDatabase_Close_ParamsDataView(
      internal::IDBDatabase_Close_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IDBDatabase_Close_Params_Data* data_ = nullptr;
};

class IDBDatabase_VersionChangeIgnored_ParamsDataView {
 public:
  IDBDatabase_VersionChangeIgnored_ParamsDataView() {}

  IDBDatabase_VersionChangeIgnored_ParamsDataView(
      internal::IDBDatabase_VersionChangeIgnored_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IDBDatabase_VersionChangeIgnored_Params_Data* data_ = nullptr;
};

class IDBDatabase_AddObserver_ParamsDataView {
 public:
  IDBDatabase_AddObserver_ParamsDataView() {}

  IDBDatabase_AddObserver_ParamsDataView(
      internal::IDBDatabase_AddObserver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int32_t observer_id() const {
    return data_->observer_id;
  }
  bool include_transaction() const {
    return data_->include_transaction;
  }
  bool no_records() const {
    return data_->no_records;
  }
  bool values() const {
    return data_->values;
  }
  uint32_t operation_types() const {
    return data_->operation_types;
  }
 private:
  internal::IDBDatabase_AddObserver_Params_Data* data_ = nullptr;
};

class IDBDatabase_RemoveObservers_ParamsDataView {
 public:
  IDBDatabase_RemoveObservers_ParamsDataView() {}

  IDBDatabase_RemoveObservers_ParamsDataView(
      internal::IDBDatabase_RemoveObservers_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetObserversDataView(
      mojo::ArrayDataView<int32_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadObservers(UserType* output) {
    auto* pointer = data_->observers.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<int32_t>>(
        pointer, output, context_);
  }
 private:
  internal::IDBDatabase_RemoveObservers_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_Get_ParamsDataView {
 public:
  IDBDatabase_Get_ParamsDataView() {}

  IDBDatabase_Get_ParamsDataView(
      internal::IDBDatabase_Get_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  int64_t index_id() const {
    return data_->index_id;
  }
  inline void GetKeyRangeDataView(
      IDBKeyRangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyRange(UserType* output) {
    auto* pointer = data_->key_range.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyRangeDataView>(
        pointer, output, context_);
  }
  bool key_only() const {
    return data_->key_only;
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBDatabase_Get_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_GetAll_ParamsDataView {
 public:
  IDBDatabase_GetAll_ParamsDataView() {}

  IDBDatabase_GetAll_ParamsDataView(
      internal::IDBDatabase_GetAll_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  int64_t index_id() const {
    return data_->index_id;
  }
  inline void GetKeyRangeDataView(
      IDBKeyRangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyRange(UserType* output) {
    auto* pointer = data_->key_range.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyRangeDataView>(
        pointer, output, context_);
  }
  bool key_only() const {
    return data_->key_only;
  }
  int64_t max_count() const {
    return data_->max_count;
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBDatabase_GetAll_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_Put_ParamsDataView {
 public:
  IDBDatabase_Put_ParamsDataView() {}

  IDBDatabase_Put_ParamsDataView(
      internal::IDBDatabase_Put_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  inline void GetValueDataView(
      IDBValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBValueDataView>(
        pointer, output, context_);
  }
  inline void GetKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMode(UserType* output) const {
    auto data_value = data_->mode;
    return mojo::internal::Deserialize<::blink::mojom::IDBPutMode>(
        data_value, output);
  }

  IDBPutMode mode() const {
    return static_cast<IDBPutMode>(data_->mode);
  }
  inline void GetIndexKeysDataView(
      mojo::ArrayDataView<IDBIndexKeysDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIndexKeys(UserType* output) {
    auto* pointer = data_->index_keys.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBIndexKeysDataView>>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBDatabase_Put_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_SetIndexKeys_ParamsDataView {
 public:
  IDBDatabase_SetIndexKeys_ParamsDataView() {}

  IDBDatabase_SetIndexKeys_ParamsDataView(
      internal::IDBDatabase_SetIndexKeys_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  inline void GetPrimaryKeyDataView(
      IDBKeyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPrimaryKey(UserType* output) {
    auto* pointer = data_->primary_key.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyDataView>(
        pointer, output, context_);
  }
  inline void GetIndexKeysDataView(
      mojo::ArrayDataView<IDBIndexKeysDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIndexKeys(UserType* output) {
    auto* pointer = data_->index_keys.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBIndexKeysDataView>>(
        pointer, output, context_);
  }
 private:
  internal::IDBDatabase_SetIndexKeys_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_SetIndexesReady_ParamsDataView {
 public:
  IDBDatabase_SetIndexesReady_ParamsDataView() {}

  IDBDatabase_SetIndexesReady_ParamsDataView(
      internal::IDBDatabase_SetIndexesReady_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  inline void GetIndexIdsDataView(
      mojo::ArrayDataView<int64_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIndexIds(UserType* output) {
    auto* pointer = data_->index_ids.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<int64_t>>(
        pointer, output, context_);
  }
 private:
  internal::IDBDatabase_SetIndexesReady_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_OpenCursor_ParamsDataView {
 public:
  IDBDatabase_OpenCursor_ParamsDataView() {}

  IDBDatabase_OpenCursor_ParamsDataView(
      internal::IDBDatabase_OpenCursor_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  int64_t index_id() const {
    return data_->index_id;
  }
  inline void GetKeyRangeDataView(
      IDBKeyRangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyRange(UserType* output) {
    auto* pointer = data_->key_range.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyRangeDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDirection(UserType* output) const {
    auto data_value = data_->direction;
    return mojo::internal::Deserialize<::blink::mojom::IDBCursorDirection>(
        data_value, output);
  }

  IDBCursorDirection direction() const {
    return static_cast<IDBCursorDirection>(data_->direction);
  }
  bool key_only() const {
    return data_->key_only;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTaskType(UserType* output) const {
    auto data_value = data_->task_type;
    return mojo::internal::Deserialize<::blink::mojom::IDBTaskType>(
        data_value, output);
  }

  IDBTaskType task_type() const {
    return static_cast<IDBTaskType>(data_->task_type);
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBDatabase_OpenCursor_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_Count_ParamsDataView {
 public:
  IDBDatabase_Count_ParamsDataView() {}

  IDBDatabase_Count_ParamsDataView(
      internal::IDBDatabase_Count_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  int64_t index_id() const {
    return data_->index_id;
  }
  inline void GetKeyRangeDataView(
      IDBKeyRangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyRange(UserType* output) {
    auto* pointer = data_->key_range.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyRangeDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBDatabase_Count_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_DeleteRange_ParamsDataView {
 public:
  IDBDatabase_DeleteRange_ParamsDataView() {}

  IDBDatabase_DeleteRange_ParamsDataView(
      internal::IDBDatabase_DeleteRange_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  inline void GetKeyRangeDataView(
      IDBKeyRangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyRange(UserType* output) {
    auto* pointer = data_->key_range.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyRangeDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBDatabase_DeleteRange_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_Clear_ParamsDataView {
 public:
  IDBDatabase_Clear_ParamsDataView() {}

  IDBDatabase_Clear_ParamsDataView(
      internal::IDBDatabase_Clear_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBDatabase_Clear_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_CreateIndex_ParamsDataView {
 public:
  IDBDatabase_CreateIndex_ParamsDataView() {}

  IDBDatabase_CreateIndex_ParamsDataView(
      internal::IDBDatabase_CreateIndex_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  int64_t index_id() const {
    return data_->index_id;
  }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetKeyPathDataView(
      IDBKeyPathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyPath(UserType* output) {
    auto* pointer = data_->key_path.Get();
    return mojo::internal::Deserialize<::blink::mojom::IDBKeyPathDataView>(
        pointer, output, context_);
  }
  bool unique() const {
    return data_->unique;
  }
  bool multi_entry() const {
    return data_->multi_entry;
  }
 private:
  internal::IDBDatabase_CreateIndex_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_DeleteIndex_ParamsDataView {
 public:
  IDBDatabase_DeleteIndex_ParamsDataView() {}

  IDBDatabase_DeleteIndex_ParamsDataView(
      internal::IDBDatabase_DeleteIndex_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  int64_t index_id() const {
    return data_->index_id;
  }
 private:
  internal::IDBDatabase_DeleteIndex_Params_Data* data_ = nullptr;
};

class IDBDatabase_RenameIndex_ParamsDataView {
 public:
  IDBDatabase_RenameIndex_ParamsDataView() {}

  IDBDatabase_RenameIndex_ParamsDataView(
      internal::IDBDatabase_RenameIndex_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t object_store_id() const {
    return data_->object_store_id;
  }
  int64_t index_id() const {
    return data_->index_id;
  }
  inline void GetNewNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNewName(UserType* output) {
    auto* pointer = data_->new_name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::IDBDatabase_RenameIndex_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBDatabase_Abort_ParamsDataView {
 public:
  IDBDatabase_Abort_ParamsDataView() {}

  IDBDatabase_Abort_ParamsDataView(
      internal::IDBDatabase_Abort_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
 private:
  internal::IDBDatabase_Abort_Params_Data* data_ = nullptr;
};

class IDBDatabase_Commit_ParamsDataView {
 public:
  IDBDatabase_Commit_ParamsDataView() {}

  IDBDatabase_Commit_ParamsDataView(
      internal::IDBDatabase_Commit_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
  int64_t num_errors_handled() const {
    return data_->num_errors_handled;
  }
 private:
  internal::IDBDatabase_Commit_Params_Data* data_ = nullptr;
};

class IDBFactory_GetDatabaseInfo_ParamsDataView {
 public:
  IDBFactory_GetDatabaseInfo_ParamsDataView() {}

  IDBFactory_GetDatabaseInfo_ParamsDataView(
      internal::IDBFactory_GetDatabaseInfo_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBFactory_GetDatabaseInfo_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBFactory_GetDatabaseNames_ParamsDataView {
 public:
  IDBFactory_GetDatabaseNames_ParamsDataView() {}

  IDBFactory_GetDatabaseNames_ParamsDataView(
      internal::IDBFactory_GetDatabaseNames_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::IDBFactory_GetDatabaseNames_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBFactory_Open_ParamsDataView {
 public:
  IDBFactory_Open_ParamsDataView() {}

  IDBFactory_Open_ParamsDataView(
      internal::IDBFactory_Open_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeDatabaseCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBDatabaseCallbacksAssociatedPtrInfoDataView>(
            &data_->database_callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  int64_t version() const {
    return data_->version;
  }
  int64_t transaction_id() const {
    return data_->transaction_id;
  }
 private:
  internal::IDBFactory_Open_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBFactory_DeleteDatabase_ParamsDataView {
 public:
  IDBFactory_DeleteDatabase_ParamsDataView() {}

  IDBFactory_DeleteDatabase_ParamsDataView(
      internal::IDBFactory_DeleteDatabase_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeCallbacks() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::IDBCallbacksAssociatedPtrInfoDataView>(
            &data_->callbacks, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetNameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  bool force_close() const {
    return data_->force_close;
  }
 private:
  internal::IDBFactory_DeleteDatabase_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBFactory_AbortTransactionsAndCompactDatabase_ParamsDataView {
 public:
  IDBFactory_AbortTransactionsAndCompactDatabase_ParamsDataView() {}

  IDBFactory_AbortTransactionsAndCompactDatabase_ParamsDataView(
      internal::IDBFactory_AbortTransactionsAndCompactDatabase_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IDBFactory_AbortTransactionsAndCompactDatabase_Params_Data* data_ = nullptr;
};

class IDBFactory_AbortTransactionsAndCompactDatabase_ResponseParamsDataView {
 public:
  IDBFactory_AbortTransactionsAndCompactDatabase_ResponseParamsDataView() {}

  IDBFactory_AbortTransactionsAndCompactDatabase_ResponseParamsDataView(
      internal::IDBFactory_AbortTransactionsAndCompactDatabase_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::IDBStatus>(
        data_value, output);
  }

  IDBStatus status() const {
    return static_cast<IDBStatus>(data_->status);
  }
 private:
  internal::IDBFactory_AbortTransactionsAndCompactDatabase_ResponseParams_Data* data_ = nullptr;
};

class IDBFactory_AbortTransactionsForDatabase_ParamsDataView {
 public:
  IDBFactory_AbortTransactionsForDatabase_ParamsDataView() {}

  IDBFactory_AbortTransactionsForDatabase_ParamsDataView(
      internal::IDBFactory_AbortTransactionsForDatabase_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IDBFactory_AbortTransactionsForDatabase_Params_Data* data_ = nullptr;
};

class IDBFactory_AbortTransactionsForDatabase_ResponseParamsDataView {
 public:
  IDBFactory_AbortTransactionsForDatabase_ResponseParamsDataView() {}

  IDBFactory_AbortTransactionsForDatabase_ResponseParamsDataView(
      internal::IDBFactory_AbortTransactionsForDatabase_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::IDBStatus>(
        data_value, output);
  }

  IDBStatus status() const {
    return static_cast<IDBStatus>(data_->status);
  }
 private:
  internal::IDBFactory_AbortTransactionsForDatabase_ResponseParams_Data* data_ = nullptr;
};

class IDBKeyDataDataView {
 public:
  using Tag = internal::IDBKeyData_Data::IDBKeyData_Tag;

  IDBKeyDataDataView() {}

  IDBKeyDataDataView(
      internal::IDBKeyData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_key_array() const { return data_->tag == Tag::KEY_ARRAY; }
  inline void GetKeyArrayDataView(
      mojo::ArrayDataView<IDBKeyDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyArray(UserType* output) {
    DCHECK(is_key_array());
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::IDBKeyDataView>>(
        data_->data.f_key_array.Get(), output, context_);
  }
  bool is_binary() const { return data_->tag == Tag::BINARY; }
  inline void GetBinaryDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBinary(UserType* output) {
    DCHECK(is_binary());
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        data_->data.f_binary.Get(), output, context_);
  }
  bool is_string() const { return data_->tag == Tag::STRING; }
  inline void GetStringDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadString(UserType* output) {
    DCHECK(is_string());
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        data_->data.f_string.Get(), output, context_);
  }
  bool is_date() const { return data_->tag == Tag::DATE; }
  double date() const {
    DCHECK(is_date());
    return data_->data.f_date;
  }
  bool is_number() const { return data_->tag == Tag::NUMBER; }
  double number() const {
    DCHECK(is_number());
    return data_->data.f_number;
  }
  bool is_other_invalid() const { return data_->tag == Tag::OTHER_INVALID; }
  bool other_invalid() const {
    DCHECK(is_other_invalid());
    return data_->data.f_other_invalid;
  }
  bool is_other_null() const { return data_->tag == Tag::OTHER_NULL; }
  bool other_null() const {
    DCHECK(is_other_null());
    return data_->data.f_other_null;
  }

 private:
  internal::IDBKeyData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IDBKeyPathDataDataView {
 public:
  using Tag = internal::IDBKeyPathData_Data::IDBKeyPathData_Tag;

  IDBKeyPathDataDataView() {}

  IDBKeyPathDataDataView(
      internal::IDBKeyPathData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_string() const { return data_->tag == Tag::STRING; }
  inline void GetStringDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadString(UserType* output) {
    DCHECK(is_string());
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        data_->data.f_string.Get(), output, context_);
  }
  bool is_string_array() const { return data_->tag == Tag::STRING_ARRAY; }
  inline void GetStringArrayDataView(
      mojo::ArrayDataView<::mojo_base::mojom::String16DataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStringArray(UserType* output) {
    DCHECK(is_string_array());
    return mojo::internal::Deserialize<mojo::ArrayDataView<::mojo_base::mojom::String16DataView>>(
        data_->data.f_string_array.Get(), output, context_);
  }

 private:
  internal::IDBKeyPathData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::IDBCursorDirection>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBCursorDirection> {};

template <>
struct hash<::blink::mojom::IDBDataLoss>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBDataLoss> {};

template <>
struct hash<::blink::mojom::IDBKeyType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBKeyType> {};

template <>
struct hash<::blink::mojom::IDBKeyPathType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBKeyPathType> {};

template <>
struct hash<::blink::mojom::IDBOperationType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBOperationType> {};

template <>
struct hash<::blink::mojom::IDBPutMode>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBPutMode> {};

template <>
struct hash<::blink::mojom::IDBTaskType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBTaskType> {};

template <>
struct hash<::blink::mojom::IDBTransactionMode>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBTransactionMode> {};

template <>
struct hash<::blink::mojom::IDBStatus>
    : public mojo::internal::EnumHashImpl<::blink::mojom::IDBStatus> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::blink::mojom::IDBCursorDirection, ::blink::mojom::IDBCursorDirection> {
  static ::blink::mojom::IDBCursorDirection ToMojom(::blink::mojom::IDBCursorDirection input) { return input; }
  static bool FromMojom(::blink::mojom::IDBCursorDirection input, ::blink::mojom::IDBCursorDirection* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBCursorDirection, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBCursorDirection, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBCursorDirection>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::IDBDataLoss, ::blink::mojom::IDBDataLoss> {
  static ::blink::mojom::IDBDataLoss ToMojom(::blink::mojom::IDBDataLoss input) { return input; }
  static bool FromMojom(::blink::mojom::IDBDataLoss input, ::blink::mojom::IDBDataLoss* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBDataLoss, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBDataLoss, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBDataLoss>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::IDBKeyType, ::blink::mojom::IDBKeyType> {
  static ::blink::mojom::IDBKeyType ToMojom(::blink::mojom::IDBKeyType input) { return input; }
  static bool FromMojom(::blink::mojom::IDBKeyType input, ::blink::mojom::IDBKeyType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBKeyType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBKeyType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBKeyType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::IDBKeyPathType, ::blink::mojom::IDBKeyPathType> {
  static ::blink::mojom::IDBKeyPathType ToMojom(::blink::mojom::IDBKeyPathType input) { return input; }
  static bool FromMojom(::blink::mojom::IDBKeyPathType input, ::blink::mojom::IDBKeyPathType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBKeyPathType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBKeyPathType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBKeyPathType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::IDBOperationType, ::blink::mojom::IDBOperationType> {
  static ::blink::mojom::IDBOperationType ToMojom(::blink::mojom::IDBOperationType input) { return input; }
  static bool FromMojom(::blink::mojom::IDBOperationType input, ::blink::mojom::IDBOperationType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBOperationType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBOperationType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBOperationType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::IDBPutMode, ::blink::mojom::IDBPutMode> {
  static ::blink::mojom::IDBPutMode ToMojom(::blink::mojom::IDBPutMode input) { return input; }
  static bool FromMojom(::blink::mojom::IDBPutMode input, ::blink::mojom::IDBPutMode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBPutMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBPutMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBPutMode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::IDBTaskType, ::blink::mojom::IDBTaskType> {
  static ::blink::mojom::IDBTaskType ToMojom(::blink::mojom::IDBTaskType input) { return input; }
  static bool FromMojom(::blink::mojom::IDBTaskType input, ::blink::mojom::IDBTaskType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBTaskType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBTaskType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBTaskType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::IDBTransactionMode, ::blink::mojom::IDBTransactionMode> {
  static ::blink::mojom::IDBTransactionMode ToMojom(::blink::mojom::IDBTransactionMode input) { return input; }
  static bool FromMojom(::blink::mojom::IDBTransactionMode input, ::blink::mojom::IDBTransactionMode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBTransactionMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBTransactionMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBTransactionMode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::IDBStatus, ::blink::mojom::IDBStatus> {
  static ::blink::mojom::IDBStatus ToMojom(::blink::mojom::IDBStatus input) { return input; }
  static bool FromMojom(::blink::mojom::IDBStatus input, ::blink::mojom::IDBStatus* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::IDBStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::IDBStatus>(input), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBKeyDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBKeyDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBKey_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::data, input, custom_context)) in_data = CallWithContext(Traits::data, input, custom_context);
    typename decltype((*output)->data)::BufferWriter data_writer;
    data_writer.AllocateInline(buffer, &(*output)->data);
    mojo::internal::Serialize<::blink::mojom::IDBKeyDataDataView>(
        in_data, buffer, &data_writer, true, context);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->data.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null data in IDBKey struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBKey_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBKeyDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBKeyPathDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBKeyPathDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBKeyPath_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::data, input, custom_context)) in_data = CallWithContext(Traits::data, input, custom_context);
    typename decltype((*output)->data)::BufferWriter data_writer;
    data_writer.AllocateInline(buffer, &(*output)->data);
    mojo::internal::Serialize<::blink::mojom::IDBKeyPathDataDataView>(
        in_data, buffer, &data_writer, true, context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBKeyPath_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBKeyPathDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBKeyRangeDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBKeyRangeDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBKeyRange_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::lower, input, custom_context)) in_lower = CallWithContext(Traits::lower, input, custom_context);
    typename decltype((*output)->lower)::BaseType::BufferWriter
        lower_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyDataView>(
        in_lower, buffer, &lower_writer, context);
    (*output)->lower.Set(
        lower_writer.is_null() ? nullptr : lower_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->lower.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null lower in IDBKeyRange struct");
    decltype(CallWithContext(Traits::upper, input, custom_context)) in_upper = CallWithContext(Traits::upper, input, custom_context);
    typename decltype((*output)->upper)::BaseType::BufferWriter
        upper_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyDataView>(
        in_upper, buffer, &upper_writer, context);
    (*output)->upper.Set(
        upper_writer.is_null() ? nullptr : upper_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->upper.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null upper in IDBKeyRange struct");
    (*output)->lower_open = CallWithContext(Traits::lower_open, input, custom_context);
    (*output)->upper_open = CallWithContext(Traits::upper_open, input, custom_context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBKeyRange_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBKeyRangeDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBIndexMetadataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBIndexMetadataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBIndexMetadata_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->id = CallWithContext(Traits::id, input, custom_context);
    decltype(CallWithContext(Traits::name, input, custom_context)) in_name = CallWithContext(Traits::name, input, custom_context);
    typename decltype((*output)->name)::BaseType::BufferWriter
        name_writer;
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_name, buffer, &name_writer, context);
    (*output)->name.Set(
        name_writer.is_null() ? nullptr : name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in IDBIndexMetadata struct");
    decltype(CallWithContext(Traits::key_path, input, custom_context)) in_key_path = CallWithContext(Traits::key_path, input, custom_context);
    typename decltype((*output)->key_path)::BaseType::BufferWriter
        key_path_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyPathDataView>(
        in_key_path, buffer, &key_path_writer, context);
    (*output)->key_path.Set(
        key_path_writer.is_null() ? nullptr : key_path_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->key_path.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null key_path in IDBIndexMetadata struct");
    (*output)->unique = CallWithContext(Traits::unique, input, custom_context);
    (*output)->multi_entry = CallWithContext(Traits::multi_entry, input, custom_context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBIndexMetadata_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBIndexMetadataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBObjectStoreMetadataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBObjectStoreMetadataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBObjectStoreMetadata_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->id = CallWithContext(Traits::id, input, custom_context);
    decltype(CallWithContext(Traits::name, input, custom_context)) in_name = CallWithContext(Traits::name, input, custom_context);
    typename decltype((*output)->name)::BaseType::BufferWriter
        name_writer;
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_name, buffer, &name_writer, context);
    (*output)->name.Set(
        name_writer.is_null() ? nullptr : name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in IDBObjectStoreMetadata struct");
    decltype(CallWithContext(Traits::key_path, input, custom_context)) in_key_path = CallWithContext(Traits::key_path, input, custom_context);
    typename decltype((*output)->key_path)::BaseType::BufferWriter
        key_path_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyPathDataView>(
        in_key_path, buffer, &key_path_writer, context);
    (*output)->key_path.Set(
        key_path_writer.is_null() ? nullptr : key_path_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->key_path.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null key_path in IDBObjectStoreMetadata struct");
    (*output)->auto_increment = CallWithContext(Traits::auto_increment, input, custom_context);
    (*output)->max_index_id = CallWithContext(Traits::max_index_id, input, custom_context);
    decltype(CallWithContext(Traits::indexes, input, custom_context)) in_indexes = CallWithContext(Traits::indexes, input, custom_context);
    typename decltype((*output)->indexes)::BaseType::BufferWriter
        indexes_writer;
    const mojo::internal::ContainerValidateParams indexes_validate_params(
        new mojo::internal::ContainerValidateParams(0, false, nullptr), new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::MapDataView<int64_t, ::blink::mojom::IDBIndexMetadataDataView>>(
        in_indexes, buffer, &indexes_writer, &indexes_validate_params,
        context);
    (*output)->indexes.Set(
        indexes_writer.is_null() ? nullptr : indexes_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->indexes.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null indexes in IDBObjectStoreMetadata struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBObjectStoreMetadata_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBObjectStoreMetadataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBDatabaseMetadataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBDatabaseMetadataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBDatabaseMetadata_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->id = CallWithContext(Traits::id, input, custom_context);
    decltype(CallWithContext(Traits::name, input, custom_context)) in_name = CallWithContext(Traits::name, input, custom_context);
    typename decltype((*output)->name)::BaseType::BufferWriter
        name_writer;
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_name, buffer, &name_writer, context);
    (*output)->name.Set(
        name_writer.is_null() ? nullptr : name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in IDBDatabaseMetadata struct");
    (*output)->version = CallWithContext(Traits::version, input, custom_context);
    (*output)->max_object_store_id = CallWithContext(Traits::max_object_store_id, input, custom_context);
    decltype(CallWithContext(Traits::object_stores, input, custom_context)) in_object_stores = CallWithContext(Traits::object_stores, input, custom_context);
    typename decltype((*output)->object_stores)::BaseType::BufferWriter
        object_stores_writer;
    const mojo::internal::ContainerValidateParams object_stores_validate_params(
        new mojo::internal::ContainerValidateParams(0, false, nullptr), new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::MapDataView<int64_t, ::blink::mojom::IDBObjectStoreMetadataDataView>>(
        in_object_stores, buffer, &object_stores_writer, &object_stores_validate_params,
        context);
    (*output)->object_stores.Set(
        object_stores_writer.is_null() ? nullptr : object_stores_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->object_stores.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null object_stores in IDBDatabaseMetadata struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBDatabaseMetadata_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBDatabaseMetadataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBNameAndVersionDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBNameAndVersionDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBNameAndVersion_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::name, input, custom_context)) in_name = CallWithContext(Traits::name, input, custom_context);
    typename decltype((*output)->name)::BaseType::BufferWriter
        name_writer;
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_name, buffer, &name_writer, context);
    (*output)->name.Set(
        name_writer.is_null() ? nullptr : name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in IDBNameAndVersion struct");
    (*output)->version = CallWithContext(Traits::version, input, custom_context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBNameAndVersion_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBNameAndVersionDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBIndexKeysDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBIndexKeysDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBIndexKeys_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->index_id = CallWithContext(Traits::index_id, input, custom_context);
    decltype(CallWithContext(Traits::index_keys, input, custom_context)) in_index_keys = CallWithContext(Traits::index_keys, input, custom_context);
    typename decltype((*output)->index_keys)::BaseType::BufferWriter
        index_keys_writer;
    const mojo::internal::ContainerValidateParams index_keys_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::IDBKeyDataView>>(
        in_index_keys, buffer, &index_keys_writer, &index_keys_validate_params,
        context);
    (*output)->index_keys.Set(
        index_keys_writer.is_null() ? nullptr : index_keys_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->index_keys.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null index_keys in IDBIndexKeys struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBIndexKeys_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBIndexKeysDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBFileInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBFileInfoDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBFileInfo_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::path, input, custom_context)) in_path = CallWithContext(Traits::path, input, custom_context);
    typename decltype((*output)->path)::BaseType::BufferWriter
        path_writer;
    mojo::internal::Serialize<::mojo_base::mojom::FilePathDataView>(
        in_path, buffer, &path_writer, context);
    (*output)->path.Set(
        path_writer.is_null() ? nullptr : path_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->path.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null path in IDBFileInfo struct");
    decltype(CallWithContext(Traits::name, input, custom_context)) in_name = CallWithContext(Traits::name, input, custom_context);
    typename decltype((*output)->name)::BaseType::BufferWriter
        name_writer;
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_name, buffer, &name_writer, context);
    (*output)->name.Set(
        name_writer.is_null() ? nullptr : name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in IDBFileInfo struct");
    decltype(CallWithContext(Traits::last_modified, input, custom_context)) in_last_modified = CallWithContext(Traits::last_modified, input, custom_context);
    typename decltype((*output)->last_modified)::BaseType::BufferWriter
        last_modified_writer;
    mojo::internal::Serialize<::mojo_base::mojom::TimeDataView>(
        in_last_modified, buffer, &last_modified_writer, context);
    (*output)->last_modified.Set(
        last_modified_writer.is_null() ? nullptr : last_modified_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->last_modified.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null last_modified in IDBFileInfo struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBFileInfo_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBFileInfoDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBBlobInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBBlobInfoDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBBlobInfo_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::blob, input, custom_context)) in_blob = CallWithContext(Traits::blob, input, custom_context);
    mojo::internal::Serialize<::blink::mojom::BlobPtrDataView>(
        in_blob, &(*output)->blob, context);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid((*output)->blob),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid blob in IDBBlobInfo struct");
    decltype(CallWithContext(Traits::uuid, input, custom_context)) in_uuid = CallWithContext(Traits::uuid, input, custom_context);
    typename decltype((*output)->uuid)::BaseType::BufferWriter
        uuid_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_uuid, buffer, &uuid_writer, context);
    (*output)->uuid.Set(
        uuid_writer.is_null() ? nullptr : uuid_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->uuid.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null uuid in IDBBlobInfo struct");
    decltype(CallWithContext(Traits::mime_type, input, custom_context)) in_mime_type = CallWithContext(Traits::mime_type, input, custom_context);
    typename decltype((*output)->mime_type)::BaseType::BufferWriter
        mime_type_writer;
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_mime_type, buffer, &mime_type_writer, context);
    (*output)->mime_type.Set(
        mime_type_writer.is_null() ? nullptr : mime_type_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->mime_type.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null mime_type in IDBBlobInfo struct");
    (*output)->size = CallWithContext(Traits::size, input, custom_context);
    decltype(CallWithContext(Traits::file, input, custom_context)) in_file = CallWithContext(Traits::file, input, custom_context);
    typename decltype((*output)->file)::BaseType::BufferWriter
        file_writer;
    mojo::internal::Serialize<::blink::mojom::IDBFileInfoDataView>(
        in_file, buffer, &file_writer, context);
    (*output)->file.Set(
        file_writer.is_null() ? nullptr : file_writer.data());
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBBlobInfo_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBBlobInfoDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBValueDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBValueDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBValue_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::bits, input, custom_context)) in_bits = CallWithContext(Traits::bits, input, custom_context);
    typename decltype((*output)->bits)::BaseType::BufferWriter
        bits_writer;
    const mojo::internal::ContainerValidateParams bits_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
        in_bits, buffer, &bits_writer, &bits_validate_params,
        context);
    (*output)->bits.Set(
        bits_writer.is_null() ? nullptr : bits_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->bits.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null bits in IDBValue struct");
    decltype(CallWithContext(Traits::blob_or_file_info, input, custom_context)) in_blob_or_file_info = CallWithContext(Traits::blob_or_file_info, input, custom_context);
    typename decltype((*output)->blob_or_file_info)::BaseType::BufferWriter
        blob_or_file_info_writer;
    const mojo::internal::ContainerValidateParams blob_or_file_info_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::IDBBlobInfoDataView>>(
        in_blob_or_file_info, buffer, &blob_or_file_info_writer, &blob_or_file_info_validate_params,
        context);
    (*output)->blob_or_file_info.Set(
        blob_or_file_info_writer.is_null() ? nullptr : blob_or_file_info_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->blob_or_file_info.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null blob_or_file_info in IDBValue struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBValue_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBValueDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBReturnValueDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBReturnValueDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBReturnValue_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::value, input, custom_context)) in_value = CallWithContext(Traits::value, input, custom_context);
    typename decltype((*output)->value)::BaseType::BufferWriter
        value_writer;
    mojo::internal::Serialize<::blink::mojom::IDBValueDataView>(
        in_value, buffer, &value_writer, context);
    (*output)->value.Set(
        value_writer.is_null() ? nullptr : value_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->value.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null value in IDBReturnValue struct");
    decltype(CallWithContext(Traits::primary_key, input, custom_context)) in_primary_key = CallWithContext(Traits::primary_key, input, custom_context);
    typename decltype((*output)->primary_key)::BaseType::BufferWriter
        primary_key_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyDataView>(
        in_primary_key, buffer, &primary_key_writer, context);
    (*output)->primary_key.Set(
        primary_key_writer.is_null() ? nullptr : primary_key_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->primary_key.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null primary_key in IDBReturnValue struct");
    decltype(CallWithContext(Traits::key_path, input, custom_context)) in_key_path = CallWithContext(Traits::key_path, input, custom_context);
    typename decltype((*output)->key_path)::BaseType::BufferWriter
        key_path_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyPathDataView>(
        in_key_path, buffer, &key_path_writer, context);
    (*output)->key_path.Set(
        key_path_writer.is_null() ? nullptr : key_path_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->key_path.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null key_path in IDBReturnValue struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBReturnValue_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBReturnValueDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBObservationDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBObservationDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBObservation_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->object_store_id = CallWithContext(Traits::object_store_id, input, custom_context);
    mojo::internal::Serialize<::blink::mojom::IDBOperationType>(
        CallWithContext(Traits::type, input, custom_context), &(*output)->type);
    decltype(CallWithContext(Traits::key_range, input, custom_context)) in_key_range = CallWithContext(Traits::key_range, input, custom_context);
    typename decltype((*output)->key_range)::BaseType::BufferWriter
        key_range_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyRangeDataView>(
        in_key_range, buffer, &key_range_writer, context);
    (*output)->key_range.Set(
        key_range_writer.is_null() ? nullptr : key_range_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->key_range.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null key_range in IDBObservation struct");
    decltype(CallWithContext(Traits::value, input, custom_context)) in_value = CallWithContext(Traits::value, input, custom_context);
    typename decltype((*output)->value)::BaseType::BufferWriter
        value_writer;
    mojo::internal::Serialize<::blink::mojom::IDBValueDataView>(
        in_value, buffer, &value_writer, context);
    (*output)->value.Set(
        value_writer.is_null() ? nullptr : value_writer.data());
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBObservation_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBObservationDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBObserverTransactionDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBObserverTransactionDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBObserverTransaction_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->id = CallWithContext(Traits::id, input, custom_context);
    decltype(CallWithContext(Traits::scope, input, custom_context)) in_scope = CallWithContext(Traits::scope, input, custom_context);
    typename decltype((*output)->scope)::BaseType::BufferWriter
        scope_writer;
    const mojo::internal::ContainerValidateParams scope_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<int64_t>>(
        in_scope, buffer, &scope_writer, &scope_validate_params,
        context);
    (*output)->scope.Set(
        scope_writer.is_null() ? nullptr : scope_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->scope.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null scope in IDBObserverTransaction struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBObserverTransaction_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBObserverTransactionDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBObserverChangesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBObserverChangesDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBObserverChanges_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::observation_index_map, input, custom_context)) in_observation_index_map = CallWithContext(Traits::observation_index_map, input, custom_context);
    typename decltype((*output)->observation_index_map)::BaseType::BufferWriter
        observation_index_map_writer;
    const mojo::internal::ContainerValidateParams observation_index_map_validate_params(
        new mojo::internal::ContainerValidateParams(0, false, nullptr), new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)));
    mojo::internal::Serialize<mojo::MapDataView<int32_t, mojo::ArrayDataView<int32_t>>>(
        in_observation_index_map, buffer, &observation_index_map_writer, &observation_index_map_validate_params,
        context);
    (*output)->observation_index_map.Set(
        observation_index_map_writer.is_null() ? nullptr : observation_index_map_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->observation_index_map.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null observation_index_map in IDBObserverChanges struct");
    decltype(CallWithContext(Traits::transaction_map, input, custom_context)) in_transaction_map = CallWithContext(Traits::transaction_map, input, custom_context);
    typename decltype((*output)->transaction_map)::BaseType::BufferWriter
        transaction_map_writer;
    const mojo::internal::ContainerValidateParams transaction_map_validate_params(
        new mojo::internal::ContainerValidateParams(0, false, nullptr), new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::MapDataView<int32_t, ::blink::mojom::IDBObserverTransactionDataView>>(
        in_transaction_map, buffer, &transaction_map_writer, &transaction_map_validate_params,
        context);
    (*output)->transaction_map.Set(
        transaction_map_writer.is_null() ? nullptr : transaction_map_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->transaction_map.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null transaction_map in IDBObserverChanges struct");
    decltype(CallWithContext(Traits::observations, input, custom_context)) in_observations = CallWithContext(Traits::observations, input, custom_context);
    typename decltype((*output)->observations)::BaseType::BufferWriter
        observations_writer;
    const mojo::internal::ContainerValidateParams observations_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::IDBObservationDataView>>(
        in_observations, buffer, &observations_writer, &observations_validate_params,
        context);
    (*output)->observations.Set(
        observations_writer.is_null() ? nullptr : observations_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->observations.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null observations in IDBObserverChanges struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBObserverChanges_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBObserverChangesDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBErrorDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBErrorDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBError_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->error_code = CallWithContext(Traits::error_code, input, custom_context);
    decltype(CallWithContext(Traits::error_message, input, custom_context)) in_error_message = CallWithContext(Traits::error_message, input, custom_context);
    typename decltype((*output)->error_message)::BaseType::BufferWriter
        error_message_writer;
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_error_message, buffer, &error_message_writer, context);
    (*output)->error_message.Set(
        error_message_writer.is_null() ? nullptr : error_message_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->error_message.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null error_message in IDBError struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBError_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBErrorDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBCursorValueDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::IDBCursorValueDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBCursorValue_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::key, input, custom_context)) in_key = CallWithContext(Traits::key, input, custom_context);
    typename decltype((*output)->key)::BaseType::BufferWriter
        key_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyDataView>(
        in_key, buffer, &key_writer, context);
    (*output)->key.Set(
        key_writer.is_null() ? nullptr : key_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->key.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null key in IDBCursorValue struct");
    decltype(CallWithContext(Traits::primary_key, input, custom_context)) in_primary_key = CallWithContext(Traits::primary_key, input, custom_context);
    typename decltype((*output)->primary_key)::BaseType::BufferWriter
        primary_key_writer;
    mojo::internal::Serialize<::blink::mojom::IDBKeyDataView>(
        in_primary_key, buffer, &primary_key_writer, context);
    (*output)->primary_key.Set(
        primary_key_writer.is_null() ? nullptr : primary_key_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->primary_key.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null primary_key in IDBCursorValue struct");
    decltype(CallWithContext(Traits::value, input, custom_context)) in_value = CallWithContext(Traits::value, input, custom_context);
    typename decltype((*output)->value)::BaseType::BufferWriter
        value_writer;
    mojo::internal::Serialize<::blink::mojom::IDBValueDataView>(
        in_value, buffer, &value_writer, context);
    (*output)->value.Set(
        value_writer.is_null() ? nullptr : value_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->value.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null value in IDBCursorValue struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBCursorValue_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBCursorValueDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBKeyDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::blink::mojom::IDBKeyDataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBKeyData_Data::BufferWriter* writer,
                        bool inlined,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
         writer->data()->set_null();
      return;
    }
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);

    if (!inlined)
      writer->Allocate(buffer);

    ::blink::mojom::internal::IDBKeyData_Data::BufferWriter& result = *writer;
    ALLOW_UNUSED_LOCAL(result);
    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    result->size = kUnionDataSize;
    result->tag = CallWithContext(Traits::GetTag, input, custom_context);
    switch (result->tag) {
      case ::blink::mojom::IDBKeyDataDataView::Tag::KEY_ARRAY: {
        decltype(CallWithContext(Traits::key_array, input, custom_context))
            in_key_array = CallWithContext(Traits::key_array, input,
                                          custom_context);
        typename decltype(result->data.f_key_array)::BaseType::BufferWriter
            value_writer;
        const ContainerValidateParams key_array_validate_params(
            0, false, nullptr);
        mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::IDBKeyDataView>>(
            in_key_array, buffer, &value_writer, &key_array_validate_params,
            context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null key_array in IDBKeyData union");
        result->data.f_key_array.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
      case ::blink::mojom::IDBKeyDataDataView::Tag::BINARY: {
        decltype(CallWithContext(Traits::binary, input, custom_context))
            in_binary = CallWithContext(Traits::binary, input,
                                          custom_context);
        typename decltype(result->data.f_binary)::BaseType::BufferWriter
            value_writer;
        const ContainerValidateParams binary_validate_params(
            0, false, nullptr);
        mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
            in_binary, buffer, &value_writer, &binary_validate_params,
            context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null binary in IDBKeyData union");
        result->data.f_binary.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
      case ::blink::mojom::IDBKeyDataDataView::Tag::STRING: {
        decltype(CallWithContext(Traits::string, input, custom_context))
            in_string = CallWithContext(Traits::string, input,
                                          custom_context);
        typename decltype(result->data.f_string)::BaseType::BufferWriter
            value_writer;
        mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
            in_string, buffer, &value_writer, context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null string in IDBKeyData union");
        result->data.f_string.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
      case ::blink::mojom::IDBKeyDataDataView::Tag::DATE: {
        decltype(CallWithContext(Traits::date, input, custom_context))
            in_date = CallWithContext(Traits::date, input,
                                          custom_context);
        result->data.f_date = in_date;
        break;
      }
      case ::blink::mojom::IDBKeyDataDataView::Tag::NUMBER: {
        decltype(CallWithContext(Traits::number, input, custom_context))
            in_number = CallWithContext(Traits::number, input,
                                          custom_context);
        result->data.f_number = in_number;
        break;
      }
      case ::blink::mojom::IDBKeyDataDataView::Tag::OTHER_INVALID: {
        decltype(CallWithContext(Traits::other_invalid, input, custom_context))
            in_other_invalid = CallWithContext(Traits::other_invalid, input,
                                          custom_context);
        result->data.f_other_invalid = in_other_invalid;
        break;
      }
      case ::blink::mojom::IDBKeyDataDataView::Tag::OTHER_NULL: {
        decltype(CallWithContext(Traits::other_null, input, custom_context))
            in_other_null = CallWithContext(Traits::other_null, input,
                                          custom_context);
        result->data.f_other_null = in_other_null;
        break;
      }
    }

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBKeyData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBKeyDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::IDBKeyPathDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::blink::mojom::IDBKeyPathDataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::IDBKeyPathData_Data::BufferWriter* writer,
                        bool inlined,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
         writer->data()->set_null();
      return;
    }
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);

    if (!inlined)
      writer->Allocate(buffer);

    ::blink::mojom::internal::IDBKeyPathData_Data::BufferWriter& result = *writer;
    ALLOW_UNUSED_LOCAL(result);
    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    result->size = kUnionDataSize;
    result->tag = CallWithContext(Traits::GetTag, input, custom_context);
    switch (result->tag) {
      case ::blink::mojom::IDBKeyPathDataDataView::Tag::STRING: {
        decltype(CallWithContext(Traits::string, input, custom_context))
            in_string = CallWithContext(Traits::string, input,
                                          custom_context);
        typename decltype(result->data.f_string)::BaseType::BufferWriter
            value_writer;
        mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
            in_string, buffer, &value_writer, context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null string in IDBKeyPathData union");
        result->data.f_string.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
      case ::blink::mojom::IDBKeyPathDataDataView::Tag::STRING_ARRAY: {
        decltype(CallWithContext(Traits::string_array, input, custom_context))
            in_string_array = CallWithContext(Traits::string_array, input,
                                          custom_context);
        typename decltype(result->data.f_string_array)::BaseType::BufferWriter
            value_writer;
        const ContainerValidateParams string_array_validate_params(
            0, false, nullptr);
        mojo::internal::Serialize<mojo::ArrayDataView<::mojo_base::mojom::String16DataView>>(
            in_string_array, buffer, &value_writer, &string_array_validate_params,
            context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null string_array in IDBKeyPathData union");
        result->data.f_string_array.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
    }

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::IDBKeyPathData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::IDBKeyPathDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void IDBKeyDataView::GetDataDataView(
    IDBKeyDataDataView* output) {
  auto pointer = &data_->data;
  *output = IDBKeyDataDataView(pointer, context_);
}


inline void IDBKeyPathDataView::GetDataDataView(
    IDBKeyPathDataDataView* output) {
  auto pointer = &data_->data;
  *output = IDBKeyPathDataDataView(pointer, context_);
}


inline void IDBKeyRangeDataView::GetLowerDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->lower.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBKeyRangeDataView::GetUpperDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->upper.Get();
  *output = IDBKeyDataView(pointer, context_);
}


inline void IDBIndexMetadataDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void IDBIndexMetadataDataView::GetKeyPathDataView(
    IDBKeyPathDataView* output) {
  auto pointer = data_->key_path.Get();
  *output = IDBKeyPathDataView(pointer, context_);
}


inline void IDBObjectStoreMetadataDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void IDBObjectStoreMetadataDataView::GetKeyPathDataView(
    IDBKeyPathDataView* output) {
  auto pointer = data_->key_path.Get();
  *output = IDBKeyPathDataView(pointer, context_);
}
inline void IDBObjectStoreMetadataDataView::GetIndexesDataView(
    mojo::MapDataView<int64_t, IDBIndexMetadataDataView>* output) {
  auto pointer = data_->indexes.Get();
  *output = mojo::MapDataView<int64_t, IDBIndexMetadataDataView>(pointer, context_);
}


inline void IDBDatabaseMetadataDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void IDBDatabaseMetadataDataView::GetObjectStoresDataView(
    mojo::MapDataView<int64_t, IDBObjectStoreMetadataDataView>* output) {
  auto pointer = data_->object_stores.Get();
  *output = mojo::MapDataView<int64_t, IDBObjectStoreMetadataDataView>(pointer, context_);
}


inline void IDBNameAndVersionDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void IDBIndexKeysDataView::GetIndexKeysDataView(
    mojo::ArrayDataView<IDBKeyDataView>* output) {
  auto pointer = data_->index_keys.Get();
  *output = mojo::ArrayDataView<IDBKeyDataView>(pointer, context_);
}


inline void IDBFileInfoDataView::GetPathDataView(
    ::mojo_base::mojom::FilePathDataView* output) {
  auto pointer = data_->path.Get();
  *output = ::mojo_base::mojom::FilePathDataView(pointer, context_);
}
inline void IDBFileInfoDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void IDBFileInfoDataView::GetLastModifiedDataView(
    ::mojo_base::mojom::TimeDataView* output) {
  auto pointer = data_->last_modified.Get();
  *output = ::mojo_base::mojom::TimeDataView(pointer, context_);
}


inline void IDBBlobInfoDataView::GetUuidDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->uuid.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void IDBBlobInfoDataView::GetMimeTypeDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->mime_type.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void IDBBlobInfoDataView::GetFileDataView(
    IDBFileInfoDataView* output) {
  auto pointer = data_->file.Get();
  *output = IDBFileInfoDataView(pointer, context_);
}


inline void IDBValueDataView::GetBitsDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->bits.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}
inline void IDBValueDataView::GetBlobOrFileInfoDataView(
    mojo::ArrayDataView<IDBBlobInfoDataView>* output) {
  auto pointer = data_->blob_or_file_info.Get();
  *output = mojo::ArrayDataView<IDBBlobInfoDataView>(pointer, context_);
}


inline void IDBReturnValueDataView::GetValueDataView(
    IDBValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = IDBValueDataView(pointer, context_);
}
inline void IDBReturnValueDataView::GetPrimaryKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->primary_key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBReturnValueDataView::GetKeyPathDataView(
    IDBKeyPathDataView* output) {
  auto pointer = data_->key_path.Get();
  *output = IDBKeyPathDataView(pointer, context_);
}


inline void IDBObservationDataView::GetKeyRangeDataView(
    IDBKeyRangeDataView* output) {
  auto pointer = data_->key_range.Get();
  *output = IDBKeyRangeDataView(pointer, context_);
}
inline void IDBObservationDataView::GetValueDataView(
    IDBValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = IDBValueDataView(pointer, context_);
}


inline void IDBObserverTransactionDataView::GetScopeDataView(
    mojo::ArrayDataView<int64_t>* output) {
  auto pointer = data_->scope.Get();
  *output = mojo::ArrayDataView<int64_t>(pointer, context_);
}


inline void IDBObserverChangesDataView::GetObservationIndexMapDataView(
    mojo::MapDataView<int32_t, mojo::ArrayDataView<int32_t>>* output) {
  auto pointer = data_->observation_index_map.Get();
  *output = mojo::MapDataView<int32_t, mojo::ArrayDataView<int32_t>>(pointer, context_);
}
inline void IDBObserverChangesDataView::GetTransactionMapDataView(
    mojo::MapDataView<int32_t, IDBObserverTransactionDataView>* output) {
  auto pointer = data_->transaction_map.Get();
  *output = mojo::MapDataView<int32_t, IDBObserverTransactionDataView>(pointer, context_);
}
inline void IDBObserverChangesDataView::GetObservationsDataView(
    mojo::ArrayDataView<IDBObservationDataView>* output) {
  auto pointer = data_->observations.Get();
  *output = mojo::ArrayDataView<IDBObservationDataView>(pointer, context_);
}


inline void IDBErrorDataView::GetErrorMessageDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->error_message.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void IDBCursorValueDataView::GetKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBCursorValueDataView::GetPrimaryKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->primary_key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBCursorValueDataView::GetValueDataView(
    IDBValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = IDBValueDataView(pointer, context_);
}


inline void IDBCallbacks_Error_ParamsDataView::GetMessageDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->message.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void IDBCallbacks_SuccessNamesAndVersionsList_ParamsDataView::GetValueDataView(
    mojo::ArrayDataView<IDBNameAndVersionDataView>* output) {
  auto pointer = data_->value.Get();
  *output = mojo::ArrayDataView<IDBNameAndVersionDataView>(pointer, context_);
}


inline void IDBCallbacks_SuccessStringList_ParamsDataView::GetValueDataView(
    mojo::ArrayDataView<::mojo_base::mojom::String16DataView>* output) {
  auto pointer = data_->value.Get();
  *output = mojo::ArrayDataView<::mojo_base::mojom::String16DataView>(pointer, context_);
}




inline void IDBCallbacks_UpgradeNeeded_ParamsDataView::GetDataLossMessageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->data_loss_message.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void IDBCallbacks_UpgradeNeeded_ParamsDataView::GetDbMetadataDataView(
    IDBDatabaseMetadataDataView* output) {
  auto pointer = data_->db_metadata.Get();
  *output = IDBDatabaseMetadataDataView(pointer, context_);
}


inline void IDBCallbacks_SuccessDatabase_ParamsDataView::GetMetadataDataView(
    IDBDatabaseMetadataDataView* output) {
  auto pointer = data_->metadata.Get();
  *output = IDBDatabaseMetadataDataView(pointer, context_);
}


inline void IDBCallbacks_SuccessCursor_ParamsDataView::GetKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBCallbacks_SuccessCursor_ParamsDataView::GetPrimaryKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->primary_key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBCallbacks_SuccessCursor_ParamsDataView::GetValueDataView(
    IDBValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = IDBValueDataView(pointer, context_);
}


inline void IDBCallbacks_SuccessValue_ParamsDataView::GetValueDataView(
    IDBReturnValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = IDBReturnValueDataView(pointer, context_);
}


inline void IDBCallbacks_SuccessCursorContinue_ParamsDataView::GetKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBCallbacks_SuccessCursorContinue_ParamsDataView::GetPrimaryKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->primary_key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBCallbacks_SuccessCursorContinue_ParamsDataView::GetValueDataView(
    IDBValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = IDBValueDataView(pointer, context_);
}


inline void IDBCallbacks_SuccessCursorPrefetch_ParamsDataView::GetKeysDataView(
    mojo::ArrayDataView<IDBKeyDataView>* output) {
  auto pointer = data_->keys.Get();
  *output = mojo::ArrayDataView<IDBKeyDataView>(pointer, context_);
}
inline void IDBCallbacks_SuccessCursorPrefetch_ParamsDataView::GetPrimaryKeysDataView(
    mojo::ArrayDataView<IDBKeyDataView>* output) {
  auto pointer = data_->primary_keys.Get();
  *output = mojo::ArrayDataView<IDBKeyDataView>(pointer, context_);
}
inline void IDBCallbacks_SuccessCursorPrefetch_ParamsDataView::GetValuesDataView(
    mojo::ArrayDataView<IDBValueDataView>* output) {
  auto pointer = data_->values.Get();
  *output = mojo::ArrayDataView<IDBValueDataView>(pointer, context_);
}


inline void IDBCallbacks_SuccessArray_ParamsDataView::GetValuesDataView(
    mojo::ArrayDataView<IDBReturnValueDataView>* output) {
  auto pointer = data_->values.Get();
  *output = mojo::ArrayDataView<IDBReturnValueDataView>(pointer, context_);
}


inline void IDBCallbacks_SuccessKey_ParamsDataView::GetKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->key.Get();
  *output = IDBKeyDataView(pointer, context_);
}










inline void IDBDatabaseCallbacks_Abort_ParamsDataView::GetMessageDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->message.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}




inline void IDBDatabaseCallbacks_Changes_ParamsDataView::GetChangesDataView(
    IDBObserverChangesDataView* output) {
  auto pointer = data_->changes.Get();
  *output = IDBObserverChangesDataView(pointer, context_);
}




inline void IDBCursor_Advance_ResponseParamsDataView::GetErrorDataView(
    IDBErrorDataView* output) {
  auto pointer = data_->error.Get();
  *output = IDBErrorDataView(pointer, context_);
}
inline void IDBCursor_Advance_ResponseParamsDataView::GetValueDataView(
    IDBCursorValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = IDBCursorValueDataView(pointer, context_);
}


inline void IDBCursor_CursorContinue_ParamsDataView::GetKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBCursor_CursorContinue_ParamsDataView::GetPrimaryKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->primary_key.Get();
  *output = IDBKeyDataView(pointer, context_);
}






inline void IDBDatabase_CreateObjectStore_ParamsDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void IDBDatabase_CreateObjectStore_ParamsDataView::GetKeyPathDataView(
    IDBKeyPathDataView* output) {
  auto pointer = data_->key_path.Get();
  *output = IDBKeyPathDataView(pointer, context_);
}




inline void IDBDatabase_RenameObjectStore_ParamsDataView::GetNewNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->new_name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void IDBDatabase_CreateTransaction_ParamsDataView::GetObjectStoreIdsDataView(
    mojo::ArrayDataView<int64_t>* output) {
  auto pointer = data_->object_store_ids.Get();
  *output = mojo::ArrayDataView<int64_t>(pointer, context_);
}








inline void IDBDatabase_RemoveObservers_ParamsDataView::GetObserversDataView(
    mojo::ArrayDataView<int32_t>* output) {
  auto pointer = data_->observers.Get();
  *output = mojo::ArrayDataView<int32_t>(pointer, context_);
}


inline void IDBDatabase_Get_ParamsDataView::GetKeyRangeDataView(
    IDBKeyRangeDataView* output) {
  auto pointer = data_->key_range.Get();
  *output = IDBKeyRangeDataView(pointer, context_);
}


inline void IDBDatabase_GetAll_ParamsDataView::GetKeyRangeDataView(
    IDBKeyRangeDataView* output) {
  auto pointer = data_->key_range.Get();
  *output = IDBKeyRangeDataView(pointer, context_);
}


inline void IDBDatabase_Put_ParamsDataView::GetValueDataView(
    IDBValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = IDBValueDataView(pointer, context_);
}
inline void IDBDatabase_Put_ParamsDataView::GetKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBDatabase_Put_ParamsDataView::GetIndexKeysDataView(
    mojo::ArrayDataView<IDBIndexKeysDataView>* output) {
  auto pointer = data_->index_keys.Get();
  *output = mojo::ArrayDataView<IDBIndexKeysDataView>(pointer, context_);
}


inline void IDBDatabase_SetIndexKeys_ParamsDataView::GetPrimaryKeyDataView(
    IDBKeyDataView* output) {
  auto pointer = data_->primary_key.Get();
  *output = IDBKeyDataView(pointer, context_);
}
inline void IDBDatabase_SetIndexKeys_ParamsDataView::GetIndexKeysDataView(
    mojo::ArrayDataView<IDBIndexKeysDataView>* output) {
  auto pointer = data_->index_keys.Get();
  *output = mojo::ArrayDataView<IDBIndexKeysDataView>(pointer, context_);
}


inline void IDBDatabase_SetIndexesReady_ParamsDataView::GetIndexIdsDataView(
    mojo::ArrayDataView<int64_t>* output) {
  auto pointer = data_->index_ids.Get();
  *output = mojo::ArrayDataView<int64_t>(pointer, context_);
}


inline void IDBDatabase_OpenCursor_ParamsDataView::GetKeyRangeDataView(
    IDBKeyRangeDataView* output) {
  auto pointer = data_->key_range.Get();
  *output = IDBKeyRangeDataView(pointer, context_);
}


inline void IDBDatabase_Count_ParamsDataView::GetKeyRangeDataView(
    IDBKeyRangeDataView* output) {
  auto pointer = data_->key_range.Get();
  *output = IDBKeyRangeDataView(pointer, context_);
}


inline void IDBDatabase_DeleteRange_ParamsDataView::GetKeyRangeDataView(
    IDBKeyRangeDataView* output) {
  auto pointer = data_->key_range.Get();
  *output = IDBKeyRangeDataView(pointer, context_);
}




inline void IDBDatabase_CreateIndex_ParamsDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void IDBDatabase_CreateIndex_ParamsDataView::GetKeyPathDataView(
    IDBKeyPathDataView* output) {
  auto pointer = data_->key_path.Get();
  *output = IDBKeyPathDataView(pointer, context_);
}




inline void IDBDatabase_RenameIndex_ParamsDataView::GetNewNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->new_name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}










inline void IDBFactory_Open_ParamsDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void IDBFactory_DeleteDatabase_ParamsDataView::GetNameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->name.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}










inline void IDBKeyDataDataView::GetKeyArrayDataView(
    mojo::ArrayDataView<IDBKeyDataView>* output) {
  DCHECK(is_key_array());
  *output = mojo::ArrayDataView<IDBKeyDataView>(data_->data.f_key_array.Get(), context_);
}
inline void IDBKeyDataDataView::GetBinaryDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  DCHECK(is_binary());
  *output = mojo::ArrayDataView<uint8_t>(data_->data.f_binary.Get(), context_);
}
inline void IDBKeyDataDataView::GetStringDataView(
    ::mojo_base::mojom::String16DataView* output) {
  DCHECK(is_string());
  *output = ::mojo_base::mojom::String16DataView(data_->data.f_string.Get(), context_);
}

inline void IDBKeyPathDataDataView::GetStringDataView(
    ::mojo_base::mojom::String16DataView* output) {
  DCHECK(is_string());
  *output = ::mojo_base::mojom::String16DataView(data_->data.f_string.Get(), context_);
}
inline void IDBKeyPathDataDataView::GetStringArrayDataView(
    mojo::ArrayDataView<::mojo_base::mojom::String16DataView>* output) {
  DCHECK(is_string_array());
  *output = mojo::ArrayDataView<::mojo_base::mojom::String16DataView>(data_->data.f_string_array.Get(), context_);
}


}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_INDEXEDDB_INDEXEDDB_MOJOM_SHARED_H_