// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "third_party/blink/public/mojom/portal/portal.mojom-blink-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PORTAL_PORTAL_MOJOM_BLINK_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PORTAL_PORTAL_MOJOM_BLINK_JUMBO_H_
#include "third_party/blink/renderer/platform/mojo/kurl_struct_traits.h"
#endif


namespace blink {
namespace mojom {
namespace blink {


void PortalInterceptorForTesting::Navigate(const ::blink::KURL& url) {
  GetForwardingInterface()->Navigate(std::move(url));
}
void PortalInterceptorForTesting::Activate(ActivateCallback callback) {
  GetForwardingInterface()->Activate(std::move(callback));
}
PortalAsyncWaiter::PortalAsyncWaiter(
    Portal* proxy) : proxy_(proxy) {}

PortalAsyncWaiter::~PortalAsyncWaiter() = default;

void PortalAsyncWaiter::Activate(
    PortalActivationStatus* out_result) {
  base::RunLoop loop;
  proxy_->Activate(
      base::BindOnce(
          [](base::RunLoop* loop,
             PortalActivationStatus* out_result
,
             PortalActivationStatus result) {*out_result = std::move(result);
            loop->Quit();
          },
          &loop,
          out_result));
  loop.Run();
}





}  // namespace blink
}  // namespace mojom
}  // namespace blink

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif