// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PORTAL_PORTAL_MOJOM_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PORTAL_PORTAL_MOJOM_TEST_UTILS_H_

#include "third_party/blink/public/mojom/portal/portal.mojom.h"
#include "third_party/blink/public/common/common_export.h"


namespace blink {
namespace mojom {


class BLINK_COMMON_EXPORT PortalInterceptorForTesting : public Portal {
  virtual Portal* GetForwardingInterface() = 0;
  void Navigate(const GURL& url) override;
  void Activate(ActivateCallback callback) override;
};
class BLINK_COMMON_EXPORT PortalAsyncWaiter {
 public:
  explicit PortalAsyncWaiter(Portal* proxy);
  ~PortalAsyncWaiter();
  void Activate(
      PortalActivationStatus* out_result);

 private:
  Portal* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PortalAsyncWaiter);
};




}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PORTAL_PORTAL_MOJOM_TEST_UTILS_H_