// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERIAL_SERIAL_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERIAL_SERIAL_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class SerialPortInfo_Data;
class SerialPortFilter_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SerialPortInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SerialPortInfo_Data));
      new (data()) SerialPortInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SerialPortInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SerialPortInfo_Data>(index_);
    }
    SerialPortInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> token;
  uint32_t vendor_id;
  uint8_t has_vendor_id : 1;
  uint8_t has_product_id : 1;
  uint8_t pad3_[1];
  uint16_t product_id;

 private:
  SerialPortInfo_Data();
  ~SerialPortInfo_Data() = delete;
};
static_assert(sizeof(SerialPortInfo_Data) == 24,
              "Bad sizeof(SerialPortInfo_Data)");
// Used by SerialPortInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SerialPortInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SerialPortInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SerialPortInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    SerialPortInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SerialPortInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SerialPortFilter_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SerialPortFilter_Data));
      new (data()) SerialPortFilter_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SerialPortFilter_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SerialPortFilter_Data>(index_);
    }
    SerialPortFilter_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t vendor_id;
  uint8_t has_vendor_id : 1;
  uint8_t has_product_id : 1;
  uint8_t pad2_[1];
  uint16_t product_id;

 private:
  SerialPortFilter_Data();
  ~SerialPortFilter_Data() = delete;
};
static_assert(sizeof(SerialPortFilter_Data) == 16,
              "Bad sizeof(SerialPortFilter_Data)");
// Used by SerialPortFilter::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SerialPortFilter_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SerialPortFilter_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SerialPortFilter_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    SerialPortFilter_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SerialPortFilter_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SerialService_GetPorts_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SerialService_GetPorts_Params_Data));
      new (data()) SerialService_GetPorts_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SerialService_GetPorts_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SerialService_GetPorts_Params_Data>(index_);
    }
    SerialService_GetPorts_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  SerialService_GetPorts_Params_Data();
  ~SerialService_GetPorts_Params_Data() = delete;
};
static_assert(sizeof(SerialService_GetPorts_Params_Data) == 8,
              "Bad sizeof(SerialService_GetPorts_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SerialService_GetPorts_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SerialService_GetPorts_ResponseParams_Data));
      new (data()) SerialService_GetPorts_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SerialService_GetPorts_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SerialService_GetPorts_ResponseParams_Data>(index_);
    }
    SerialService_GetPorts_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SerialPortInfo_Data>>> ports;

 private:
  SerialService_GetPorts_ResponseParams_Data();
  ~SerialService_GetPorts_ResponseParams_Data() = delete;
};
static_assert(sizeof(SerialService_GetPorts_ResponseParams_Data) == 16,
              "Bad sizeof(SerialService_GetPorts_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SerialService_RequestPort_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SerialService_RequestPort_Params_Data));
      new (data()) SerialService_RequestPort_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SerialService_RequestPort_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SerialService_RequestPort_Params_Data>(index_);
    }
    SerialService_RequestPort_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SerialPortFilter_Data>>> filters;

 private:
  SerialService_RequestPort_Params_Data();
  ~SerialService_RequestPort_Params_Data() = delete;
};
static_assert(sizeof(SerialService_RequestPort_Params_Data) == 16,
              "Bad sizeof(SerialService_RequestPort_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SerialService_RequestPort_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SerialService_RequestPort_ResponseParams_Data));
      new (data()) SerialService_RequestPort_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SerialService_RequestPort_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SerialService_RequestPort_ResponseParams_Data>(index_);
    }
    SerialService_RequestPort_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::SerialPortInfo_Data> port;

 private:
  SerialService_RequestPort_ResponseParams_Data();
  ~SerialService_RequestPort_ResponseParams_Data() = delete;
};
static_assert(sizeof(SerialService_RequestPort_ResponseParams_Data) == 16,
              "Bad sizeof(SerialService_RequestPort_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERIAL_SERIAL_MOJOM_SHARED_INTERNAL_H_