// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/string16.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "services/network/public/mojom/cookie_manager.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/background_fetch/background_fetch.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/fetch/fetch_api_response.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/messaging/transferable_message.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/notifications/notification.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/payments/payment_app.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/service_worker/dispatch_fetch_event_params.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_client.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_error_type.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_event_status.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_fetch_response_callback.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_object.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_registration.mojom-shared-internal.h"
#include "url/mojom/origin.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class ExtendableMessageEvent_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ExtendableMessageEvent_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ExtendableMessageEvent_Data));
      new (data()) ExtendableMessageEvent_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ExtendableMessageEvent_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ExtendableMessageEvent_Data>(index_);
    }
    ExtendableMessageEvent_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::TransferableMessage_Data> message;
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> source_origin;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientInfo_Data> source_info_for_client;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerObjectInfo_Data> source_info_for_service_worker;

 private:
  ExtendableMessageEvent_Data();
  ~ExtendableMessageEvent_Data() = delete;
};
static_assert(sizeof(ExtendableMessageEvent_Data) == 40,
              "Bad sizeof(ExtendableMessageEvent_Data)");
// Used by ExtendableMessageEvent::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct ExtendableMessageEvent_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  ExtendableMessageEvent_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~ExtendableMessageEvent_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    ExtendableMessageEvent_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    ExtendableMessageEvent_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_SetCachedMetadata_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_SetCachedMetadata_Params_Data));
      new (data()) ServiceWorkerHost_SetCachedMetadata_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_SetCachedMetadata_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_SetCachedMetadata_Params_Data>(index_);
    }
    ServiceWorkerHost_SetCachedMetadata_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> data;

 private:
  ServiceWorkerHost_SetCachedMetadata_Params_Data();
  ~ServiceWorkerHost_SetCachedMetadata_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_SetCachedMetadata_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerHost_SetCachedMetadata_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_ClearCachedMetadata_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_ClearCachedMetadata_Params_Data));
      new (data()) ServiceWorkerHost_ClearCachedMetadata_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_ClearCachedMetadata_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_ClearCachedMetadata_Params_Data>(index_);
    }
    ServiceWorkerHost_ClearCachedMetadata_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  ServiceWorkerHost_ClearCachedMetadata_Params_Data();
  ~ServiceWorkerHost_ClearCachedMetadata_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_ClearCachedMetadata_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_ClearCachedMetadata_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_GetClients_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_GetClients_Params_Data));
      new (data()) ServiceWorkerHost_GetClients_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_GetClients_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_GetClients_Params_Data>(index_);
    }
    ServiceWorkerHost_GetClients_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientQueryOptions_Data> options;

 private:
  ServiceWorkerHost_GetClients_Params_Data();
  ~ServiceWorkerHost_GetClients_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_GetClients_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_GetClients_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_GetClients_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_GetClients_ResponseParams_Data));
      new (data()) ServiceWorkerHost_GetClients_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_GetClients_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_GetClients_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_GetClients_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientInfo_Data>>> clients;

 private:
  ServiceWorkerHost_GetClients_ResponseParams_Data();
  ~ServiceWorkerHost_GetClients_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_GetClients_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_GetClients_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_GetClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_GetClient_Params_Data));
      new (data()) ServiceWorkerHost_GetClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_GetClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_GetClient_Params_Data>(index_);
    }
    ServiceWorkerHost_GetClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> client_uuid;

 private:
  ServiceWorkerHost_GetClient_Params_Data();
  ~ServiceWorkerHost_GetClient_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_GetClient_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_GetClient_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_GetClient_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_GetClient_ResponseParams_Data));
      new (data()) ServiceWorkerHost_GetClient_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_GetClient_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_GetClient_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_GetClient_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientInfo_Data> client;

 private:
  ServiceWorkerHost_GetClient_ResponseParams_Data();
  ~ServiceWorkerHost_GetClient_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_GetClient_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_GetClient_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_OpenNewTab_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_OpenNewTab_Params_Data));
      new (data()) ServiceWorkerHost_OpenNewTab_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_OpenNewTab_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_OpenNewTab_Params_Data>(index_);
    }
    ServiceWorkerHost_OpenNewTab_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  ServiceWorkerHost_OpenNewTab_Params_Data();
  ~ServiceWorkerHost_OpenNewTab_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_OpenNewTab_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_OpenNewTab_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_OpenNewTab_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_OpenNewTab_ResponseParams_Data));
      new (data()) ServiceWorkerHost_OpenNewTab_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_OpenNewTab_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_OpenNewTab_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_OpenNewTab_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientInfo_Data> client;
  mojo::internal::Pointer<mojo::internal::String_Data> error_msg;

 private:
  ServiceWorkerHost_OpenNewTab_ResponseParams_Data();
  ~ServiceWorkerHost_OpenNewTab_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_OpenNewTab_ResponseParams_Data) == 32,
              "Bad sizeof(ServiceWorkerHost_OpenNewTab_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data));
      new (data()) ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data>(index_);
    }
    ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data();
  ~ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data));
      new (data()) ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientInfo_Data> client;
  mojo::internal::Pointer<mojo::internal::String_Data> error_msg;

 private:
  ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data();
  ~ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data) == 32,
              "Bad sizeof(ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_PostMessageToClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_PostMessageToClient_Params_Data));
      new (data()) ServiceWorkerHost_PostMessageToClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_PostMessageToClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_PostMessageToClient_Params_Data>(index_);
    }
    ServiceWorkerHost_PostMessageToClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> client_uuid;
  mojo::internal::Pointer<::blink::mojom::internal::TransferableMessage_Data> message;

 private:
  ServiceWorkerHost_PostMessageToClient_Params_Data();
  ~ServiceWorkerHost_PostMessageToClient_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_PostMessageToClient_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerHost_PostMessageToClient_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_FocusClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_FocusClient_Params_Data));
      new (data()) ServiceWorkerHost_FocusClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_FocusClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_FocusClient_Params_Data>(index_);
    }
    ServiceWorkerHost_FocusClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> client_uuid;

 private:
  ServiceWorkerHost_FocusClient_Params_Data();
  ~ServiceWorkerHost_FocusClient_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_FocusClient_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_FocusClient_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_FocusClient_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_FocusClient_ResponseParams_Data));
      new (data()) ServiceWorkerHost_FocusClient_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_FocusClient_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_FocusClient_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_FocusClient_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientInfo_Data> client;

 private:
  ServiceWorkerHost_FocusClient_ResponseParams_Data();
  ~ServiceWorkerHost_FocusClient_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_FocusClient_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_FocusClient_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_NavigateClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_NavigateClient_Params_Data));
      new (data()) ServiceWorkerHost_NavigateClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_NavigateClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_NavigateClient_Params_Data>(index_);
    }
    ServiceWorkerHost_NavigateClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> client_uuid;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  ServiceWorkerHost_NavigateClient_Params_Data();
  ~ServiceWorkerHost_NavigateClient_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_NavigateClient_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerHost_NavigateClient_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_NavigateClient_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_NavigateClient_ResponseParams_Data));
      new (data()) ServiceWorkerHost_NavigateClient_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_NavigateClient_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_NavigateClient_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_NavigateClient_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientInfo_Data> client;
  mojo::internal::Pointer<mojo::internal::String_Data> error_msg;

 private:
  ServiceWorkerHost_NavigateClient_ResponseParams_Data();
  ~ServiceWorkerHost_NavigateClient_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_NavigateClient_ResponseParams_Data) == 32,
              "Bad sizeof(ServiceWorkerHost_NavigateClient_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_SkipWaiting_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_SkipWaiting_Params_Data));
      new (data()) ServiceWorkerHost_SkipWaiting_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_SkipWaiting_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_SkipWaiting_Params_Data>(index_);
    }
    ServiceWorkerHost_SkipWaiting_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorkerHost_SkipWaiting_Params_Data();
  ~ServiceWorkerHost_SkipWaiting_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_SkipWaiting_Params_Data) == 8,
              "Bad sizeof(ServiceWorkerHost_SkipWaiting_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_SkipWaiting_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_SkipWaiting_ResponseParams_Data));
      new (data()) ServiceWorkerHost_SkipWaiting_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_SkipWaiting_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_SkipWaiting_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_SkipWaiting_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  ServiceWorkerHost_SkipWaiting_ResponseParams_Data();
  ~ServiceWorkerHost_SkipWaiting_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_SkipWaiting_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_SkipWaiting_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_ClaimClients_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_ClaimClients_Params_Data));
      new (data()) ServiceWorkerHost_ClaimClients_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_ClaimClients_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_ClaimClients_Params_Data>(index_);
    }
    ServiceWorkerHost_ClaimClients_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorkerHost_ClaimClients_Params_Data();
  ~ServiceWorkerHost_ClaimClients_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_ClaimClients_Params_Data) == 8,
              "Bad sizeof(ServiceWorkerHost_ClaimClients_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorkerHost_ClaimClients_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_ClaimClients_ResponseParams_Data));
      new (data()) ServiceWorkerHost_ClaimClients_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_ClaimClients_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_ClaimClients_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_ClaimClients_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> error_msg;

 private:
  ServiceWorkerHost_ClaimClients_ResponseParams_Data();
  ~ServiceWorkerHost_ClaimClients_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_ClaimClients_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerHost_ClaimClients_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_InitializeGlobalScope_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_InitializeGlobalScope_Params_Data));
      new (data()) ServiceWorker_InitializeGlobalScope_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_InitializeGlobalScope_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_InitializeGlobalScope_Params_Data>(index_);
    }
    ServiceWorker_InitializeGlobalScope_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data service_worker_host;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerRegistrationObjectInfo_Data> registration_info;

 private:
  ServiceWorker_InitializeGlobalScope_Params_Data();
  ~ServiceWorker_InitializeGlobalScope_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_InitializeGlobalScope_Params_Data) == 24,
              "Bad sizeof(ServiceWorker_InitializeGlobalScope_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchInstallEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchInstallEvent_Params_Data));
      new (data()) ServiceWorker_DispatchInstallEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchInstallEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchInstallEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchInstallEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorker_DispatchInstallEvent_Params_Data();
  ~ServiceWorker_DispatchInstallEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchInstallEvent_Params_Data) == 8,
              "Bad sizeof(ServiceWorker_DispatchInstallEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchInstallEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchInstallEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchInstallEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchInstallEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchInstallEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchInstallEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t has_fetch_handler : 1;
  uint8_t padfinal_[3];

 private:
  ServiceWorker_DispatchInstallEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchInstallEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchInstallEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchInstallEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchActivateEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchActivateEvent_Params_Data));
      new (data()) ServiceWorker_DispatchActivateEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchActivateEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchActivateEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchActivateEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorker_DispatchActivateEvent_Params_Data();
  ~ServiceWorker_DispatchActivateEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchActivateEvent_Params_Data) == 8,
              "Bad sizeof(ServiceWorker_DispatchActivateEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchActivateEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchActivateEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchActivateEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchActivateEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchActivateEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchActivateEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchActivateEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchActivateEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchActivateEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchActivateEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data));
      new (data()) ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::BackgroundFetchRegistration_Data> registration;

 private:
  ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data();
  ~ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data));
      new (data()) ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::BackgroundFetchRegistration_Data> registration;

 private:
  ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data();
  ~ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data));
      new (data()) ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::BackgroundFetchRegistration_Data> registration;

 private:
  ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data();
  ~ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data));
      new (data()) ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::BackgroundFetchRegistration_Data> registration;

 private:
  ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data();
  ~ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchCookieChangeEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchCookieChangeEvent_Params_Data));
      new (data()) ServiceWorker_DispatchCookieChangeEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchCookieChangeEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchCookieChangeEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchCookieChangeEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::network::mojom::internal::CanonicalCookie_Data> cookie;
  int32_t cause;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchCookieChangeEvent_Params_Data();
  ~ServiceWorker_DispatchCookieChangeEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchCookieChangeEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorker_DispatchCookieChangeEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchFetchEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchFetchEvent_Params_Data));
      new (data()) ServiceWorker_DispatchFetchEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchFetchEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchFetchEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchFetchEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::DispatchFetchEventParams_Data> params;
  mojo::internal::Interface_Data response_callback;

 private:
  ServiceWorker_DispatchFetchEvent_Params_Data();
  ~ServiceWorker_DispatchFetchEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchFetchEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorker_DispatchFetchEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchFetchEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchFetchEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchFetchEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchFetchEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchFetchEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchFetchEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchFetchEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchFetchEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchFetchEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchFetchEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchNotificationClickEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchNotificationClickEvent_Params_Data));
      new (data()) ServiceWorker_DispatchNotificationClickEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchNotificationClickEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchNotificationClickEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchNotificationClickEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> notification_id;
  mojo::internal::Pointer<::blink::mojom::internal::NotificationData_Data> notification_data;
  int32_t action_index;
  uint8_t pad2_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data> reply;

 private:
  ServiceWorker_DispatchNotificationClickEvent_Params_Data();
  ~ServiceWorker_DispatchNotificationClickEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchNotificationClickEvent_Params_Data) == 40,
              "Bad sizeof(ServiceWorker_DispatchNotificationClickEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchNotificationCloseEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchNotificationCloseEvent_Params_Data));
      new (data()) ServiceWorker_DispatchNotificationCloseEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchNotificationCloseEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchNotificationCloseEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchNotificationCloseEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> notification_id;
  mojo::internal::Pointer<::blink::mojom::internal::NotificationData_Data> notification_data;

 private:
  ServiceWorker_DispatchNotificationCloseEvent_Params_Data();
  ~ServiceWorker_DispatchNotificationCloseEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchNotificationCloseEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorker_DispatchNotificationCloseEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchPushEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchPushEvent_Params_Data));
      new (data()) ServiceWorker_DispatchPushEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchPushEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchPushEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchPushEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> payload;

 private:
  ServiceWorker_DispatchPushEvent_Params_Data();
  ~ServiceWorker_DispatchPushEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchPushEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchPushEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchPushEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchPushEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchPushEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchPushEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchPushEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchPushEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchPushEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchPushEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchPushEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchPushEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchSyncEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchSyncEvent_Params_Data));
      new (data()) ServiceWorker_DispatchSyncEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchSyncEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchSyncEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchSyncEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> id;
  uint8_t last_chance : 1;
  uint8_t pad1_[7];
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> timeout;

 private:
  ServiceWorker_DispatchSyncEvent_Params_Data();
  ~ServiceWorker_DispatchSyncEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchSyncEvent_Params_Data) == 32,
              "Bad sizeof(ServiceWorker_DispatchSyncEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchSyncEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchSyncEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchSyncEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchSyncEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchSyncEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchSyncEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchSyncEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchSyncEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchSyncEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchSyncEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchAbortPaymentEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchAbortPaymentEvent_Params_Data));
      new (data()) ServiceWorker_DispatchAbortPaymentEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchAbortPaymentEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchAbortPaymentEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchAbortPaymentEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data result_of_abort_payment;

 private:
  ServiceWorker_DispatchAbortPaymentEvent_Params_Data();
  ~ServiceWorker_DispatchAbortPaymentEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchAbortPaymentEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchAbortPaymentEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchCanMakePaymentEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchCanMakePaymentEvent_Params_Data));
      new (data()) ServiceWorker_DispatchCanMakePaymentEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchCanMakePaymentEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchCanMakePaymentEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchCanMakePaymentEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::payments::mojom::internal::CanMakePaymentEventData_Data> event_data;
  mojo::internal::Interface_Data result_of_can_make_payment;

 private:
  ServiceWorker_DispatchCanMakePaymentEvent_Params_Data();
  ~ServiceWorker_DispatchCanMakePaymentEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchCanMakePaymentEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorker_DispatchCanMakePaymentEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchPaymentRequestEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchPaymentRequestEvent_Params_Data));
      new (data()) ServiceWorker_DispatchPaymentRequestEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchPaymentRequestEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchPaymentRequestEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchPaymentRequestEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::payments::mojom::internal::PaymentRequestEventData_Data> request_data;
  mojo::internal::Interface_Data response_callback;

 private:
  ServiceWorker_DispatchPaymentRequestEvent_Params_Data();
  ~ServiceWorker_DispatchPaymentRequestEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchPaymentRequestEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorker_DispatchPaymentRequestEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchExtendableMessageEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchExtendableMessageEvent_Params_Data));
      new (data()) ServiceWorker_DispatchExtendableMessageEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchExtendableMessageEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchExtendableMessageEvent_Params_Data>(index_);
    }
    ServiceWorker_DispatchExtendableMessageEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::ExtendableMessageEvent_Data> event;

 private:
  ServiceWorker_DispatchExtendableMessageEvent_Params_Data();
  ~ServiceWorker_DispatchExtendableMessageEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchExtendableMessageEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchExtendableMessageEvent_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data();
  ~ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data));
      new (data()) ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data>(index_);
    }
    ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::ExtendableMessageEvent_Data> event;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> timeout;

 private:
  ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data();
  ~ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data) == 24,
              "Bad sizeof(ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data));
      new (data()) ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data>(index_);
    }
    ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data();
  ~ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_Ping_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_Ping_Params_Data));
      new (data()) ServiceWorker_Ping_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_Ping_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_Ping_Params_Data>(index_);
    }
    ServiceWorker_Ping_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorker_Ping_Params_Data();
  ~ServiceWorker_Ping_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_Ping_Params_Data) == 8,
              "Bad sizeof(ServiceWorker_Ping_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_Ping_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_Ping_ResponseParams_Data));
      new (data()) ServiceWorker_Ping_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_Ping_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_Ping_ResponseParams_Data>(index_);
    }
    ServiceWorker_Ping_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorker_Ping_ResponseParams_Data();
  ~ServiceWorker_Ping_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorker_Ping_ResponseParams_Data) == 8,
              "Bad sizeof(ServiceWorker_Ping_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) ServiceWorker_SetIdleTimerDelayToZero_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorker_SetIdleTimerDelayToZero_Params_Data));
      new (data()) ServiceWorker_SetIdleTimerDelayToZero_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorker_SetIdleTimerDelayToZero_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorker_SetIdleTimerDelayToZero_Params_Data>(index_);
    }
    ServiceWorker_SetIdleTimerDelayToZero_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorker_SetIdleTimerDelayToZero_Params_Data();
  ~ServiceWorker_SetIdleTimerDelayToZero_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorker_SetIdleTimerDelayToZero_Params_Data) == 8,
              "Bad sizeof(ServiceWorker_SetIdleTimerDelayToZero_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_INTERNAL_H_