// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/mojom/service_worker/service_worker.mojom-shared-internal.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "services/network/public/mojom/cookie_manager.mojom-shared.h"
#include "third_party/blink/public/mojom/background_fetch/background_fetch.mojom-shared.h"
#include "third_party/blink/public/mojom/fetch/fetch_api_response.mojom-shared.h"
#include "third_party/blink/public/mojom/messaging/transferable_message.mojom-shared.h"
#include "third_party/blink/public/mojom/notifications/notification.mojom-shared.h"
#include "third_party/blink/public/mojom/payments/payment_app.mojom-shared.h"
#include "third_party/blink/public/mojom/service_worker/dispatch_fetch_event_params.mojom-shared.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_client.mojom-shared.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_error_type.mojom-shared.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_event_status.mojom-shared.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_fetch_response_callback.mojom-shared.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_object.mojom-shared.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_registration.mojom-shared.h"
#include "url/mojom/origin.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace blink {
namespace mojom {
class ExtendableMessageEventDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::ExtendableMessageEventDataView> {
  using Data = ::blink::mojom::internal::ExtendableMessageEvent_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ServiceWorkerHostInterfaceBase {};

using ServiceWorkerHostPtrDataView =
    mojo::InterfacePtrDataView<ServiceWorkerHostInterfaceBase>;
using ServiceWorkerHostRequestDataView =
    mojo::InterfaceRequestDataView<ServiceWorkerHostInterfaceBase>;
using ServiceWorkerHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ServiceWorkerHostInterfaceBase>;
using ServiceWorkerHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ServiceWorkerHostInterfaceBase>;
class ServiceWorkerInterfaceBase {};

using ServiceWorkerPtrDataView =
    mojo::InterfacePtrDataView<ServiceWorkerInterfaceBase>;
using ServiceWorkerRequestDataView =
    mojo::InterfaceRequestDataView<ServiceWorkerInterfaceBase>;
using ServiceWorkerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ServiceWorkerInterfaceBase>;
using ServiceWorkerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ServiceWorkerInterfaceBase>;
class ExtendableMessageEventDataView {
 public:
  ExtendableMessageEventDataView() {}

  ExtendableMessageEventDataView(
      internal::ExtendableMessageEvent_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMessageDataView(
      ::blink::mojom::TransferableMessageDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<::blink::mojom::TransferableMessageDataView>(
        pointer, output, context_);
  }
  inline void GetSourceOriginDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSourceOrigin(UserType* output) {
    auto* pointer = data_->source_origin.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, context_);
  }
  inline void GetSourceInfoForClientDataView(
      ::blink::mojom::ServiceWorkerClientInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSourceInfoForClient(UserType* output) {
    auto* pointer = data_->source_info_for_client.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerClientInfoDataView>(
        pointer, output, context_);
  }
  inline void GetSourceInfoForServiceWorkerDataView(
      ::blink::mojom::ServiceWorkerObjectInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSourceInfoForServiceWorker(UserType* output) {
    auto* pointer = data_->source_info_for_service_worker.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerObjectInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::ExtendableMessageEvent_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_SetCachedMetadata_ParamsDataView {
 public:
  ServiceWorkerHost_SetCachedMetadata_ParamsDataView() {}

  ServiceWorkerHost_SetCachedMetadata_ParamsDataView(
      internal::ServiceWorkerHost_SetCachedMetadata_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetDataDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_SetCachedMetadata_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_ClearCachedMetadata_ParamsDataView {
 public:
  ServiceWorkerHost_ClearCachedMetadata_ParamsDataView() {}

  ServiceWorkerHost_ClearCachedMetadata_ParamsDataView(
      internal::ServiceWorkerHost_ClearCachedMetadata_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_ClearCachedMetadata_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_GetClients_ParamsDataView {
 public:
  ServiceWorkerHost_GetClients_ParamsDataView() {}

  ServiceWorkerHost_GetClients_ParamsDataView(
      internal::ServiceWorkerHost_GetClients_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetOptionsDataView(
      ::blink::mojom::ServiceWorkerClientQueryOptionsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOptions(UserType* output) {
    auto* pointer = data_->options.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerClientQueryOptionsDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_GetClients_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_GetClients_ResponseParamsDataView {
 public:
  ServiceWorkerHost_GetClients_ResponseParamsDataView() {}

  ServiceWorkerHost_GetClients_ResponseParamsDataView(
      internal::ServiceWorkerHost_GetClients_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetClientsDataView(
      mojo::ArrayDataView<::blink::mojom::ServiceWorkerClientInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClients(UserType* output) {
    auto* pointer = data_->clients.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::ServiceWorkerClientInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_GetClients_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_GetClient_ParamsDataView {
 public:
  ServiceWorkerHost_GetClient_ParamsDataView() {}

  ServiceWorkerHost_GetClient_ParamsDataView(
      internal::ServiceWorkerHost_GetClient_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetClientUuidDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClientUuid(UserType* output) {
    auto* pointer = data_->client_uuid.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_GetClient_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_GetClient_ResponseParamsDataView {
 public:
  ServiceWorkerHost_GetClient_ResponseParamsDataView() {}

  ServiceWorkerHost_GetClient_ResponseParamsDataView(
      internal::ServiceWorkerHost_GetClient_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetClientDataView(
      ::blink::mojom::ServiceWorkerClientInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClient(UserType* output) {
    auto* pointer = data_->client.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerClientInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_GetClient_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_OpenNewTab_ParamsDataView {
 public:
  ServiceWorkerHost_OpenNewTab_ParamsDataView() {}

  ServiceWorkerHost_OpenNewTab_ParamsDataView(
      internal::ServiceWorkerHost_OpenNewTab_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_OpenNewTab_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_OpenNewTab_ResponseParamsDataView {
 public:
  ServiceWorkerHost_OpenNewTab_ResponseParamsDataView() {}

  ServiceWorkerHost_OpenNewTab_ResponseParamsDataView(
      internal::ServiceWorkerHost_OpenNewTab_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
  inline void GetClientDataView(
      ::blink::mojom::ServiceWorkerClientInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClient(UserType* output) {
    auto* pointer = data_->client.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerClientInfoDataView>(
        pointer, output, context_);
  }
  inline void GetErrorMsgDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadErrorMsg(UserType* output) {
    auto* pointer = data_->error_msg.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_OpenNewTab_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_OpenPaymentHandlerWindow_ParamsDataView {
 public:
  ServiceWorkerHost_OpenPaymentHandlerWindow_ParamsDataView() {}

  ServiceWorkerHost_OpenPaymentHandlerWindow_ParamsDataView(
      internal::ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_OpenPaymentHandlerWindow_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParamsDataView {
 public:
  ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParamsDataView() {}

  ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParamsDataView(
      internal::ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
  inline void GetClientDataView(
      ::blink::mojom::ServiceWorkerClientInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClient(UserType* output) {
    auto* pointer = data_->client.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerClientInfoDataView>(
        pointer, output, context_);
  }
  inline void GetErrorMsgDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadErrorMsg(UserType* output) {
    auto* pointer = data_->error_msg.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_PostMessageToClient_ParamsDataView {
 public:
  ServiceWorkerHost_PostMessageToClient_ParamsDataView() {}

  ServiceWorkerHost_PostMessageToClient_ParamsDataView(
      internal::ServiceWorkerHost_PostMessageToClient_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetClientUuidDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClientUuid(UserType* output) {
    auto* pointer = data_->client_uuid.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetMessageDataView(
      ::blink::mojom::TransferableMessageDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<::blink::mojom::TransferableMessageDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_PostMessageToClient_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_FocusClient_ParamsDataView {
 public:
  ServiceWorkerHost_FocusClient_ParamsDataView() {}

  ServiceWorkerHost_FocusClient_ParamsDataView(
      internal::ServiceWorkerHost_FocusClient_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetClientUuidDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClientUuid(UserType* output) {
    auto* pointer = data_->client_uuid.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_FocusClient_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_FocusClient_ResponseParamsDataView {
 public:
  ServiceWorkerHost_FocusClient_ResponseParamsDataView() {}

  ServiceWorkerHost_FocusClient_ResponseParamsDataView(
      internal::ServiceWorkerHost_FocusClient_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetClientDataView(
      ::blink::mojom::ServiceWorkerClientInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClient(UserType* output) {
    auto* pointer = data_->client.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerClientInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_FocusClient_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_NavigateClient_ParamsDataView {
 public:
  ServiceWorkerHost_NavigateClient_ParamsDataView() {}

  ServiceWorkerHost_NavigateClient_ParamsDataView(
      internal::ServiceWorkerHost_NavigateClient_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetClientUuidDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClientUuid(UserType* output) {
    auto* pointer = data_->client_uuid.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_NavigateClient_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_NavigateClient_ResponseParamsDataView {
 public:
  ServiceWorkerHost_NavigateClient_ResponseParamsDataView() {}

  ServiceWorkerHost_NavigateClient_ResponseParamsDataView(
      internal::ServiceWorkerHost_NavigateClient_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
  inline void GetClientDataView(
      ::blink::mojom::ServiceWorkerClientInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClient(UserType* output) {
    auto* pointer = data_->client.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerClientInfoDataView>(
        pointer, output, context_);
  }
  inline void GetErrorMsgDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadErrorMsg(UserType* output) {
    auto* pointer = data_->error_msg.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_NavigateClient_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorkerHost_SkipWaiting_ParamsDataView {
 public:
  ServiceWorkerHost_SkipWaiting_ParamsDataView() {}

  ServiceWorkerHost_SkipWaiting_ParamsDataView(
      internal::ServiceWorkerHost_SkipWaiting_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceWorkerHost_SkipWaiting_Params_Data* data_ = nullptr;
};

class ServiceWorkerHost_SkipWaiting_ResponseParamsDataView {
 public:
  ServiceWorkerHost_SkipWaiting_ResponseParamsDataView() {}

  ServiceWorkerHost_SkipWaiting_ResponseParamsDataView(
      internal::ServiceWorkerHost_SkipWaiting_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::ServiceWorkerHost_SkipWaiting_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorkerHost_ClaimClients_ParamsDataView {
 public:
  ServiceWorkerHost_ClaimClients_ParamsDataView() {}

  ServiceWorkerHost_ClaimClients_ParamsDataView(
      internal::ServiceWorkerHost_ClaimClients_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceWorkerHost_ClaimClients_Params_Data* data_ = nullptr;
};

class ServiceWorkerHost_ClaimClients_ResponseParamsDataView {
 public:
  ServiceWorkerHost_ClaimClients_ResponseParamsDataView() {}

  ServiceWorkerHost_ClaimClients_ResponseParamsDataView(
      internal::ServiceWorkerHost_ClaimClients_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadError(UserType* output) const {
    auto data_value = data_->error;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerErrorType>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerErrorType error() const {
    return static_cast<::blink::mojom::ServiceWorkerErrorType>(data_->error);
  }
  inline void GetErrorMsgDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadErrorMsg(UserType* output) {
    auto* pointer = data_->error_msg.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorkerHost_ClaimClients_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_InitializeGlobalScope_ParamsDataView {
 public:
  ServiceWorker_InitializeGlobalScope_ParamsDataView() {}

  ServiceWorker_InitializeGlobalScope_ParamsDataView(
      internal::ServiceWorker_InitializeGlobalScope_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeServiceWorkerHost() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::ServiceWorkerHostAssociatedPtrInfoDataView>(
            &data_->service_worker_host, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetRegistrationInfoDataView(
      ::blink::mojom::ServiceWorkerRegistrationObjectInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRegistrationInfo(UserType* output) {
    auto* pointer = data_->registration_info.Get();
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerRegistrationObjectInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_InitializeGlobalScope_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchInstallEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchInstallEvent_ParamsDataView() {}

  ServiceWorker_DispatchInstallEvent_ParamsDataView(
      internal::ServiceWorker_DispatchInstallEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceWorker_DispatchInstallEvent_Params_Data* data_ = nullptr;
};

class ServiceWorker_DispatchInstallEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchInstallEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchInstallEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchInstallEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
  bool has_fetch_handler() const {
    return data_->has_fetch_handler;
  }
 private:
  internal::ServiceWorker_DispatchInstallEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchActivateEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchActivateEvent_ParamsDataView() {}

  ServiceWorker_DispatchActivateEvent_ParamsDataView(
      internal::ServiceWorker_DispatchActivateEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceWorker_DispatchActivateEvent_Params_Data* data_ = nullptr;
};

class ServiceWorker_DispatchActivateEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchActivateEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchActivateEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchActivateEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchActivateEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchBackgroundFetchAbortEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchBackgroundFetchAbortEvent_ParamsDataView() {}

  ServiceWorker_DispatchBackgroundFetchAbortEvent_ParamsDataView(
      internal::ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRegistrationDataView(
      ::blink::mojom::BackgroundFetchRegistrationDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRegistration(UserType* output) {
    auto* pointer = data_->registration.Get();
    return mojo::internal::Deserialize<::blink::mojom::BackgroundFetchRegistrationDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchBackgroundFetchAbortEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchBackgroundFetchAbortEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchBackgroundFetchClickEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchBackgroundFetchClickEvent_ParamsDataView() {}

  ServiceWorker_DispatchBackgroundFetchClickEvent_ParamsDataView(
      internal::ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRegistrationDataView(
      ::blink::mojom::BackgroundFetchRegistrationDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRegistration(UserType* output) {
    auto* pointer = data_->registration.Get();
    return mojo::internal::Deserialize<::blink::mojom::BackgroundFetchRegistrationDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchBackgroundFetchClickEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchBackgroundFetchClickEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchBackgroundFetchFailEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchBackgroundFetchFailEvent_ParamsDataView() {}

  ServiceWorker_DispatchBackgroundFetchFailEvent_ParamsDataView(
      internal::ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRegistrationDataView(
      ::blink::mojom::BackgroundFetchRegistrationDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRegistration(UserType* output) {
    auto* pointer = data_->registration.Get();
    return mojo::internal::Deserialize<::blink::mojom::BackgroundFetchRegistrationDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchBackgroundFetchFailEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchBackgroundFetchFailEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchBackgroundFetchSuccessEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchBackgroundFetchSuccessEvent_ParamsDataView() {}

  ServiceWorker_DispatchBackgroundFetchSuccessEvent_ParamsDataView(
      internal::ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRegistrationDataView(
      ::blink::mojom::BackgroundFetchRegistrationDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRegistration(UserType* output) {
    auto* pointer = data_->registration.Get();
    return mojo::internal::Deserialize<::blink::mojom::BackgroundFetchRegistrationDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchBackgroundFetchSuccessEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchBackgroundFetchSuccessEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchCookieChangeEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchCookieChangeEvent_ParamsDataView() {}

  ServiceWorker_DispatchCookieChangeEvent_ParamsDataView(
      internal::ServiceWorker_DispatchCookieChangeEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCookieDataView(
      ::network::mojom::CanonicalCookieDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCookie(UserType* output) {
    auto* pointer = data_->cookie.Get();
    return mojo::internal::Deserialize<::network::mojom::CanonicalCookieDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCause(UserType* output) const {
    auto data_value = data_->cause;
    return mojo::internal::Deserialize<::network::mojom::CookieChangeCause>(
        data_value, output);
  }

  ::network::mojom::CookieChangeCause cause() const {
    return static_cast<::network::mojom::CookieChangeCause>(data_->cause);
  }
 private:
  internal::ServiceWorker_DispatchCookieChangeEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchCookieChangeEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchCookieChangeEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchCookieChangeEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchCookieChangeEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchFetchEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchFetchEvent_ParamsDataView() {}

  ServiceWorker_DispatchFetchEvent_ParamsDataView(
      internal::ServiceWorker_DispatchFetchEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetParamsDataView(
      ::blink::mojom::DispatchFetchEventParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadParams(UserType* output) {
    auto* pointer = data_->params.Get();
    return mojo::internal::Deserialize<::blink::mojom::DispatchFetchEventParamsDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeResponseCallback() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::ServiceWorkerFetchResponseCallbackPtrDataView>(
            &data_->response_callback, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ServiceWorker_DispatchFetchEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchFetchEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchFetchEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchFetchEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchFetchEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchFetchEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchNotificationClickEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchNotificationClickEvent_ParamsDataView() {}

  ServiceWorker_DispatchNotificationClickEvent_ParamsDataView(
      internal::ServiceWorker_DispatchNotificationClickEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNotificationIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNotificationId(UserType* output) {
    auto* pointer = data_->notification_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetNotificationDataDataView(
      ::blink::mojom::NotificationDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNotificationData(UserType* output) {
    auto* pointer = data_->notification_data.Get();
    return mojo::internal::Deserialize<::blink::mojom::NotificationDataDataView>(
        pointer, output, context_);
  }
  int32_t action_index() const {
    return data_->action_index;
  }
  inline void GetReplyDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReply(UserType* output) {
    auto* pointer = data_->reply.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchNotificationClickEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchNotificationClickEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchNotificationClickEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchNotificationClickEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchNotificationClickEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchNotificationCloseEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchNotificationCloseEvent_ParamsDataView() {}

  ServiceWorker_DispatchNotificationCloseEvent_ParamsDataView(
      internal::ServiceWorker_DispatchNotificationCloseEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetNotificationIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNotificationId(UserType* output) {
    auto* pointer = data_->notification_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetNotificationDataDataView(
      ::blink::mojom::NotificationDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNotificationData(UserType* output) {
    auto* pointer = data_->notification_data.Get();
    return mojo::internal::Deserialize<::blink::mojom::NotificationDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchNotificationCloseEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchNotificationCloseEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchNotificationCloseEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchNotificationCloseEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchNotificationCloseEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchPushEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchPushEvent_ParamsDataView() {}

  ServiceWorker_DispatchPushEvent_ParamsDataView(
      internal::ServiceWorker_DispatchPushEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPayloadDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPayload(UserType* output) {
    auto* pointer = data_->payload.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchPushEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchPushEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchPushEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchPushEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchPushEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchPushEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchSyncEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchSyncEvent_ParamsDataView() {}

  ServiceWorker_DispatchSyncEvent_ParamsDataView(
      internal::ServiceWorker_DispatchSyncEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool last_chance() const {
    return data_->last_chance;
  }
  inline void GetTimeoutDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTimeout(UserType* output) {
    auto* pointer = data_->timeout.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchSyncEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchSyncEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchSyncEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchSyncEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchSyncEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchSyncEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchAbortPaymentEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchAbortPaymentEvent_ParamsDataView() {}

  ServiceWorker_DispatchAbortPaymentEvent_ParamsDataView(
      internal::ServiceWorker_DispatchAbortPaymentEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeResultOfAbortPayment() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::payments::mojom::PaymentHandlerResponseCallbackPtrDataView>(
            &data_->result_of_abort_payment, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ServiceWorker_DispatchAbortPaymentEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchAbortPaymentEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchAbortPaymentEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchAbortPaymentEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchAbortPaymentEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchCanMakePaymentEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchCanMakePaymentEvent_ParamsDataView() {}

  ServiceWorker_DispatchCanMakePaymentEvent_ParamsDataView(
      internal::ServiceWorker_DispatchCanMakePaymentEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetEventDataDataView(
      ::payments::mojom::CanMakePaymentEventDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEventData(UserType* output) {
    auto* pointer = data_->event_data.Get();
    return mojo::internal::Deserialize<::payments::mojom::CanMakePaymentEventDataDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeResultOfCanMakePayment() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::payments::mojom::PaymentHandlerResponseCallbackPtrDataView>(
            &data_->result_of_can_make_payment, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ServiceWorker_DispatchCanMakePaymentEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchCanMakePaymentEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchCanMakePaymentEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchCanMakePaymentEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchCanMakePaymentEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchPaymentRequestEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchPaymentRequestEvent_ParamsDataView() {}

  ServiceWorker_DispatchPaymentRequestEvent_ParamsDataView(
      internal::ServiceWorker_DispatchPaymentRequestEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRequestDataDataView(
      ::payments::mojom::PaymentRequestEventDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRequestData(UserType* output) {
    auto* pointer = data_->request_data.Get();
    return mojo::internal::Deserialize<::payments::mojom::PaymentRequestEventDataDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeResponseCallback() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::payments::mojom::PaymentHandlerResponseCallbackPtrDataView>(
            &data_->response_callback, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ServiceWorker_DispatchPaymentRequestEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchPaymentRequestEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchPaymentRequestEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchPaymentRequestEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchPaymentRequestEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchExtendableMessageEvent_ParamsDataView {
 public:
  ServiceWorker_DispatchExtendableMessageEvent_ParamsDataView() {}

  ServiceWorker_DispatchExtendableMessageEvent_ParamsDataView(
      internal::ServiceWorker_DispatchExtendableMessageEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetEventDataView(
      ExtendableMessageEventDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEvent(UserType* output) {
    auto* pointer = data_->event.Get();
    return mojo::internal::Deserialize<::blink::mojom::ExtendableMessageEventDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchExtendableMessageEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchExtendableMessageEvent_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchExtendableMessageEvent_ResponseParamsDataView() {}

  ServiceWorker_DispatchExtendableMessageEvent_ResponseParamsDataView(
      internal::ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchExtendableMessageEvent_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ParamsDataView {
 public:
  ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ParamsDataView() {}

  ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ParamsDataView(
      internal::ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetEventDataView(
      ExtendableMessageEventDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEvent(UserType* output) {
    auto* pointer = data_->event.Get();
    return mojo::internal::Deserialize<::blink::mojom::ExtendableMessageEventDataView>(
        pointer, output, context_);
  }
  inline void GetTimeoutDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTimeout(UserType* output) {
    auto* pointer = data_->timeout.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
 private:
  internal::ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParamsDataView {
 public:
  ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParamsDataView() {}

  ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParamsDataView(
      internal::ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerEventStatus>(
        data_value, output);
  }

  ::blink::mojom::ServiceWorkerEventStatus status() const {
    return static_cast<::blink::mojom::ServiceWorkerEventStatus>(data_->status);
  }
 private:
  internal::ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_Ping_ParamsDataView {
 public:
  ServiceWorker_Ping_ParamsDataView() {}

  ServiceWorker_Ping_ParamsDataView(
      internal::ServiceWorker_Ping_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceWorker_Ping_Params_Data* data_ = nullptr;
};

class ServiceWorker_Ping_ResponseParamsDataView {
 public:
  ServiceWorker_Ping_ResponseParamsDataView() {}

  ServiceWorker_Ping_ResponseParamsDataView(
      internal::ServiceWorker_Ping_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceWorker_Ping_ResponseParams_Data* data_ = nullptr;
};

class ServiceWorker_SetIdleTimerDelayToZero_ParamsDataView {
 public:
  ServiceWorker_SetIdleTimerDelayToZero_ParamsDataView() {}

  ServiceWorker_SetIdleTimerDelayToZero_ParamsDataView(
      internal::ServiceWorker_SetIdleTimerDelayToZero_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceWorker_SetIdleTimerDelayToZero_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ExtendableMessageEventDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ExtendableMessageEventDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::ExtendableMessageEvent_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::message, input, custom_context)) in_message = CallWithContext(Traits::message, input, custom_context);
    typename decltype((*output)->message)::BaseType::BufferWriter
        message_writer;
    mojo::internal::Serialize<::blink::mojom::TransferableMessageDataView>(
        in_message, buffer, &message_writer, context);
    (*output)->message.Set(
        message_writer.is_null() ? nullptr : message_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->message.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null message in ExtendableMessageEvent struct");
    decltype(CallWithContext(Traits::source_origin, input, custom_context)) in_source_origin = CallWithContext(Traits::source_origin, input, custom_context);
    typename decltype((*output)->source_origin)::BaseType::BufferWriter
        source_origin_writer;
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_source_origin, buffer, &source_origin_writer, context);
    (*output)->source_origin.Set(
        source_origin_writer.is_null() ? nullptr : source_origin_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->source_origin.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null source_origin in ExtendableMessageEvent struct");
    decltype(CallWithContext(Traits::source_info_for_client, input, custom_context)) in_source_info_for_client = CallWithContext(Traits::source_info_for_client, input, custom_context);
    typename decltype((*output)->source_info_for_client)::BaseType::BufferWriter
        source_info_for_client_writer;
    mojo::internal::Serialize<::blink::mojom::ServiceWorkerClientInfoDataView>(
        in_source_info_for_client, buffer, &source_info_for_client_writer, context);
    (*output)->source_info_for_client.Set(
        source_info_for_client_writer.is_null() ? nullptr : source_info_for_client_writer.data());
    decltype(CallWithContext(Traits::source_info_for_service_worker, input, custom_context)) in_source_info_for_service_worker = CallWithContext(Traits::source_info_for_service_worker, input, custom_context);
    typename decltype((*output)->source_info_for_service_worker)::BaseType::BufferWriter
        source_info_for_service_worker_writer;
    mojo::internal::Serialize<::blink::mojom::ServiceWorkerObjectInfoDataView>(
        in_source_info_for_service_worker, buffer, &source_info_for_service_worker_writer, context);
    (*output)->source_info_for_service_worker.Set(
        source_info_for_service_worker_writer.is_null() ? nullptr : source_info_for_service_worker_writer.data());
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::ExtendableMessageEvent_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ExtendableMessageEventDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void ExtendableMessageEventDataView::GetMessageDataView(
    ::blink::mojom::TransferableMessageDataView* output) {
  auto pointer = data_->message.Get();
  *output = ::blink::mojom::TransferableMessageDataView(pointer, context_);
}
inline void ExtendableMessageEventDataView::GetSourceOriginDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->source_origin.Get();
  *output = ::url::mojom::OriginDataView(pointer, context_);
}
inline void ExtendableMessageEventDataView::GetSourceInfoForClientDataView(
    ::blink::mojom::ServiceWorkerClientInfoDataView* output) {
  auto pointer = data_->source_info_for_client.Get();
  *output = ::blink::mojom::ServiceWorkerClientInfoDataView(pointer, context_);
}
inline void ExtendableMessageEventDataView::GetSourceInfoForServiceWorkerDataView(
    ::blink::mojom::ServiceWorkerObjectInfoDataView* output) {
  auto pointer = data_->source_info_for_service_worker.Get();
  *output = ::blink::mojom::ServiceWorkerObjectInfoDataView(pointer, context_);
}


inline void ServiceWorkerHost_SetCachedMetadata_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void ServiceWorkerHost_SetCachedMetadata_ParamsDataView::GetDataDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->data.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void ServiceWorkerHost_ClearCachedMetadata_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void ServiceWorkerHost_GetClients_ParamsDataView::GetOptionsDataView(
    ::blink::mojom::ServiceWorkerClientQueryOptionsDataView* output) {
  auto pointer = data_->options.Get();
  *output = ::blink::mojom::ServiceWorkerClientQueryOptionsDataView(pointer, context_);
}


inline void ServiceWorkerHost_GetClients_ResponseParamsDataView::GetClientsDataView(
    mojo::ArrayDataView<::blink::mojom::ServiceWorkerClientInfoDataView>* output) {
  auto pointer = data_->clients.Get();
  *output = mojo::ArrayDataView<::blink::mojom::ServiceWorkerClientInfoDataView>(pointer, context_);
}


inline void ServiceWorkerHost_GetClient_ParamsDataView::GetClientUuidDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->client_uuid.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void ServiceWorkerHost_GetClient_ResponseParamsDataView::GetClientDataView(
    ::blink::mojom::ServiceWorkerClientInfoDataView* output) {
  auto pointer = data_->client.Get();
  *output = ::blink::mojom::ServiceWorkerClientInfoDataView(pointer, context_);
}


inline void ServiceWorkerHost_OpenNewTab_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void ServiceWorkerHost_OpenNewTab_ResponseParamsDataView::GetClientDataView(
    ::blink::mojom::ServiceWorkerClientInfoDataView* output) {
  auto pointer = data_->client.Get();
  *output = ::blink::mojom::ServiceWorkerClientInfoDataView(pointer, context_);
}
inline void ServiceWorkerHost_OpenNewTab_ResponseParamsDataView::GetErrorMsgDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->error_msg.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void ServiceWorkerHost_OpenPaymentHandlerWindow_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParamsDataView::GetClientDataView(
    ::blink::mojom::ServiceWorkerClientInfoDataView* output) {
  auto pointer = data_->client.Get();
  *output = ::blink::mojom::ServiceWorkerClientInfoDataView(pointer, context_);
}
inline void ServiceWorkerHost_OpenPaymentHandlerWindow_ResponseParamsDataView::GetErrorMsgDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->error_msg.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void ServiceWorkerHost_PostMessageToClient_ParamsDataView::GetClientUuidDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->client_uuid.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void ServiceWorkerHost_PostMessageToClient_ParamsDataView::GetMessageDataView(
    ::blink::mojom::TransferableMessageDataView* output) {
  auto pointer = data_->message.Get();
  *output = ::blink::mojom::TransferableMessageDataView(pointer, context_);
}


inline void ServiceWorkerHost_FocusClient_ParamsDataView::GetClientUuidDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->client_uuid.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void ServiceWorkerHost_FocusClient_ResponseParamsDataView::GetClientDataView(
    ::blink::mojom::ServiceWorkerClientInfoDataView* output) {
  auto pointer = data_->client.Get();
  *output = ::blink::mojom::ServiceWorkerClientInfoDataView(pointer, context_);
}


inline void ServiceWorkerHost_NavigateClient_ParamsDataView::GetClientUuidDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->client_uuid.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void ServiceWorkerHost_NavigateClient_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void ServiceWorkerHost_NavigateClient_ResponseParamsDataView::GetClientDataView(
    ::blink::mojom::ServiceWorkerClientInfoDataView* output) {
  auto pointer = data_->client.Get();
  *output = ::blink::mojom::ServiceWorkerClientInfoDataView(pointer, context_);
}
inline void ServiceWorkerHost_NavigateClient_ResponseParamsDataView::GetErrorMsgDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->error_msg.Get();
  *output = mojo::StringDataView(pointer, context_);
}








inline void ServiceWorkerHost_ClaimClients_ResponseParamsDataView::GetErrorMsgDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->error_msg.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void ServiceWorker_InitializeGlobalScope_ParamsDataView::GetRegistrationInfoDataView(
    ::blink::mojom::ServiceWorkerRegistrationObjectInfoDataView* output) {
  auto pointer = data_->registration_info.Get();
  *output = ::blink::mojom::ServiceWorkerRegistrationObjectInfoDataView(pointer, context_);
}










inline void ServiceWorker_DispatchBackgroundFetchAbortEvent_ParamsDataView::GetRegistrationDataView(
    ::blink::mojom::BackgroundFetchRegistrationDataView* output) {
  auto pointer = data_->registration.Get();
  *output = ::blink::mojom::BackgroundFetchRegistrationDataView(pointer, context_);
}




inline void ServiceWorker_DispatchBackgroundFetchClickEvent_ParamsDataView::GetRegistrationDataView(
    ::blink::mojom::BackgroundFetchRegistrationDataView* output) {
  auto pointer = data_->registration.Get();
  *output = ::blink::mojom::BackgroundFetchRegistrationDataView(pointer, context_);
}




inline void ServiceWorker_DispatchBackgroundFetchFailEvent_ParamsDataView::GetRegistrationDataView(
    ::blink::mojom::BackgroundFetchRegistrationDataView* output) {
  auto pointer = data_->registration.Get();
  *output = ::blink::mojom::BackgroundFetchRegistrationDataView(pointer, context_);
}




inline void ServiceWorker_DispatchBackgroundFetchSuccessEvent_ParamsDataView::GetRegistrationDataView(
    ::blink::mojom::BackgroundFetchRegistrationDataView* output) {
  auto pointer = data_->registration.Get();
  *output = ::blink::mojom::BackgroundFetchRegistrationDataView(pointer, context_);
}




inline void ServiceWorker_DispatchCookieChangeEvent_ParamsDataView::GetCookieDataView(
    ::network::mojom::CanonicalCookieDataView* output) {
  auto pointer = data_->cookie.Get();
  *output = ::network::mojom::CanonicalCookieDataView(pointer, context_);
}




inline void ServiceWorker_DispatchFetchEvent_ParamsDataView::GetParamsDataView(
    ::blink::mojom::DispatchFetchEventParamsDataView* output) {
  auto pointer = data_->params.Get();
  *output = ::blink::mojom::DispatchFetchEventParamsDataView(pointer, context_);
}




inline void ServiceWorker_DispatchNotificationClickEvent_ParamsDataView::GetNotificationIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->notification_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void ServiceWorker_DispatchNotificationClickEvent_ParamsDataView::GetNotificationDataDataView(
    ::blink::mojom::NotificationDataDataView* output) {
  auto pointer = data_->notification_data.Get();
  *output = ::blink::mojom::NotificationDataDataView(pointer, context_);
}
inline void ServiceWorker_DispatchNotificationClickEvent_ParamsDataView::GetReplyDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->reply.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}




inline void ServiceWorker_DispatchNotificationCloseEvent_ParamsDataView::GetNotificationIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->notification_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void ServiceWorker_DispatchNotificationCloseEvent_ParamsDataView::GetNotificationDataDataView(
    ::blink::mojom::NotificationDataDataView* output) {
  auto pointer = data_->notification_data.Get();
  *output = ::blink::mojom::NotificationDataDataView(pointer, context_);
}




inline void ServiceWorker_DispatchPushEvent_ParamsDataView::GetPayloadDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->payload.Get();
  *output = mojo::StringDataView(pointer, context_);
}




inline void ServiceWorker_DispatchSyncEvent_ParamsDataView::GetIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void ServiceWorker_DispatchSyncEvent_ParamsDataView::GetTimeoutDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->timeout.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}








inline void ServiceWorker_DispatchCanMakePaymentEvent_ParamsDataView::GetEventDataDataView(
    ::payments::mojom::CanMakePaymentEventDataDataView* output) {
  auto pointer = data_->event_data.Get();
  *output = ::payments::mojom::CanMakePaymentEventDataDataView(pointer, context_);
}




inline void ServiceWorker_DispatchPaymentRequestEvent_ParamsDataView::GetRequestDataDataView(
    ::payments::mojom::PaymentRequestEventDataDataView* output) {
  auto pointer = data_->request_data.Get();
  *output = ::payments::mojom::PaymentRequestEventDataDataView(pointer, context_);
}




inline void ServiceWorker_DispatchExtendableMessageEvent_ParamsDataView::GetEventDataView(
    ExtendableMessageEventDataView* output) {
  auto pointer = data_->event.Get();
  *output = ExtendableMessageEventDataView(pointer, context_);
}




inline void ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ParamsDataView::GetEventDataView(
    ExtendableMessageEventDataView* output) {
  auto pointer = data_->event.Get();
  *output = ExtendableMessageEventDataView(pointer, context_);
}
inline void ServiceWorker_DispatchExtendableMessageEventWithCustomTimeout_ParamsDataView::GetTimeoutDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->timeout.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}











}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_H_