// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_USB_WEB_USB_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_USB_WEB_USB_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "device/usb/public/mojom/device.mojom-shared-internal.h"
#include "device/usb/public/mojom/device_enumeration_options.mojom-shared-internal.h"
#include "device/usb/public/mojom/device_manager_client.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) WebUsbService_GetDevices_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUsbService_GetDevices_Params_Data));
      new (data()) WebUsbService_GetDevices_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUsbService_GetDevices_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUsbService_GetDevices_Params_Data>(index_);
    }
    WebUsbService_GetDevices_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WebUsbService_GetDevices_Params_Data();
  ~WebUsbService_GetDevices_Params_Data() = delete;
};
static_assert(sizeof(WebUsbService_GetDevices_Params_Data) == 8,
              "Bad sizeof(WebUsbService_GetDevices_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) WebUsbService_GetDevices_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUsbService_GetDevices_ResponseParams_Data));
      new (data()) WebUsbService_GetDevices_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUsbService_GetDevices_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUsbService_GetDevices_ResponseParams_Data>(index_);
    }
    WebUsbService_GetDevices_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::device::mojom::internal::UsbDeviceInfo_Data>>> results;

 private:
  WebUsbService_GetDevices_ResponseParams_Data();
  ~WebUsbService_GetDevices_ResponseParams_Data() = delete;
};
static_assert(sizeof(WebUsbService_GetDevices_ResponseParams_Data) == 16,
              "Bad sizeof(WebUsbService_GetDevices_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) WebUsbService_GetDevice_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUsbService_GetDevice_Params_Data));
      new (data()) WebUsbService_GetDevice_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUsbService_GetDevice_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUsbService_GetDevice_Params_Data>(index_);
    }
    WebUsbService_GetDevice_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> guid;
  mojo::internal::Handle_Data device_requestd;
  uint8_t padfinal_[4];

 private:
  WebUsbService_GetDevice_Params_Data();
  ~WebUsbService_GetDevice_Params_Data() = delete;
};
static_assert(sizeof(WebUsbService_GetDevice_Params_Data) == 24,
              "Bad sizeof(WebUsbService_GetDevice_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) WebUsbService_GetPermission_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUsbService_GetPermission_Params_Data));
      new (data()) WebUsbService_GetPermission_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUsbService_GetPermission_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUsbService_GetPermission_Params_Data>(index_);
    }
    WebUsbService_GetPermission_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::device::mojom::internal::UsbDeviceFilter_Data>>> device_filters;

 private:
  WebUsbService_GetPermission_Params_Data();
  ~WebUsbService_GetPermission_Params_Data() = delete;
};
static_assert(sizeof(WebUsbService_GetPermission_Params_Data) == 16,
              "Bad sizeof(WebUsbService_GetPermission_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) WebUsbService_GetPermission_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUsbService_GetPermission_ResponseParams_Data));
      new (data()) WebUsbService_GetPermission_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUsbService_GetPermission_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUsbService_GetPermission_ResponseParams_Data>(index_);
    }
    WebUsbService_GetPermission_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::UsbDeviceInfo_Data> result;

 private:
  WebUsbService_GetPermission_ResponseParams_Data();
  ~WebUsbService_GetPermission_ResponseParams_Data() = delete;
};
static_assert(sizeof(WebUsbService_GetPermission_ResponseParams_Data) == 16,
              "Bad sizeof(WebUsbService_GetPermission_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) WebUsbService_SetClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUsbService_SetClient_Params_Data));
      new (data()) WebUsbService_SetClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUsbService_SetClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUsbService_SetClient_Params_Data>(index_);
    }
    WebUsbService_SetClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data client;

 private:
  WebUsbService_SetClient_Params_Data();
  ~WebUsbService_SetClient_Params_Data() = delete;
};
static_assert(sizeof(WebUsbService_SetClient_Params_Data) == 16,
              "Bad sizeof(WebUsbService_SetClient_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_USB_WEB_USB_SERVICE_MOJOM_SHARED_INTERNAL_H_