// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_USB_WEB_USB_SERVICE_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_USB_WEB_USB_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/mojom/usb/web_usb_service.mojom-shared-internal.h"
#include "device/usb/public/mojom/device.mojom-shared.h"
#include "device/usb/public/mojom/device_enumeration_options.mojom-shared.h"
#include "device/usb/public/mojom/device_manager_client.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class WebUsbServiceInterfaceBase {};

using WebUsbServicePtrDataView =
    mojo::InterfacePtrDataView<WebUsbServiceInterfaceBase>;
using WebUsbServiceRequestDataView =
    mojo::InterfaceRequestDataView<WebUsbServiceInterfaceBase>;
using WebUsbServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebUsbServiceInterfaceBase>;
using WebUsbServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebUsbServiceInterfaceBase>;
class WebUsbService_GetDevices_ParamsDataView {
 public:
  WebUsbService_GetDevices_ParamsDataView() {}

  WebUsbService_GetDevices_ParamsDataView(
      internal::WebUsbService_GetDevices_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::WebUsbService_GetDevices_Params_Data* data_ = nullptr;
};

class WebUsbService_GetDevices_ResponseParamsDataView {
 public:
  WebUsbService_GetDevices_ResponseParamsDataView() {}

  WebUsbService_GetDevices_ResponseParamsDataView(
      internal::WebUsbService_GetDevices_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetResultsDataView(
      mojo::ArrayDataView<::device::mojom::UsbDeviceInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResults(UserType* output) {
    auto* pointer = data_->results.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::device::mojom::UsbDeviceInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::WebUsbService_GetDevices_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUsbService_GetDevice_ParamsDataView {
 public:
  WebUsbService_GetDevice_ParamsDataView() {}

  WebUsbService_GetDevice_ParamsDataView(
      internal::WebUsbService_GetDevice_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetGuidDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGuid(UserType* output) {
    auto* pointer = data_->guid.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeDeviceRequestd() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::UsbDeviceRequestDataView>(
            &data_->device_requestd, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::WebUsbService_GetDevice_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUsbService_GetPermission_ParamsDataView {
 public:
  WebUsbService_GetPermission_ParamsDataView() {}

  WebUsbService_GetPermission_ParamsDataView(
      internal::WebUsbService_GetPermission_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDeviceFiltersDataView(
      mojo::ArrayDataView<::device::mojom::UsbDeviceFilterDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDeviceFilters(UserType* output) {
    auto* pointer = data_->device_filters.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::device::mojom::UsbDeviceFilterDataView>>(
        pointer, output, context_);
  }
 private:
  internal::WebUsbService_GetPermission_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUsbService_GetPermission_ResponseParamsDataView {
 public:
  WebUsbService_GetPermission_ResponseParamsDataView() {}

  WebUsbService_GetPermission_ResponseParamsDataView(
      internal::WebUsbService_GetPermission_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetResultDataView(
      ::device::mojom::UsbDeviceInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) {
    auto* pointer = data_->result.Get();
    return mojo::internal::Deserialize<::device::mojom::UsbDeviceInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUsbService_GetPermission_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUsbService_SetClient_ParamsDataView {
 public:
  WebUsbService_SetClient_ParamsDataView() {}

  WebUsbService_SetClient_ParamsDataView(
      internal::WebUsbService_SetClient_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::UsbDeviceManagerClientAssociatedPtrInfoDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::WebUsbService_SetClient_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace blink {
namespace mojom {



inline void WebUsbService_GetDevices_ResponseParamsDataView::GetResultsDataView(
    mojo::ArrayDataView<::device::mojom::UsbDeviceInfoDataView>* output) {
  auto pointer = data_->results.Get();
  *output = mojo::ArrayDataView<::device::mojom::UsbDeviceInfoDataView>(pointer, context_);
}


inline void WebUsbService_GetDevice_ParamsDataView::GetGuidDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->guid.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void WebUsbService_GetPermission_ParamsDataView::GetDeviceFiltersDataView(
    mojo::ArrayDataView<::device::mojom::UsbDeviceFilterDataView>* output) {
  auto pointer = data_->device_filters.Get();
  *output = mojo::ArrayDataView<::device::mojom::UsbDeviceFilterDataView>(pointer, context_);
}


inline void WebUsbService_GetPermission_ResponseParamsDataView::GetResultDataView(
    ::device::mojom::UsbDeviceInfoDataView* output) {
  auto pointer = data_->result.Get();
  *output = ::device::mojom::UsbDeviceInfoDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_USB_WEB_USB_SERVICE_MOJOM_SHARED_H_