// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WORKER_DEDICATED_WORKER_FACTORY_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WORKER_DEDICATED_WORKER_FACTORY_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/worker/dedicated_worker_factory.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink {
namespace mojom {
namespace blink {


class PLATFORM_EXPORT DedicatedWorkerFactoryInterceptorForTesting : public DedicatedWorkerFactory {
  virtual DedicatedWorkerFactory* GetForwardingInterface() = 0;
  void CreateDedicatedWorker(const scoped_refptr<const ::blink::SecurityOrigin>& origin, ::service_manager::mojom::blink::InterfaceProviderRequest worker_interface_provider) override;
};
class PLATFORM_EXPORT DedicatedWorkerFactoryAsyncWaiter {
 public:
  explicit DedicatedWorkerFactoryAsyncWaiter(DedicatedWorkerFactory* proxy);
  ~DedicatedWorkerFactoryAsyncWaiter();

 private:
  DedicatedWorkerFactory* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DedicatedWorkerFactoryAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WORKER_DEDICATED_WORKER_FACTORY_MOJOM_BLINK_TEST_UTILS_H_