// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MEDIA_DOWNLOAD_IN_PRODUCT_HELP_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MEDIA_DOWNLOAD_IN_PRODUCT_HELP_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/platform/media_download_in_product_help.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace blink {
namespace mojom {
namespace blink {


class BLINK_PLATFORM_EXPORT MediaDownloadInProductHelpInterceptorForTesting : public MediaDownloadInProductHelp {
  virtual MediaDownloadInProductHelp* GetForwardingInterface() = 0;
  void ShowInProductHelpWidget(const ::blink::WebRect& button_rect) override;
};
class BLINK_PLATFORM_EXPORT MediaDownloadInProductHelpAsyncWaiter {
 public:
  explicit MediaDownloadInProductHelpAsyncWaiter(MediaDownloadInProductHelp* proxy);
  ~MediaDownloadInProductHelpAsyncWaiter();

 private:
  MediaDownloadInProductHelp* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MediaDownloadInProductHelpAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MEDIA_DOWNLOAD_IN_PRODUCT_HELP_MOJOM_BLINK_TEST_UTILS_H_