// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MEDIA_DOWNLOAD_IN_PRODUCT_HELP_MOJOM_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MEDIA_DOWNLOAD_IN_PRODUCT_HELP_MOJOM_TEST_UTILS_H_

#include "third_party/blink/public/platform/media_download_in_product_help.mojom.h"
#include "content/common/content_export.h"


namespace blink {
namespace mojom {


class CONTENT_EXPORT MediaDownloadInProductHelpInterceptorForTesting : public MediaDownloadInProductHelp {
  virtual MediaDownloadInProductHelp* GetForwardingInterface() = 0;
  void ShowInProductHelpWidget(const gfx::Rect& button_rect) override;
};
class CONTENT_EXPORT MediaDownloadInProductHelpAsyncWaiter {
 public:
  explicit MediaDownloadInProductHelpAsyncWaiter(MediaDownloadInProductHelp* proxy);
  ~MediaDownloadInProductHelpAsyncWaiter();

 private:
  MediaDownloadInProductHelp* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MediaDownloadInProductHelpAsyncWaiter);
};




}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MEDIA_DOWNLOAD_IN_PRODUCT_HELP_MOJOM_TEST_UTILS_H_