// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_BADGING_BADGING_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_BADGING_BADGING_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/platform/modules/badging/badging.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class BadgeServiceInterfaceBase {};

using BadgeServicePtrDataView =
    mojo::InterfacePtrDataView<BadgeServiceInterfaceBase>;
using BadgeServiceRequestDataView =
    mojo::InterfaceRequestDataView<BadgeServiceInterfaceBase>;
using BadgeServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<BadgeServiceInterfaceBase>;
using BadgeServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<BadgeServiceInterfaceBase>;
class BadgeService_SetInteger_ParamsDataView {
 public:
  BadgeService_SetInteger_ParamsDataView() {}

  BadgeService_SetInteger_ParamsDataView(
      internal::BadgeService_SetInteger_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint64_t content() const {
    return data_->content;
  }
 private:
  internal::BadgeService_SetInteger_Params_Data* data_ = nullptr;
};

class BadgeService_SetFlag_ParamsDataView {
 public:
  BadgeService_SetFlag_ParamsDataView() {}

  BadgeService_SetFlag_ParamsDataView(
      internal::BadgeService_SetFlag_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::BadgeService_SetFlag_Params_Data* data_ = nullptr;
};

class BadgeService_ClearBadge_ParamsDataView {
 public:
  BadgeService_ClearBadge_ParamsDataView() {}

  BadgeService_ClearBadge_ParamsDataView(
      internal::BadgeService_ClearBadge_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::BadgeService_ClearBadge_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace blink {
namespace mojom {








}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_BADGING_BADGING_MOJOM_SHARED_H_