// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_FONT_UNIQUE_NAME_LOOKUP_FONT_UNIQUE_NAME_LOOKUP_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_FONT_UNIQUE_NAME_LOOKUP_FONT_UNIQUE_NAME_LOOKUP_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/platform/modules/font_unique_name_lookup/font_unique_name_lookup.mojom-shared-internal.h"
#include "mojo/public/mojom/base/file_path.mojom-shared.h"
#include "mojo/public/mojom/base/shared_memory.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class FontUniqueNameLookupInterfaceBase {};

using FontUniqueNameLookupPtrDataView =
    mojo::InterfacePtrDataView<FontUniqueNameLookupInterfaceBase>;
using FontUniqueNameLookupRequestDataView =
    mojo::InterfaceRequestDataView<FontUniqueNameLookupInterfaceBase>;
using FontUniqueNameLookupAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<FontUniqueNameLookupInterfaceBase>;
using FontUniqueNameLookupAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<FontUniqueNameLookupInterfaceBase>;
class FontUniqueNameLookup_GetUniqueNameLookupTable_ParamsDataView {
 public:
  FontUniqueNameLookup_GetUniqueNameLookupTable_ParamsDataView() {}

  FontUniqueNameLookup_GetUniqueNameLookupTable_ParamsDataView(
      internal::FontUniqueNameLookup_GetUniqueNameLookupTable_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FontUniqueNameLookup_GetUniqueNameLookupTable_Params_Data* data_ = nullptr;
};

class FontUniqueNameLookup_GetUniqueNameLookupTable_ResponseParamsDataView {
 public:
  FontUniqueNameLookup_GetUniqueNameLookupTable_ResponseParamsDataView() {}

  FontUniqueNameLookup_GetUniqueNameLookupTable_ResponseParamsDataView(
      internal::FontUniqueNameLookup_GetUniqueNameLookupTable_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFontLookupTableDataView(
      ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFontLookupTable(UserType* output) {
    auto* pointer = data_->font_lookup_table.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
        pointer, output, context_);
  }
 private:
  internal::FontUniqueNameLookup_GetUniqueNameLookupTable_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace blink {
namespace mojom {



inline void FontUniqueNameLookup_GetUniqueNameLookupTable_ResponseParamsDataView::GetFontLookupTableDataView(
    ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output) {
  auto pointer = data_->font_lookup_table.Get();
  *output = ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_FONT_UNIQUE_NAME_LOOKUP_FONT_UNIQUE_NAME_LOOKUP_MOJOM_SHARED_H_