// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_GEOLOCATION_GEOLOCATION_SERVICE_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_GEOLOCATION_GEOLOCATION_SERVICE_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/platform/modules/geolocation/geolocation_service.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace blink {
namespace mojom {
namespace blink {


class BLINK_PLATFORM_EXPORT GeolocationServiceInterceptorForTesting : public GeolocationService {
  virtual GeolocationService* GetForwardingInterface() = 0;
  void CreateGeolocation(::device::mojom::blink::GeolocationRequest request, bool user_gesture) override;
};
class BLINK_PLATFORM_EXPORT GeolocationServiceAsyncWaiter {
 public:
  explicit GeolocationServiceAsyncWaiter(GeolocationService* proxy);
  ~GeolocationServiceAsyncWaiter();

 private:
  GeolocationService* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(GeolocationServiceAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_GEOLOCATION_GEOLOCATION_SERVICE_MOJOM_BLINK_TEST_UTILS_H_