// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_IDLE_IDLE_MANAGER_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_IDLE_IDLE_MANAGER_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/platform/modules/idle/idle_manager.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace blink {
namespace mojom {
namespace blink {


class BLINK_PLATFORM_EXPORT IdleMonitorInterceptorForTesting : public IdleMonitor {
  virtual IdleMonitor* GetForwardingInterface() = 0;
  void Update(IdleState state) override;
};
class BLINK_PLATFORM_EXPORT IdleMonitorAsyncWaiter {
 public:
  explicit IdleMonitorAsyncWaiter(IdleMonitor* proxy);
  ~IdleMonitorAsyncWaiter();

 private:
  IdleMonitor* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(IdleMonitorAsyncWaiter);
};


class BLINK_PLATFORM_EXPORT IdleManagerInterceptorForTesting : public IdleManager {
  virtual IdleManager* GetForwardingInterface() = 0;
  void AddMonitor(uint32_t threshold, IdleMonitorPtr monitor, AddMonitorCallback callback) override;
};
class BLINK_PLATFORM_EXPORT IdleManagerAsyncWaiter {
 public:
  explicit IdleManagerAsyncWaiter(IdleManager* proxy);
  ~IdleManagerAsyncWaiter();
  void AddMonitor(
      uint32_t threshold, IdleMonitorPtr monitor, IdleState* out_state);

 private:
  IdleManager* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(IdleManagerAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_IDLE_IDLE_MANAGER_MOJOM_BLINK_TEST_UTILS_H_