// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_IDLE_IDLE_MANAGER_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_IDLE_IDLE_MANAGER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

struct IdleState_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) IdleMonitor_Update_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdleMonitor_Update_Params_Data));
      new (data()) IdleMonitor_Update_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdleMonitor_Update_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdleMonitor_Update_Params_Data>(index_);
    }
    IdleMonitor_Update_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  IdleMonitor_Update_Params_Data();
  ~IdleMonitor_Update_Params_Data() = delete;
};
static_assert(sizeof(IdleMonitor_Update_Params_Data) == 16,
              "Bad sizeof(IdleMonitor_Update_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) IdleManager_AddMonitor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdleManager_AddMonitor_Params_Data));
      new (data()) IdleManager_AddMonitor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdleManager_AddMonitor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdleManager_AddMonitor_Params_Data>(index_);
    }
    IdleManager_AddMonitor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t threshold;
  mojo::internal::Interface_Data monitor;
  uint8_t padfinal_[4];

 private:
  IdleManager_AddMonitor_Params_Data();
  ~IdleManager_AddMonitor_Params_Data() = delete;
};
static_assert(sizeof(IdleManager_AddMonitor_Params_Data) == 24,
              "Bad sizeof(IdleManager_AddMonitor_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) IdleManager_AddMonitor_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdleManager_AddMonitor_ResponseParams_Data));
      new (data()) IdleManager_AddMonitor_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdleManager_AddMonitor_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdleManager_AddMonitor_ResponseParams_Data>(index_);
    }
    IdleManager_AddMonitor_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  IdleManager_AddMonitor_ResponseParams_Data();
  ~IdleManager_AddMonitor_ResponseParams_Data() = delete;
};
static_assert(sizeof(IdleManager_AddMonitor_ResponseParams_Data) == 16,
              "Bad sizeof(IdleManager_AddMonitor_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_IDLE_IDLE_MANAGER_MOJOM_SHARED_INTERNAL_H_