// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_INSTALLATION_INSTALLATION_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_INSTALLATION_INSTALLATION_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/platform/modules/installation/installation.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace blink {
namespace mojom {
namespace blink {


class BLINK_PLATFORM_EXPORT InstallationServiceInterceptorForTesting : public InstallationService {
  virtual InstallationService* GetForwardingInterface() = 0;
  void OnInstall() override;
};
class BLINK_PLATFORM_EXPORT InstallationServiceAsyncWaiter {
 public:
  explicit InstallationServiceAsyncWaiter(InstallationService* proxy);
  ~InstallationServiceAsyncWaiter();

 private:
  InstallationService* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(InstallationServiceAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_INSTALLATION_INSTALLATION_MOJOM_BLINK_TEST_UTILS_H_