// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_SHARED_INTERNAL_H_
#define UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "ui/accessibility/ax_enums.mojom-shared-internal.h"
#include "ui/accessibility/mojom/ax_action_data.mojom-shared-internal.h"
#include "ui/accessibility/mojom/ax_event.mojom-shared-internal.h"
#include "ui/accessibility/mojom/ax_tree_id.mojom-shared-internal.h"
#include "ui/accessibility/mojom/ax_tree_update.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ax {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  AXHost_RegisterRemoteHost_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXHost_RegisterRemoteHost_Params_Data));
      new (data()) AXHost_RegisterRemoteHost_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXHost_RegisterRemoteHost_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXHost_RegisterRemoteHost_Params_Data>(index_);
    }
    AXHost_RegisterRemoteHost_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data remote;

 private:
  AXHost_RegisterRemoteHost_Params_Data();
  ~AXHost_RegisterRemoteHost_Params_Data() = delete;
};
static_assert(sizeof(AXHost_RegisterRemoteHost_Params_Data) == 16,
              "Bad sizeof(AXHost_RegisterRemoteHost_Params_Data)");
class  AXHost_RegisterRemoteHost_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXHost_RegisterRemoteHost_ResponseParams_Data));
      new (data()) AXHost_RegisterRemoteHost_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXHost_RegisterRemoteHost_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXHost_RegisterRemoteHost_ResponseParams_Data>(index_);
    }
    AXHost_RegisterRemoteHost_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  ::ax::mojom::internal::AXTreeID_Data tree_id;
  uint8_t automation_enabled : 1;
  uint8_t padfinal_[7];

 private:
  AXHost_RegisterRemoteHost_ResponseParams_Data();
  ~AXHost_RegisterRemoteHost_ResponseParams_Data() = delete;
};
static_assert(sizeof(AXHost_RegisterRemoteHost_ResponseParams_Data) == 32,
              "Bad sizeof(AXHost_RegisterRemoteHost_ResponseParams_Data)");
class  AXHost_HandleAccessibilityEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXHost_HandleAccessibilityEvent_Params_Data));
      new (data()) AXHost_HandleAccessibilityEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXHost_HandleAccessibilityEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXHost_HandleAccessibilityEvent_Params_Data>(index_);
    }
    AXHost_HandleAccessibilityEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  ::ax::mojom::internal::AXTreeID_Data tree_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ax::mojom::internal::AXTreeUpdate_Data>>> updates;
  mojo::internal::Pointer<::ax::mojom::internal::AXEvent_Data> event;

 private:
  AXHost_HandleAccessibilityEvent_Params_Data();
  ~AXHost_HandleAccessibilityEvent_Params_Data() = delete;
};
static_assert(sizeof(AXHost_HandleAccessibilityEvent_Params_Data) == 40,
              "Bad sizeof(AXHost_HandleAccessibilityEvent_Params_Data)");
class  AXRemoteHost_OnAutomationEnabled_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXRemoteHost_OnAutomationEnabled_Params_Data));
      new (data()) AXRemoteHost_OnAutomationEnabled_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXRemoteHost_OnAutomationEnabled_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXRemoteHost_OnAutomationEnabled_Params_Data>(index_);
    }
    AXRemoteHost_OnAutomationEnabled_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t enabled : 1;
  uint8_t padfinal_[7];

 private:
  AXRemoteHost_OnAutomationEnabled_Params_Data();
  ~AXRemoteHost_OnAutomationEnabled_Params_Data() = delete;
};
static_assert(sizeof(AXRemoteHost_OnAutomationEnabled_Params_Data) == 16,
              "Bad sizeof(AXRemoteHost_OnAutomationEnabled_Params_Data)");
class  AXRemoteHost_PerformAction_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXRemoteHost_PerformAction_Params_Data));
      new (data()) AXRemoteHost_PerformAction_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXRemoteHost_PerformAction_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXRemoteHost_PerformAction_Params_Data>(index_);
    }
    AXRemoteHost_PerformAction_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::ax::mojom::internal::AXActionData_Data> data;

 private:
  AXRemoteHost_PerformAction_Params_Data();
  ~AXRemoteHost_PerformAction_Params_Data() = delete;
};
static_assert(sizeof(AXRemoteHost_PerformAction_Params_Data) == 16,
              "Bad sizeof(AXRemoteHost_PerformAction_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ax

#endif  // UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_SHARED_INTERNAL_H_