// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_SHARED_H_
#define UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "ui/accessibility/mojom/ax_host.mojom-shared-internal.h"
#include "ui/accessibility/ax_enums.mojom-shared.h"
#include "ui/accessibility/mojom/ax_action_data.mojom-shared.h"
#include "ui/accessibility/mojom/ax_event.mojom-shared.h"
#include "ui/accessibility/mojom/ax_tree_id.mojom-shared.h"
#include "ui/accessibility/mojom/ax_tree_update.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace ax {
namespace mojom {


}  // namespace mojom
}  // namespace ax

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace ax {
namespace mojom {
// Interface base classes. They are used for type safety check.
class AXHostInterfaceBase {};

using AXHostPtrDataView =
    mojo::InterfacePtrDataView<AXHostInterfaceBase>;
using AXHostRequestDataView =
    mojo::InterfaceRequestDataView<AXHostInterfaceBase>;
using AXHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AXHostInterfaceBase>;
using AXHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AXHostInterfaceBase>;
class AXRemoteHostInterfaceBase {};

using AXRemoteHostPtrDataView =
    mojo::InterfacePtrDataView<AXRemoteHostInterfaceBase>;
using AXRemoteHostRequestDataView =
    mojo::InterfaceRequestDataView<AXRemoteHostInterfaceBase>;
using AXRemoteHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AXRemoteHostInterfaceBase>;
using AXRemoteHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AXRemoteHostInterfaceBase>;
class AXHost_RegisterRemoteHost_ParamsDataView {
 public:
  AXHost_RegisterRemoteHost_ParamsDataView() {}

  AXHost_RegisterRemoteHost_ParamsDataView(
      internal::AXHost_RegisterRemoteHost_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRemote() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::ax::mojom::AXRemoteHostPtrDataView>(
            &data_->remote, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::AXHost_RegisterRemoteHost_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AXHost_RegisterRemoteHost_ResponseParamsDataView {
 public:
  AXHost_RegisterRemoteHost_ResponseParamsDataView() {}

  AXHost_RegisterRemoteHost_ResponseParamsDataView(
      internal::AXHost_RegisterRemoteHost_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTreeIdDataView(
      ::ax::mojom::AXTreeIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTreeId(UserType* output) {
    auto* pointer = !data_->tree_id.is_null() ? &data_->tree_id : nullptr;
    return mojo::internal::Deserialize<::ax::mojom::AXTreeIDDataView>(
        pointer, output, context_);
  }
  bool automation_enabled() const {
    return data_->automation_enabled;
  }
 private:
  internal::AXHost_RegisterRemoteHost_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AXHost_HandleAccessibilityEvent_ParamsDataView {
 public:
  AXHost_HandleAccessibilityEvent_ParamsDataView() {}

  AXHost_HandleAccessibilityEvent_ParamsDataView(
      internal::AXHost_HandleAccessibilityEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTreeIdDataView(
      ::ax::mojom::AXTreeIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTreeId(UserType* output) {
    auto* pointer = !data_->tree_id.is_null() ? &data_->tree_id : nullptr;
    return mojo::internal::Deserialize<::ax::mojom::AXTreeIDDataView>(
        pointer, output, context_);
  }
  inline void GetUpdatesDataView(
      mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdates(UserType* output) {
    auto* pointer = data_->updates.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>>(
        pointer, output, context_);
  }
  inline void GetEventDataView(
      ::ax::mojom::AXEventDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEvent(UserType* output) {
    auto* pointer = data_->event.Get();
    return mojo::internal::Deserialize<::ax::mojom::AXEventDataView>(
        pointer, output, context_);
  }
 private:
  internal::AXHost_HandleAccessibilityEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AXRemoteHost_OnAutomationEnabled_ParamsDataView {
 public:
  AXRemoteHost_OnAutomationEnabled_ParamsDataView() {}

  AXRemoteHost_OnAutomationEnabled_ParamsDataView(
      internal::AXRemoteHost_OnAutomationEnabled_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool enabled() const {
    return data_->enabled;
  }
 private:
  internal::AXRemoteHost_OnAutomationEnabled_Params_Data* data_ = nullptr;
};

class AXRemoteHost_PerformAction_ParamsDataView {
 public:
  AXRemoteHost_PerformAction_ParamsDataView() {}

  AXRemoteHost_PerformAction_ParamsDataView(
      internal::AXRemoteHost_PerformAction_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDataDataView(
      ::ax::mojom::AXActionDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<::ax::mojom::AXActionDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::AXRemoteHost_PerformAction_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace ax

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace ax {
namespace mojom {



inline void AXHost_RegisterRemoteHost_ResponseParamsDataView::GetTreeIdDataView(
    ::ax::mojom::AXTreeIDDataView* output) {
  auto pointer = &data_->tree_id;
  *output = ::ax::mojom::AXTreeIDDataView(pointer, context_);
}


inline void AXHost_HandleAccessibilityEvent_ParamsDataView::GetTreeIdDataView(
    ::ax::mojom::AXTreeIDDataView* output) {
  auto pointer = &data_->tree_id;
  *output = ::ax::mojom::AXTreeIDDataView(pointer, context_);
}
inline void AXHost_HandleAccessibilityEvent_ParamsDataView::GetUpdatesDataView(
    mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>* output) {
  auto pointer = data_->updates.Get();
  *output = mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>(pointer, context_);
}
inline void AXHost_HandleAccessibilityEvent_ParamsDataView::GetEventDataView(
    ::ax::mojom::AXEventDataView* output) {
  auto pointer = data_->event.Get();
  *output = ::ax::mojom::AXEventDataView(pointer, context_);
}




inline void AXRemoteHost_PerformAction_ParamsDataView::GetDataDataView(
    ::ax::mojom::AXActionDataDataView* output) {
  auto pointer = data_->data.Get();
  *output = ::ax::mojom::AXActionDataDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace ax

#endif  // UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_SHARED_H_