// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ui/accessibility/mojom/ax_host.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/accessibility/mojom/ax_host.mojom-shared-message-ids.h"


#ifndef UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_JUMBO_H_
#define UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "ui/accessibility/mojom/ax_action_data_mojom_traits.h"
#include "ui/accessibility/mojom/ax_event_mojom_traits.h"
#include "ui/accessibility/mojom/ax_node_data_mojom_traits.h"
#include "ui/accessibility/mojom/ax_relative_bounds_mojom_traits.h"
#include "ui/accessibility/mojom/ax_tree_data_mojom_traits.h"
#include "ui/accessibility/mojom/ax_tree_id_mojom_traits.h"
#include "ui/accessibility/mojom/ax_tree_update_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/mojo/transform_struct_traits.h"
#endif
namespace ax {
namespace mojom {
const char kAXHostServiceName[] = "ax_host_service";
const char AXHost::Name_[] = "ax.mojom.AXHost";

class AXHost_RegisterRemoteHost_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  AXHost_RegisterRemoteHost_ForwardToCallback(
      AXHost::RegisterRemoteHostCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  AXHost::RegisterRemoteHostCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(AXHost_RegisterRemoteHost_ForwardToCallback);
};

AXHostProxy::AXHostProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void AXHostProxy::RegisterRemoteHost(
    AXRemoteHostPtr in_remote, RegisterRemoteHostCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ax::mojom::AXHost::RegisterRemoteHost");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAXHost_RegisterRemoteHost_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ax::mojom::internal::AXHost_RegisterRemoteHost_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::ax::mojom::AXRemoteHostPtrDataView>(
      in_remote, &params->remote, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->remote),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid remote in AXHost.RegisterRemoteHost request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AXHost::Name_);
  message.set_method_name("RegisterRemoteHost");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new AXHost_RegisterRemoteHost_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void AXHostProxy::HandleAccessibilityEvent(
    const ui::AXTreeID& in_tree_id, const std::vector<ui::AXTreeUpdate>& in_updates, const ui::AXEvent& in_event) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ax::mojom::AXHost::HandleAccessibilityEvent");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAXHost_HandleAccessibilityEvent_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ax::mojom::internal::AXHost_HandleAccessibilityEvent_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->tree_id)::BufferWriter tree_id_writer;
  tree_id_writer.AllocateInline(buffer, &params->tree_id);
  mojo::internal::Serialize<::ax::mojom::AXTreeIDDataView>(
      in_tree_id, buffer, &tree_id_writer, true, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tree_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tree_id in AXHost.HandleAccessibilityEvent request");
  typename decltype(params->updates)::BaseType::BufferWriter
      updates_writer;
  const mojo::internal::ContainerValidateParams updates_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>>(
      in_updates, buffer, &updates_writer, &updates_validate_params,
      &serialization_context);
  params->updates.Set(
      updates_writer.is_null() ? nullptr : updates_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->updates.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null updates in AXHost.HandleAccessibilityEvent request");
  typename decltype(params->event)::BaseType::BufferWriter
      event_writer;
  mojo::internal::Serialize<::ax::mojom::AXEventDataView>(
      in_event, buffer, &event_writer, &serialization_context);
  params->event.Set(
      event_writer.is_null() ? nullptr : event_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->event.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null event in AXHost.HandleAccessibilityEvent request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AXHost::Name_);
  message.set_method_name("HandleAccessibilityEvent");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class AXHost_RegisterRemoteHost_ProxyToResponder {
 public:
  static AXHost::RegisterRemoteHostCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<AXHost_RegisterRemoteHost_ProxyToResponder> proxy(
        new AXHost_RegisterRemoteHost_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&AXHost_RegisterRemoteHost_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~AXHost_RegisterRemoteHost_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  AXHost_RegisterRemoteHost_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "AXHost::RegisterRemoteHostCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      const ui::AXTreeID& in_tree_id, bool in_automation_enabled);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(AXHost_RegisterRemoteHost_ProxyToResponder);
};

bool AXHost_RegisterRemoteHost_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ax::mojom::AXHost::RegisterRemoteHostCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::AXHost_RegisterRemoteHost_ResponseParams_Data* params =
      reinterpret_cast<
          internal::AXHost_RegisterRemoteHost_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ui::AXTreeID p_tree_id{};
  bool p_automation_enabled{};
  AXHost_RegisterRemoteHost_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadTreeId(&p_tree_id))
    success = false;
  p_automation_enabled = input_data_view.automation_enabled();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "AXHost::RegisterRemoteHost response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_tree_id), 
std::move(p_automation_enabled));
  return true;
}

void AXHost_RegisterRemoteHost_ProxyToResponder::Run(
    const ui::AXTreeID& in_tree_id, bool in_automation_enabled) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAXHost_RegisterRemoteHost_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ax::mojom::internal::AXHost_RegisterRemoteHost_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->tree_id)::BufferWriter tree_id_writer;
  tree_id_writer.AllocateInline(buffer, &params->tree_id);
  mojo::internal::Serialize<::ax::mojom::AXTreeIDDataView>(
      in_tree_id, buffer, &tree_id_writer, true, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tree_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tree_id in ");
  params->automation_enabled = in_automation_enabled;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXHost::RegisterRemoteHostCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AXHost::Name_);
  message.set_method_name("RegisterRemoteHost");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool AXHostStubDispatch::Accept(
    AXHost* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kAXHost_RegisterRemoteHost_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXHost::RegisterRemoteHost",
               "message", message->name());
#endif
      break;
    }
    case internal::kAXHost_HandleAccessibilityEvent_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXHost::HandleAccessibilityEvent",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AXHost_HandleAccessibilityEvent_Params_Data* params =
          reinterpret_cast<internal::AXHost_HandleAccessibilityEvent_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ui::AXTreeID p_tree_id{};
      std::vector<ui::AXTreeUpdate> p_updates{};
      ui::AXEvent p_event{};
      AXHost_HandleAccessibilityEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTreeId(&p_tree_id))
        success = false;
      if (!input_data_view.ReadUpdates(&p_updates))
        success = false;
      if (!input_data_view.ReadEvent(&p_event))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "AXHost::HandleAccessibilityEvent deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->HandleAccessibilityEvent(
std::move(p_tree_id), 
std::move(p_updates), 
std::move(p_event));
      return true;
    }
  }
  return false;
}

// static
bool AXHostStubDispatch::AcceptWithResponder(
    AXHost* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kAXHost_RegisterRemoteHost_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXHost::RegisterRemoteHost",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::AXHost_RegisterRemoteHost_Params_Data* params =
          reinterpret_cast<
              internal::AXHost_RegisterRemoteHost_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      AXRemoteHostPtr p_remote{};
      AXHost_RegisterRemoteHost_ParamsDataView input_data_view(params, &serialization_context);
      
      p_remote =
          input_data_view.TakeRemote<decltype(p_remote)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "AXHost::RegisterRemoteHost deserializer");
        return false;
      }
      AXHost::RegisterRemoteHostCallback callback =
          AXHost_RegisterRemoteHost_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RegisterRemoteHost(
std::move(p_remote), std::move(callback));
      return true;
    }
    case internal::kAXHost_HandleAccessibilityEvent_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXHost::HandleAccessibilityEvent",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool AXHostRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "AXHost RequestValidator");

  switch (message->header()->name) {
    case internal::kAXHost_RegisterRemoteHost_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AXHost_RegisterRemoteHost_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAXHost_HandleAccessibilityEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AXHost_HandleAccessibilityEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool AXHostResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "AXHost ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kAXHost_RegisterRemoteHost_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::AXHost_RegisterRemoteHost_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
const char AXRemoteHost::Name_[] = "ax.mojom.AXRemoteHost";

AXRemoteHostProxy::AXRemoteHostProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void AXRemoteHostProxy::OnAutomationEnabled(
    bool in_enabled) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ax::mojom::AXRemoteHost::OnAutomationEnabled");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAXRemoteHost_OnAutomationEnabled_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ax::mojom::internal::AXRemoteHost_OnAutomationEnabled_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->enabled = in_enabled;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AXRemoteHost::Name_);
  message.set_method_name("OnAutomationEnabled");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void AXRemoteHostProxy::PerformAction(
    const ui::AXActionData& in_data) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ax::mojom::AXRemoteHost::PerformAction");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAXRemoteHost_PerformAction_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ax::mojom::internal::AXRemoteHost_PerformAction_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->data)::BaseType::BufferWriter
      data_writer;
  mojo::internal::Serialize<::ax::mojom::AXActionDataDataView>(
      in_data, buffer, &data_writer, &serialization_context);
  params->data.Set(
      data_writer.is_null() ? nullptr : data_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null data in AXRemoteHost.PerformAction request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AXRemoteHost::Name_);
  message.set_method_name("PerformAction");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool AXRemoteHostStubDispatch::Accept(
    AXRemoteHost* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kAXRemoteHost_OnAutomationEnabled_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXRemoteHost::OnAutomationEnabled",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AXRemoteHost_OnAutomationEnabled_Params_Data* params =
          reinterpret_cast<internal::AXRemoteHost_OnAutomationEnabled_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_enabled{};
      AXRemoteHost_OnAutomationEnabled_ParamsDataView input_data_view(params, &serialization_context);
      
      p_enabled = input_data_view.enabled();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "AXRemoteHost::OnAutomationEnabled deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnAutomationEnabled(
std::move(p_enabled));
      return true;
    }
    case internal::kAXRemoteHost_PerformAction_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXRemoteHost::PerformAction",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AXRemoteHost_PerformAction_Params_Data* params =
          reinterpret_cast<internal::AXRemoteHost_PerformAction_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ui::AXActionData p_data{};
      AXRemoteHost_PerformAction_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadData(&p_data))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "AXRemoteHost::PerformAction deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->PerformAction(
std::move(p_data));
      return true;
    }
  }
  return false;
}

// static
bool AXRemoteHostStubDispatch::AcceptWithResponder(
    AXRemoteHost* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kAXRemoteHost_OnAutomationEnabled_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXRemoteHost::OnAutomationEnabled",
               "message", message->name());
#endif
      break;
    }
    case internal::kAXRemoteHost_PerformAction_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ax::mojom::AXRemoteHost::PerformAction",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool AXRemoteHostRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "AXRemoteHost RequestValidator");

  switch (message->header()->name) {
    case internal::kAXRemoteHost_OnAutomationEnabled_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AXRemoteHost_OnAutomationEnabled_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAXRemoteHost_PerformAction_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AXRemoteHost_PerformAction_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace ax

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif