// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "ui/base/mojo/ui_base_types.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
namespace ui {
namespace mojom {

std::ostream& operator<<(std::ostream& os, DialogButton value) {
  switch(value) {
    case DialogButton::NONE:
      return os << "DialogButton::NONE";
    case DialogButton::OK:
      return os << "DialogButton::OK";
    case DialogButton::CANCEL:
      return os << "DialogButton::CANCEL";
    default:
      return os << "Unknown DialogButton value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, ModalType value) {
  switch(value) {
    case ModalType::NONE:
      return os << "ModalType::NONE";
    case ModalType::WINDOW:
      return os << "ModalType::WINDOW";
    case ModalType::CHILD:
      return os << "ModalType::CHILD";
    case ModalType::SYSTEM:
      return os << "ModalType::SYSTEM";
    default:
      return os << "Unknown ModalType value: " << static_cast<int32_t>(value);
  }
}

namespace internal {

}  // namespace internal
}  // namespace mojom
}  // namespace ui

#if defined(_MSC_VER)
#pragma warning(pop)
#endif