// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_SHARED_INTERNAL_H_
#define UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "skia/public/interfaces/bitmap.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/accelerated_widget.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace ozone {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  DeviceCursor_SetCursor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceCursor_SetCursor_Params_Data));
      new (data()) DeviceCursor_SetCursor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceCursor_SetCursor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceCursor_SetCursor_Params_Data>(index_);
    }
    DeviceCursor_SetCursor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::AcceleratedWidget_Data> window;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::skia::mojom::internal::Bitmap_Data>>> bitmaps;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> point;
  int32_t frame_delay_ms;
  uint8_t padfinal_[4];

 private:
  DeviceCursor_SetCursor_Params_Data();
  ~DeviceCursor_SetCursor_Params_Data() = delete;
};
static_assert(sizeof(DeviceCursor_SetCursor_Params_Data) == 40,
              "Bad sizeof(DeviceCursor_SetCursor_Params_Data)");
class  DeviceCursor_MoveCursor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceCursor_MoveCursor_Params_Data));
      new (data()) DeviceCursor_MoveCursor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceCursor_MoveCursor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceCursor_MoveCursor_Params_Data>(index_);
    }
    DeviceCursor_MoveCursor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::AcceleratedWidget_Data> window;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> point;

 private:
  DeviceCursor_MoveCursor_Params_Data();
  ~DeviceCursor_MoveCursor_Params_Data() = delete;
};
static_assert(sizeof(DeviceCursor_MoveCursor_Params_Data) == 24,
              "Bad sizeof(DeviceCursor_MoveCursor_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ozone
}  // namespace ui

#endif  // UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_SHARED_INTERNAL_H_