// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_SHARED_H_
#define UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "ui/ozone/public/interfaces/device_cursor.mojom-shared-internal.h"
#include "skia/public/interfaces/bitmap.mojom-shared.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"
#include "ui/gfx/mojo/accelerated_widget.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace ui {
namespace ozone {
namespace mojom {


}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace ui {
namespace ozone {
namespace mojom {
// Interface base classes. They are used for type safety check.
class DeviceCursorInterfaceBase {};

using DeviceCursorPtrDataView =
    mojo::InterfacePtrDataView<DeviceCursorInterfaceBase>;
using DeviceCursorRequestDataView =
    mojo::InterfaceRequestDataView<DeviceCursorInterfaceBase>;
using DeviceCursorAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DeviceCursorInterfaceBase>;
using DeviceCursorAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DeviceCursorInterfaceBase>;
class DeviceCursor_SetCursor_ParamsDataView {
 public:
  DeviceCursor_SetCursor_ParamsDataView() {}

  DeviceCursor_SetCursor_ParamsDataView(
      internal::DeviceCursor_SetCursor_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWindowDataView(
      ::gfx::mojom::AcceleratedWidgetDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWindow(UserType* output) {
    auto* pointer = data_->window.Get();
    return mojo::internal::Deserialize<::gfx::mojom::AcceleratedWidgetDataView>(
        pointer, output, context_);
  }
  inline void GetBitmapsDataView(
      mojo::ArrayDataView<::skia::mojom::BitmapDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBitmaps(UserType* output) {
    auto* pointer = data_->bitmaps.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::skia::mojom::BitmapDataView>>(
        pointer, output, context_);
  }
  inline void GetPointDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPoint(UserType* output) {
    auto* pointer = data_->point.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
  int32_t frame_delay_ms() const {
    return data_->frame_delay_ms;
  }
 private:
  internal::DeviceCursor_SetCursor_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DeviceCursor_MoveCursor_ParamsDataView {
 public:
  DeviceCursor_MoveCursor_ParamsDataView() {}

  DeviceCursor_MoveCursor_ParamsDataView(
      internal::DeviceCursor_MoveCursor_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWindowDataView(
      ::gfx::mojom::AcceleratedWidgetDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWindow(UserType* output) {
    auto* pointer = data_->window.Get();
    return mojo::internal::Deserialize<::gfx::mojom::AcceleratedWidgetDataView>(
        pointer, output, context_);
  }
  inline void GetPointDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPoint(UserType* output) {
    auto* pointer = data_->point.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
 private:
  internal::DeviceCursor_MoveCursor_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace ui {
namespace ozone {
namespace mojom {

inline void DeviceCursor_SetCursor_ParamsDataView::GetWindowDataView(
    ::gfx::mojom::AcceleratedWidgetDataView* output) {
  auto pointer = data_->window.Get();
  *output = ::gfx::mojom::AcceleratedWidgetDataView(pointer, context_);
}
inline void DeviceCursor_SetCursor_ParamsDataView::GetBitmapsDataView(
    mojo::ArrayDataView<::skia::mojom::BitmapDataView>* output) {
  auto pointer = data_->bitmaps.Get();
  *output = mojo::ArrayDataView<::skia::mojom::BitmapDataView>(pointer, context_);
}
inline void DeviceCursor_SetCursor_ParamsDataView::GetPointDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->point.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}


inline void DeviceCursor_MoveCursor_ParamsDataView::GetWindowDataView(
    ::gfx::mojom::AcceleratedWidgetDataView* output) {
  auto pointer = data_->window.Get();
  *output = ::gfx::mojom::AcceleratedWidgetDataView(pointer, context_);
}
inline void DeviceCursor_MoveCursor_ParamsDataView::GetPointDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->point.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace ozone
}  // namespace ui

#endif  // UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_SHARED_H_