// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "ui/ozone/public/interfaces/device_cursor.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_JUMBO_H_
#define UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/big_buffer_mojom_traits.h"
#include "skia/public/interfaces/bitmap_skbitmap_struct_traits.h"
#include "skia/public/interfaces/image_info_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/mojo/accelerated_widget_struct_traits.h"
#endif


namespace ui {
namespace ozone {
namespace mojom {


void DeviceCursorInterceptorForTesting::SetCursor(gfx::AcceleratedWidget window, const std::vector<SkBitmap>& bitmaps, const gfx::Point& point, int32_t frame_delay_ms) {
  GetForwardingInterface()->SetCursor(std::move(window), std::move(bitmaps), std::move(point), std::move(frame_delay_ms));
}
void DeviceCursorInterceptorForTesting::MoveCursor(gfx::AcceleratedWidget window, const gfx::Point& point) {
  GetForwardingInterface()->MoveCursor(std::move(window), std::move(point));
}
DeviceCursorAsyncWaiter::DeviceCursorAsyncWaiter(
    DeviceCursor* proxy) : proxy_(proxy) {}

DeviceCursorAsyncWaiter::~DeviceCursorAsyncWaiter() = default;






}  // namespace mojom
}  // namespace ozone
}  // namespace ui

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif