// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_TEST_UTILS_H_
#define UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_TEST_UTILS_H_

#include "ui/ozone/public/interfaces/device_cursor.mojom.h"


namespace ui {
namespace ozone {
namespace mojom {


class  DeviceCursorInterceptorForTesting : public DeviceCursor {
  virtual DeviceCursor* GetForwardingInterface() = 0;
  void SetCursor(gfx::AcceleratedWidget window, const std::vector<SkBitmap>& bitmaps, const gfx::Point& point, int32_t frame_delay_ms) override;
  void MoveCursor(gfx::AcceleratedWidget window, const gfx::Point& point) override;
};
class  DeviceCursorAsyncWaiter {
 public:
  explicit DeviceCursorAsyncWaiter(DeviceCursor* proxy);
  ~DeviceCursorAsyncWaiter();

 private:
  DeviceCursor* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DeviceCursorAsyncWaiter);
};




}  // namespace mojom
}  // namespace ozone
}  // namespace ui

#endif  // UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_TEST_UTILS_H_