// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ui/ozone/public/interfaces/device_cursor.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/ozone/public/interfaces/device_cursor.mojom-shared-message-ids.h"


#ifndef UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_JUMBO_H_
#define UI_OZONE_PUBLIC_INTERFACES_DEVICE_CURSOR_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/big_buffer_mojom_traits.h"
#include "skia/public/interfaces/bitmap_skbitmap_struct_traits.h"
#include "skia/public/interfaces/image_info_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/mojo/accelerated_widget_struct_traits.h"
#endif
namespace ui {
namespace ozone {
namespace mojom {
const char DeviceCursor::Name_[] = "ui.ozone.mojom.DeviceCursor";

DeviceCursorProxy::DeviceCursorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void DeviceCursorProxy::SetCursor(
    gfx::AcceleratedWidget in_window, const std::vector<SkBitmap>& in_bitmaps, const gfx::Point& in_point, int32_t in_frame_delay_ms) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DeviceCursor::SetCursor");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDeviceCursor_SetCursor_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DeviceCursor_SetCursor_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->window)::BaseType::BufferWriter
      window_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_window, buffer, &window_writer, &serialization_context);
  params->window.Set(
      window_writer.is_null() ? nullptr : window_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->window.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null window in DeviceCursor.SetCursor request");
  typename decltype(params->bitmaps)::BaseType::BufferWriter
      bitmaps_writer;
  const mojo::internal::ContainerValidateParams bitmaps_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::skia::mojom::BitmapDataView>>(
      in_bitmaps, buffer, &bitmaps_writer, &bitmaps_validate_params,
      &serialization_context);
  params->bitmaps.Set(
      bitmaps_writer.is_null() ? nullptr : bitmaps_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->bitmaps.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null bitmaps in DeviceCursor.SetCursor request");
  typename decltype(params->point)::BaseType::BufferWriter
      point_writer;
  mojo::internal::Serialize<::gfx::mojom::PointDataView>(
      in_point, buffer, &point_writer, &serialization_context);
  params->point.Set(
      point_writer.is_null() ? nullptr : point_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->point.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null point in DeviceCursor.SetCursor request");
  params->frame_delay_ms = in_frame_delay_ms;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DeviceCursor::Name_);
  message.set_method_name("SetCursor");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DeviceCursorProxy::MoveCursor(
    gfx::AcceleratedWidget in_window, const gfx::Point& in_point) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DeviceCursor::MoveCursor");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDeviceCursor_MoveCursor_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DeviceCursor_MoveCursor_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->window)::BaseType::BufferWriter
      window_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_window, buffer, &window_writer, &serialization_context);
  params->window.Set(
      window_writer.is_null() ? nullptr : window_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->window.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null window in DeviceCursor.MoveCursor request");
  typename decltype(params->point)::BaseType::BufferWriter
      point_writer;
  mojo::internal::Serialize<::gfx::mojom::PointDataView>(
      in_point, buffer, &point_writer, &serialization_context);
  params->point.Set(
      point_writer.is_null() ? nullptr : point_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->point.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null point in DeviceCursor.MoveCursor request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DeviceCursor::Name_);
  message.set_method_name("MoveCursor");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool DeviceCursorStubDispatch::Accept(
    DeviceCursor* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kDeviceCursor_SetCursor_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DeviceCursor::SetCursor",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DeviceCursor_SetCursor_Params_Data* params =
          reinterpret_cast<internal::DeviceCursor_SetCursor_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::AcceleratedWidget p_window{};
      std::vector<SkBitmap> p_bitmaps{};
      gfx::Point p_point{};
      int32_t p_frame_delay_ms{};
      DeviceCursor_SetCursor_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadWindow(&p_window))
        success = false;
      if (!input_data_view.ReadBitmaps(&p_bitmaps))
        success = false;
      if (!input_data_view.ReadPoint(&p_point))
        success = false;
      p_frame_delay_ms = input_data_view.frame_delay_ms();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DeviceCursor::SetCursor deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetCursor(
std::move(p_window), 
std::move(p_bitmaps), 
std::move(p_point), 
std::move(p_frame_delay_ms));
      return true;
    }
    case internal::kDeviceCursor_MoveCursor_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DeviceCursor::MoveCursor",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DeviceCursor_MoveCursor_Params_Data* params =
          reinterpret_cast<internal::DeviceCursor_MoveCursor_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::AcceleratedWidget p_window{};
      gfx::Point p_point{};
      DeviceCursor_MoveCursor_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadWindow(&p_window))
        success = false;
      if (!input_data_view.ReadPoint(&p_point))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DeviceCursor::MoveCursor deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->MoveCursor(
std::move(p_window), 
std::move(p_point));
      return true;
    }
  }
  return false;
}

// static
bool DeviceCursorStubDispatch::AcceptWithResponder(
    DeviceCursor* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kDeviceCursor_SetCursor_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DeviceCursor::SetCursor",
               "message", message->name());
#endif
      break;
    }
    case internal::kDeviceCursor_MoveCursor_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DeviceCursor::MoveCursor",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool DeviceCursorRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "DeviceCursor RequestValidator");

  switch (message->header()->name) {
    case internal::kDeviceCursor_SetCursor_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DeviceCursor_SetCursor_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDeviceCursor_MoveCursor_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DeviceCursor_MoveCursor_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif