// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "ui/ozone/public/interfaces/drm_device.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_JUMBO_H_
#define UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/file_mojom_traits.h"
#include "mojo/public/cpp/base/file_path_mojom_traits.h"
#include "ui/display/mojo/display_constants_struct_traits.h"
#include "ui/display/mojo/display_mode_struct_traits.h"
#include "ui/display/mojo/display_snapshot_struct_traits.h"
#include "ui/display/mojo/gamma_ramp_rgb_entry_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/ipc/color/gfx_param_traits.h"
#include "ui/gfx/mojo/accelerated_widget_struct_traits.h"
#include "ui/gfx/mojo/buffer_types_struct_traits.h"
#include "ui/gfx/mojo/overlay_transform_struct_traits.h"
#include "ui/ozone/public/interfaces/overlay_surface_candidate_struct_traits.h"
#endif


namespace ui {
namespace ozone {
namespace mojom {


void DrmDeviceInterceptorForTesting::StartDrmDevice(StartDrmDeviceCallback callback) {
  GetForwardingInterface()->StartDrmDevice(std::move(callback));
}
void DrmDeviceInterceptorForTesting::CreateWindow(gfx::AcceleratedWidget widget) {
  GetForwardingInterface()->CreateWindow(std::move(widget));
}
void DrmDeviceInterceptorForTesting::DestroyWindow(gfx::AcceleratedWidget widget) {
  GetForwardingInterface()->DestroyWindow(std::move(widget));
}
void DrmDeviceInterceptorForTesting::SetWindowBounds(gfx::AcceleratedWidget widget, const gfx::Rect& bounds) {
  GetForwardingInterface()->SetWindowBounds(std::move(widget), std::move(bounds));
}
void DrmDeviceInterceptorForTesting::TakeDisplayControl(TakeDisplayControlCallback callback) {
  GetForwardingInterface()->TakeDisplayControl(std::move(callback));
}
void DrmDeviceInterceptorForTesting::RelinquishDisplayControl(RelinquishDisplayControlCallback callback) {
  GetForwardingInterface()->RelinquishDisplayControl(std::move(callback));
}
void DrmDeviceInterceptorForTesting::RefreshNativeDisplays(RefreshNativeDisplaysCallback callback) {
  GetForwardingInterface()->RefreshNativeDisplays(std::move(callback));
}
void DrmDeviceInterceptorForTesting::AddGraphicsDevice(const base::FilePath& path, base::File file) {
  GetForwardingInterface()->AddGraphicsDevice(std::move(path), std::move(file));
}
void DrmDeviceInterceptorForTesting::RemoveGraphicsDevice(const base::FilePath& path) {
  GetForwardingInterface()->RemoveGraphicsDevice(std::move(path));
}
void DrmDeviceInterceptorForTesting::DisableNativeDisplay(int64_t display_id, DisableNativeDisplayCallback callback) {
  GetForwardingInterface()->DisableNativeDisplay(std::move(display_id), std::move(callback));
}
void DrmDeviceInterceptorForTesting::ConfigureNativeDisplay(int64_t display_id, std::unique_ptr<display::DisplayMode> display_mode, const gfx::Point& point, ConfigureNativeDisplayCallback callback) {
  GetForwardingInterface()->ConfigureNativeDisplay(std::move(display_id), std::move(display_mode), std::move(point), std::move(callback));
}
void DrmDeviceInterceptorForTesting::GetHDCPState(int64_t display_id, GetHDCPStateCallback callback) {
  GetForwardingInterface()->GetHDCPState(std::move(display_id), std::move(callback));
}
void DrmDeviceInterceptorForTesting::SetHDCPState(int64_t display_id, display::HDCPState state, SetHDCPStateCallback callback) {
  GetForwardingInterface()->SetHDCPState(std::move(display_id), std::move(state), std::move(callback));
}
void DrmDeviceInterceptorForTesting::SetColorMatrix(int64_t display_id, const std::vector<float>& color_matrix) {
  GetForwardingInterface()->SetColorMatrix(std::move(display_id), std::move(color_matrix));
}
void DrmDeviceInterceptorForTesting::SetGammaCorrection(int64_t display_id, const std::vector<display::GammaRampRGBEntry>& degamma_lut, const std::vector<display::GammaRampRGBEntry>& gamma_lut) {
  GetForwardingInterface()->SetGammaCorrection(std::move(display_id), std::move(degamma_lut), std::move(gamma_lut));
}
void DrmDeviceInterceptorForTesting::CheckOverlayCapabilities(gfx::AcceleratedWidget widget, const std::vector<ui::OverlaySurfaceCandidate>& candidates, CheckOverlayCapabilitiesCallback callback) {
  GetForwardingInterface()->CheckOverlayCapabilities(std::move(widget), std::move(candidates), std::move(callback));
}
DrmDeviceAsyncWaiter::DrmDeviceAsyncWaiter(
    DrmDevice* proxy) : proxy_(proxy) {}

DrmDeviceAsyncWaiter::~DrmDeviceAsyncWaiter() = default;

void DrmDeviceAsyncWaiter::StartDrmDevice(
    bool* out_success) {
  base::RunLoop loop;
  proxy_->StartDrmDevice(
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}
void DrmDeviceAsyncWaiter::TakeDisplayControl(
    bool* out_success) {
  base::RunLoop loop;
  proxy_->TakeDisplayControl(
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}
void DrmDeviceAsyncWaiter::RelinquishDisplayControl(
    bool* out_success) {
  base::RunLoop loop;
  proxy_->RelinquishDisplayControl(
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}
void DrmDeviceAsyncWaiter::RefreshNativeDisplays(
    std::vector<std::unique_ptr<display::DisplaySnapshot>>* out_display_snapshots) {
  base::RunLoop loop;
  proxy_->RefreshNativeDisplays(
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<std::unique_ptr<display::DisplaySnapshot>>* out_display_snapshots
,
             std::vector<std::unique_ptr<display::DisplaySnapshot>> display_snapshots) {*out_display_snapshots = std::move(display_snapshots);
            loop->Quit();
          },
          &loop,
          out_display_snapshots));
  loop.Run();
}
void DrmDeviceAsyncWaiter::DisableNativeDisplay(
    int64_t display_id, int64_t* out_display_id, bool* out_success) {
  base::RunLoop loop;
  proxy_->DisableNativeDisplay(std::move(display_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             int64_t* out_display_id
,
             bool* out_success
,
             int64_t display_id,
             bool success) {*out_display_id = std::move(display_id);*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_display_id,
          out_success));
  loop.Run();
}
void DrmDeviceAsyncWaiter::ConfigureNativeDisplay(
    int64_t display_id, std::unique_ptr<display::DisplayMode> display_mode, const gfx::Point& point, int64_t* out_display_id, bool* out_success) {
  base::RunLoop loop;
  proxy_->ConfigureNativeDisplay(std::move(display_id),std::move(display_mode),std::move(point),
      base::BindOnce(
          [](base::RunLoop* loop,
             int64_t* out_display_id
,
             bool* out_success
,
             int64_t display_id,
             bool success) {*out_display_id = std::move(display_id);*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_display_id,
          out_success));
  loop.Run();
}
void DrmDeviceAsyncWaiter::GetHDCPState(
    int64_t display_id, int64_t* out_display_id, bool* out_success, display::HDCPState* out_state) {
  base::RunLoop loop;
  proxy_->GetHDCPState(std::move(display_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             int64_t* out_display_id
,
             bool* out_success
,
             display::HDCPState* out_state
,
             int64_t display_id,
             bool success,
             display::HDCPState state) {*out_display_id = std::move(display_id);*out_success = std::move(success);*out_state = std::move(state);
            loop->Quit();
          },
          &loop,
          out_display_id,
          out_success,
          out_state));
  loop.Run();
}
void DrmDeviceAsyncWaiter::SetHDCPState(
    int64_t display_id, display::HDCPState state, int64_t* out_display_id, bool* out_success) {
  base::RunLoop loop;
  proxy_->SetHDCPState(std::move(display_id),std::move(state),
      base::BindOnce(
          [](base::RunLoop* loop,
             int64_t* out_display_id
,
             bool* out_success
,
             int64_t display_id,
             bool success) {*out_display_id = std::move(display_id);*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_display_id,
          out_success));
  loop.Run();
}
void DrmDeviceAsyncWaiter::CheckOverlayCapabilities(
    gfx::AcceleratedWidget widget, const std::vector<ui::OverlaySurfaceCandidate>& candidates, gfx::AcceleratedWidget* out_widget, std::vector<ui::OverlaySurfaceCandidate>* out_candidates, std::vector<ui::OverlayStatus>* out_status) {
  base::RunLoop loop;
  proxy_->CheckOverlayCapabilities(std::move(widget),std::move(candidates),
      base::BindOnce(
          [](base::RunLoop* loop,
             gfx::AcceleratedWidget* out_widget
,
             std::vector<ui::OverlaySurfaceCandidate>* out_candidates
,
             std::vector<ui::OverlayStatus>* out_status
,
             gfx::AcceleratedWidget widget,
             const std::vector<ui::OverlaySurfaceCandidate>& candidates,
             const std::vector<ui::OverlayStatus>& status) {*out_widget = std::move(widget);*out_candidates = std::move(candidates);*out_status = std::move(status);
            loop->Quit();
          },
          &loop,
          out_widget,
          out_candidates,
          out_status));
  loop.Run();
}





}  // namespace mojom
}  // namespace ozone
}  // namespace ui

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif