// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ui/ozone/public/interfaces/drm_device.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/ozone/public/interfaces/drm_device.mojom-shared-message-ids.h"


#ifndef UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_JUMBO_H_
#define UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/file_mojom_traits.h"
#include "mojo/public/cpp/base/file_path_mojom_traits.h"
#include "ui/display/mojo/display_constants_struct_traits.h"
#include "ui/display/mojo/display_mode_struct_traits.h"
#include "ui/display/mojo/display_snapshot_struct_traits.h"
#include "ui/display/mojo/gamma_ramp_rgb_entry_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/ipc/color/gfx_param_traits.h"
#include "ui/gfx/mojo/accelerated_widget_struct_traits.h"
#include "ui/gfx/mojo/buffer_types_struct_traits.h"
#include "ui/gfx/mojo/overlay_transform_struct_traits.h"
#include "ui/ozone/public/interfaces/overlay_surface_candidate_struct_traits.h"
#endif
namespace ui {
namespace ozone {
namespace mojom {
const char DrmDevice::Name_[] = "ui.ozone.mojom.DrmDevice";
bool DrmDevice::StartDrmDevice(bool* out_success) {
  NOTREACHED();
  return false;
}
class DrmDevice_StartDrmDevice_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  DrmDevice_StartDrmDevice_HandleSyncResponse(
      bool* result, bool* out_success)
      : result_(result), out_success_(out_success) {
    DCHECK(!*result_);
  }
  bool Accept(mojo::Message* message) override;
 private:
  bool* result_;
  bool* out_success_;DISALLOW_COPY_AND_ASSIGN(DrmDevice_StartDrmDevice_HandleSyncResponse);
};

class DrmDevice_StartDrmDevice_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_StartDrmDevice_ForwardToCallback(
      DrmDevice::StartDrmDeviceCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::StartDrmDeviceCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_StartDrmDevice_ForwardToCallback);
};

class DrmDevice_TakeDisplayControl_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_TakeDisplayControl_ForwardToCallback(
      DrmDevice::TakeDisplayControlCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::TakeDisplayControlCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_TakeDisplayControl_ForwardToCallback);
};

class DrmDevice_RelinquishDisplayControl_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_RelinquishDisplayControl_ForwardToCallback(
      DrmDevice::RelinquishDisplayControlCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::RelinquishDisplayControlCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_RelinquishDisplayControl_ForwardToCallback);
};

class DrmDevice_RefreshNativeDisplays_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_RefreshNativeDisplays_ForwardToCallback(
      DrmDevice::RefreshNativeDisplaysCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::RefreshNativeDisplaysCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_RefreshNativeDisplays_ForwardToCallback);
};

class DrmDevice_DisableNativeDisplay_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_DisableNativeDisplay_ForwardToCallback(
      DrmDevice::DisableNativeDisplayCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::DisableNativeDisplayCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_DisableNativeDisplay_ForwardToCallback);
};

class DrmDevice_ConfigureNativeDisplay_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_ConfigureNativeDisplay_ForwardToCallback(
      DrmDevice::ConfigureNativeDisplayCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::ConfigureNativeDisplayCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_ConfigureNativeDisplay_ForwardToCallback);
};

class DrmDevice_GetHDCPState_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_GetHDCPState_ForwardToCallback(
      DrmDevice::GetHDCPStateCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::GetHDCPStateCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_GetHDCPState_ForwardToCallback);
};

class DrmDevice_SetHDCPState_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_SetHDCPState_ForwardToCallback(
      DrmDevice::SetHDCPStateCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::SetHDCPStateCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_SetHDCPState_ForwardToCallback);
};

class DrmDevice_CheckOverlayCapabilities_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DrmDevice_CheckOverlayCapabilities_ForwardToCallback(
      DrmDevice::CheckOverlayCapabilitiesCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DrmDevice::CheckOverlayCapabilitiesCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DrmDevice_CheckOverlayCapabilities_ForwardToCallback);
};

DrmDeviceProxy::DrmDeviceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
bool DrmDeviceProxy::StartDrmDevice(
    bool* out_param_success) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::StartDrmDevice");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_StartDrmDevice_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_StartDrmDevice_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("StartDrmDevice");
#endif

  bool result = false;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_StartDrmDevice_HandleSyncResponse(
          &result, out_param_success));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
  return result;
}

void DrmDeviceProxy::StartDrmDevice(
    StartDrmDeviceCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::StartDrmDevice");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_StartDrmDevice_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_StartDrmDevice_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("StartDrmDevice");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_StartDrmDevice_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DrmDeviceProxy::CreateWindow(
    gfx::AcceleratedWidget in_widget) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::CreateWindow");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_CreateWindow_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_CreateWindow_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in DrmDevice.CreateWindow request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("CreateWindow");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DrmDeviceProxy::DestroyWindow(
    gfx::AcceleratedWidget in_widget) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::DestroyWindow");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_DestroyWindow_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_DestroyWindow_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in DrmDevice.DestroyWindow request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("DestroyWindow");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DrmDeviceProxy::SetWindowBounds(
    gfx::AcceleratedWidget in_widget, const gfx::Rect& in_bounds) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::SetWindowBounds");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_SetWindowBounds_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_SetWindowBounds_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in DrmDevice.SetWindowBounds request");
  typename decltype(params->bounds)::BaseType::BufferWriter
      bounds_writer;
  mojo::internal::Serialize<::gfx::mojom::RectDataView>(
      in_bounds, buffer, &bounds_writer, &serialization_context);
  params->bounds.Set(
      bounds_writer.is_null() ? nullptr : bounds_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->bounds.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null bounds in DrmDevice.SetWindowBounds request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("SetWindowBounds");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DrmDeviceProxy::TakeDisplayControl(
    TakeDisplayControlCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::TakeDisplayControl");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_TakeDisplayControl_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_TakeDisplayControl_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("TakeDisplayControl");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_TakeDisplayControl_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DrmDeviceProxy::RelinquishDisplayControl(
    RelinquishDisplayControlCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::RelinquishDisplayControl");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_RelinquishDisplayControl_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_RelinquishDisplayControl_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("RelinquishDisplayControl");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_RelinquishDisplayControl_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DrmDeviceProxy::RefreshNativeDisplays(
    RefreshNativeDisplaysCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::RefreshNativeDisplays");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_RefreshNativeDisplays_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_RefreshNativeDisplays_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("RefreshNativeDisplays");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_RefreshNativeDisplays_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DrmDeviceProxy::AddGraphicsDevice(
    const base::FilePath& in_path, base::File in_file) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::AddGraphicsDevice");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_AddGraphicsDevice_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_AddGraphicsDevice_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->path)::BaseType::BufferWriter
      path_writer;
  mojo::internal::Serialize<::mojo_base::mojom::FilePathDataView>(
      in_path, buffer, &path_writer, &serialization_context);
  params->path.Set(
      path_writer.is_null() ? nullptr : path_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->path.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null path in DrmDevice.AddGraphicsDevice request");
  typename decltype(params->file)::BaseType::BufferWriter
      file_writer;
  mojo::internal::Serialize<::mojo_base::mojom::FileDataView>(
      in_file, buffer, &file_writer, &serialization_context);
  params->file.Set(
      file_writer.is_null() ? nullptr : file_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->file.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null file in DrmDevice.AddGraphicsDevice request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("AddGraphicsDevice");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DrmDeviceProxy::RemoveGraphicsDevice(
    const base::FilePath& in_path) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::RemoveGraphicsDevice");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_RemoveGraphicsDevice_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_RemoveGraphicsDevice_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->path)::BaseType::BufferWriter
      path_writer;
  mojo::internal::Serialize<::mojo_base::mojom::FilePathDataView>(
      in_path, buffer, &path_writer, &serialization_context);
  params->path.Set(
      path_writer.is_null() ? nullptr : path_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->path.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null path in DrmDevice.RemoveGraphicsDevice request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("RemoveGraphicsDevice");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DrmDeviceProxy::DisableNativeDisplay(
    int64_t in_display_id, DisableNativeDisplayCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::DisableNativeDisplay");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_DisableNativeDisplay_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_DisableNativeDisplay_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("DisableNativeDisplay");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_DisableNativeDisplay_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DrmDeviceProxy::ConfigureNativeDisplay(
    int64_t in_display_id, std::unique_ptr<display::DisplayMode> in_display_mode, const gfx::Point& in_point, ConfigureNativeDisplayCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::ConfigureNativeDisplay");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_ConfigureNativeDisplay_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_ConfigureNativeDisplay_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  typename decltype(params->display_mode)::BaseType::BufferWriter
      display_mode_writer;
  mojo::internal::Serialize<::display::mojom::DisplayModeDataView>(
      in_display_mode, buffer, &display_mode_writer, &serialization_context);
  params->display_mode.Set(
      display_mode_writer.is_null() ? nullptr : display_mode_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->display_mode.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null display_mode in DrmDevice.ConfigureNativeDisplay request");
  typename decltype(params->point)::BaseType::BufferWriter
      point_writer;
  mojo::internal::Serialize<::gfx::mojom::PointDataView>(
      in_point, buffer, &point_writer, &serialization_context);
  params->point.Set(
      point_writer.is_null() ? nullptr : point_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->point.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null point in DrmDevice.ConfigureNativeDisplay request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("ConfigureNativeDisplay");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_ConfigureNativeDisplay_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DrmDeviceProxy::GetHDCPState(
    int64_t in_display_id, GetHDCPStateCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::GetHDCPState");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_GetHDCPState_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_GetHDCPState_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("GetHDCPState");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_GetHDCPState_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DrmDeviceProxy::SetHDCPState(
    int64_t in_display_id, display::HDCPState in_state, SetHDCPStateCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::SetHDCPState");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_SetHDCPState_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_SetHDCPState_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  mojo::internal::Serialize<::display::mojom::HDCPState>(
      in_state, &params->state);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("SetHDCPState");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_SetHDCPState_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DrmDeviceProxy::SetColorMatrix(
    int64_t in_display_id, const std::vector<float>& in_color_matrix) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::SetColorMatrix");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_SetColorMatrix_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_SetColorMatrix_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  typename decltype(params->color_matrix)::BaseType::BufferWriter
      color_matrix_writer;
  const mojo::internal::ContainerValidateParams color_matrix_validate_params(
      9, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<float>>(
      in_color_matrix, buffer, &color_matrix_writer, &color_matrix_validate_params,
      &serialization_context);
  params->color_matrix.Set(
      color_matrix_writer.is_null() ? nullptr : color_matrix_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->color_matrix.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null color_matrix in DrmDevice.SetColorMatrix request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("SetColorMatrix");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DrmDeviceProxy::SetGammaCorrection(
    int64_t in_display_id, const std::vector<display::GammaRampRGBEntry>& in_degamma_lut, const std::vector<display::GammaRampRGBEntry>& in_gamma_lut) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::SetGammaCorrection");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_SetGammaCorrection_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_SetGammaCorrection_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  typename decltype(params->degamma_lut)::BaseType::BufferWriter
      degamma_lut_writer;
  const mojo::internal::ContainerValidateParams degamma_lut_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>>(
      in_degamma_lut, buffer, &degamma_lut_writer, &degamma_lut_validate_params,
      &serialization_context);
  params->degamma_lut.Set(
      degamma_lut_writer.is_null() ? nullptr : degamma_lut_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->degamma_lut.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null degamma_lut in DrmDevice.SetGammaCorrection request");
  typename decltype(params->gamma_lut)::BaseType::BufferWriter
      gamma_lut_writer;
  const mojo::internal::ContainerValidateParams gamma_lut_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>>(
      in_gamma_lut, buffer, &gamma_lut_writer, &gamma_lut_validate_params,
      &serialization_context);
  params->gamma_lut.Set(
      gamma_lut_writer.is_null() ? nullptr : gamma_lut_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->gamma_lut.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null gamma_lut in DrmDevice.SetGammaCorrection request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("SetGammaCorrection");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DrmDeviceProxy::CheckOverlayCapabilities(
    gfx::AcceleratedWidget in_widget, const std::vector<ui::OverlaySurfaceCandidate>& in_candidates, CheckOverlayCapabilitiesCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::DrmDevice::CheckOverlayCapabilities");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_CheckOverlayCapabilities_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_CheckOverlayCapabilities_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in DrmDevice.CheckOverlayCapabilities request");
  typename decltype(params->candidates)::BaseType::BufferWriter
      candidates_writer;
  const mojo::internal::ContainerValidateParams candidates_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>>(
      in_candidates, buffer, &candidates_writer, &candidates_validate_params,
      &serialization_context);
  params->candidates.Set(
      candidates_writer.is_null() ? nullptr : candidates_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->candidates.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null candidates in DrmDevice.CheckOverlayCapabilities request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("CheckOverlayCapabilities");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DrmDevice_CheckOverlayCapabilities_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class DrmDevice_StartDrmDevice_ProxyToResponder {
 public:
  static DrmDevice::StartDrmDeviceCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_StartDrmDevice_ProxyToResponder> proxy(
        new DrmDevice_StartDrmDevice_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_StartDrmDevice_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_StartDrmDevice_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_StartDrmDevice_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::StartDrmDeviceCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_StartDrmDevice_ProxyToResponder);
};

bool DrmDevice_StartDrmDevice_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::StartDrmDeviceCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_StartDrmDevice_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_StartDrmDevice_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  DrmDevice_StartDrmDevice_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::StartDrmDevice response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void DrmDevice_StartDrmDevice_ProxyToResponder::Run(
    bool in_success) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_StartDrmDevice_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_StartDrmDevice_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->success = in_success;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::StartDrmDeviceCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("StartDrmDevice");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
bool DrmDevice_StartDrmDevice_HandleSyncResponse::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::DrmDevice_StartDrmDevice_ResponseParams_Data* params =
      reinterpret_cast<internal::DrmDevice_StartDrmDevice_ResponseParams_Data*>(
          message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  DrmDevice_StartDrmDevice_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::StartDrmDevice response deserializer");
    return false;
  }
  *out_success_ = std::move(p_success);
  mojo::internal::SyncMessageResponseSetup::SetCurrentSyncResponseMessage(
      message);
  *result_ = true;
  return true;
}
class DrmDevice_TakeDisplayControl_ProxyToResponder {
 public:
  static DrmDevice::TakeDisplayControlCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_TakeDisplayControl_ProxyToResponder> proxy(
        new DrmDevice_TakeDisplayControl_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_TakeDisplayControl_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_TakeDisplayControl_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_TakeDisplayControl_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::TakeDisplayControlCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_TakeDisplayControl_ProxyToResponder);
};

bool DrmDevice_TakeDisplayControl_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::TakeDisplayControlCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_TakeDisplayControl_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_TakeDisplayControl_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  DrmDevice_TakeDisplayControl_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::TakeDisplayControl response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void DrmDevice_TakeDisplayControl_ProxyToResponder::Run(
    bool in_success) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_TakeDisplayControl_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_TakeDisplayControl_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->success = in_success;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::TakeDisplayControlCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("TakeDisplayControl");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DrmDevice_RelinquishDisplayControl_ProxyToResponder {
 public:
  static DrmDevice::RelinquishDisplayControlCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_RelinquishDisplayControl_ProxyToResponder> proxy(
        new DrmDevice_RelinquishDisplayControl_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_RelinquishDisplayControl_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_RelinquishDisplayControl_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_RelinquishDisplayControl_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::RelinquishDisplayControlCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_RelinquishDisplayControl_ProxyToResponder);
};

bool DrmDevice_RelinquishDisplayControl_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::RelinquishDisplayControlCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_RelinquishDisplayControl_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_RelinquishDisplayControl_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  DrmDevice_RelinquishDisplayControl_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::RelinquishDisplayControl response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void DrmDevice_RelinquishDisplayControl_ProxyToResponder::Run(
    bool in_success) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_RelinquishDisplayControl_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_RelinquishDisplayControl_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->success = in_success;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::RelinquishDisplayControlCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("RelinquishDisplayControl");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DrmDevice_RefreshNativeDisplays_ProxyToResponder {
 public:
  static DrmDevice::RefreshNativeDisplaysCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_RefreshNativeDisplays_ProxyToResponder> proxy(
        new DrmDevice_RefreshNativeDisplays_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_RefreshNativeDisplays_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_RefreshNativeDisplays_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_RefreshNativeDisplays_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::RefreshNativeDisplaysCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<std::unique_ptr<display::DisplaySnapshot>> in_display_snapshots);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_RefreshNativeDisplays_ProxyToResponder);
};

bool DrmDevice_RefreshNativeDisplays_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::RefreshNativeDisplaysCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_RefreshNativeDisplays_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_RefreshNativeDisplays_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  std::vector<std::unique_ptr<display::DisplaySnapshot>> p_display_snapshots{};
  DrmDevice_RefreshNativeDisplays_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadDisplaySnapshots(&p_display_snapshots))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::RefreshNativeDisplays response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_display_snapshots));
  return true;
}

void DrmDevice_RefreshNativeDisplays_ProxyToResponder::Run(
    std::vector<std::unique_ptr<display::DisplaySnapshot>> in_display_snapshots) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_RefreshNativeDisplays_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_RefreshNativeDisplays_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->display_snapshots)::BaseType::BufferWriter
      display_snapshots_writer;
  const mojo::internal::ContainerValidateParams display_snapshots_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::display::mojom::DisplaySnapshotDataView>>(
      in_display_snapshots, buffer, &display_snapshots_writer, &display_snapshots_validate_params,
      &serialization_context);
  params->display_snapshots.Set(
      display_snapshots_writer.is_null() ? nullptr : display_snapshots_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->display_snapshots.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null display_snapshots in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::RefreshNativeDisplaysCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("RefreshNativeDisplays");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DrmDevice_DisableNativeDisplay_ProxyToResponder {
 public:
  static DrmDevice::DisableNativeDisplayCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_DisableNativeDisplay_ProxyToResponder> proxy(
        new DrmDevice_DisableNativeDisplay_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_DisableNativeDisplay_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_DisableNativeDisplay_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_DisableNativeDisplay_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::DisableNativeDisplayCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      int64_t in_display_id, bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_DisableNativeDisplay_ProxyToResponder);
};

bool DrmDevice_DisableNativeDisplay_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::DisableNativeDisplayCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_DisableNativeDisplay_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_DisableNativeDisplay_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int64_t p_display_id{};
  bool p_success{};
  DrmDevice_DisableNativeDisplay_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_display_id = input_data_view.display_id();
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::DisableNativeDisplay response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_display_id), 
std::move(p_success));
  return true;
}

void DrmDevice_DisableNativeDisplay_ProxyToResponder::Run(
    int64_t in_display_id, bool in_success) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_DisableNativeDisplay_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_DisableNativeDisplay_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  params->success = in_success;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::DisableNativeDisplayCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("DisableNativeDisplay");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DrmDevice_ConfigureNativeDisplay_ProxyToResponder {
 public:
  static DrmDevice::ConfigureNativeDisplayCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_ConfigureNativeDisplay_ProxyToResponder> proxy(
        new DrmDevice_ConfigureNativeDisplay_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_ConfigureNativeDisplay_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_ConfigureNativeDisplay_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_ConfigureNativeDisplay_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::ConfigureNativeDisplayCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      int64_t in_display_id, bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_ConfigureNativeDisplay_ProxyToResponder);
};

bool DrmDevice_ConfigureNativeDisplay_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::ConfigureNativeDisplayCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_ConfigureNativeDisplay_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_ConfigureNativeDisplay_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int64_t p_display_id{};
  bool p_success{};
  DrmDevice_ConfigureNativeDisplay_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_display_id = input_data_view.display_id();
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::ConfigureNativeDisplay response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_display_id), 
std::move(p_success));
  return true;
}

void DrmDevice_ConfigureNativeDisplay_ProxyToResponder::Run(
    int64_t in_display_id, bool in_success) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_ConfigureNativeDisplay_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_ConfigureNativeDisplay_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  params->success = in_success;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::ConfigureNativeDisplayCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("ConfigureNativeDisplay");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DrmDevice_GetHDCPState_ProxyToResponder {
 public:
  static DrmDevice::GetHDCPStateCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_GetHDCPState_ProxyToResponder> proxy(
        new DrmDevice_GetHDCPState_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_GetHDCPState_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_GetHDCPState_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_GetHDCPState_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::GetHDCPStateCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      int64_t in_display_id, bool in_success, display::HDCPState in_state);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_GetHDCPState_ProxyToResponder);
};

bool DrmDevice_GetHDCPState_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::GetHDCPStateCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_GetHDCPState_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_GetHDCPState_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int64_t p_display_id{};
  bool p_success{};
  display::HDCPState p_state{};
  DrmDevice_GetHDCPState_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_display_id = input_data_view.display_id();
  p_success = input_data_view.success();
  if (!input_data_view.ReadState(&p_state))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::GetHDCPState response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_display_id), 
std::move(p_success), 
std::move(p_state));
  return true;
}

void DrmDevice_GetHDCPState_ProxyToResponder::Run(
    int64_t in_display_id, bool in_success, display::HDCPState in_state) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_GetHDCPState_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_GetHDCPState_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  params->success = in_success;
  mojo::internal::Serialize<::display::mojom::HDCPState>(
      in_state, &params->state);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::GetHDCPStateCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("GetHDCPState");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DrmDevice_SetHDCPState_ProxyToResponder {
 public:
  static DrmDevice::SetHDCPStateCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_SetHDCPState_ProxyToResponder> proxy(
        new DrmDevice_SetHDCPState_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_SetHDCPState_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_SetHDCPState_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_SetHDCPState_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::SetHDCPStateCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      int64_t in_display_id, bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_SetHDCPState_ProxyToResponder);
};

bool DrmDevice_SetHDCPState_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::SetHDCPStateCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_SetHDCPState_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_SetHDCPState_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int64_t p_display_id{};
  bool p_success{};
  DrmDevice_SetHDCPState_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_display_id = input_data_view.display_id();
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::SetHDCPState response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_display_id), 
std::move(p_success));
  return true;
}

void DrmDevice_SetHDCPState_ProxyToResponder::Run(
    int64_t in_display_id, bool in_success) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_SetHDCPState_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_SetHDCPState_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->display_id = in_display_id;
  params->success = in_success;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetHDCPStateCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("SetHDCPState");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DrmDevice_CheckOverlayCapabilities_ProxyToResponder {
 public:
  static DrmDevice::CheckOverlayCapabilitiesCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DrmDevice_CheckOverlayCapabilities_ProxyToResponder> proxy(
        new DrmDevice_CheckOverlayCapabilities_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DrmDevice_CheckOverlayCapabilities_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DrmDevice_CheckOverlayCapabilities_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DrmDevice_CheckOverlayCapabilities_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DrmDevice::CheckOverlayCapabilitiesCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      gfx::AcceleratedWidget in_widget, const std::vector<ui::OverlaySurfaceCandidate>& in_candidates, const std::vector<ui::OverlayStatus>& in_status);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DrmDevice_CheckOverlayCapabilities_ProxyToResponder);
};

bool DrmDevice_CheckOverlayCapabilities_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "ui::ozone::mojom::DrmDevice::CheckOverlayCapabilitiesCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DrmDevice_CheckOverlayCapabilities_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DrmDevice_CheckOverlayCapabilities_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  gfx::AcceleratedWidget p_widget{};
  std::vector<ui::OverlaySurfaceCandidate> p_candidates{};
  std::vector<ui::OverlayStatus> p_status{};
  DrmDevice_CheckOverlayCapabilities_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadWidget(&p_widget))
    success = false;
  if (!input_data_view.ReadCandidates(&p_candidates))
    success = false;
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DrmDevice::CheckOverlayCapabilities response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_widget), 
std::move(p_candidates), 
std::move(p_status));
  return true;
}

void DrmDevice_CheckOverlayCapabilities_ProxyToResponder::Run(
    gfx::AcceleratedWidget in_widget, const std::vector<ui::OverlaySurfaceCandidate>& in_candidates, const std::vector<ui::OverlayStatus>& in_status) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDrmDevice_CheckOverlayCapabilities_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::DrmDevice_CheckOverlayCapabilities_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in ");
  typename decltype(params->candidates)::BaseType::BufferWriter
      candidates_writer;
  const mojo::internal::ContainerValidateParams candidates_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>>(
      in_candidates, buffer, &candidates_writer, &candidates_validate_params,
      &serialization_context);
  params->candidates.Set(
      candidates_writer.is_null() ? nullptr : candidates_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->candidates.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null candidates in ");
  typename decltype(params->status)::BaseType::BufferWriter
      status_writer;
  const mojo::internal::ContainerValidateParams status_validate_params(
      0, ::ui::ozone::mojom::internal::OverlayStatus_Data::Validate);
  mojo::internal::Serialize<mojo::ArrayDataView<::ui::ozone::mojom::OverlayStatus>>(
      in_status, buffer, &status_writer, &status_validate_params,
      &serialization_context);
  params->status.Set(
      status_writer.is_null() ? nullptr : status_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->status.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null status in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::CheckOverlayCapabilitiesCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DrmDevice::Name_);
  message.set_method_name("CheckOverlayCapabilities");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool DrmDeviceStubDispatch::Accept(
    DrmDevice* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kDrmDevice_StartDrmDevice_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::StartDrmDevice",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_CreateWindow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::CreateWindow",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DrmDevice_CreateWindow_Params_Data* params =
          reinterpret_cast<internal::DrmDevice_CreateWindow_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::AcceleratedWidget p_widget{};
      DrmDevice_CreateWindow_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadWidget(&p_widget))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::CreateWindow deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateWindow(
std::move(p_widget));
      return true;
    }
    case internal::kDrmDevice_DestroyWindow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::DestroyWindow",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DrmDevice_DestroyWindow_Params_Data* params =
          reinterpret_cast<internal::DrmDevice_DestroyWindow_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::AcceleratedWidget p_widget{};
      DrmDevice_DestroyWindow_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadWidget(&p_widget))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::DestroyWindow deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DestroyWindow(
std::move(p_widget));
      return true;
    }
    case internal::kDrmDevice_SetWindowBounds_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetWindowBounds",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DrmDevice_SetWindowBounds_Params_Data* params =
          reinterpret_cast<internal::DrmDevice_SetWindowBounds_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::AcceleratedWidget p_widget{};
      gfx::Rect p_bounds{};
      DrmDevice_SetWindowBounds_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadWidget(&p_widget))
        success = false;
      if (!input_data_view.ReadBounds(&p_bounds))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::SetWindowBounds deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetWindowBounds(
std::move(p_widget), 
std::move(p_bounds));
      return true;
    }
    case internal::kDrmDevice_TakeDisplayControl_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::TakeDisplayControl",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_RelinquishDisplayControl_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::RelinquishDisplayControl",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_RefreshNativeDisplays_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::RefreshNativeDisplays",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_AddGraphicsDevice_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::AddGraphicsDevice",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DrmDevice_AddGraphicsDevice_Params_Data* params =
          reinterpret_cast<internal::DrmDevice_AddGraphicsDevice_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      base::FilePath p_path{};
      base::File p_file{};
      DrmDevice_AddGraphicsDevice_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadPath(&p_path))
        success = false;
      if (!input_data_view.ReadFile(&p_file))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::AddGraphicsDevice deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->AddGraphicsDevice(
std::move(p_path), 
std::move(p_file));
      return true;
    }
    case internal::kDrmDevice_RemoveGraphicsDevice_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::RemoveGraphicsDevice",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DrmDevice_RemoveGraphicsDevice_Params_Data* params =
          reinterpret_cast<internal::DrmDevice_RemoveGraphicsDevice_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      base::FilePath p_path{};
      DrmDevice_RemoveGraphicsDevice_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadPath(&p_path))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::RemoveGraphicsDevice deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RemoveGraphicsDevice(
std::move(p_path));
      return true;
    }
    case internal::kDrmDevice_DisableNativeDisplay_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::DisableNativeDisplay",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_ConfigureNativeDisplay_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::ConfigureNativeDisplay",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_GetHDCPState_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::GetHDCPState",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_SetHDCPState_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetHDCPState",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_SetColorMatrix_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetColorMatrix",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DrmDevice_SetColorMatrix_Params_Data* params =
          reinterpret_cast<internal::DrmDevice_SetColorMatrix_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      std::vector<float> p_color_matrix{};
      DrmDevice_SetColorMatrix_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      if (!input_data_view.ReadColorMatrix(&p_color_matrix))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::SetColorMatrix deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetColorMatrix(
std::move(p_display_id), 
std::move(p_color_matrix));
      return true;
    }
    case internal::kDrmDevice_SetGammaCorrection_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetGammaCorrection",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DrmDevice_SetGammaCorrection_Params_Data* params =
          reinterpret_cast<internal::DrmDevice_SetGammaCorrection_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      std::vector<display::GammaRampRGBEntry> p_degamma_lut{};
      std::vector<display::GammaRampRGBEntry> p_gamma_lut{};
      DrmDevice_SetGammaCorrection_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      if (!input_data_view.ReadDegammaLut(&p_degamma_lut))
        success = false;
      if (!input_data_view.ReadGammaLut(&p_gamma_lut))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::SetGammaCorrection deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetGammaCorrection(
std::move(p_display_id), 
std::move(p_degamma_lut), 
std::move(p_gamma_lut));
      return true;
    }
    case internal::kDrmDevice_CheckOverlayCapabilities_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::CheckOverlayCapabilities",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

// static
bool DrmDeviceStubDispatch::AcceptWithResponder(
    DrmDevice* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kDrmDevice_StartDrmDevice_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::StartDrmDevice",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_StartDrmDevice_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_StartDrmDevice_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DrmDevice_StartDrmDevice_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::StartDrmDevice deserializer");
        return false;
      }
      DrmDevice::StartDrmDeviceCallback callback =
          DrmDevice_StartDrmDevice_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StartDrmDevice(std::move(callback));
      return true;
    }
    case internal::kDrmDevice_CreateWindow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::CreateWindow",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_DestroyWindow_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::DestroyWindow",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_SetWindowBounds_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetWindowBounds",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_TakeDisplayControl_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::TakeDisplayControl",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_TakeDisplayControl_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_TakeDisplayControl_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DrmDevice_TakeDisplayControl_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::TakeDisplayControl deserializer");
        return false;
      }
      DrmDevice::TakeDisplayControlCallback callback =
          DrmDevice_TakeDisplayControl_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->TakeDisplayControl(std::move(callback));
      return true;
    }
    case internal::kDrmDevice_RelinquishDisplayControl_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::RelinquishDisplayControl",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_RelinquishDisplayControl_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_RelinquishDisplayControl_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DrmDevice_RelinquishDisplayControl_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::RelinquishDisplayControl deserializer");
        return false;
      }
      DrmDevice::RelinquishDisplayControlCallback callback =
          DrmDevice_RelinquishDisplayControl_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RelinquishDisplayControl(std::move(callback));
      return true;
    }
    case internal::kDrmDevice_RefreshNativeDisplays_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::RefreshNativeDisplays",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_RefreshNativeDisplays_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_RefreshNativeDisplays_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DrmDevice_RefreshNativeDisplays_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::RefreshNativeDisplays deserializer");
        return false;
      }
      DrmDevice::RefreshNativeDisplaysCallback callback =
          DrmDevice_RefreshNativeDisplays_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RefreshNativeDisplays(std::move(callback));
      return true;
    }
    case internal::kDrmDevice_AddGraphicsDevice_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::AddGraphicsDevice",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_RemoveGraphicsDevice_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::RemoveGraphicsDevice",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_DisableNativeDisplay_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::DisableNativeDisplay",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_DisableNativeDisplay_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_DisableNativeDisplay_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      DrmDevice_DisableNativeDisplay_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::DisableNativeDisplay deserializer");
        return false;
      }
      DrmDevice::DisableNativeDisplayCallback callback =
          DrmDevice_DisableNativeDisplay_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DisableNativeDisplay(
std::move(p_display_id), std::move(callback));
      return true;
    }
    case internal::kDrmDevice_ConfigureNativeDisplay_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::ConfigureNativeDisplay",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_ConfigureNativeDisplay_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_ConfigureNativeDisplay_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      std::unique_ptr<display::DisplayMode> p_display_mode{};
      gfx::Point p_point{};
      DrmDevice_ConfigureNativeDisplay_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      if (!input_data_view.ReadDisplayMode(&p_display_mode))
        success = false;
      if (!input_data_view.ReadPoint(&p_point))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::ConfigureNativeDisplay deserializer");
        return false;
      }
      DrmDevice::ConfigureNativeDisplayCallback callback =
          DrmDevice_ConfigureNativeDisplay_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->ConfigureNativeDisplay(
std::move(p_display_id), 
std::move(p_display_mode), 
std::move(p_point), std::move(callback));
      return true;
    }
    case internal::kDrmDevice_GetHDCPState_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::GetHDCPState",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_GetHDCPState_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_GetHDCPState_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      DrmDevice_GetHDCPState_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::GetHDCPState deserializer");
        return false;
      }
      DrmDevice::GetHDCPStateCallback callback =
          DrmDevice_GetHDCPState_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GetHDCPState(
std::move(p_display_id), std::move(callback));
      return true;
    }
    case internal::kDrmDevice_SetHDCPState_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetHDCPState",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_SetHDCPState_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_SetHDCPState_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      display::HDCPState p_state{};
      DrmDevice_SetHDCPState_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      if (!input_data_view.ReadState(&p_state))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::SetHDCPState deserializer");
        return false;
      }
      DrmDevice::SetHDCPStateCallback callback =
          DrmDevice_SetHDCPState_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetHDCPState(
std::move(p_display_id), 
std::move(p_state), std::move(callback));
      return true;
    }
    case internal::kDrmDevice_SetColorMatrix_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetColorMatrix",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_SetGammaCorrection_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::SetGammaCorrection",
               "message", message->name());
#endif
      break;
    }
    case internal::kDrmDevice_CheckOverlayCapabilities_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::ozone::mojom::DrmDevice::CheckOverlayCapabilities",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DrmDevice_CheckOverlayCapabilities_Params_Data* params =
          reinterpret_cast<
              internal::DrmDevice_CheckOverlayCapabilities_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      gfx::AcceleratedWidget p_widget{};
      std::vector<ui::OverlaySurfaceCandidate> p_candidates{};
      DrmDevice_CheckOverlayCapabilities_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadWidget(&p_widget))
        success = false;
      if (!input_data_view.ReadCandidates(&p_candidates))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DrmDevice::CheckOverlayCapabilities deserializer");
        return false;
      }
      DrmDevice::CheckOverlayCapabilitiesCallback callback =
          DrmDevice_CheckOverlayCapabilities_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CheckOverlayCapabilities(
std::move(p_widget), 
std::move(p_candidates), std::move(callback));
      return true;
    }
  }
  return false;
}

bool DrmDeviceRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "DrmDevice RequestValidator");

  switch (message->header()->name) {
    case internal::kDrmDevice_StartDrmDevice_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_StartDrmDevice_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_CreateWindow_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_CreateWindow_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_DestroyWindow_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_DestroyWindow_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_SetWindowBounds_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_SetWindowBounds_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_TakeDisplayControl_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_TakeDisplayControl_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_RelinquishDisplayControl_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_RelinquishDisplayControl_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_RefreshNativeDisplays_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_RefreshNativeDisplays_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_AddGraphicsDevice_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_AddGraphicsDevice_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_RemoveGraphicsDevice_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_RemoveGraphicsDevice_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_DisableNativeDisplay_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_DisableNativeDisplay_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_ConfigureNativeDisplay_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_ConfigureNativeDisplay_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_GetHDCPState_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_GetHDCPState_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_SetHDCPState_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_SetHDCPState_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_SetColorMatrix_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_SetColorMatrix_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_SetGammaCorrection_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_SetGammaCorrection_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_CheckOverlayCapabilities_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_CheckOverlayCapabilities_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool DrmDeviceResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "DrmDevice ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kDrmDevice_StartDrmDevice_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_StartDrmDevice_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_TakeDisplayControl_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_TakeDisplayControl_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_RelinquishDisplayControl_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_RelinquishDisplayControl_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_RefreshNativeDisplays_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_RefreshNativeDisplays_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_DisableNativeDisplay_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_DisableNativeDisplay_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_ConfigureNativeDisplay_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_ConfigureNativeDisplay_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_GetHDCPState_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_GetHDCPState_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_SetHDCPState_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_SetHDCPState_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDrmDevice_CheckOverlayCapabilities_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DrmDevice_CheckOverlayCapabilities_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif