// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ui/ozone/public/interfaces/overlay_surface_candidate.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/ozone/public/interfaces/overlay_surface_candidate.mojom-shared-message-ids.h"


#ifndef UI_OZONE_PUBLIC_INTERFACES_OVERLAY_SURFACE_CANDIDATE_MOJOM_JUMBO_H_
#define UI_OZONE_PUBLIC_INTERFACES_OVERLAY_SURFACE_CANDIDATE_MOJOM_JUMBO_H_
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/mojo/buffer_types_struct_traits.h"
#include "ui/gfx/mojo/overlay_transform_struct_traits.h"
#endif
namespace ui {
namespace ozone {
namespace mojom {
OverlaySurfaceCandidate::OverlaySurfaceCandidate()
    : transform(),
      format(),
      buffer_size(),
      display_rect(),
      crop_rect(),
      clip_rect(),
      is_clipped(),
      plane_z_order(0),
      overlay_handled() {}

OverlaySurfaceCandidate::OverlaySurfaceCandidate(
    gfx::OverlayTransform transform_in,
    gfx::BufferFormat format_in,
    const gfx::Size& buffer_size_in,
    const gfx::RectF& display_rect_in,
    const gfx::RectF& crop_rect_in,
    const gfx::Rect& clip_rect_in,
    bool is_clipped_in,
    int32_t plane_z_order_in,
    bool overlay_handled_in)
    : transform(std::move(transform_in)),
      format(std::move(format_in)),
      buffer_size(std::move(buffer_size_in)),
      display_rect(std::move(display_rect_in)),
      crop_rect(std::move(crop_rect_in)),
      clip_rect(std::move(clip_rect_in)),
      is_clipped(std::move(is_clipped_in)),
      plane_z_order(std::move(plane_z_order_in)),
      overlay_handled(std::move(overlay_handled_in)) {}

OverlaySurfaceCandidate::~OverlaySurfaceCandidate() = default;

bool OverlaySurfaceCandidate::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace mojo {


// static
bool StructTraits<::ui::ozone::mojom::OverlaySurfaceCandidate::DataView, ::ui::ozone::mojom::OverlaySurfaceCandidatePtr>::Read(
    ::ui::ozone::mojom::OverlaySurfaceCandidate::DataView input,
    ::ui::ozone::mojom::OverlaySurfaceCandidatePtr* output) {
  bool success = true;
  ::ui::ozone::mojom::OverlaySurfaceCandidatePtr result(::ui::ozone::mojom::OverlaySurfaceCandidate::New());
  
      if (!input.ReadTransform(&result->transform))
        success = false;
      if (!input.ReadFormat(&result->format))
        success = false;
      if (!input.ReadBufferSize(&result->buffer_size))
        success = false;
      if (!input.ReadDisplayRect(&result->display_rect))
        success = false;
      if (!input.ReadCropRect(&result->crop_rect))
        success = false;
      if (!input.ReadClipRect(&result->clip_rect))
        success = false;
      result->is_clipped = input.is_clipped();
      result->plane_z_order = input.plane_z_order();
      result->overlay_handled = input.overlay_handled();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif