// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_HOST_MOJOM_SHARED_H_
#define UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_HOST_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "ui/ozone/public/interfaces/scenic_gpu_host.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace ui {
namespace mojom {


}  // namespace mojom
}  // namespace ui

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace ui {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ScenicGpuHostInterfaceBase {};

using ScenicGpuHostPtrDataView =
    mojo::InterfacePtrDataView<ScenicGpuHostInterfaceBase>;
using ScenicGpuHostRequestDataView =
    mojo::InterfaceRequestDataView<ScenicGpuHostInterfaceBase>;
using ScenicGpuHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ScenicGpuHostInterfaceBase>;
using ScenicGpuHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ScenicGpuHostInterfaceBase>;
class ScenicGpuHost_ExportParent_ParamsDataView {
 public:
  ScenicGpuHost_ExportParent_ParamsDataView() {}

  ScenicGpuHost_ExportParent_ParamsDataView(
      internal::ScenicGpuHost_ExportParent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t surface_handle() const {
    return data_->surface_handle;
  }
  mojo::ScopedHandle TakeExportToken() {
    mojo::ScopedHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedHandle>(
            &data_->export_token, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ScenicGpuHost_ExportParent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace ui

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace ui {
namespace mojom {




}  // namespace mojom
}  // namespace ui

#endif  // UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_HOST_MOJOM_SHARED_H_