// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ui/ozone/public/interfaces/scenic_gpu_host.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/ozone/public/interfaces/scenic_gpu_host.mojom-shared-message-ids.h"


#ifndef UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_HOST_MOJOM_JUMBO_H_
#define UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_HOST_MOJOM_JUMBO_H_
#endif
namespace ui {
namespace mojom {
const char ScenicGpuHost::Name_[] = "ui.mojom.ScenicGpuHost";

ScenicGpuHostProxy::ScenicGpuHostProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ScenicGpuHostProxy::ExportParent(
    int32_t in_surface_handle, mojo::ScopedHandle in_export_token) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::mojom::ScenicGpuHost::ExportParent");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kScenicGpuHost_ExportParent_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::mojom::internal::ScenicGpuHost_ExportParent_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->surface_handle = in_surface_handle;
  mojo::internal::Serialize<mojo::ScopedHandle>(
      in_export_token, &params->export_token, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->export_token),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid export_token in ScenicGpuHost.ExportParent request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ScenicGpuHost::Name_);
  message.set_method_name("ExportParent");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool ScenicGpuHostStubDispatch::Accept(
    ScenicGpuHost* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kScenicGpuHost_ExportParent_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::mojom::ScenicGpuHost::ExportParent",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ScenicGpuHost_ExportParent_Params_Data* params =
          reinterpret_cast<internal::ScenicGpuHost_ExportParent_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_surface_handle{};
      mojo::ScopedHandle p_export_token{};
      ScenicGpuHost_ExportParent_ParamsDataView input_data_view(params, &serialization_context);
      
      p_surface_handle = input_data_view.surface_handle();
      p_export_token = input_data_view.TakeExportToken();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ScenicGpuHost::ExportParent deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->ExportParent(
std::move(p_surface_handle), 
std::move(p_export_token));
      return true;
    }
  }
  return false;
}

// static
bool ScenicGpuHostStubDispatch::AcceptWithResponder(
    ScenicGpuHost* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kScenicGpuHost_ExportParent_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)ui::mojom::ScenicGpuHost::ExportParent",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool ScenicGpuHostRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ScenicGpuHost RequestValidator");

  switch (message->header()->name) {
    case internal::kScenicGpuHost_ExportParent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ScenicGpuHost_ExportParent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace ui

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif