// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_HOST_MOJOM_H_
#define UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_HOST_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "ui/ozone/public/interfaces/scenic_gpu_host.mojom-shared.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace ui {
namespace mojom {
class ScenicGpuHost;
using ScenicGpuHostPtr = mojo::InterfacePtr<ScenicGpuHost>;
using ScenicGpuHostPtrInfo = mojo::InterfacePtrInfo<ScenicGpuHost>;
using ThreadSafeScenicGpuHostPtr =
    mojo::ThreadSafeInterfacePtr<ScenicGpuHost>;
using ScenicGpuHostRequest = mojo::InterfaceRequest<ScenicGpuHost>;
using ScenicGpuHostAssociatedPtr =
    mojo::AssociatedInterfacePtr<ScenicGpuHost>;
using ThreadSafeScenicGpuHostAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<ScenicGpuHost>;
using ScenicGpuHostAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<ScenicGpuHost>;
using ScenicGpuHostAssociatedRequest =
    mojo::AssociatedInterfaceRequest<ScenicGpuHost>;


class ScenicGpuHostProxy;

template <typename ImplRefTraits>
class ScenicGpuHostStub;

class ScenicGpuHostRequestValidator;

class  ScenicGpuHost
    : public ScenicGpuHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = ScenicGpuHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = ScenicGpuHostStub<ImplRefTraits>;

  using RequestValidator_ = ScenicGpuHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kExportParentMinVersion = 0,
  };
  virtual ~ScenicGpuHost() {}

  virtual void ExportParent(int32_t surface_handle, mojo::ScopedHandle export_token) = 0;
};

class  ScenicGpuHostProxy
    : public ScenicGpuHost {
 public:
  explicit ScenicGpuHostProxy(mojo::MessageReceiverWithResponder* receiver);
  void ExportParent(int32_t surface_handle, mojo::ScopedHandle export_token) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  ScenicGpuHostStubDispatch {
 public:
  static bool Accept(ScenicGpuHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ScenicGpuHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ScenicGpuHost>>
class ScenicGpuHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ScenicGpuHostStub() {}
  ~ScenicGpuHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ScenicGpuHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ScenicGpuHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ScenicGpuHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace ui

namespace mojo {

}  // namespace mojo

#endif  // UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_HOST_MOJOM_H_