// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_SERVICE_MOJOM_H_
#define UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "ui/ozone/public/interfaces/scenic_gpu_service.mojom-shared.h"
#include "ui/ozone/public/interfaces/scenic_gpu_host.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace ui {
namespace mojom {
class ScenicGpuService;
using ScenicGpuServicePtr = mojo::InterfacePtr<ScenicGpuService>;
using ScenicGpuServicePtrInfo = mojo::InterfacePtrInfo<ScenicGpuService>;
using ThreadSafeScenicGpuServicePtr =
    mojo::ThreadSafeInterfacePtr<ScenicGpuService>;
using ScenicGpuServiceRequest = mojo::InterfaceRequest<ScenicGpuService>;
using ScenicGpuServiceAssociatedPtr =
    mojo::AssociatedInterfacePtr<ScenicGpuService>;
using ThreadSafeScenicGpuServiceAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<ScenicGpuService>;
using ScenicGpuServiceAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<ScenicGpuService>;
using ScenicGpuServiceAssociatedRequest =
    mojo::AssociatedInterfaceRequest<ScenicGpuService>;


class ScenicGpuServiceProxy;

template <typename ImplRefTraits>
class ScenicGpuServiceStub;

class ScenicGpuServiceRequestValidator;

class  ScenicGpuService
    : public ScenicGpuServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = ScenicGpuServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = ScenicGpuServiceStub<ImplRefTraits>;

  using RequestValidator_ = ScenicGpuServiceRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kInitializeMinVersion = 0,
  };
  virtual ~ScenicGpuService() {}

  virtual void Initialize(::ui::mojom::ScenicGpuHostPtr scenic_gpu_host) = 0;
};

class  ScenicGpuServiceProxy
    : public ScenicGpuService {
 public:
  explicit ScenicGpuServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  void Initialize(::ui::mojom::ScenicGpuHostPtr scenic_gpu_host) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  ScenicGpuServiceStubDispatch {
 public:
  static bool Accept(ScenicGpuService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ScenicGpuService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ScenicGpuService>>
class ScenicGpuServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ScenicGpuServiceStub() {}
  ~ScenicGpuServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ScenicGpuServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ScenicGpuServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ScenicGpuServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace ui

namespace mojo {

}  // namespace mojo

#endif  // UI_OZONE_PUBLIC_INTERFACES_SCENIC_GPU_SERVICE_MOJOM_H_